/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/network","vs/nls","vs/nls!vs/server/remoteExtensionHostAgent","vs/base/common/types","vs/base/common/errors","vs/base/common/strings","vs/base/common/async","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/process","os","vs/base/common/cancellation","vs/base/common/map","fs","vs/platform/environment/common/environment","vs/platform/registry/common/platform","vs/base/common/extpath","vs/platform/product/common/product","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","child_process","vs/base/parts/ipc/common/ipc","vs/base/common/json","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetry","vs/server/remoteUriTransformer","vs/base/common/codicons","vs/base/common/stream","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/platform/product/common/productService","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/performance","vs/base/common/semver/semver","vs/base/parts/ipc/node/ipc.net","vs/base/common/iterator","vs/base/common/labels","vs/base/common/mime","vs/base/common/uriIpc","vs/editor/common/core/range","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","crypto","vs/platform/files/node/diskFileSystemProvider","vs/platform/request/common/request","url","vs/platform/telemetry/common/telemetryUtils","vs/server/serverEnvironmentService","vs/workbench/services/editor/common/editorService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/severity","vs/base/common/htmlContent","vs/base/common/normalization","vs/base/node/decoder","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/node/processes","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/localizations/node/localizations","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/files/common/fileService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/server/remoteLanguagePacks","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/filters","vs/base/common/iconLabels","vs/base/node/languagePacks","vs/base/node/macAddress","util","vs/base/node/extpath","vs/base/node/ports","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/editor/common/modes/languageSelector","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/remoteAgentEnvironmentImpl","vs/nls!vs/server/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/common/ipcFileSystemProvider","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/editor/common/modes","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/argvHelper","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/workspaces/common/workspaces","vs/server/remoteExtensionManagement","vs/server/remoteAgentFileSystemImpl","vs/server/webClientServer","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/api/common/extHostTypeConverters","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/node/extensionPoints","vs/server/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/remoteTerminalChannel","vs/server/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","cookie","vs/base/common/marked/marked","yauzl","yazl","http","vs/server/remoteExtensionHostAgent"],he=function(X){for(var e=[],y=0,D=X.length;y<D;y++)e[y]=fe[X[y]];return e};define(fe[109],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class y{static get(){const g=new Map,C=new Map,_=new Map,P=new Map;function d(m,u){m.has(u.detail)||m.set(u.detail,-u.timestamp)}function v(m,u){let f=m.get(u.detail);!f||f>=0||m.set(u.detail,f+u.timestamp)}const n=X.getStats().slice(0).sort((m,u)=>m.timestamp-u.timestamp);for(const m of n)switch(m.type){case 10:d(g,m);break;case 11:case 12:v(g,m);break;case 21:d(C,m);break;case 22:v(C,m);break;case 33:d(_,m);break;case 34:v(_,m);break;case 31:d(P,m);break;case 32:v(P,m);break}let k=0;_.forEach(m=>k+=m);function b(m){let u=[];return m.forEach((f,S)=>u.push([S,f])),u}return{amdLoad:b(g),amdInvoke:b(C),nodeRequire:b(_),nodeEval:b(P),nodeRequireTotal:k}}static toMarkdownTable(g,C){let _="",P=[];return g.forEach((d,v)=>{P[v]=d.length}),C.forEach(d=>{d.forEach((v,n)=>{typeof v=="undefined"&&(v=d[n]="-");const k=v.toString().length;P[n]=Math.max(k,P[n])})}),g.forEach((d,v)=>{_+=`| ${d+" ".repeat(P[v]-d.toString().length)} `}),_+=`|
`,g.forEach((d,v)=>{_+=`| ${"-".repeat(P[v])} `}),_+=`|
`,C.forEach(d=>{d.forEach((v,n)=>{typeof v!="undefined"&&(_+=`| ${v+" ".repeat(P[n]-v.toString().length)} `)}),_+=`|
`}),_}}e.LoaderStats=y}),define(fe[110],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function y(D,g){if(!D)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=y}),define(fe[71],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function y(_){return(P,d,v)=>{let n=null,k=null;if(typeof v.value=="function"?(n="value",k=v.value):typeof v.get=="function"&&(n="get",k=v.get),!k)throw new Error("not supported");v[n]=_(k,d)}}e.createDecorator=y;function D(_,P,d){let v=null,n=null;if(typeof d.value=="function"?(v="value",n=d.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(v="get",n=d.get),!n)throw new Error("not supported");const k=`$memoize$${P}`;d[v]=function(...b){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,b)}),this[k]}}e.memoize=D;function g(_,P,d){return y((v,n)=>{const k=`$debounce$${n}`,b=`$debounce$result$${n}`;return function(...m){this[b]||(this[b]=d?d():void 0),clearTimeout(this[k]),P&&(this[b]=P(this[b],...m),m=[this[b]]),this[k]=setTimeout(()=>{v.apply(this,m),this[b]=d?d():void 0},_)}})}e.debounce=g;function C(_,P,d){return y((v,n)=>{const k=`$throttle$timer$${n}`,b=`$throttle$result$${n}`,m=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...f){if(this[b]||(this[b]=d?d():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[b]=P(this[b],...f)),this[u])return;const S=this[m]+_;S<=Date.now()?(this[m]=Date.now(),v.apply(this,[this[b]]),this[b]=d?d():void 0):(this[u]=!0,this[k]=setTimeout(()=>{this[u]=!1,this[m]=Date.now(),v.apply(this,[this[b]]),this[b]=d?d():void 0},S-Date.now()))}})}e.throttle=C}),define(fe[12],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=y,e.errorHandler=new y;function D(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=D;function g(l){d(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=g;function C(l){d(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=C;function _(l){if(l instanceof Error){let{name:t,message:r}=l;const i=l.stacktrace||l.stack;return{$isError:!0,name:t,message:r,stack:i}}return l}e.transformErrorForSerialization=_;const P="Canceled";function d(l){return l instanceof Error&&l.name===P&&l.message===P}e.isPromiseCanceledError=d;class v extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=v;function n(){const l=new Error(P);return l.name=l.message,l}e.canceled=n;function k(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=k;function b(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=b;function m(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function u(l){const t=new Error(`${l} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function f(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=f;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function h(l){const t=l;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=h;function a(l,t=Object.create(null)){const r=new Error(l);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=a}),define(fe[21],he([0,1,12]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function D(T,R=0){return T[T.length-(1+R)]}e.tail=D;function g(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=g;function C(T,R,M=(z,j)=>z===j){if(T===R)return!0;if(!T||!R||T.length!==R.length)return!1;for(let z=0,j=T.length;z<j;z++)if(!M(T[z],R[z]))return!1;return!0}e.equals=C;function _(T,R,M){let z=0,j=T.length-1;for(;z<=j;){const ee=(z+j)/2|0,me=M(T[ee],R);if(me<0)z=ee+1;else if(me>0)j=ee-1;else return ee}return-(z+1)}e.binarySearch=_;function P(T,R){let M=0,z=T.length;if(z===0)return 0;for(;M<z;){const j=Math.floor((M+z)/2);R(T[j])?z=j:M=j+1}return M}e.findFirstInSorted=P;function d(T,R,M){if(T=T|0,T>=R.length)throw new TypeError("invalid index");let z=R[Math.floor(R.length*Math.random())],j=[],ee=[],me=[];for(let ge of R){const be=M(ge,z);be<0?j.push(ge):be>0?ee.push(ge):me.push(ge)}return T<j.length?d(T,j,M):T<j.length+me.length?me[0]:d(T-(j.length+me.length),ee,M)}e.quickSelect=d;function v(T,R){const M=[];let z;for(const j of T.slice(0).sort(R))!z||R(z[0],j)!==0?(z=[j],M.push(z)):z.push(j);return M}e.groupBy=v;function n(T,R,M){const z=[];function j(ge,be,Ie){if(be===0&&Ie.length===0)return;const Ae=z[z.length-1];Ae&&Ae.start+Ae.deleteCount===ge?(Ae.deleteCount+=be,Ae.toInsert.push(...Ie)):z.push({start:ge,deleteCount:be,toInsert:Ie})}let ee=0,me=0;for(;;){if(ee===T.length){j(ee,0,R.slice(me));break}if(me===R.length){j(ee,T.length-ee,[]);break}const ge=T[ee],be=R[me],Ie=M(ge,be);Ie===0?(ee+=1,me+=1):Ie<0?(j(ee,1,[]),ee+=1):Ie>0&&(j(ee,0,[be]),me+=1)}return z}e.sortedDiff=n;function k(T,R,M){const z=n(T,R,M),j=[],ee=[];for(const me of z)j.push(...T.slice(me.start,me.start+me.deleteCount)),ee.push(...me.toInsert);return{removed:j,added:ee}}e.delta=k;function b(T,R,M){if(M===0)return[];const z=T.slice(0,M).sort(R);return u(T,R,z,M,T.length),z}e.top=b;function m(T,R,M,z,j){return M===0?Promise.resolve([]):new Promise((ee,me)=>{(async()=>{const ge=T.length,be=T.slice(0,M).sort(R);for(let Ie=M,Ae=Math.min(M+z,ge);Ie<ge;Ie=Ae,Ae=Math.min(Ae+z,ge)){if(Ie>M&&await new Promise(Fe=>setTimeout(Fe)),j&&j.isCancellationRequested)throw y.canceled();u(T,R,be,Ie,Ae)}return be})().then(ee,me)})}e.topAsync=m;function u(T,R,M,z,j){for(const ee=M.length;z<j;z++){const me=T[z];if(R(me,M[ee-1])<0){M.pop();const ge=P(M,be=>R(me,be)<0);M.splice(ge,0,me)}}}function f(T){return T.filter(R=>!!R)}e.coalesce=f;function S(T){let R=0;for(let M=0;M<T.length;M++)T[M]&&(T[R]=T[M],R+=1);T.length=R}e.coalesceInPlace=S;function E(T,R,M){T.splice(M,0,T.splice(R,1)[0])}e.move=E;function I(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=I;function h(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=h;function a(T,R){if(!R)return T.filter((z,j)=>T.indexOf(z)===j);const M=Object.create(null);return T.filter(z=>{const j=R(z);return M[j]?!1:(M[j]=!0,!0)})}e.distinct=a;function l(T){const R=new Set;return T.filter(M=>R.has(M)?!1:(R.add(M),!0))}e.distinctES6=l;function t(T){const R=Object.create(null);return M=>{const z=T(M);return R[z]?!1:(R[z]=!0,!0)}}e.uniqueFilter=t;function r(T,R){for(let M=T.length-1;M>=0;M--){const z=T[M];if(R(z))return M}return-1}e.lastIndex=r;function i(T,R){return T.length>0?T[0]:R}e.firstOrDefault=i;function s(T,R,M=(z,j)=>z===j){let z=0;for(let j=0,ee=Math.min(T.length,R.length);j<ee&&M(T[j],R[j]);j++)z++;return z}e.commonPrefixLength=s;function c(T){return[].concat(...T)}e.flatten=c;function p(T,R){let M=typeof R=="number"?T:0;typeof R=="number"?M=T:(M=0,R=T);const z=[];if(M<=R)for(let j=M;j<R;j++)z.push(j);else for(let j=M;j>R;j--)z.push(j);return z}e.range=p;function w(T,R,M){return T.reduce((z,j)=>(z[R(j)]=M?M(j):j,z),Object.create(null))}e.index=w;function L(T,R){return T.push(R),()=>F(T,R)}e.insert=L;function F(T,R){const M=T.indexOf(R);if(M>-1)return T.splice(M,1),R}e.remove=F;function o(T,R,M){const z=T.slice(0,R),j=T.slice(R);return z.concat(M,j)}e.arrayInsert=o;function A(T,R){let M;if(typeof R=="number"){let z=R;M=()=>{const j=Math.sin(z++)*179426549;return j-Math.floor(j)}}else M=Math.random;for(let z=T.length-1;z>0;z-=1){const j=Math.floor(M()*(z+1)),ee=T[z];T[z]=T[j],T[j]=ee}}e.shuffle=A;function N(T,R){const M=T.indexOf(R);M>-1&&(T.splice(M,1),T.unshift(R))}e.pushToStart=N;function Q(T,R){const M=T.indexOf(R);M>-1&&(T.splice(M,1),T.push(R))}e.pushToEnd=Q;function J(T,R){return Array.isArray(T)?T.map(R):R(T)}e.mapArrayOrNot=J;function ce(T){return Array.isArray(T)?T:[T]}e.asArray=ce;function se(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=se;function $(T,R){for(const M of T){const z=R(M);if(z!==void 0)return z}}e.mapFind=$;function q(T,R){let M=Number.MAX_SAFE_INTEGER,z=0;return T.forEach((j,ee)=>{const me=R(j);me<M&&(M=me,z=ee)}),z}e.minIndex=q;function W(T,R){let M=Number.MIN_SAFE_INTEGER,z=0;return T.forEach((j,ee)=>{const me=R(j);me>M&&(M=me,z=ee)}),z}e.maxIndex=W;class V{constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let M=this.firstIdx;for(;M<this.items.length&&R(this.items[M]);)M++;const z=M===this.firstIdx?null:this.items.slice(this.firstIdx,M);return this.firstIdx=M,z}takeFromEndWhile(R){let M=this.lastIdx;for(;M>=0&&R(this.items[M]);)M--;const z=M===this.lastIdx?null:this.items.slice(M+1,this.lastIdx+1);return this.lastIdx=M,z}}e.ArrayQueue=V}),define(fe[72],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(D){const g=this;let C=!1,_;return function(){return C||(C=!0,_=D.apply(g,arguments)),_}}e.once=y}),define(fe[51],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(D){function g(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}D.is=g;const C=Object.freeze([]);function _(){return C}D.empty=_;function*P(l){yield l}D.single=P;function d(l){return l||C}D.from=d;function v(l){return!l||l[Symbol.iterator]().next().done===!0}D.isEmpty=v;function n(l){return l[Symbol.iterator]().next().value}D.first=n;function k(l,t){for(const r of l)if(t(r))return!0;return!1}D.some=k;function b(l,t){for(const r of l)if(t(r))return r}D.find=b;function*m(l,t){for(const r of l)t(r)&&(yield r)}D.filter=m;function*u(l,t){let r=0;for(const i of l)yield t(i,r++)}D.map=u;function*f(...l){for(const t of l)for(const r of t)yield r}D.concat=f;function*S(l){for(const t of l)for(const r of t)yield r}D.concatNested=S;function E(l,t,r){let i=r;for(const s of l)i=t(i,s);return i}D.reduce=E;function*I(l,t,r=l.length){for(t<0&&(t+=l.length),r<0?r+=l.length:r>l.length&&(r=l.length);t<r;t++)yield l[t]}D.slice=I;function h(l,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,l];const i=l[Symbol.iterator]();for(let s=0;s<t;s++){const c=i.next();if(c.done)return[r,D.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return i}}]}D.consume=h;function a(l,t,r=(i,s)=>i===s){const i=l[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const c=i.next(),p=s.next();if(c.done!==p.done)return!1;if(c.done)return!0;if(!r(c.value,p.value))return!1}}D.equals=a})(y=e.Iterable||(e.Iterable={}))}),define(fe[37],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function _(t,r=!1){let i=0,s=t.length,c="",p=0,w=16,L=0;function F(se){let $=0,q=0;for(;$<se;){const W=t.charCodeAt(i);if(W>=48&&W<=57)q=q*16+W-48;else if(W>=65&&W<=70)q=q*16+W-65+10;else if(W>=97&&W<=102)q=q*16+W-97+10;else break;i++,$++}return $<se&&(q=-1),q}function o(se){i=se,c="",p=0,w=16,L=0}function A(){const se=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&v(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&v(t.charCodeAt(i)))for(i++;i<t.length&&v(t.charCodeAt(i));)i++;else return L=3,t.substring(se,i);let $=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&v(t.charCodeAt(i))){for(i++;i<t.length&&v(t.charCodeAt(i));)i++;$=i}else L=3;return t.substring(se,$)}function N(){let se="",$=i;for(;;){if(i>=s){se+=t.substring($,i),L=2;break}const q=t.charCodeAt(i);if(q===34){se+=t.substring($,i),i++;break}if(q===92){if(se+=t.substring($,i),i++,i>=s){L=2;break}switch(t.charCodeAt(i++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:const V=F(4);V>=0?se+=String.fromCharCode(V):L=4;break;default:L=5}$=i;continue}if(q>=0&&q<=31)if(d(q)){se+=t.substring($,i),L=2;break}else L=6;i++}return se}function Q(){if(c="",L=0,p=i,i>=s)return p=s,w=17;let se=t.charCodeAt(i);if(P(se)){do i++,c+=String.fromCharCode(se),se=t.charCodeAt(i);while(P(se));return w=15}if(d(se))return i++,c+=String.fromCharCode(se),se===13&&t.charCodeAt(i)===10&&(i++,c+=`
`),w=14;switch(se){case 123:return i++,w=1;case 125:return i++,w=2;case 91:return i++,w=3;case 93:return i++,w=4;case 58:return i++,w=6;case 44:return i++,w=5;case 34:return i++,c=N(),w=10;case 47:const $=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!d(t.charCodeAt(i));)i++;return c=t.substring($,i),w=12}if(t.charCodeAt(i+1)===42){i+=2;const q=s-1;let W=!1;for(;i<q;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,W=!0;break}i++}return W||(i++,L=1),c=t.substring($,i),w=13}return c+=String.fromCharCode(se),i++,w=16;case 45:if(c+=String.fromCharCode(se),i++,i===s||!v(t.charCodeAt(i)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=A(),w=11;default:for(;i<s&&J(se);)i++,se=t.charCodeAt(i);if(p!==i){switch(c=t.substring(p,i),c){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return c+=String.fromCharCode(se),i++,w=16}}function J(se){if(P(se)||d(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let se;do se=Q();while(se>=12&&se<=15);return se}return{setPosition:o,getPosition:()=>i,scan:r?ce:Q,getToken:()=>w,getTokenValue:()=>c,getTokenOffset:()=>p,getTokenLength:()=>i-p,getTokenError:()=>L}}e.createScanner=_;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function k(t,r){const i=[],s=new Object;let c;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function L(F,o,A,N){p.value=F,p.offset=o,p.length=A,p.type=N,p.colonOffset=void 0,c=p}try{h(t,{onObjectBegin:(F,o)=>{if(r<=F)throw s;c=void 0,w=r>F,i.push("")},onObjectProperty:(F,o,A)=>{if(r<o||(L(F,o,A,"property"),i[i.length-1]=F,r<=o+A))throw s},onObjectEnd:(F,o)=>{if(r<=F)throw s;c=void 0,i.pop()},onArrayBegin:(F,o)=>{if(r<=F)throw s;c=void 0,i.push(0)},onArrayEnd:(F,o)=>{if(r<=F)throw s;c=void 0,i.pop()},onLiteralValue:(F,o,A)=>{if(r<o||(L(F,o,A,l(F)),r<=o+A))throw s},onSeparator:(F,o,A)=>{if(r<=o)throw s;if(F===":"&&c&&c.type==="property")c.colonOffset=o,w=!1,c=void 0;else if(F===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(w=!0,i[i.length-1]=""),c=void 0}}})}catch(F){if(F!==s)throw F}return{path:i,previousNode:c,isAtPropertyKey:w,matches:F=>{let o=0;for(let A=0;o<F.length&&A<i.length;A++)if(F[o]===i[A]||F[o]==="*")o++;else if(F[o]!=="**")return!1;return o===F.length}}}e.getLocation=k;function b(t,r=[],i=C.DEFAULT){let s=null,c=[];const p=[];function w(F){Array.isArray(c)?c.push(F):s!==null&&(c[s]=F)}return h(t,{onObjectBegin:()=>{const F={};w(F),p.push(c),c=F,s=null},onObjectProperty:F=>{s=F},onObjectEnd:()=>{c=p.pop()},onArrayBegin:()=>{const F=[];w(F),p.push(c),c=F,s=null},onArrayEnd:()=>{c=p.pop()},onLiteralValue:w,onError:(F,o,A)=>{r.push({error:F,offset:o,length:A})}},i),c[0]}e.parse=b;function m(t,r=[],i=C.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(F){s.type==="property"&&(s.length=F-s.offset,s=s.parent)}function p(F){return s.children.push(F),F}h(t,{onObjectBegin:F=>{s=p({type:"object",offset:F,length:-1,parent:s,children:[]})},onObjectProperty:(F,o,A)=>{s=p({type:"property",offset:o,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:F,offset:o,length:A,parent:s})},onObjectEnd:(F,o)=>{s.length=F+o-s.offset,s=s.parent,c(F+o)},onArrayBegin:(F,o)=>{s=p({type:"array",offset:F,length:-1,parent:s,children:[]})},onArrayEnd:(F,o)=>{s.length=F+o-s.offset,s=s.parent,c(F+o)},onLiteralValue:(F,o,A)=>{p({type:l(F),offset:o,length:A,parent:s,value:F}),c(o+A)},onSeparator:(F,o,A)=>{s.type==="property"&&(F===":"?s.colonOffset=o:F===","&&c(o))},onError:(F,o,A)=>{r.push({error:F,offset:o,length:A})}},i);const L=s.children[0];return L&&delete L.parent,L}e.parseTree=m;function u(t,r){if(!t)return;let i=t;for(let s of r)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const p of i.children)if(Array.isArray(p.children)&&p.children[0].value===s){i=p.children[1],c=!0;break}if(!c)return}else{const c=s;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=u;function f(t){if(!t.parent||!t.parent.children)return[];const r=f(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=f;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const r=Object.create(null);for(let i of t.children){const s=i.children[1];s&&(r[i.children[0].value]=S(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function E(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=E;function I(t,r,i=!1){if(E(t,r,i)){const s=t.children;if(Array.isArray(s))for(let c=0;c<s.length&&s[c].offset<=r;c++){const p=I(s[c],r,i);if(p)return p}return t}}e.findNodeAtOffset=I;function h(t,r,i=C.DEFAULT){const s=_(t,!1);function c(ee){return ee?()=>ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function p(ee){return ee?me=>ee(me,s.getTokenOffset(),s.getTokenLength()):()=>!0}const w=c(r.onObjectBegin),L=p(r.onObjectProperty),F=c(r.onObjectEnd),o=c(r.onArrayBegin),A=c(r.onArrayEnd),N=p(r.onLiteralValue),Q=p(r.onSeparator),J=c(r.onComment),ce=p(r.onError),se=i&&i.disallowComments,$=i&&i.allowTrailingComma;function q(){for(;;){const ee=s.scan();switch(s.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:se||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ee){case 12:case 13:se?W(10):J();break;case 16:W(1);break;case 15:case 14:break;default:return ee}}}function W(ee,me=[],ge=[]){if(ce(ee),me.length+ge.length>0){let be=s.getToken();for(;be!==17;){if(me.indexOf(be)!==-1){q();break}else if(ge.indexOf(be)!==-1)break;be=q()}}}function V(ee){const me=s.getTokenValue();return ee?N(me):L(me),q(),!0}function T(){switch(s.getToken()){case 11:let ee=0;try{ee=JSON.parse(s.getTokenValue()),typeof ee!="number"&&(W(2),ee=0)}catch(me){W(2)}N(ee);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return q(),!0}function R(){return s.getToken()!==10?(W(3,[],[2,5]),!1):(V(!1),s.getToken()===6?(Q(":"),q(),j()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function M(){w(),q();let ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ee||W(4,[],[]),Q(","),q(),s.getToken()===2&&$)break}else ee&&W(6,[],[]);R()||W(4,[],[2,5]),ee=!0}return F(),s.getToken()!==2?W(7,[2],[]):q(),!0}function z(){o(),q();let ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ee||W(4,[],[]),Q(","),q(),s.getToken()===4&&$)break}else ee&&W(6,[],[]);j()||W(4,[],[4,5]),ee=!0}return A(),s.getToken()!==4?W(8,[4],[]):q(),!0}function j(){switch(s.getToken()){case 3:return z();case 1:return M();case 10:return V(!0);default:return T()}}return q(),s.getToken()===17?i.allowEmptyContent?!0:(W(4,[],[]),!1):j()?(s.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=h;function a(t,r){let i=_(t),s=[],c,p=0,w;do switch(w=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:p!==w&&s.push(t.substring(p,w)),r!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,r)),p=i.getPosition();break}while(c!==17);return s.join("")}e.stripComments=a;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(fe[111],he([0,1,37]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function D(d,v,n){let k,b,m,u,f;if(v){for(u=v.offset,f=u+v.length,m=u;m>0&&!P(d,m-1);)m--;let p=f;for(;p<d.length&&!P(d,p);)p++;b=d.substring(m,p),k=C(b,n)}else b=d,k=0,m=0,u=0,f=d.length;const S=_(n,d);let E=!1,I=0,h;n.insertSpaces?h=g(" ",n.tabSize||4):h="	";const a=y.createScanner(b,!1);let l=!1;function t(){return S+g(h,k+I)}function r(){let p=a.scan();for(E=!1;p===15||p===14;)E=E||p===14,p=a.scan();return l=p===16||a.getTokenError()!==0,p}const i=[];function s(p,w,L){!l&&w<f&&L>u&&d.substring(w,L)!==p&&i.push({offset:w,length:L-w,content:p})}let c=r();if(c!==17){const p=a.getTokenOffset()+m,w=g(h,k);s(w,m,p)}for(;c!==17;){let p=a.getTokenOffset()+a.getTokenLength()+m,w=r(),L="";for(;!E&&(w===12||w===13);){const o=a.getTokenOffset()+m;s(" ",p,o),p=a.getTokenOffset()+a.getTokenLength()+m,L=w===12?t():"",w=r()}if(w===2)c!==1&&(I--,L=t());else if(w===4)c!==3&&(I--,L=t());else{switch(c){case 3:case 1:I++,L=t();break;case 5:case 12:L=t();break;case 13:E?L=t():L=" ";break;case 6:L=" ";break;case 10:if(w===6){L="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?L=" ":w!==5&&w!==17&&(l=!0);break;case 16:l=!0;break}E&&(w===12||w===13)&&(L=t())}const F=a.getTokenOffset()+m;s(L,p,F),c=w}return i}e.format=D;function g(d,v){let n="";for(let k=0;k<v;k++)n+=d;return n}function C(d,v){let n=0,k=0;const b=v.tabSize||4;for(;n<d.length;){const m=d.charAt(n);if(m===" ")k++;else if(m==="	")k+=b;else break;n++}return Math.floor(k/b)}function _(d,v){for(let n=0;n<v.length;n++){const k=v.charAt(n);if(k==="\r")return n+1<v.length&&v.charAt(n+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=_;function P(d,v){return`\r
`.indexOf(d.charAt(v))!==-1}e.isEOL=P}),define(fe[112],he([0,1,37,111]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function g(v,n,k){return C(v,n,void 0,k)}e.removeProperty=g;function C(v,n,k,b,m){const u=n.slice(),f=[],S=y.parseTree(v,f);let E,I;for(;u.length>0&&(I=u.pop(),E=y.findNodeAtLocation(S,u),E===void 0&&k!==void 0);)typeof I=="string"?k={[I]:k}:k=[k];if(E)if(E.type==="object"&&typeof I=="string"&&Array.isArray(E.children)){const h=y.findNodeAtLocation(E,[I]);if(h!==void 0)if(k===void 0){if(!h.parent)throw new Error("Malformed AST");const a=E.children.indexOf(h.parent);let l,t=h.parent.offset+h.parent.length;if(a>0){const r=E.children[a-1];l=r.offset+r.length}else l=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return _(v,{offset:l,length:t-l,content:""},b)}else return _(v,{offset:h.offset,length:h.length,content:JSON.stringify(k)},b);else{if(k===void 0)return[];const a=`${JSON.stringify(I)}: ${JSON.stringify(k)}`,l=m?m(E.children.map(r=>r.children[0].value)):E.children.length;let t;if(l>0){const r=E.children[l-1];t={offset:r.offset+r.length,length:0,content:","+a}}else E.children.length===0?t={offset:E.offset+1,length:0,content:a}:t={offset:E.offset+1,length:0,content:a+","};return _(v,t,b)}}else if(E.type==="array"&&typeof I=="number"&&Array.isArray(E.children))if(k!==void 0){const h=`${JSON.stringify(k)}`;let a;if(E.children.length===0||I===0)a={offset:E.offset+1,length:0,content:E.children.length===0?h:h+","};else{const l=I===-1||I>E.children.length?E.children.length:I,t=E.children[l-1];a={offset:t.offset+t.length,length:0,content:","+h}}return _(v,a,b)}else{const h=I,a=E.children[h];let l;if(E.children.length===1)l={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===h){const t=E.children[h-1],r=t.offset+t.length,i=E.offset+E.length;l={offset:r,length:i-2-r,content:""}}else l={offset:a.offset,length:E.children[h+1].offset-a.offset,content:""};return _(v,l,b)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${E.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return _(v,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(k)},b)}}e.setProperty=C;function _(v,n,k){let b=P(v,n),m=n.offset,u=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;m>0&&!D.isEOL(b,m-1);)m--;for(;u<b.length&&!D.isEOL(b,u);)u++}const f=D.format(b,{offset:m,length:u-m},k);for(let E=f.length-1;E>=0;E--){const I=f[E];b=P(b,I),m=Math.min(m,I.offset),u=Math.max(u,I.offset+I.length),u+=I.content.length-I.length}const S=v.length-(b.length-u)-m;return[{offset:m,length:S,content:b.substring(m,u)}]}e.withFormatting=_;function P(v,n){return v.substring(0,n.offset)+n.content+v.substring(n.offset+n.length)}e.applyEdit=P;function d(v,n){let k=n.slice(0).sort((m,u)=>{const f=m.offset-u.offset;return f===0?m.length-u.length:f}),b=v.length;for(let m=k.length-1;m>=0;m--){let u=k[m];if(u.offset+u.length<=b)v=P(v,u);else throw new Error("Overlapping edit");b=u.offset}return v}e.applyEdits=d}),define(fe[3],he([0,1,72,51]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const g=!1;let C=null;function _(a){C=a}if(e.setDisposableTracker=_,g){const a="__is_disposable_tracked__";C=new class{trackDisposable(l){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[a]||console.log(t)},3e3)}markTracked(l){if(l&&l!==f.None)try{l[a]=!0}catch{}}}}function P(a){!C||C.markTracked(a)}function d(a){return C&&C.trackDisposable(a),a}e.trackDisposable=d;class v extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=v;function n(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=n;function k(a){if(D.Iterable.is(a)){let l=[];for(const t of a)if(t){P(t);try{t.dispose()}catch(r){l.push(r)}}if(l.length===1)throw l[0];if(l.length>1)throw new v(l);return Array.isArray(a)?[]:a}else if(a)return P(a),a.dispose(),a}e.dispose=k;function b(...a){return a.forEach(P),m(()=>k(a))}e.combinedDisposable=b;function m(a){const l=d({dispose:()=>{P(l),a()}});return l}e.toDisposable=m;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return P(l),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new u,d(this)}dispose(){P(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,d(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&P(l),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}}e.MutableDisposable=S;class E{constructor(){this.references=new Map}acquire(l,...t){let r=this.references.get(l);r||(r={counter:0,object:this.createReferencedObject(l,...t)},this.references.set(l,r));const{object:i}=r,s=y.once(()=>{--r.counter==0&&(this.destroyReferencedObject(l,r.object),this.references.delete(l))});return r.counter++,{object:i,dispose:s}}}e.ReferenceCollection=E;class I{constructor(l){this.referenceCollection=l}async acquire(l,...t){const r=this.referenceCollection.acquire(l,...t);try{return{object:await r.object,dispose:()=>r.dispose()}}catch(i){throw r.dispose(),i}}}e.AsyncReferenceCollection=I;class h{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=h}),define(fe[113],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(C){this.element=C,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class D{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let C=this._first;for(;C!==y.Undefined;){const _=C.next;C.prev=y.Undefined,C.next=y.Undefined,C=_}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,_){const P=new y(C);if(this._first===y.Undefined)this._first=P,this._last=P;else if(_){const v=this._last;this._last=P,P.prev=v,v.next=P}else{const v=this._first;this._first=P,P.next=v,v.prev=P}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(P))}}shift(){if(this._first!==y.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==y.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==y.Undefined&&C.next!==y.Undefined){const _=C.prev;_.next=C.next,C.next.prev=_}else C.prev===y.Undefined&&C.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):C.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):C.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==y.Undefined;)yield C.element,C=C.next}}e.LinkedList=D}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(ue,pe){for(var ve=0;ve<pe.length;ve++){var G=pe[ve];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ue,G.key,G)}}function e(ue,pe,ve){return pe&&X(ue.prototype,pe),ve&&X(ue,ve),ue}function y(ue,pe){if(!!ue){if(typeof ue=="string")return D(ue,pe);var ve=Object.prototype.toString.call(ue).slice(8,-1);if(ve==="Object"&&ue.constructor&&(ve=ue.constructor.name),ve==="Map"||ve==="Set")return Array.from(ue);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return D(ue,pe)}}function D(ue,pe){(pe==null||pe>ue.length)&&(pe=ue.length);for(var ve=0,G=new Array(pe);ve<pe;ve++)G[ve]=ue[ve];return G}function g(ue,pe){var ve;if(typeof Symbol=="undefined"||ue[Symbol.iterator]==null){if(Array.isArray(ue)||(ve=y(ue))||pe&&ue&&typeof ue.length=="number"){ve&&(ue=ve);var G=0;return function(){return G>=ue.length?{done:!0}:{done:!1,value:ue[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ve=ue[Symbol.iterator](),ve.next.bind(ve)}function C(ue){var pe={exports:{}};return ue(pe,pe.exports),pe.exports}var _=C(function(ue){function pe(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ve(G){ue.exports.defaults=G}ue.exports={defaults:pe(),getDefaults:pe,changeDefaults:ve}}),P=/[&<>"']/,d=/[&<>"']/g,v=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(pe){return k[pe]};function m(ue,pe){if(pe){if(P.test(ue))return ue.replace(d,b)}else if(v.test(ue))return ue.replace(n,b);return ue}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ue){return ue.replace(u,function(pe,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var S=/(^|[^\[])\^/g;function E(ue,pe){ue=ue.source||ue,pe=pe||"";var ve={replace:function(Y,te){return te=te.source||te,te=te.replace(S,"$1"),ue=ue.replace(Y,te),ve},getRegex:function(){return new RegExp(ue,pe)}};return ve}var I=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(ue,pe,ve){if(ue){var G;try{G=decodeURIComponent(f(ve)).replace(I,"").toLowerCase()}catch(Y){return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}pe&&!h.test(ve)&&(ve=s(pe,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch(Y){return null}return ve}var l={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ue,pe){l[" "+ue]||(t.test(ue)?l[" "+ue]=ue+"/":l[" "+ue]=L(ue,"/",!0)),ue=l[" "+ue];var ve=ue.indexOf(":")===-1;return pe.substring(0,2)==="//"?ve?pe:ue.replace(r,"$1")+pe:pe.charAt(0)==="/"?ve?pe:ue.replace(i,"$1")+pe:ue+pe}var c={exec:function(){}};function p(ue){for(var pe=1,ve,G;pe<arguments.length;pe++){ve=arguments[pe];for(G in ve)Object.prototype.hasOwnProperty.call(ve,G)&&(ue[G]=ve[G])}return ue}function w(ue,pe){var ve=ue.replace(/\|/g,function(te,oe,B){for(var ie=!1,ae=oe;--ae>=0&&B[ae]==="\\";)ie=!ie;return ie?"|":" |"}),G=ve.split(/ \|/),Y=0;if(G.length>pe)G.splice(pe);else for(;G.length<pe;)G.push("");for(;Y<G.length;Y++)G[Y]=G[Y].trim().replace(/\\\|/g,"|");return G}function L(ue,pe,ve){var G=ue.length;if(G===0)return"";for(var Y=0;Y<G;){var te=ue.charAt(G-Y-1);if(te===pe&&!ve)Y++;else if(te!==pe&&ve)Y++;else break}return ue.substr(0,G-Y)}function F(ue,pe){if(ue.indexOf(pe[1])===-1)return-1;for(var ve=ue.length,G=0,Y=0;Y<ve;Y++)if(ue[Y]==="\\")Y++;else if(ue[Y]===pe[0])G++;else if(ue[Y]===pe[1]&&(G--,G<0))return Y;return-1}function o(ue){ue&&ue.sanitize&&!ue.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(ue,pe){if(pe<1)return"";for(var ve="";pe>1;)pe&1&&(ve+=ue),pe>>=1,ue+=ue;return ve+ue}var N={escape:m,unescape:f,edit:E,cleanUrl:a,resolveUrl:s,noopTest:c,merge:p,splitCells:w,rtrim:L,findClosingBracket:F,checkSanitizeDeprecation:o,repeatString:A},Q=_.defaults,J=N.rtrim,ce=N.splitCells,se=N.escape,$=N.findClosingBracket;function q(ue,pe,ve){var G=pe.href,Y=pe.title?se(pe.title):null,te=ue[1].replace(/\\([\[\]])/g,"$1");return ue[0].charAt(0)!=="!"?{type:"link",raw:ve,href:G,title:Y,text:te}:{type:"image",raw:ve,href:G,title:Y,text:se(te)}}function W(ue,pe){var ve=ue.match(/^(\s+)(?:```)/);if(ve===null)return pe;var G=ve[1];return pe.split(`
`).map(function(Y){var te=Y.match(/^\s+/);if(te===null)return Y;var oe=te[0];return oe.length>=G.length?Y.slice(G.length):Y}).join(`
`)}var V=function(){function ue(ve){this.options=ve||Q}var pe=ue.prototype;return pe.space=function(G){var Y=this.rules.block.newline.exec(G);if(Y)return Y[0].length>1?{type:"space",raw:Y[0]}:{raw:`
`}},pe.code=function(G){var Y=this.rules.block.code.exec(G);if(Y){var te=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?te:J(te,`
`)}}},pe.fences=function(G){var Y=this.rules.block.fences.exec(G);if(Y){var te=Y[0],oe=W(te,Y[3]||"");return{type:"code",raw:te,lang:Y[2]?Y[2].trim():Y[2],text:oe}}},pe.heading=function(G){var Y=this.rules.block.heading.exec(G);if(Y){var te=Y[2].trim();if(/#$/.test(te)){var oe=J(te,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(te=oe.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:te}}},pe.nptable=function(G){var Y=this.rules.block.nptable.exec(G);if(Y){var te={type:"table",header:ce(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[],raw:Y[0]};if(te.header.length===te.align.length){var oe=te.align.length,B;for(B=0;B<oe;B++)/^ *-+: *$/.test(te.align[B])?te.align[B]="right":/^ *:-+: *$/.test(te.align[B])?te.align[B]="center":/^ *:-+ *$/.test(te.align[B])?te.align[B]="left":te.align[B]=null;for(oe=te.cells.length,B=0;B<oe;B++)te.cells[B]=ce(te.cells[B],te.header.length);return te}}},pe.hr=function(G){var Y=this.rules.block.hr.exec(G);if(Y)return{type:"hr",raw:Y[0]}},pe.blockquote=function(G){var Y=this.rules.block.blockquote.exec(G);if(Y){var te=Y[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Y[0],text:te}}},pe.list=function(G){var Y=this.rules.block.list.exec(G);if(Y){var te=Y[0],oe=Y[2],B=oe.length>1,ie={type:"list",raw:te,ordered:B,start:B?+oe.slice(0,-1):"",loose:!1,items:[]},ae=Y[0].match(this.rules.block.item),de=!1,Z,ye,ke,Le,Oe,He,xe,re,le=ae.length;ke=this.rules.block.listItemStart.exec(ae[0]);for(var K=0;K<le;K++){if(Z=ae[K],te=Z,K!==le-1){if(Le=this.rules.block.listItemStart.exec(ae[K+1]),this.options.pedantic?Le[1].length>ke[1].length:Le[1].length>ke[0].length||Le[1].length>3){ae.splice(K,2,ae[K]+`
`+ae[K+1]),K--,le--;continue}else(!this.options.pedantic||this.options.smartLists?Le[2][Le[2].length-1]!==oe[oe.length-1]:B===(Le[2].length===1))&&(Oe=ae.slice(K+1).join(`
`),ie.raw=ie.raw.substring(0,ie.raw.length-Oe.length),K=le-1);ke=Le}ye=Z.length,Z=Z.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Z.indexOf(`
 `)&&(ye-=Z.length,Z=this.options.pedantic?Z.replace(/^ {1,4}/gm,""):Z.replace(new RegExp("^ {1,"+ye+"}","gm"),"")),He=de||/\n\n(?!\s*$)/.test(Z),K!==le-1&&(de=Z.charAt(Z.length-1)===`
`,He||(He=de)),He&&(ie.loose=!0),this.options.gfm&&(xe=/^\[[ xX]\] /.test(Z),re=void 0,xe&&(re=Z[1]!==" ",Z=Z.replace(/^\[[ xX]\] +/,""))),ie.items.push({type:"list_item",raw:te,task:xe,checked:re,loose:He,text:Z})}return ie}},pe.html=function(G){var Y=this.rules.block.html.exec(G);if(Y)return{type:this.options.sanitize?"paragraph":"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):se(Y[0]):Y[0]}},pe.def=function(G){var Y=this.rules.block.def.exec(G);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var te=Y[1].toLowerCase().replace(/\s+/g," ");return{tag:te,raw:Y[0],href:Y[2],title:Y[3]}}},pe.table=function(G){var Y=this.rules.block.table.exec(G);if(Y){var te={type:"table",header:ce(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=Y[0];var oe=te.align.length,B;for(B=0;B<oe;B++)/^ *-+: *$/.test(te.align[B])?te.align[B]="right":/^ *:-+: *$/.test(te.align[B])?te.align[B]="center":/^ *:-+ *$/.test(te.align[B])?te.align[B]="left":te.align[B]=null;for(oe=te.cells.length,B=0;B<oe;B++)te.cells[B]=ce(te.cells[B].replace(/^ *\| *| *\| *$/g,""),te.header.length);return te}}},pe.lheading=function(G){var Y=this.rules.block.lheading.exec(G);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1]}},pe.paragraph=function(G){var Y=this.rules.block.paragraph.exec(G);if(Y)return{type:"paragraph",raw:Y[0],text:Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1]}},pe.text=function(G){var Y=this.rules.block.text.exec(G);if(Y)return{type:"text",raw:Y[0],text:Y[0]}},pe.escape=function(G){var Y=this.rules.inline.escape.exec(G);if(Y)return{type:"escape",raw:Y[0],text:se(Y[1])}},pe.tag=function(G,Y,te){var oe=this.rules.inline.tag.exec(G);if(oe)return!Y&&/^<a /i.test(oe[0])?Y=!0:Y&&/^<\/a>/i.test(oe[0])&&(Y=!1),!te&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?te=!0:te&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(te=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:Y,inRawBlock:te,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):se(oe[0]):oe[0]}},pe.link=function(G){var Y=this.rules.inline.link.exec(G);if(Y){var te=Y[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var oe=J(te.slice(0,-1),"\\");if((te.length-oe.length)%2==0)return}else{var B=$(Y[2],"()");if(B>-1){var ie=Y[0].indexOf("!")===0?5:4,ae=ie+Y[1].length+B;Y[2]=Y[2].substring(0,B),Y[0]=Y[0].substring(0,ae).trim(),Y[3]=""}}var de=Y[2],Z="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);ye&&(de=ye[1],Z=ye[3])}else Z=Y[3]?Y[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(te)?de=de.slice(1):de=de.slice(1,-1)),q(Y,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:Z&&Z.replace(this.rules.inline._escapes,"$1")},Y[0])}},pe.reflink=function(G,Y){var te;if((te=this.rules.inline.reflink.exec(G))||(te=this.rules.inline.nolink.exec(G))){var oe=(te[2]||te[1]).replace(/\s+/g," ");if(oe=Y[oe.toLowerCase()],!oe||!oe.href){var B=te[0].charAt(0);return{type:"text",raw:B,text:B}}return q(te,oe,te[0])}},pe.emStrong=function(G,Y,te){te===void 0&&(te="");var oe=this.rules.inline.emStrong.lDelim.exec(G);if(!!oe&&!(oe[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=oe[1]||oe[2]||"";if(!B||B&&(te===""||this.rules.inline.punctuation.exec(te))){var ie=oe[0].length-1,ae,de,Z=ie,ye=0,ke=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ke.lastIndex=0,Y=Y.slice(-1*G.length+ie);(oe=ke.exec(Y))!=null;)if(ae=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!ae){if(de=ae.length,oe[3]||oe[4]){Z+=de;continue}else if((oe[5]||oe[6])&&ie%3&&!((ie+de)%3)){ye+=de;continue}if(Z-=de,!(Z>0)){if(Z+ye-de<=0&&!Y.slice(ke.lastIndex).match(ke)&&(de=Math.min(de,de+Z+ye)),Math.min(ie,de)%2)return{type:"em",raw:G.slice(0,ie+oe.index+de+1),text:G.slice(1,ie+oe.index+de)};if(Math.min(ie,de)%2==0)return{type:"strong",raw:G.slice(0,ie+oe.index+de+1),text:G.slice(2,ie+oe.index+de-1)}}}}}},pe.codespan=function(G){var Y=this.rules.inline.code.exec(G);if(Y){var te=Y[2].replace(/\n/g," "),oe=/[^ ]/.test(te),B=/^ /.test(te)&&/ $/.test(te);return oe&&B&&(te=te.substring(1,te.length-1)),te=se(te,!0),{type:"codespan",raw:Y[0],text:te}}},pe.br=function(G){var Y=this.rules.inline.br.exec(G);if(Y)return{type:"br",raw:Y[0]}},pe.del=function(G){var Y=this.rules.inline.del.exec(G);if(Y)return{type:"del",raw:Y[0],text:Y[2]}},pe.autolink=function(G,Y){var te=this.rules.inline.autolink.exec(G);if(te){var oe,B;return te[2]==="@"?(oe=se(this.options.mangle?Y(te[1]):te[1]),B="mailto:"+oe):(oe=se(te[1]),B=oe),{type:"link",raw:te[0],text:oe,href:B,tokens:[{type:"text",raw:oe,text:oe}]}}},pe.url=function(G,Y){var te;if(te=this.rules.inline.url.exec(G)){var oe,B;if(te[2]==="@")oe=se(this.options.mangle?Y(te[0]):te[0]),B="mailto:"+oe;else{var ie;do ie=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(ie!==te[0]);oe=se(te[0]),te[1]==="www."?B="http://"+oe:B=oe}return{type:"link",raw:te[0],text:oe,href:B,tokens:[{type:"text",raw:oe,text:oe}]}}},pe.inlineText=function(G,Y,te){var oe=this.rules.inline.text.exec(G);if(oe){var B;return Y?B=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):se(oe[0]):oe[0]:B=se(this.options.smartypants?te(oe[0]):oe[0]),{type:"text",raw:oe[0],text:B}}},ue}(),T=N.noopTest,R=N.edit,M=N.merge,z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:T,table:T,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=R(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,z.item=R(z.item,"gm").replace(/bull/g,z.bullet).getRegex(),z.listItemStart=R(/^( *)(bull)/).replace("bull",z.bullet).getRegex(),z.list=R(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=R(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=R(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.blockquote=R(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=M({},z),z.gfm=M({},z.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.nptable=R(z.gfm.nptable).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.gfm.table=R(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.pedantic=M({},z.normal,{html:R(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:T,paragraph:R(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:T,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:T,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=R(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=R(z._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=R(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=R(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=R(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=R(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=R(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=R(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=R(j.reflink).replace("label",j._label).getRegex(),j.reflinkSearch=R(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=M({},j),j.pedantic=M({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:R(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:R(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=M({},j.normal,{escape:R(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),j.gfm.url=R(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=M({},j.gfm,{br:R(j.br).replace("{2,}","*").getRegex(),text:R(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ee={block:z,inline:j},me=_.defaults,ge=ee.block,be=ee.inline,Ie=N.repeatString;function Ae(ue){return ue.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Fe(ue){var pe="",ve,G,Y=ue.length;for(ve=0;ve<Y;ve++)G=ue.charCodeAt(ve),Math.random()>.5&&(G="x"+G.toString(16)),pe+="&#"+G+";";return pe}var $e=function(){function ue(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||me,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var G={block:ge.normal,inline:be.normal};this.options.pedantic?(G.block=ge.pedantic,G.inline=be.pedantic):this.options.gfm&&(G.block=ge.gfm,this.options.breaks?G.inline=be.breaks:G.inline=be.gfm),this.tokenizer.rules=G}ue.lex=function(G,Y){var te=new ue(Y);return te.lex(G)},ue.lexInline=function(G,Y){var te=new ue(Y);return te.inlineTokens(G)};var pe=ue.prototype;return pe.lex=function(G){return G=G.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(G,this.tokens,!0),this.inline(this.tokens),this.tokens},pe.blockTokens=function(G,Y,te){Y===void 0&&(Y=[]),te===void 0&&(te=!0),this.options.pedantic&&(G=G.replace(/^ +$/gm,""));for(var oe,B,ie,ae;G;){if(oe=this.tokenizer.space(G)){G=G.substring(oe.raw.length),oe.type&&Y.push(oe);continue}if(oe=this.tokenizer.code(G)){G=G.substring(oe.raw.length),ae=Y[Y.length-1],ae&&ae.type==="paragraph"?(ae.raw+=`
`+oe.raw,ae.text+=`
`+oe.text):Y.push(oe);continue}if(oe=this.tokenizer.fences(G)){G=G.substring(oe.raw.length),Y.push(oe);continue}if(oe=this.tokenizer.heading(G)){G=G.substring(oe.raw.length),Y.push(oe);continue}if(oe=this.tokenizer.nptable(G)){G=G.substring(oe.raw.length),Y.push(oe);continue}if(oe=this.tokenizer.hr(G)){G=G.substring(oe.raw.length),Y.push(oe);continue}if(oe=this.tokenizer.blockquote(G)){G=G.substring(oe.raw.length),oe.tokens=this.blockTokens(oe.text,[],te),Y.push(oe);continue}if(oe=this.tokenizer.list(G)){for(G=G.substring(oe.raw.length),ie=oe.items.length,B=0;B<ie;B++)oe.items[B].tokens=this.blockTokens(oe.items[B].text,[],!1);Y.push(oe);continue}if(oe=this.tokenizer.html(G)){G=G.substring(oe.raw.length),Y.push(oe);continue}if(te&&(oe=this.tokenizer.def(G))){G=G.substring(oe.raw.length),this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(G)){G=G.substring(oe.raw.length),Y.push(oe);continue}if(oe=this.tokenizer.lheading(G)){G=G.substring(oe.raw.length),Y.push(oe);continue}if(te&&(oe=this.tokenizer.paragraph(G))){G=G.substring(oe.raw.length),Y.push(oe);continue}if(oe=this.tokenizer.text(G)){G=G.substring(oe.raw.length),ae=Y[Y.length-1],ae&&ae.type==="text"?(ae.raw+=`
`+oe.raw,ae.text+=`
`+oe.text):Y.push(oe);continue}if(G){var de="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return Y},pe.inline=function(G){var Y,te,oe,B,ie,ae,de=G.length;for(Y=0;Y<de;Y++)switch(ae=G[Y],ae.type){case"paragraph":case"text":case"heading":{ae.tokens=[],this.inlineTokens(ae.text,ae.tokens);break}case"table":{for(ae.tokens={header:[],cells:[]},B=ae.header.length,te=0;te<B;te++)ae.tokens.header[te]=[],this.inlineTokens(ae.header[te],ae.tokens.header[te]);for(B=ae.cells.length,te=0;te<B;te++)for(ie=ae.cells[te],ae.tokens.cells[te]=[],oe=0;oe<ie.length;oe++)ae.tokens.cells[te][oe]=[],this.inlineTokens(ie[oe],ae.tokens.cells[te][oe]);break}case"blockquote":{this.inline(ae.tokens);break}case"list":{for(B=ae.items.length,te=0;te<B;te++)this.inline(ae.items[te].tokens);break}}return G},pe.inlineTokens=function(G,Y,te,oe){Y===void 0&&(Y=[]),te===void 0&&(te=!1),oe===void 0&&(oe=!1);var B,ie,ae=G,de,Z,ye;if(this.tokens.links){var ke=Object.keys(this.tokens.links);if(ke.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(ae))!=null;)ke.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(ae=ae.slice(0,de.index)+"["+Ie("a",de[0].length-2)+"]"+ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(ae))!=null;)ae=ae.slice(0,de.index)+"["+Ie("a",de[0].length-2)+"]"+ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(ae))!=null;)ae=ae.slice(0,de.index)+"++"+ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;){if(Z||(ye=""),Z=!1,B=this.tokenizer.escape(G)){G=G.substring(B.raw.length),Y.push(B);continue}if(B=this.tokenizer.tag(G,te,oe)){G=G.substring(B.raw.length),te=B.inLink,oe=B.inRawBlock;var Le=Y[Y.length-1];Le&&B.type==="text"&&Le.type==="text"?(Le.raw+=B.raw,Le.text+=B.text):Y.push(B);continue}if(B=this.tokenizer.link(G)){G=G.substring(B.raw.length),B.type==="link"&&(B.tokens=this.inlineTokens(B.text,[],!0,oe)),Y.push(B);continue}if(B=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(B.raw.length);var Oe=Y[Y.length-1];B.type==="link"?(B.tokens=this.inlineTokens(B.text,[],!0,oe),Y.push(B)):Oe&&B.type==="text"&&Oe.type==="text"?(Oe.raw+=B.raw,Oe.text+=B.text):Y.push(B);continue}if(B=this.tokenizer.emStrong(G,ae,ye)){G=G.substring(B.raw.length),B.tokens=this.inlineTokens(B.text,[],te,oe),Y.push(B);continue}if(B=this.tokenizer.codespan(G)){G=G.substring(B.raw.length),Y.push(B);continue}if(B=this.tokenizer.br(G)){G=G.substring(B.raw.length),Y.push(B);continue}if(B=this.tokenizer.del(G)){G=G.substring(B.raw.length),B.tokens=this.inlineTokens(B.text,[],te,oe),Y.push(B);continue}if(B=this.tokenizer.autolink(G,Fe)){G=G.substring(B.raw.length),Y.push(B);continue}if(!te&&(B=this.tokenizer.url(G,Fe))){G=G.substring(B.raw.length),Y.push(B);continue}if(B=this.tokenizer.inlineText(G,oe,Ae)){G=G.substring(B.raw.length),B.raw.slice(-1)!=="_"&&(ye=B.raw.slice(-1)),Z=!0,ie=Y[Y.length-1],ie&&ie.type==="text"?(ie.raw+=B.raw,ie.text+=B.text):Y.push(B);continue}if(G){var He="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return Y},e(ue,null,[{key:"rules",get:function(){return{block:ge,inline:be}}}]),ue}(),Qe=_.defaults,Ze=N.cleanUrl,tt=N.escape,nt=function(){function ue(ve){this.options=ve||Qe}var pe=ue.prototype;return pe.code=function(G,Y,te){var oe=(Y||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(G,oe);B!=null&&B!==G&&(te=!0,G=B)}return G=G.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+tt(oe,!0)+'">'+(te?G:tt(G,!0))+`</code></pre>
`:"<pre><code>"+(te?G:tt(G,!0))+`</code></pre>
`},pe.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},pe.html=function(G){return G},pe.heading=function(G,Y,te,oe){return this.options.headerIds?"<h"+Y+' id="'+this.options.headerPrefix+oe.slug(te)+'">'+G+"</h"+Y+`>
`:"<h"+Y+">"+G+"</h"+Y+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(G,Y,te){var oe=Y?"ol":"ul",B=Y&&te!==1?' start="'+te+'"':"";return"<"+oe+B+`>
`+G+"</"+oe+`>
`},pe.listitem=function(G){return"<li>"+G+`</li>
`},pe.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(G){return"<p>"+G+`</p>
`},pe.table=function(G,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+Y+`</table>
`},pe.tablerow=function(G){return`<tr>
`+G+`</tr>
`},pe.tablecell=function(G,Y){var te=Y.header?"th":"td",oe=Y.align?"<"+te+' align="'+Y.align+'">':"<"+te+">";return oe+G+"</"+te+`>
`},pe.strong=function(G){return"<strong>"+G+"</strong>"},pe.em=function(G){return"<em>"+G+"</em>"},pe.codespan=function(G){return"<code>"+G+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(G){return"<del>"+G+"</del>"},pe.link=function(G,Y,te){if(G=Ze(this.options.sanitize,this.options.baseUrl,G),G===null)return te;var oe='<a href="'+tt(G)+'"';return Y&&(oe+=' title="'+Y+'"'),oe+=">"+te+"</a>",oe},pe.image=function(G,Y,te){if(G=Ze(this.options.sanitize,this.options.baseUrl,G),G===null)return te;var oe='<img src="'+G+'" alt="'+te+'"';return Y&&(oe+=' title="'+Y+'"'),oe+=this.options.xhtml?"/>":">",oe},pe.text=function(G){return G},ue}(),Ce=function(){function ue(){}var pe=ue.prototype;return pe.strong=function(G){return G},pe.em=function(G){return G},pe.codespan=function(G){return G},pe.del=function(G){return G},pe.html=function(G){return G},pe.text=function(G){return G},pe.link=function(G,Y,te){return""+te},pe.image=function(G,Y,te){return""+te},pe.br=function(){return""},ue}(),De=function(){function ue(){this.seen={}}var pe=ue.prototype;return pe.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(G,Y){var te=G,oe=0;if(this.seen.hasOwnProperty(te)){oe=this.seen[G];do oe++,te=G+"-"+oe;while(this.seen.hasOwnProperty(te))}return Y||(this.seen[G]=oe,this.seen[te]=0),te},pe.slug=function(G,Y){Y===void 0&&(Y={});var te=this.serialize(G);return this.getNextSafeSlug(te,Y.dryrun)},ue}(),_e=_.defaults,Te=N.unescape,Me=function(){function ue(ve){this.options=ve||_e,this.options.renderer=this.options.renderer||new nt,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ce,this.slugger=new De}ue.parse=function(G,Y){var te=new ue(Y);return te.parse(G)},ue.parseInline=function(G,Y){var te=new ue(Y);return te.parseInline(G)};var pe=ue.prototype;return pe.parse=function(G,Y){Y===void 0&&(Y=!0);var te="",oe,B,ie,ae,de,Z,ye,ke,Le,Oe,He,xe,re,le,K,H,Pe,Re,je=G.length;for(oe=0;oe<je;oe++)switch(Oe=G[oe],Oe.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(Oe.tokens),Oe.depth,Te(this.parseInline(Oe.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(Oe.text,Oe.lang,Oe.escaped);continue}case"table":{for(ke="",ye="",ae=Oe.header.length,B=0;B<ae;B++)ye+=this.renderer.tablecell(this.parseInline(Oe.tokens.header[B]),{header:!0,align:Oe.align[B]});for(ke+=this.renderer.tablerow(ye),Le="",ae=Oe.cells.length,B=0;B<ae;B++){for(Z=Oe.tokens.cells[B],ye="",de=Z.length,ie=0;ie<de;ie++)ye+=this.renderer.tablecell(this.parseInline(Z[ie]),{header:!1,align:Oe.align[ie]});Le+=this.renderer.tablerow(ye)}te+=this.renderer.table(ke,Le);continue}case"blockquote":{Le=this.parse(Oe.tokens),te+=this.renderer.blockquote(Le);continue}case"list":{for(He=Oe.ordered,xe=Oe.start,re=Oe.loose,ae=Oe.items.length,Le="",B=0;B<ae;B++)K=Oe.items[B],H=K.checked,Pe=K.task,le="",K.task&&(Re=this.renderer.checkbox(H),re?K.tokens.length>0&&K.tokens[0].type==="text"?(K.tokens[0].text=Re+" "+K.tokens[0].text,K.tokens[0].tokens&&K.tokens[0].tokens.length>0&&K.tokens[0].tokens[0].type==="text"&&(K.tokens[0].tokens[0].text=Re+" "+K.tokens[0].tokens[0].text)):K.tokens.unshift({type:"text",text:Re}):le+=Re),le+=this.parse(K.tokens,re),Le+=this.renderer.listitem(le,Pe,H);te+=this.renderer.list(Le,He,xe);continue}case"html":{te+=this.renderer.html(Oe.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(Oe.tokens));continue}case"text":{for(Le=Oe.tokens?this.parseInline(Oe.tokens):Oe.text;oe+1<je&&G[oe+1].type==="text";)Oe=G[++oe],Le+=`
`+(Oe.tokens?this.parseInline(Oe.tokens):Oe.text);te+=Y?this.renderer.paragraph(Le):Le;continue}default:{var Be='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}return te},pe.parseInline=function(G,Y){Y=Y||this.renderer;var te="",oe,B,ie=G.length;for(oe=0;oe<ie;oe++)switch(B=G[oe],B.type){case"escape":{te+=Y.text(B.text);break}case"html":{te+=Y.html(B.text);break}case"link":{te+=Y.link(B.href,B.title,this.parseInline(B.tokens,Y));break}case"image":{te+=Y.image(B.href,B.title,B.text);break}case"strong":{te+=Y.strong(this.parseInline(B.tokens,Y));break}case"em":{te+=Y.em(this.parseInline(B.tokens,Y));break}case"codespan":{te+=Y.codespan(B.text);break}case"br":{te+=Y.br();break}case"del":{te+=Y.del(this.parseInline(B.tokens,Y));break}case"text":{te+=Y.text(B.text);break}default:{var ae='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(ae);return}else throw new Error(ae)}}return te},ue}(),We=N.merge,qe=N.checkSanitizeDeprecation,Ge=N.escape,et=_.getDefaults,ne=_.changeDefaults,Se=_.defaults;function we(ue,pe,ve){if(typeof ue=="undefined"||ue===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");if(typeof pe=="function"&&(ve=pe,pe=null),pe=We({},we.defaults,pe||{}),qe(pe),ve){var G=pe.highlight,Y;try{Y=$e.lex(ue,pe)}catch(ie){return ve(ie)}var te=function(ae){var de;if(!ae)try{de=Me.parse(Y,pe)}catch(Z){ae=Z}return pe.highlight=G,ae?ve(ae):ve(null,de)};if(!G||G.length<3||(delete pe.highlight,!Y.length))return te();var oe=0;we.walkTokens(Y,function(ie){ie.type==="code"&&(oe++,setTimeout(function(){G(ie.text,ie.lang,function(ae,de){if(ae)return te(ae);de!=null&&de!==ie.text&&(ie.text=de,ie.escaped=!0),oe--,oe===0&&te()})},0))}),oe===0&&te();return}try{var B=$e.lex(ue,pe);return pe.walkTokens&&we.walkTokens(B,pe.walkTokens),Me.parse(B,pe)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+Ge(ie.message+"",!0)+"</pre>";throw ie}}we.options=we.setOptions=function(ue){return We(we.defaults,ue),ne(we.defaults),we},we.getDefaults=et,we.defaults=Se,we.use=function(ue){var pe=We({},ue);if(ue.renderer&&function(){var G=we.defaults.renderer||new nt,Y=function(B){var ie=G[B];G[B]=function(){for(var ae=arguments.length,de=new Array(ae),Z=0;Z<ae;Z++)de[Z]=arguments[Z];var ye=ue.renderer[B].apply(G,de);return ye===!1&&(ye=ie.apply(G,de)),ye}};for(var te in ue.renderer)Y(te);pe.renderer=G}(),ue.tokenizer&&function(){var G=we.defaults.tokenizer||new V,Y=function(B){var ie=G[B];G[B]=function(){for(var ae=arguments.length,de=new Array(ae),Z=0;Z<ae;Z++)de[Z]=arguments[Z];var ye=ue.tokenizer[B].apply(G,de);return ye===!1&&(ye=ie.apply(G,de)),ye}};for(var te in ue.tokenizer)Y(te);pe.tokenizer=G}(),ue.walkTokens){var ve=we.defaults.walkTokens;pe.walkTokens=function(G){ue.walkTokens(G),ve&&ve(G)}}we.setOptions(pe)},we.walkTokens=function(ue,pe){for(var ve=g(ue),G;!(G=ve()).done;){var Y=G.value;switch(pe(Y),Y.type){case"table":{for(var te=g(Y.tokens.header),oe;!(oe=te()).done;){var B=oe.value;we.walkTokens(B,pe)}for(var ie=g(Y.tokens.cells),ae;!(ae=ie()).done;)for(var de=ae.value,Z=g(de),ye;!(ye=Z()).done;){var ke=ye.value;we.walkTokens(ke,pe)}break}case"list":{we.walkTokens(Y.items,pe);break}default:Y.tokens&&we.walkTokens(Y.tokens,pe)}}},we.parseInline=function(ue,pe){if(typeof ue=="undefined"||ue===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");pe=We({},we.defaults,pe||{}),qe(pe);try{var ve=$e.lexInline(ue,pe);return pe.walkTokens&&we.walkTokens(ve,pe.walkTokens),Me.parseInline(ve,pe)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+Ge(G.message+"",!0)+"</pre>";throw G}},we.Parser=Me,we.parser=Me.parse,we.Renderer=nt,we.TextRenderer=Ce,we.Lexer=$e,we.lexer=$e.lex,we.Tokenizer=V,we.Slugger=De,we.parse=we;var Ue=we;return Ue}),define(fe[114],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function y(_,P,d){return Math.min(Math.max(_,P),d)}e.clamp=y;function D(_,P){return(P+_%P)%P}e.rot=D;class g{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=g;class C{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function X(g){const C=[];typeof g=="number"&&C.push("code/timeOrigin",g);function _(d){C.push(d,Date.now())}function P(){const d=[];for(let v=0;v<C.length;v+=2)d.push({name:C[v],startTime:C[v+1]});return d}return{mark:_,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const _ of performance.getEntriesByType("mark"))C.push({name:_.name,startTime:Math.round(g+_.startTime)});return C}};if(typeof process=="object"){const g=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function y(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=y(D))}(),define(fe[5],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const y="en";let D=!1,g=!1,C=!1,_=!1,P=!1,d=!1,v=!1,n,k=y,b,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const f=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=f&&u?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=u?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!f)m=navigator.userAgent,D=m.indexOf("Windows")>=0,g=m.indexOf("Macintosh")>=0,v=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=m.indexOf("Linux")>=0,d=!0,n=navigator.language,k=n;else if(typeof u=="object"){D=u.platform==="win32",g=u.platform==="darwin",C=u.platform==="linux",_=C&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=y,k=y;const i=u.env.VSCODE_NLS_CONFIG;if(i)try{const s=JSON.parse(i),c=s.availableLanguages["*"];n=s.locale,k=c||y,b=s._translationsConfigFile}catch(s){}P=!0}else console.error("Unable to resolve platform.");var S;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function E(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let I=0;g?I=1:D?I=3:C&&(I=2),e.isWindows=D,e.isMacintosh=g,e.isLinux=C,e.isLinuxSnap=_,e.isNative=P,e.isWeb=d,e.isIOS=v,e.platform=I,e.userAgent=m,e.language=k;var h;(function(i){function s(){return e.language}i.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=c;function p(){return e.language==="en"}i.isDefault=p})(h=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeSetImmediateId)for(let L=0,F=c.length;L<F;L++){const o=c[L];if(o.id===w.data.vscodeSetImmediateId){c.splice(L,1),o.callback();return}}});let p=0;return w=>{const L=++p;c.push({id:L,callback:w}),e.globals.postMessage({vscodeSetImmediateId:L},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const s=Promise.resolve();return c=>s.then(c)}();var a;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=g||v?2:D?1:3;let l=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,l=new Uint16Array(i.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=r}),define(fe[23],he([0,1,5]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let D;if(typeof y.globals.vscode!="undefined"&&typeof y.globals.vscode.process!="undefined"){const g=y.globals.vscode.process;D={get platform(){return g.platform},get env(){return g.env},cwd(){return g.cwd()},nextTick(C){return y.setImmediate(C)}}}else typeof process!="undefined"?D={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(g){return process.nextTick(g)}}:D={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},nextTick(g){return y.setImmediate(g)},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.nextTick=D.nextTick}),define(fe[4],he([0,1,23]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,g=97,C=90,_=122,P=46,d=47,v=92,n=58,k=63;class b extends Error{constructor(a,l,t){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const i=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${i} ${r} of type ${l}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function m(h,a){if(typeof h!="string")throw new b(a,"string",h)}function u(h){return h===d||h===v}function f(h){return h===d}function S(h){return h>=D&&h<=C||h>=g&&h<=_}function E(h,a,l,t){let r="",i=0,s=-1,c=0,p=0;for(let w=0;w<=h.length;++w){if(w<h.length)p=h.charCodeAt(w);else{if(t(p))break;p=d}if(t(p)){if(!(s===w-1||c===1))if(c===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const L=r.lastIndexOf(l);L===-1?(r="",i=0):(r=r.slice(0,L),i=r.length-1-r.lastIndexOf(l)),s=w,c=0;continue}else if(r.length!==0){r="",i=0,s=w,c=0;continue}}a&&(r+=r.length>0?`${l}..`:"..",i=2)}else r.length>0?r+=`${l}${h.slice(s+1,w)}`:r=h.slice(s+1,w),i=w-s-1;s=w,c=0}else p===P&&c!==-1?++c:c=-1}return r}function I(h,a){if(a===null||typeof a!="object")throw new b("pathObject","Object",a);const l=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${t}`:`${l}${h}${t}`:t}e.win32={resolve(...h){let a="",l="",t=!1;for(let r=h.length-1;r>=-1;r--){let i;if(r>=0){if(i=h[r],m(i,"path"),i.length===0)continue}else a.length===0?i=y.cwd():(i=y.env[`=${a}`]||y.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==a.toLowerCase()&&i.charCodeAt(2)===v)&&(i=`${a}\\`));const s=i.length;let c=0,p="",w=!1;const L=i.charCodeAt(0);if(s===1)u(L)&&(c=1,w=!0);else if(u(L))if(w=!0,u(i.charCodeAt(1))){let F=2,o=F;for(;F<s&&!u(i.charCodeAt(F));)F++;if(F<s&&F!==o){const A=i.slice(o,F);for(o=F;F<s&&u(i.charCodeAt(F));)F++;if(F<s&&F!==o){for(o=F;F<s&&!u(i.charCodeAt(F));)F++;(F===s||F!==o)&&(p=`\\\\${A}\\${i.slice(o,F)}`,c=F)}}}else c=1;else S(L)&&i.charCodeAt(1)===n&&(p=i.slice(0,2),c=2,s>2&&u(i.charCodeAt(2))&&(w=!0,c=3));if(p.length>0)if(a.length>0){if(p.toLowerCase()!==a.toLowerCase())continue}else a=p;if(t){if(a.length>0)break}else if(l=`${i.slice(c)}\\${l}`,t=w,w&&a.length>0)break}return l=E(l,!t,"\\",u),t?`${a}\\${l}`:`${a}${l}`||"."},normalize(h){m(h,"path");const a=h.length;if(a===0)return".";let l=0,t,r=!1;const i=h.charCodeAt(0);if(a===1)return f(i)?"\\":h;if(u(i))if(r=!0,u(h.charCodeAt(1))){let c=2,p=c;for(;c<a&&!u(h.charCodeAt(c));)c++;if(c<a&&c!==p){const w=h.slice(p,c);for(p=c;c<a&&u(h.charCodeAt(c));)c++;if(c<a&&c!==p){for(p=c;c<a&&!u(h.charCodeAt(c));)c++;if(c===a)return`\\\\${w}\\${h.slice(p)}\\`;c!==p&&(t=`\\\\${w}\\${h.slice(p,c)}`,l=c)}}}else l=1;else S(i)&&h.charCodeAt(1)===n&&(t=h.slice(0,2),l=2,a>2&&u(h.charCodeAt(2))&&(r=!0,l=3));let s=l<a?E(h.slice(l),!r,"\\",u):"";return s.length===0&&!r&&(s="."),s.length>0&&u(h.charCodeAt(a-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(h){m(h,"path");const a=h.length;if(a===0)return!1;const l=h.charCodeAt(0);return u(l)||a>2&&S(l)&&h.charCodeAt(1)===n&&u(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let a,l;for(let i=0;i<h.length;++i){const s=h[i];m(s,"path"),s.length>0&&(a===void 0?a=l=s:a+=`\\${s}`)}if(a===void 0)return".";let t=!0,r=0;if(typeof l=="string"&&u(l.charCodeAt(0))){++r;const i=l.length;i>1&&u(l.charCodeAt(1))&&(++r,i>2&&(u(l.charCodeAt(2))?++r:t=!1))}if(t){for(;r<a.length&&u(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(h,a){if(m(h,"from"),m(a,"to"),h===a)return"";const l=e.win32.resolve(h),t=e.win32.resolve(a);if(l===t||(h=l.toLowerCase(),a=t.toLowerCase(),h===a))return"";let r=0;for(;r<h.length&&h.charCodeAt(r)===v;)r++;let i=h.length;for(;i-1>r&&h.charCodeAt(i-1)===v;)i--;const s=i-r;let c=0;for(;c<a.length&&a.charCodeAt(c)===v;)c++;let p=a.length;for(;p-1>c&&a.charCodeAt(p-1)===v;)p--;const w=p-c,L=s<w?s:w;let F=-1,o=0;for(;o<L;o++){const N=h.charCodeAt(r+o);if(N!==a.charCodeAt(c+o))break;N===v&&(F=o)}if(o!==L){if(F===-1)return t}else{if(w>L){if(a.charCodeAt(c+o)===v)return t.slice(c+o+1);if(o===2)return t.slice(c+o)}s>L&&(h.charCodeAt(r+o)===v?F=o:o===2&&(F=3)),F===-1&&(F=0)}let A="";for(o=r+F+1;o<=i;++o)(o===i||h.charCodeAt(o)===v)&&(A+=A.length===0?"..":"\\..");return c+=F,A.length>0?`${A}${t.slice(c,p)}`:(t.charCodeAt(c)===v&&++c,t.slice(c,p))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const a=e.win32.resolve(h);if(a.length<=2)return h;if(a.charCodeAt(0)===v){if(a.charCodeAt(1)===v){const l=a.charCodeAt(2);if(l!==k&&l!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(S(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===v)return`\\\\?\\${a}`;return h},dirname(h){m(h,"path");const a=h.length;if(a===0)return".";let l=-1,t=0;const r=h.charCodeAt(0);if(a===1)return u(r)?h:".";if(u(r)){if(l=t=1,u(h.charCodeAt(1))){let c=2,p=c;for(;c<a&&!u(h.charCodeAt(c));)c++;if(c<a&&c!==p){for(p=c;c<a&&u(h.charCodeAt(c));)c++;if(c<a&&c!==p){for(p=c;c<a&&!u(h.charCodeAt(c));)c++;if(c===a)return h;c!==p&&(l=t=c+1)}}}}else S(r)&&h.charCodeAt(1)===n&&(l=a>2&&u(h.charCodeAt(2))?3:2,t=l);let i=-1,s=!0;for(let c=a-1;c>=t;--c)if(u(h.charCodeAt(c))){if(!s){i=c;break}}else s=!1;if(i===-1){if(l===-1)return".";i=l}return h.slice(0,i)},basename(h,a){a!==void 0&&m(a,"ext"),m(h,"path");let l=0,t=-1,r=!0,i;if(h.length>=2&&S(h.charCodeAt(0))&&h.charCodeAt(1)===n&&(l=2),a!==void 0&&a.length>0&&a.length<=h.length){if(a===h)return"";let s=a.length-1,c=-1;for(i=h.length-1;i>=l;--i){const p=h.charCodeAt(i);if(u(p)){if(!r){l=i+1;break}}else c===-1&&(r=!1,c=i+1),s>=0&&(p===a.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=c))}return l===t?t=c:t===-1&&(t=h.length),h.slice(l,t)}for(i=h.length-1;i>=l;--i)if(u(h.charCodeAt(i))){if(!r){l=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":h.slice(l,t)},extname(h){m(h,"path");let a=0,l=-1,t=0,r=-1,i=!0,s=0;h.length>=2&&h.charCodeAt(1)===n&&S(h.charCodeAt(0))&&(a=t=2);for(let c=h.length-1;c>=a;--c){const p=h.charCodeAt(c);if(u(p)){if(!i){t=c+1;break}continue}r===-1&&(i=!1,r=c+1),p===P?l===-1?l=c:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||r===-1||s===0||s===1&&l===r-1&&l===t+1?"":h.slice(l,r)},format:I.bind(null,"\\"),parse(h){m(h,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return a;const l=h.length;let t=0,r=h.charCodeAt(0);if(l===1)return u(r)?(a.root=a.dir=h,a):(a.base=a.name=h,a);if(u(r)){if(t=1,u(h.charCodeAt(1))){let F=2,o=F;for(;F<l&&!u(h.charCodeAt(F));)F++;if(F<l&&F!==o){for(o=F;F<l&&u(h.charCodeAt(F));)F++;if(F<l&&F!==o){for(o=F;F<l&&!u(h.charCodeAt(F));)F++;F===l?t=F:F!==o&&(t=F+1)}}}}else if(S(r)&&h.charCodeAt(1)===n){if(l<=2)return a.root=a.dir=h,a;if(t=2,u(h.charCodeAt(2))){if(l===3)return a.root=a.dir=h,a;t=3}}t>0&&(a.root=h.slice(0,t));let i=-1,s=t,c=-1,p=!0,w=h.length-1,L=0;for(;w>=t;--w){if(r=h.charCodeAt(w),u(r)){if(!p){s=w+1;break}continue}c===-1&&(p=!1,c=w+1),r===P?i===-1?i=w:L!==1&&(L=1):i!==-1&&(L=-1)}return c!==-1&&(i===-1||L===0||L===1&&i===c-1&&i===s+1?a.base=a.name=h.slice(s,c):(a.name=h.slice(s,i),a.base=h.slice(s,c),a.ext=h.slice(i,c))),s>0&&s!==t?a.dir=h.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let a="",l=!1;for(let t=h.length-1;t>=-1&&!l;t--){const r=t>=0?h[t]:y.cwd();m(r,"path"),r.length!==0&&(a=`${r}/${a}`,l=r.charCodeAt(0)===d)}return a=E(a,!l,"/",f),l?`/${a}`:a.length>0?a:"."},normalize(h){if(m(h,"path"),h.length===0)return".";const a=h.charCodeAt(0)===d,l=h.charCodeAt(h.length-1)===d;return h=E(h,!a,"/",f),h.length===0?a?"/":l?"./":".":(l&&(h+="/"),a?`/${h}`:h)},isAbsolute(h){return m(h,"path"),h.length>0&&h.charCodeAt(0)===d},join(...h){if(h.length===0)return".";let a;for(let l=0;l<h.length;++l){const t=h[l];m(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(h,a){if(m(h,"from"),m(a,"to"),h===a||(h=e.posix.resolve(h),a=e.posix.resolve(a),h===a))return"";const l=1,t=h.length,r=t-l,i=1,s=a.length-i,c=r<s?r:s;let p=-1,w=0;for(;w<c;w++){const F=h.charCodeAt(l+w);if(F!==a.charCodeAt(i+w))break;F===d&&(p=w)}if(w===c)if(s>c){if(a.charCodeAt(i+w)===d)return a.slice(i+w+1);if(w===0)return a.slice(i+w)}else r>c&&(h.charCodeAt(l+w)===d?p=w:w===0&&(p=0));let L="";for(w=l+p+1;w<=t;++w)(w===t||h.charCodeAt(w)===d)&&(L+=L.length===0?"..":"/..");return`${L}${a.slice(i+p)}`},toNamespacedPath(h){return h},dirname(h){if(m(h,"path"),h.length===0)return".";const a=h.charCodeAt(0)===d;let l=-1,t=!0;for(let r=h.length-1;r>=1;--r)if(h.charCodeAt(r)===d){if(!t){l=r;break}}else t=!1;return l===-1?a?"/":".":a&&l===1?"//":h.slice(0,l)},basename(h,a){a!==void 0&&m(a,"ext"),m(h,"path");let l=0,t=-1,r=!0,i;if(a!==void 0&&a.length>0&&a.length<=h.length){if(a===h)return"";let s=a.length-1,c=-1;for(i=h.length-1;i>=0;--i){const p=h.charCodeAt(i);if(p===d){if(!r){l=i+1;break}}else c===-1&&(r=!1,c=i+1),s>=0&&(p===a.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=c))}return l===t?t=c:t===-1&&(t=h.length),h.slice(l,t)}for(i=h.length-1;i>=0;--i)if(h.charCodeAt(i)===d){if(!r){l=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":h.slice(l,t)},extname(h){m(h,"path");let a=-1,l=0,t=-1,r=!0,i=0;for(let s=h.length-1;s>=0;--s){const c=h.charCodeAt(s);if(c===d){if(!r){l=s+1;break}continue}t===-1&&(r=!1,t=s+1),c===P?a===-1?a=s:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||t===-1||i===0||i===1&&a===t-1&&a===l+1?"":h.slice(a,t)},format:I.bind(null,"/"),parse(h){m(h,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return a;const l=h.charCodeAt(0)===d;let t;l?(a.root="/",t=1):t=0;let r=-1,i=0,s=-1,c=!0,p=h.length-1,w=0;for(;p>=t;--p){const L=h.charCodeAt(p);if(L===d){if(!c){i=p+1;break}continue}s===-1&&(c=!1,s=p+1),L===P?r===-1?r=p:w!==1&&(w=1):r!==-1&&(w=-1)}if(s!==-1){const L=i===0&&l?1:i;r===-1||w===0||w===1&&r===s-1&&r===i+1?a.base=a.name=h.slice(L,s):(a.name=h.slice(L,r),a.base=h.slice(L,s),a.ext=h.slice(r,s))}return i>0?a.dir=h.slice(0,i-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=y.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y.platform==="win32"?e.win32.join:e.posix.join,e.resolve=y.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=y.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=y.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=y.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=y.platform==="win32"?e.win32.extname:e.posix.extname,e.format=y.platform==="win32"?e.win32.format:e.posix.format,e.parse=y.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=y.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=y.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[115],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var y;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(y=e.Source||(e.Source={}));var D;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function g(C,..._){const P=_.reduce((n,k)=>(n[k]=!0,n),{}),d=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(n=>!P[n]).forEach(n=>{for(let k=0;k<d.length;k++)if(n.search(d[k])!==-1){delete C[n];break}})}e.sanitizeProcessEnvironment=g}),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var D in y)(typeof exports=="object"?exports:X)[D]=y[D]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function y(D){if(e[D])return e[D].exports;var g=e[D]={i:D,l:!1,exports:{}};return X[D].call(g.exports,g,g.exports,y),g.l=!0,g.exports}return y.m=X,y.c=e,y.d=function(D,g,C){y.o(D,g)||Object.defineProperty(D,g,{enumerable:!0,get:C})},y.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},y.t=function(D,g){if(1&g&&(D=y(D)),8&g||4&g&&typeof D=="object"&&D&&D.__esModule)return D;var C=Object.create(null);if(y.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:D}),2&g&&typeof D!="string")for(var _ in D)y.d(C,_,function(P){return D[P]}.bind(null,_));return C},y.n=function(D){var g=D&&D.__esModule?function(){return D.default}:function(){return D};return y.d(g,"a",g),g},y.o=function(D,g){return Object.prototype.hasOwnProperty.call(D,g)},y.p="",y(y.s=0)}([function(X,e,y){(function(D){var g;e=X.exports=ge,g=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var ne=Array.prototype.slice.call(arguments,0);ne.unshift("SEMVER"),console.log.apply(console,ne)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],d=e.src=[],v=0,n=v++;d[n]="0|[1-9]\\d*";var k=v++;d[k]="[0-9]+";var b=v++;d[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=v++;d[m]="("+d[n]+")\\.("+d[n]+")\\.("+d[n]+")";var u=v++;d[u]="("+d[k]+")\\.("+d[k]+")\\.("+d[k]+")";var f=v++;d[f]="(?:"+d[n]+"|"+d[b]+")";var S=v++;d[S]="(?:"+d[k]+"|"+d[b]+")";var E=v++;d[E]="(?:-("+d[f]+"(?:\\."+d[f]+")*))";var I=v++;d[I]="(?:-?("+d[S]+"(?:\\."+d[S]+")*))";var h=v++;d[h]="[0-9A-Za-z-]+";var a=v++;d[a]="(?:\\+("+d[h]+"(?:\\."+d[h]+")*))";var l=v++,t="v?"+d[m]+d[E]+"?"+d[a]+"?";d[l]="^"+t+"$";var r="[v=\\s]*"+d[u]+d[I]+"?"+d[a]+"?",i=v++;d[i]="^"+r+"$";var s=v++;d[s]="((?:<|>)?=?)";var c=v++;d[c]=d[k]+"|x|X|\\*";var p=v++;d[p]=d[n]+"|x|X|\\*";var w=v++;d[w]="[v=\\s]*("+d[p]+")(?:\\.("+d[p]+")(?:\\.("+d[p]+")(?:"+d[E]+")?"+d[a]+"?)?)?";var L=v++;d[L]="[v=\\s]*("+d[c]+")(?:\\.("+d[c]+")(?:\\.("+d[c]+")(?:"+d[I]+")?"+d[a]+"?)?)?";var F=v++;d[F]="^"+d[s]+"\\s*"+d[w]+"$";var o=v++;d[o]="^"+d[s]+"\\s*"+d[L]+"$";var A=v++;d[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=v++;d[N]="(?:~>?)";var Q=v++;d[Q]="(\\s*)"+d[N]+"\\s+",P[Q]=new RegExp(d[Q],"g");var J=v++;d[J]="^"+d[N]+d[w]+"$";var ce=v++;d[ce]="^"+d[N]+d[L]+"$";var se=v++;d[se]="(?:\\^)";var $=v++;d[$]="(\\s*)"+d[se]+"\\s+",P[$]=new RegExp(d[$],"g");var q=v++;d[q]="^"+d[se]+d[w]+"$";var W=v++;d[W]="^"+d[se]+d[L]+"$";var V=v++;d[V]="^"+d[s]+"\\s*("+r+")$|^$";var T=v++;d[T]="^"+d[s]+"\\s*("+t+")$|^$";var R=v++;d[R]="(\\s*)"+d[s]+"\\s*("+r+"|"+d[w]+")",P[R]=new RegExp(d[R],"g");var M=v++;d[M]="^\\s*("+d[w]+")\\s+-\\s+("+d[w]+")\\s*$";var z=v++;d[z]="^\\s*("+d[L]+")\\s+-\\s+("+d[L]+")\\s*$";var j=v++;d[j]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)g(ee,d[ee]),P[ee]||(P[ee]=new RegExp(d[ee]));function me(ne,Se){if(ne instanceof ge)return ne;if(typeof ne!="string"||ne.length>C||!(Se?P[i]:P[l]).test(ne))return null;try{return new ge(ne,Se)}catch(we){return null}}function ge(ne,Se){if(ne instanceof ge){if(ne.loose===Se)return ne;ne=ne.version}else if(typeof ne!="string")throw new TypeError("Invalid Version: "+ne);if(ne.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof ge))return new ge(ne,Se);g("SemVer",ne,Se),this.loose=Se;var we=ne.trim().match(Se?P[i]:P[l]);if(!we)throw new TypeError("Invalid Version: "+ne);if(this.raw=ne,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var ue=+Ue;if(ue>=0&&ue<_)return ue}return Ue}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=me,e.valid=function(ne,Se){var we=me(ne,Se);return we?we.version:null},e.clean=function(ne,Se){var we=me(ne.trim().replace(/^[=v]+/,""),Se);return we?we.version:null},e.SemVer=ge,ge.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ge.prototype.toString=function(){return this.version},ge.prototype.compare=function(ne){return g("SemVer.compare",this.version,this.loose,ne),ne instanceof ge||(ne=new ge(ne,this.loose)),this.compareMain(ne)||this.comparePre(ne)},ge.prototype.compareMain=function(ne){return ne instanceof ge||(ne=new ge(ne,this.loose)),Ie(this.major,ne.major)||Ie(this.minor,ne.minor)||Ie(this.patch,ne.patch)},ge.prototype.comparePre=function(ne){if(ne instanceof ge||(ne=new ge(ne,this.loose)),this.prerelease.length&&!ne.prerelease.length)return-1;if(!this.prerelease.length&&ne.prerelease.length)return 1;if(!this.prerelease.length&&!ne.prerelease.length)return 0;var Se=0;do{var we=this.prerelease[Se],Ue=ne.prerelease[Se];if(g("prerelease compare",Se,we,Ue),we===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(we===void 0)return-1;if(we!==Ue)return Ie(we,Ue)}while(++Se)},ge.prototype.inc=function(ne,Se){switch(ne){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ne)}return this.format(),this.raw=this.version,this},e.inc=function(ne,Se,we,Ue){typeof we=="string"&&(Ue=we,we=void 0);try{return new ge(ne,we).inc(Se,Ue).version}catch(ue){return null}},e.diff=function(ne,Se){if(Qe(ne,Se))return null;var we=me(ne),Ue=me(Se);if(we.prerelease.length||Ue.prerelease.length){for(var ue in we)if((ue==="major"||ue==="minor"||ue==="patch")&&we[ue]!==Ue[ue])return"pre"+ue;return"prerelease"}for(var ue in we)if((ue==="major"||ue==="minor"||ue==="patch")&&we[ue]!==Ue[ue])return ue},e.compareIdentifiers=Ie;var be=/^[0-9]+$/;function Ie(ne,Se){var we=be.test(ne),Ue=be.test(Se);return we&&Ue&&(ne=+ne,Se=+Se),we&&!Ue?-1:Ue&&!we?1:ne<Se?-1:ne>Se?1:0}function Ae(ne,Se,we){return new ge(ne,we).compare(new ge(Se,we))}function Fe(ne,Se,we){return Ae(ne,Se,we)>0}function $e(ne,Se,we){return Ae(ne,Se,we)<0}function Qe(ne,Se,we){return Ae(ne,Se,we)===0}function Ze(ne,Se,we){return Ae(ne,Se,we)!==0}function tt(ne,Se,we){return Ae(ne,Se,we)>=0}function nt(ne,Se,we){return Ae(ne,Se,we)<=0}function Ce(ne,Se,we,Ue){var ue;switch(Se){case"===":typeof ne=="object"&&(ne=ne.version),typeof we=="object"&&(we=we.version),ue=ne===we;break;case"!==":typeof ne=="object"&&(ne=ne.version),typeof we=="object"&&(we=we.version),ue=ne!==we;break;case"":case"=":case"==":ue=Qe(ne,we,Ue);break;case"!=":ue=Ze(ne,we,Ue);break;case">":ue=Fe(ne,we,Ue);break;case">=":ue=tt(ne,we,Ue);break;case"<":ue=$e(ne,we,Ue);break;case"<=":ue=nt(ne,we,Ue);break;default:throw new TypeError("Invalid operator: "+Se)}return ue}function De(ne,Se){if(ne instanceof De){if(ne.loose===Se)return ne;ne=ne.value}if(!(this instanceof De))return new De(ne,Se);g("comparator",ne,Se),this.loose=Se,this.parse(ne),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(ne,Se){return Ie(Se,ne)},e.major=function(ne,Se){return new ge(ne,Se).major},e.minor=function(ne,Se){return new ge(ne,Se).minor},e.patch=function(ne,Se){return new ge(ne,Se).patch},e.compare=Ae,e.compareLoose=function(ne,Se){return Ae(ne,Se,!0)},e.rcompare=function(ne,Se,we){return Ae(Se,ne,we)},e.sort=function(ne,Se){return ne.sort(function(we,Ue){return e.compare(we,Ue,Se)})},e.rsort=function(ne,Se){return ne.sort(function(we,Ue){return e.rcompare(we,Ue,Se)})},e.gt=Fe,e.lt=$e,e.eq=Qe,e.neq=Ze,e.gte=tt,e.lte=nt,e.cmp=Ce,e.Comparator=De;var _e={};function Te(ne,Se){if(ne instanceof Te)return ne.loose===Se?ne:new Te(ne.raw,Se);if(ne instanceof De)return new Te(ne.value,Se);if(!(this instanceof Te))return new Te(ne,Se);if(this.loose=Se,this.raw=ne,this.set=ne.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ne);this.format()}function Me(ne){return!ne||ne.toLowerCase()==="x"||ne==="*"}function We(ne,Se,we,Ue,ue,pe,ve,G,Y,te,oe,B,ie){return((Se=Me(we)?"":Me(Ue)?">="+we+".0.0":Me(ue)?">="+we+"."+Ue+".0":">="+Se)+" "+(G=Me(Y)?"":Me(te)?"<"+(+Y+1)+".0.0":Me(oe)?"<"+Y+"."+(+te+1)+".0":B?"<="+Y+"."+te+"."+oe+"-"+B:"<="+G)).trim()}function qe(ne,Se){for(var we=0;we<ne.length;we++)if(!ne[we].test(Se))return!1;if(Se.prerelease.length){for(we=0;we<ne.length;we++)if(g(ne[we].semver),ne[we].semver!==_e&&ne[we].semver.prerelease.length>0){var Ue=ne[we].semver;if(Ue.major===Se.major&&Ue.minor===Se.minor&&Ue.patch===Se.patch)return!0}return!1}return!0}function Ge(ne,Se,we){try{Se=new Te(Se,we)}catch(Ue){return!1}return Se.test(ne)}function et(ne,Se,we,Ue){var ue,pe,ve,G,Y;switch(ne=new ge(ne,Ue),Se=new Te(Se,Ue),we){case">":ue=Fe,pe=nt,ve=$e,G=">",Y=">=";break;case"<":ue=$e,pe=tt,ve=Fe,G="<",Y="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ge(ne,Se,Ue))return!1;for(var te=0;te<Se.set.length;++te){var oe=Se.set[te],B=null,ie=null;if(oe.forEach(function(ae){ae.semver===_e&&(ae=new De(">=0.0.0")),B=B||ae,ie=ie||ae,ue(ae.semver,B.semver,Ue)?B=ae:ve(ae.semver,ie.semver,Ue)&&(ie=ae)}),B.operator===G||B.operator===Y||(!ie.operator||ie.operator===G)&&pe(ne,ie.semver)||ie.operator===Y&&ve(ne,ie.semver))return!1}return!0}De.prototype.parse=function(ne){var Se=this.loose?P[V]:P[T],we=ne.match(Se);if(!we)throw new TypeError("Invalid comparator: "+ne);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new ge(we[2],this.loose):this.semver=_e},De.prototype.toString=function(){return this.value},De.prototype.test=function(ne){return g("Comparator.test",ne,this.loose),this.semver===_e||(typeof ne=="string"&&(ne=new ge(ne,this.loose)),Ce(ne,this.operator,this.semver,this.loose))},De.prototype.intersects=function(ne,Se){if(!(ne instanceof De))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new Te(ne.value,Se),Ge(this.value,we,Se);if(ne.operator==="")return we=new Te(this.value,Se),Ge(ne.semver,we,Se);var Ue=!(this.operator!==">="&&this.operator!==">"||ne.operator!==">="&&ne.operator!==">"),ue=!(this.operator!=="<="&&this.operator!=="<"||ne.operator!=="<="&&ne.operator!=="<"),pe=this.semver.version===ne.semver.version,ve=!(this.operator!==">="&&this.operator!=="<="||ne.operator!==">="&&ne.operator!=="<="),G=Ce(this.semver,"<",ne.semver,Se)&&(this.operator===">="||this.operator===">")&&(ne.operator==="<="||ne.operator==="<"),Y=Ce(this.semver,">",ne.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ne.operator===">="||ne.operator===">");return Ue||ue||pe&&ve||G||Y},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(ne){return ne.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(ne){var Se=this.loose;ne=ne.trim(),g("range",ne,Se);var we=Se?P[z]:P[M];ne=ne.replace(we,We),g("hyphen replace",ne),ne=ne.replace(P[R],"$1$2$3"),g("comparator trim",ne,P[R]),ne=(ne=(ne=ne.replace(P[Q],"$1~")).replace(P[$],"$1^")).split(/\s+/).join(" ");var Ue=Se?P[V]:P[T],ue=ne.split(" ").map(function(pe){return function(ve,G){return g("comp",ve),ve=function(Y,te){return Y.trim().split(/\s+/).map(function(oe){return function(B,ie){g("caret",B,ie);var ae=ie?P[W]:P[q];return B.replace(ae,function(de,Z,ye,ke,Le){var Oe;return g("caret",B,de,Z,ye,ke,Le),Me(Z)?Oe="":Me(ye)?Oe=">="+Z+".0.0 <"+(+Z+1)+".0.0":Me(ke)?Oe=Z==="0"?">="+Z+"."+ye+".0 <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+".0 <"+(+Z+1)+".0.0":Le?(g("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Oe=Z==="0"?ye==="0"?">="+Z+"."+ye+"."+ke+Le+" <"+Z+"."+ye+"."+(+ke+1):">="+Z+"."+ye+"."+ke+Le+" <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+"."+ke+Le+" <"+(+Z+1)+".0.0"):(g("no pr"),Oe=Z==="0"?ye==="0"?">="+Z+"."+ye+"."+ke+" <"+Z+"."+ye+"."+(+ke+1):">="+Z+"."+ye+"."+ke+" <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+"."+ke+" <"+(+Z+1)+".0.0"),g("caret return",Oe),Oe})}(oe,te)}).join(" ")}(ve,G),g("caret",ve),ve=function(Y,te){return Y.trim().split(/\s+/).map(function(oe){return function(B,ie){var ae=ie?P[ce]:P[J];return B.replace(ae,function(de,Z,ye,ke,Le){var Oe;return g("tilde",B,de,Z,ye,ke,Le),Me(Z)?Oe="":Me(ye)?Oe=">="+Z+".0.0 <"+(+Z+1)+".0.0":Me(ke)?Oe=">="+Z+"."+ye+".0 <"+Z+"."+(+ye+1)+".0":Le?(g("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Oe=">="+Z+"."+ye+"."+ke+Le+" <"+Z+"."+(+ye+1)+".0"):Oe=">="+Z+"."+ye+"."+ke+" <"+Z+"."+(+ye+1)+".0",g("tilde return",Oe),Oe})}(oe,te)}).join(" ")}(ve,G),g("tildes",ve),ve=function(Y,te){return g("replaceXRanges",Y,te),Y.split(/\s+/).map(function(oe){return function(B,ie){B=B.trim();var ae=ie?P[o]:P[F];return B.replace(ae,function(de,Z,ye,ke,Le,Oe){g("xRange",B,de,Z,ye,ke,Le,Oe);var He=Me(ye),xe=He||Me(ke),re=xe||Me(Le);return Z==="="&&re&&(Z=""),He?de=Z===">"||Z==="<"?"<0.0.0":"*":Z&&re?(xe&&(ke=0),re&&(Le=0),Z===">"?(Z=">=",xe?(ye=+ye+1,ke=0,Le=0):re&&(ke=+ke+1,Le=0)):Z==="<="&&(Z="<",xe?ye=+ye+1:ke=+ke+1),de=Z+ye+"."+ke+"."+Le):xe?de=">="+ye+".0.0 <"+(+ye+1)+".0.0":re&&(de=">="+ye+"."+ke+".0 <"+ye+"."+(+ke+1)+".0"),g("xRange return",de),de})}(oe,te)}).join(" ")}(ve,G),g("xrange",ve),ve=function(Y,te){return g("replaceStars",Y,te),Y.trim().replace(P[j],"")}(ve,G),g("stars",ve),ve}(pe,Se)}).join(" ").split(/\s+/);return this.loose&&(ue=ue.filter(function(pe){return!!pe.match(Ue)})),ue=ue.map(function(pe){return new De(pe,Se)})},Te.prototype.intersects=function(ne,Se){if(!(ne instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Ue){return ne.set.some(function(ue){return ue.every(function(pe){return Ue.intersects(pe,Se)})})})})},e.toComparators=function(ne,Se){return new Te(ne,Se).set.map(function(we){return we.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(ne){if(!ne)return!1;typeof ne=="string"&&(ne=new ge(ne,this.loose));for(var Se=0;Se<this.set.length;Se++)if(qe(this.set[Se],ne))return!0;return!1},e.satisfies=Ge,e.maxSatisfying=function(ne,Se,we){var Ue=null,ue=null;try{var pe=new Te(Se,we)}catch(ve){return null}return ne.forEach(function(ve){pe.test(ve)&&(Ue&&ue.compare(ve)!==-1||(ue=new ge(Ue=ve,we)))}),Ue},e.minSatisfying=function(ne,Se,we){var Ue=null,ue=null;try{var pe=new Te(Se,we)}catch(ve){return null}return ne.forEach(function(ve){pe.test(ve)&&(Ue&&ue.compare(ve)!==1||(ue=new ge(Ue=ve,we)))}),Ue},e.validRange=function(ne,Se){try{return new Te(ne,Se).range||"*"}catch(we){return null}},e.ltr=function(ne,Se,we){return et(ne,Se,"<",we)},e.gtr=function(ne,Se,we){return et(ne,Se,">",we)},e.outside=et,e.prerelease=function(ne,Se){var we=me(ne,Se);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(ne,Se,we){return ne=new Te(ne,we),Se=new Te(Se,we),ne.intersects(Se)},e.coerce=function(ne){if(ne instanceof ge)return ne;if(typeof ne!="string")return null;var Se=ne.match(P[A]);return Se==null?null:me((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,y(1))},function(X,e){var y,D,g=X.exports={};function C(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function P(S){if(y===setTimeout)return setTimeout(S,0);if((y===C||!y)&&setTimeout)return y=setTimeout,setTimeout(S,0);try{return y(S,0)}catch(E){try{return y.call(null,S,0)}catch(I){return y.call(this,S,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:C}catch(S){y=C}try{D=typeof clearTimeout=="function"?clearTimeout:_}catch(S){D=_}})();var d,v=[],n=!1,k=-1;function b(){n&&d&&(n=!1,d.length?v=d.concat(v):k=-1,v.length&&m())}function m(){if(!n){var S=P(b);n=!0;for(var E=v.length;E;){for(d=v,v=[];++k<E;)d&&d[k].run();k=-1,E=v.length}d=null,n=!1,function(I){if(D===clearTimeout)return clearTimeout(I);if((D===_||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(I);try{D(I)}catch(h){try{return D.call(null,I)}catch(a){return D.call(this,I)}}}(S)}}function u(S,E){this.fun=S,this.array=E}function f(){}g.nextTick=function(S){var E=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)E[I-1]=arguments[I];v.push(new u(S,E)),v.length!==1||n||P(m)},u.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=f,g.addListener=f,g.once=f,g.off=f,g.removeListener=f,g.removeAllListeners=f,g.emit=f,g.prependListener=f,g.prependOnceListener=f,g.listeners=function(S){return[]},g.binding=function(S){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(S){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(fe[116],he([0,1,5]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=y.globals.performance&&typeof y.globals.performance.now=="function";class g{constructor(_){this._highResolution=D&&_,this._startTime=this._now(),this._stopTime=-1}static create(_=!0){return new g(_)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}e.StopWatch=g}),define(fe[7],he([0,1,12,72,3,113,116]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(h){h.None=()=>g.Disposable.None;function a(se){return($,q=null,W)=>{let V=!1,T;return T=se(R=>{if(!V)return T?T.dispose():V=!0,$.call(q,R)},null,W),V&&T.dispose(),T}}h.once=a;function l(se,$){return p((q,W=null,V)=>se(T=>q.call(W,$(T)),null,V))}h.map=l;function t(se,$){return p((q,W=null,V)=>se(T=>{$(T),q.call(W,T)},null,V))}h.forEach=t;function r(se,$){return p((q,W=null,V)=>se(T=>$(T)&&q.call(W,T),null,V))}h.filter=r;function i(se){return se}h.signal=i;function s(...se){return($,q=null,W)=>g.combinedDisposable(...se.map(V=>V(T=>$.call(q,T),null,W)))}h.any=s;function c(se,$,q){let W=q;return l(se,V=>(W=$(W,V),W))}h.reduce=c;function p(se){let $;const q=new b({onFirstListenerAdd(){$=se(q.fire,q)},onLastListenerRemove(){$.dispose()}});return q.event}function w(se,$,q=100,W=!1,V){let T,R,M,z=0;const j=new b({leakWarningThreshold:V,onFirstListenerAdd(){T=se(ee=>{z++,R=$(R,ee),W&&!M&&(j.fire(R),R=void 0),clearTimeout(M),M=setTimeout(()=>{const me=R;R=void 0,M=void 0,(!W||z>1)&&j.fire(me),z=0},q)})},onLastListenerRemove(){T.dispose()}});return j.event}h.debounce=w;function L(se,$=(q,W)=>q===W){let q=!0,W;return r(se,V=>{const T=q||!$(V,W);return q=!1,W=V,T})}h.latch=L;function F(se,$){return[h.filter(se,$),h.filter(se,q=>!$(q))]}h.split=F;function o(se,$=!1,q=[]){let W=q.slice(),V=se(M=>{W?W.push(M):R.fire(M)});const T=()=>{W&&W.forEach(M=>R.fire(M)),W=null},R=new b({onFirstListenerAdd(){V||(V=se(M=>R.fire(M)))},onFirstListenerDidAdd(){W&&($?setTimeout(T):T())},onLastListenerRemove(){V&&V.dispose(),V=null}});return R.event}h.buffer=o;class A{constructor($){this.event=$}map($){return new A(l(this.event,$))}forEach($){return new A(t(this.event,$))}filter($){return new A(r(this.event,$))}reduce($,q){return new A(c(this.event,$,q))}latch(){return new A(L(this.event))}debounce($,q=100,W=!1,V){return new A(w(this.event,$,q,W,V))}on($,q,W){return this.event($,q,W)}once($,q,W){return a(this.event)($,q,W)}}function N(se){return new A(se)}h.chain=N;function Q(se,$,q=W=>W){const W=(...M)=>R.fire(q(...M)),V=()=>se.on($,W),T=()=>se.removeListener($,W),R=new b({onFirstListenerAdd:V,onLastListenerRemove:T});return R.event}h.fromNodeEventEmitter=Q;function J(se,$,q=W=>W){const W=(...M)=>R.fire(q(...M)),V=()=>se.addEventListener($,W),T=()=>se.removeEventListener($,W),R=new b({onFirstListenerAdd:V,onLastListenerRemove:T});return R.event}h.fromDOMEventEmitter=J;function ce(se){return new Promise($=>a(se)($))}h.toPromise=ce})(P=e.Event||(e.Event={}));class d{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${d._idPool++}`}start(a){this._stopWatch=new _.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let v=-1;function n(h){const a=v;return v=h,{dispose(){v=a}}}e.setGlobalLeakWarningThreshold=n;class k{constructor(a,l=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let l=v;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),l<=0||a<l)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let i,s=0;for(const[c,p]of this._stacks)(!i||s<p)&&(i=c,s=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class b{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=v>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0}get event(){return this._event||(this._event=(a,l,t)=>{this._listeners||(this._listeners=new C.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(l?[a,l]:a);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,l);const s=this._leakageMon?.check(this._listeners.size);let c;return c={dispose:()=>{s&&s(),c.dispose=b._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},t instanceof g.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[l,t]=this._deliveryQueue.shift();try{typeof l=="function"?l.call(void 0,t):l[0].call(l[1],t)}catch(r){y.onUnexpectedError(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=b,b._noop=function(){};class m extends b{async fireAsync(a,l,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,a]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),s=[],c={...i,waitUntil:p=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");t&&(p=t(p,typeof r=="function"?r:r[0])),s.push(p)}};try{typeof r=="function"?r.call(void 0,c):r[0].call(r[1],c)}catch(p){y.onUnexpectedError(p);continue}Object.freeze(s),await Promise.allSettled(s).then(p=>{for(const w of p)w.status==="rejected"&&y.onUnexpectedError(w.reason)})}}}}e.AsyncEmitter=m;class u extends b{constructor(a){super(a);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=u;class f extends u{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=f;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const l={event:a,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const t=()=>{this.hasListeners&&this.unhook(l);const r=this.events.indexOf(l);this.events.splice(r,1)};return g.toDisposable(D.once(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(l=>this.emitter.fire(l))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class E{constructor(){this.buffers=[]}wrapEvent(a){return(l,t,r)=>a(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>l.call(t,i)):l.call(t,i)},void 0,r)}bufferEvents(a){const l=[];this.buffers.push(l);const t=a();return this.buffers.pop(),l.forEach(r=>r()),t}}e.EventBufferer=E;class I{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=g.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(fe[25],he([0,1,7]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(P,d){const v=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(v)}}});var g;(function(P){function d(v){return v===P.None||v===P.Cancelled||v instanceof C?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(g=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=g.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=g.None}}e.CancellationTokenSource=_}),define(fe[41],he([0,1,7]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class D{constructor(){this._icons=new Map,this._onDidRegister=new y.Emitter}add(k){const b=this._icons.get(k.id);b?k.description?b.description=k.description:console.error(`Duplicate registration of codicon ${k.id}`):(this._icons.set(k.id,k),this._onDidRegister.fire(k))}get(k){return this._icons.get(k)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const g=new D;e.iconRegistry=g;function C(n,k){return new P(n,k)}e.registerCodicon=C;function _(n){return n?n.replace(/\$\((.*?)\)/g,(k,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=_;class P{constructor(k,b,m){this.id=k,this.definition=b,this.description=m,g.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function d(n,k){const b=["codicon","codicon-"+n];return k&&b.push("codicon-modifier-"+k),b}e.getClassNamesArray=d;var v;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const k=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function b(f){if(f instanceof P)return["codicon","codicon-"+f.id];const S=k.exec(f.id);if(!S)return b(P.error);let[,E,I]=S;const h=["codicon","codicon-"+E];return I&&h.push("codicon-modifier-"+I.substr(1)),h}n.asClassNameArray=b;function m(f){return b(f).join(" ")}n.asClassName=m;function u(f){return"."+b(f).join(".")}n.asCSSSelector=u})(v=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(fe[42],he([0,1,12,3]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function g(h){const a=h;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=g;function C(h){const a=h;return a?g(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=C;function _(h,a){return new P(h,a)}e.newWriteableStream=_;class P{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?y.onUnexpectedError(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(l);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(h,a){const l=[];let t;for(;(t=h.read())!==null;)l.push(t);return a(l)}e.consumeReadable=d;function v(h,a,l){const t=[];let r;for(;(r=h.read())!==null&&t.length<l;)t.push(r);return r===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return h.read()}}}e.peekReadable=v;function n(h,a){return new Promise((l,t)=>{const r=[];k(h,{onData:i=>{a&&r.push(i)},onError:i=>{a?t(i):l(void 0)},onEnd:()=>{l(a?a(r):void 0)}})})}e.consumeStream=n;function k(h,a){h.on("error",l=>a.onError(l)),h.on("end",()=>a.onEnd()),h.on("data",l=>a.onData(l))}e.listenStream=k;function b(h,a){return new Promise((l,t)=>{const r=new D.DisposableStore,i=[],s=w=>{if(i.push(w),i.length>a)return r.dispose(),h.pause(),l({stream:h,buffer:i,ended:!1})},c=w=>t(w),p=()=>l({stream:h,buffer:i,ended:!0});r.add(D.toDisposable(()=>h.removeListener("error",c))),h.on("error",c),r.add(D.toDisposable(()=>h.removeListener("end",p))),h.on("end",p),r.add(D.toDisposable(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=b;function m(h,a){const l=_(a);return l.end(h),l}e.toStream=m;function u(){const h=_(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=u;function f(h){let a=!1;return{read:()=>a?null:(a=!0,h)}}e.toReadable=f;function S(h,a,l){const t=_(l);return k(h,{onData:r=>t.write(a.data(r)),onError:r=>t.error(a.error?a.error(r):r),onEnd:()=>t.end()}),t}e.transform=S;function E(h,a,l){let t=!1;return{read:()=>{const r=a.read();return t?r:(t=!0,r!==null?l([h,r]):h)}}}e.prefixedReadable=E;function I(h,a,l){let t=!1;const r=_(l);return k(a,{onData:i=>t?r.write(i):(t=!0,r.write(l([h,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(h)),r.end()}}),r}e.prefixedStream=I}),define(fe[13],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function y(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=y;const D=/{(\d+)}/g;function g(B,...ie){return ie.length===0?B:B.replace(D,function(ae,de){const Z=parseInt(de,10);return isNaN(Z)||Z<0||Z>=ie.length?ae:ie[Z]})}e.format=g;const C=/{([^}]+)}/g;function _(B,ie){return B.replace(C,(ae,de)=>ie[de]??ae)}e.format2=_;function P(B){return B.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=P;function d(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=d;function v(B,ie){let ae=0;const de=ie.charCodeAt(0);for(let Z=B.length-1;Z>=0;Z--)B.charCodeAt(Z)===de&&ae++;return ae}e.count=v;function n(B,ie,ae="\u2026"){return B.length<=ie?B:`${B.substr(0,ie)}${ae}`}e.truncate=n;function k(B,ie=" "){const ae=b(B,ie);return m(ae,ie)}e.trim=k;function b(B,ie){if(!B||!ie)return B;const ae=ie.length;if(ae===0||B.length===0)return B;let de=0;for(;B.indexOf(ie,de)===de;)de=de+ae;return B.substring(de)}e.ltrim=b;function m(B,ie){if(!B||!ie)return B;const ae=ie.length,de=B.length;if(ae===0||de===0)return B;let Z=de,ye=-1;for(;ye=B.lastIndexOf(ie,Z-1),!(ye===-1||ye+ae!==Z);){if(ye===0)return"";Z=ye}return B.substring(0,Z)}e.rtrim=m;function u(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function f(B){return B.replace(/\*/g,"")}e.stripWildcards=f;function S(B,ie,ae={}){if(!B)throw new Error("Cannot create regex from empty string");ie||(B=d(B)),ae.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let de="";return ae.global&&(de+="g"),ae.matchCase||(de+="i"),ae.multiline&&(de+="m"),ae.unicode&&(de+="u"),new RegExp(B,de)}e.createRegExp=S;function E(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function I(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function h(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=h;function a(B){return B.split(/\r\n|\r|\n/)}e.splitLines=a;function l(B){for(let ie=0,ae=B.length;ie<ae;ie++){const de=B.charCodeAt(ie);if(de!==32&&de!==9)return ie}return-1}e.firstNonWhitespaceIndex=l;function t(B,ie=0,ae=B.length){for(let de=ie;de<ae;de++){const Z=B.charCodeAt(de);if(Z!==32&&Z!==9)return B.substring(ie,de)}return B.substring(ie,ae)}e.getLeadingWhitespace=t;function r(B,ie=B.length-1){for(let ae=ie;ae>=0;ae--){const de=B.charCodeAt(ae);if(de!==32&&de!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function i(B,ie){return B<ie?-1:B>ie?1:0}e.compare=i;function s(B,ie,ae=0,de=B.length,Z=0,ye=ie.length){for(;ae<de&&Z<ye;ae++,Z++){let Oe=B.charCodeAt(ae),He=ie.charCodeAt(Z);if(Oe<He)return-1;if(Oe>He)return 1}const ke=de-ae,Le=ye-Z;return ke<Le?-1:ke>Le?1:0}e.compareSubstring=s;function c(B,ie){return p(B,ie,0,B.length,0,ie.length)}e.compareIgnoreCase=c;function p(B,ie,ae=0,de=B.length,Z=0,ye=ie.length){for(;ae<de&&Z<ye;ae++,Z++){let Oe=B.charCodeAt(ae),He=ie.charCodeAt(Z);if(Oe===He)continue;const xe=Oe-He;if(!(xe===32&&L(He))&&!(xe===-32&&L(Oe)))return w(Oe)&&w(He)?xe:s(B.toLowerCase(),ie.toLowerCase(),ae,de,Z,ye)}const ke=de-ae,Le=ye-Z;return ke<Le?-1:ke>Le?1:0}e.compareSubstringIgnoreCase=p;function w(B){return B>=97&&B<=122}e.isLowerAsciiLetter=w;function L(B){return B>=65&&B<=90}e.isUpperAsciiLetter=L;function F(B){return w(B)||L(B)}function o(B,ie){return B.length===ie.length&&A(B,ie)}e.equalsIgnoreCase=o;function A(B,ie,ae=B.length){for(let de=0;de<ae;de++){const Z=B.charCodeAt(de),ye=ie.charCodeAt(de);if(Z!==ye){if(F(Z)&&F(ye)){const ke=Math.abs(Z-ye);if(ke!==0&&ke!==32)return!1}else if(String.fromCharCode(Z).toLowerCase()!==String.fromCharCode(ye).toLowerCase())return!1}}return!0}function N(B,ie){const ae=ie.length;return ie.length>B.length?!1:A(B,ie,ae)}e.startsWithIgnoreCase=N;function Q(B,ie){let ae,de=Math.min(B.length,ie.length);for(ae=0;ae<de;ae++)if(B.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return de}e.commonPrefixLength=Q;function J(B,ie){let ae,de=Math.min(B.length,ie.length);const Z=B.length-1,ye=ie.length-1;for(ae=0;ae<de;ae++)if(B.charCodeAt(Z-ae)!==ie.charCodeAt(ye-ae))return ae;return de}e.commonSuffixLength=J;function ce(B){return 55296<=B&&B<=56319}e.isHighSurrogate=ce;function se(B){return 56320<=B&&B<=57343}e.isLowSurrogate=se;function $(B,ie){return(B-55296<<10)+(ie-56320)+65536}e.computeCodePoint=$;function q(B,ie,ae){const de=B.charCodeAt(ae);if(ce(de)&&ae+1<ie){const Z=B.charCodeAt(ae+1);if(se(Z))return $(de,Z)}return de}e.getNextCodePoint=q;function W(B,ie){const ae=B.charCodeAt(ie-1);if(se(ae)&&ie>1){const de=B.charCodeAt(ie-2);if(ce(de))return $(de,ae)}return ae}function V(B,ie){const ae=ue.getInstance(),de=ie,Z=B.length,ye=q(B,Z,ie);ie+=ye>=65536?2:1;let ke=ae.getGraphemeBreakType(ye);for(;ie<Z;){const Le=q(B,Z,ie),Oe=ae.getGraphemeBreakType(Le);if(we(ke,Oe))break;ie+=Le>=65536?2:1,ke=Oe}return ie-de}e.nextCharLength=V;function T(B,ie){const ae=ue.getInstance(),de=ie,Z=W(B,ie);ie-=Z>=65536?2:1;let ye=ae.getGraphemeBreakType(Z);for(;ie>0;){const ke=W(B,ie),Le=ae.getGraphemeBreakType(ke);if(we(Le,ye))break;ie-=ke>=65536?2:1,ye=Le}return de-ie}e.prevCharLength=T;function R(B,ie){const ae=ue.getInstance(),de=B.length,Z=ie,ye=q(B,de,ie),ke=ae.getGraphemeBreakType(ye);ie+=ye>=65536?2:1;let Le=ke;for(;ie<de;){const He=q(B,de,ie),xe=ae.getGraphemeBreakType(He);if(we(Le,xe))break;ie+=He>=65536?2:1,Le=xe}const Oe=ie;for(ie=Z,Le=ke;ie>0;){const He=W(B,ie),xe=ae.getGraphemeBreakType(He);if(we(xe,Le))break;ie-=He>=65536?2:1,Le=xe}return[ie,Oe]}function M(B,ie){return ie>0&&se(B.charCodeAt(ie))?R(B,ie-1):R(B,ie)}e.getCharContainingOffset=M;function z(B){const ie=B.length;let ae=0,de=0;for(;de<ie;){const ke=q(B,ie,de);de+=ke>=65536?2:1,ke<128?ae+=1:ke<2048?ae+=2:ke<65536?ae+=3:ae+=4}const Z=new Uint8Array(ae);de=0;let ye=0;for(;de<ie;){const ke=q(B,ie,de);de+=ke>=65536?2:1,ke<128?Z[ye++]=ke:ke<2048?(Z[ye++]=192|(ke&1984)>>>6,Z[ye++]=128|(ke&63)>>>0):ke<65536?(Z[ye++]=224|(ke&61440)>>>12,Z[ye++]=128|(ke&4032)>>>6,Z[ye++]=128|(ke&63)>>>0):(Z[ye++]=240|(ke&1835008)>>>18,Z[ye++]=128|(ke&258048)>>>12,Z[ye++]=128|(ke&4032)>>>6,Z[ye++]=128|(ke&63)>>>0)}return Z}e.encodeUTF8=z;function j(B){const ie=B.byteLength,ae=[];let de=0;for(;de<ie;){const Z=B[de];let ye;if(Z>=240&&de+3<ie?ye=(B[de++]&7)<<18>>>0|(B[de++]&63)<<12>>>0|(B[de++]&63)<<6>>>0|(B[de++]&63)<<0>>>0:Z>=224&&de+2<ie?ye=(B[de++]&15)<<12>>>0|(B[de++]&63)<<6>>>0|(B[de++]&63)<<0>>>0:Z>=192&&de+1<ie?ye=(B[de++]&31)<<6>>>0|(B[de++]&63)<<0>>>0:ye=B[de++],ye>=0&&ye<=55295||ye>=57344&&ye<=65535)ae.push(String.fromCharCode(ye));else if(ye>=65536&&ye<=1114111){const ke=ye-65536,Le=55296+((ke&1047552)>>>10),Oe=56320+((ke&1023)>>>0);ae.push(String.fromCharCode(Le)),ae.push(String.fromCharCode(Oe))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=j;const ee=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function me(B){return ee.test(B)}e.containsRTL=me;const ge=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function be(B){return ge.test(B)}e.containsEmoji=be;const Ie=/^[\t\n\r\x20-\x7E]*$/;function Ae(B){return Ie.test(B)}e.isBasicASCII=Ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Fe(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=Fe;function $e(B){for(let ie=0,ae=B.length;ie<ae;ie++)if(Qe(B.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=$e;function Qe(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=Qe;function Ze(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=Ze;function tt(B,ie){if(B.length<ie)return B;const ae=/\b/g;let de=0;for(;ae.test(B)&&!(B.length-ae.lastIndex<ie);)de=ae.lastIndex,ae.lastIndex+=1;return B.substring(de).replace(/^\s/,"")}e.lcut=tt;const nt=/\x1B\x5B[12]?K/g,Ce=/\x1b\[\d+m/g,De=/\x1b\[0?m/g;function _e(B){return B&&(B=B.replace(nt,""),B=B.replace(Ce,""),B=B.replace(De,"")),B}e.removeAnsiEscapeCodes=_e,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Te(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Te;function Me(B){return Te(B)?B.substr(1):B}e.stripUTF8BOM=Me;function We(B,ie){if(!B||!ie||B.length<ie.length)return!1;const ae=ie.length,de=B.toLowerCase();let Z=0,ye=-1;for(;Z<ae;){const ke=de.indexOf(ie[Z],ye+1);if(ke<0)return!1;ye=ke,Z++}return!0}e.fuzzyContains=We;function qe(B,ie=!1){return B?(ie&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=qe;function Ge(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=Ge;function et(B,ie=1){if(ie===0)return"";let ae=-1;do ae=B.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?B:(B[ae-1]==="\r"&&ae--,B.substr(0,ae))}e.getNLines=et;function ne(B){const ie=90-65+1;return B=B%(2*ie),B<ie?String.fromCharCode(97+B):String.fromCharCode(65+B-ie)}e.singleLetterHash=ne;function Se(B){return ue.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=Se;function we(B,ie){return B===0?ie!==5&&ie!==7:B===2&&ie===3?!1:B===4||B===2||B===3||ie===4||ie===2||ie===3?!0:!(B===8&&(ie===8||ie===9||ie===11||ie===12)||(B===11||B===9)&&(ie===9||ie===10)||(B===12||B===10)&&ie===10||ie===5||ie===13||ie===7||B===1||B===13&&ie===14||B===6&&ie===6)}e.breakBetweenGraphemeBreakType=we;var Ue;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(Ue=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ue{constructor(){this._data=pe()}static getInstance(){return ue._INSTANCE||(ue._INSTANCE=new ue),ue._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,de=ae.length/3;let Z=1;for(;Z<=de;)if(ie<ae[3*Z])Z=2*Z;else if(ie>ae[3*Z+1])Z=2*Z+1;else return ae[3*Z+2];return 0}}ue._INSTANCE=null;function pe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ve(B,ie){if(B===0)return 0;const ae=G(B,ie);if(ae!==void 0)return ae;const de=W(ie,B);return B-=Y(de),B}e.getLeftDeleteOffset=ve;function G(B,ie){let ae=W(ie,B);for(B-=Y(ae);te(ae)||ae===65039||ae===8419;){if(B===0)return;ae=W(ie,B),B-=Y(ae)}if(!!Ze(ae)){if(B>=0){const de=W(ie,B);de===8205&&(B-=Y(de))}return B}}function Y(B){return B>=65536?2:1}function te(B){return 127995<=B&&B<=127999}var oe;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(oe||(oe={}))}),define(fe[17],he([0,1,13,42]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const g=typeof Buffer!="undefined",C=typeof TextEncoder!="undefined",_=typeof TextDecoder!="undefined";let P,d;class v{constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}static alloc(w){return g?new v(Buffer.allocUnsafe(w)):new v(new Uint8Array(w))}static wrap(w){return g&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new v(w)}static fromString(w,L){return!(L?.dontUseNodeBuffer||!1)&&g?new v(Buffer.from(w)):C?(P||(P=new TextEncoder),new v(P.encode(w))):new v(y.encodeUTF8(w))}static concat(w,L){if(typeof L=="undefined"){L=0;for(let A=0,N=w.length;A<N;A++)L+=w[A].byteLength}const F=v.alloc(L);let o=0;for(let A=0,N=w.length;A<N;A++){const Q=w[A];F.set(Q,o),o+=Q.byteLength}return F}toString(){return g?this.buffer.toString():_?(d||(d=new TextDecoder),d.decode(this.buffer)):y.decodeUTF8(this.buffer)}slice(w,L){return new v(this.buffer.subarray(w,L))}set(w,L){w instanceof v?this.buffer.set(w.buffer,L):this.buffer.set(w,L)}readUInt32BE(w){return b(this.buffer,w)}writeUInt32BE(w,L){m(this.buffer,w,L)}readUInt32LE(w){return u(this.buffer,w)}writeUInt32LE(w,L){f(this.buffer,w,L)}readUInt8(w){return S(this.buffer,w)}writeUInt8(w,L){E(this.buffer,w,L)}}e.VSBuffer=v;function n(p,w){return p[w+0]<<0>>>0|p[w+1]<<8>>>0}e.readUInt16LE=n;function k(p,w,L){p[L+0]=w&255,w=w>>>8,p[L+1]=w&255}e.writeUInt16LE=k;function b(p,w){return p[w]*2**24+p[w+1]*2**16+p[w+2]*2**8+p[w+3]}e.readUInt32BE=b;function m(p,w,L){p[L+3]=w,w=w>>>8,p[L+2]=w,w=w>>>8,p[L+1]=w,w=w>>>8,p[L]=w}e.writeUInt32BE=m;function u(p,w){return p[w+0]<<0>>>0|p[w+1]<<8>>>0|p[w+2]<<16>>>0|p[w+3]<<24>>>0}e.readUInt32LE=u;function f(p,w,L){p[L+0]=w&255,w=w>>>8,p[L+1]=w&255,w=w>>>8,p[L+2]=w&255,w=w>>>8,p[L+3]=w&255}e.writeUInt32LE=f;function S(p,w){return p[w]}e.readUInt8=S;function E(p,w,L){p[L]=w}e.writeUInt8=E;function I(p){return D.consumeReadable(p,w=>v.concat(w))}e.readableToBuffer=I;function h(p){return D.toReadable(p)}e.bufferToReadable=h;function a(p){return D.consumeStream(p,w=>v.concat(w))}e.streamToBuffer=a;async function l(p){return p.ended?v.concat(p.buffer):v.concat([...p.buffer,await a(p.stream)])}e.bufferedStreamToBuffer=l;function t(p){return D.toStream(p,w=>v.concat(w))}e.bufferToStream=t;function r(p){return D.transform(p,{data:w=>typeof w=="string"?v.fromString(w):v.wrap(w)},w=>v.concat(w))}e.streamToBufferReadableStream=r;function i(p){return D.newWriteableStream(w=>v.concat(w),p)}e.newWriteableBufferStream=i;function s(p,w){return D.prefixedReadable(p,w,L=>v.concat(L))}e.prefixedBufferReadable=s;function c(p,w){return D.prefixedStream(p,w,L=>v.concat(L))}e.prefixedBufferStream=c}),define(fe[117],he([0,1,13]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function D(E){return g(E,0)}e.hash=D;function g(E,I){switch(typeof E){case"object":return E===null?C(349,I):Array.isArray(E)?d(E,I):v(E,I);case"string":return P(E,I);case"boolean":return _(E,I);case"number":return C(E,I);case"undefined":return C(937,I);default:return C(617,I)}}e.doHash=g;function C(E,I){return(I<<5)-I+E|0}function _(E,I){return C(E?433:863,I)}function P(E,I){I=C(149417,I);for(let h=0,a=E.length;h<a;h++)I=C(E.charCodeAt(h),I);return I}e.stringHash=P;function d(E,I){return I=C(104579,I),E.reduce((h,a)=>g(a,h),I)}function v(E,I){return I=C(181387,I),Object.keys(E).sort().reduce((h,a)=>(h=P(a,h),g(E[a],h)),I)}class n{constructor(){this._value=0}get value(){return this._value}hash(I){return this._value=g(I,this._value),this._value}}e.Hasher=n;var k;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function b(E,I,h=32){const a=h-I,l=~((1<<a)-1);return(E<<I|(l&E)>>>a)>>>0}function m(E,I=0,h=E.byteLength,a=0){for(let l=0;l<h;l++)E[I+l]=a}function u(E,I,h="0"){for(;E.length<I;)E=h+E;return E}function f(E,I=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(h=>h.toString(16).padStart(2,"0")).join(""):u((E>>>0).toString(16),I/4)}e.toHexString=f;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(I){const h=I.length;if(h===0)return;const a=this._buff;let l=this._buffLen,t=this._leftoverHighSurrogate,r,i;for(t!==0?(r=t,i=-1,t=0):(r=I.charCodeAt(0),i=0);;){let s=r;if(y.isHighSurrogate(r))if(i+1<h){const c=I.charCodeAt(i+1);y.isLowSurrogate(c)?(i++,s=y.computeCodePoint(r,c)):s=65533}else{t=r;break}else y.isLowSurrogate(r)&&(s=65533);if(l=this._push(a,l,s),i++,i<h)r=I.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=t}_push(I,h,a){return a<128?I[h++]=a:a<2048?(I[h++]=192|(a&1984)>>>6,I[h++]=128|(a&63)>>>0):a<65536?(I[h++]=224|(a&61440)>>>12,I[h++]=128|(a&4032)>>>6,I[h++]=128|(a&63)>>>0):(I[h++]=240|(a&1835008)>>>18,I[h++]=128|(a&258048)>>>12,I[h++]=128|(a&4032)>>>6,I[h++]=128|(a&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,I[0]=I[64+0],I[1]=I[64+1],I[2]=I[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const I=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(I/4294967296),!1),this._buffDV.setUint32(60,I%4294967296,!1),this._step()}_step(){const I=S._bigBlock32,h=this._buffDV;for(let w=0;w<64;w+=4)I.setUint32(w,h.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)I.setUint32(w,b(I.getUint32(w-12,!1)^I.getUint32(w-32,!1)^I.getUint32(w-56,!1)^I.getUint32(w-64,!1),1),!1);let a=this._h0,l=this._h1,t=this._h2,r=this._h3,i=this._h4,s,c,p;for(let w=0;w<80;w++)w<20?(s=l&t|~l&r,c=1518500249):w<40?(s=l^t^r,c=1859775393):w<60?(s=l&t|l&r|t&r,c=2400959708):(s=l^t^r,c=3395469782),p=b(a,5)+s+i+c+I.getUint32(w*4,!1)&4294967295,i=r,r=t,t=b(l,30),l=a,a=p;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(fe[73],he([0,1,13]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(D||(D={})),function(g){const C="error",_="warning",P="warn",d="info",v="ignore";function n(b){return b?y.equalsIgnoreCase(C,b)?g.Error:y.equalsIgnoreCase(_,b)||y.equalsIgnoreCase(P,b)?g.Warning:y.equalsIgnoreCase(d,b)?g.Info:g.Ignore:g.Ignore}g.fromValue=n;function k(b){switch(b){case g.Error:return C;case g.Warning:return _;case g.Info:return d;default:return v}}g.toString=k}(D||(D={})),e.default=D}),define(fe[11],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function y(w){return Array.isArray(w)}e.isArray=y;function D(w){return typeof w=="string"}e.isString=D;function g(w){return Array.isArray(w)&&w.every(L=>D(L))}e.isStringArray=g;function C(w){return typeof w=="object"&&w!==null&&!Array.isArray(w)&&!(w instanceof RegExp)&&!(w instanceof Date)}e.isObject=C;function _(w){return typeof w=="number"&&!isNaN(w)}e.isNumber=_;function P(w){return!!w&&typeof w[Symbol.iterator]=="function"}e.isIterable=P;function d(w){return w===!0||w===!1}e.isBoolean=d;function v(w){return typeof w=="undefined"}e.isUndefined=v;function n(w){return!k(w)}e.isDefined=n;function k(w){return v(w)||w===null}e.isUndefinedOrNull=k;function b(w,L){if(!w)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=b;function m(w){if(k(w))throw new Error("Assertion Failed: argument is undefined or null");return w}e.assertIsDefined=m;function u(...w){const L=[];for(let F=0;F<w.length;F++){const o=w[F];if(k(o))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);L.push(o)}return L}e.assertAllDefined=u;const f=Object.prototype.hasOwnProperty;function S(w){if(!C(w))return!1;for(let L in w)if(f.call(w,L))return!1;return!0}e.isEmptyObject=S;function E(w){return typeof w=="function"}e.isFunction=E;function I(...w){return w.length>0&&w.every(E)}e.areFunctions=I;function h(w,L){const F=Math.min(w.length,L.length);for(let o=0;o<F;o++)a(w[o],L[o])}e.validateConstraints=h;function a(w,L){if(D(L)){if(typeof w!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(E(L)){try{if(w instanceof L)return}catch{}if(!k(w)&&w.constructor===L||L.length===1&&L.call(void 0,w)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(w){let L=[],F=Object.getPrototypeOf(w);for(;Object.prototype!==F;)L=L.concat(Object.getOwnPropertyNames(F)),F=Object.getPrototypeOf(F);return L}e.getAllPropertyNames=l;function t(w){const L=[];for(const F of l(w))typeof w[F]=="function"&&L.push(F);return L}e.getAllMethodNames=t;function r(w,L){const F=A=>function(){const N=Array.prototype.slice.call(arguments,0);return L(A,N)};let o={};for(const A of w)o[A]=F(A);return o}e.createProxyObject=r;function i(w){return w===null?void 0:w}e.withNullAsUndefined=i;function s(w){return typeof w=="undefined"?null:w}e.withUndefinedAsNull=s;function c(w){return class{constructor(){return new Proxy({},{get(L,F){if(L[F])return L[F];throw new Error(`Not Implemented: ${w}->${String(F)}`)}})}}}e.NotImplementedProxy=c;function p(w){throw new Error("Unreachable")}e.assertNever=p}),define(fe[30],he([0,1,5,13,4,11]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(i){return i===47||i===92}e.isPathSeparator=_;function P(i){return i.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=P;function d(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=d;function v(i,s=g.posix.sep){if(!i)return"";const c=i.length,p=i.charCodeAt(0);if(_(p)){if(_(i.charCodeAt(1))&&!_(i.charCodeAt(2))){let L=3;const F=L;for(;L<c&&!_(i.charCodeAt(L));L++);if(F!==L&&!_(i.charCodeAt(L+1))){for(L+=1;L<c;L++)if(_(i.charCodeAt(L)))return i.slice(0,L+1).replace(/[\\/]/g,s)}}return s}else if(E(p)&&i.charCodeAt(1)===58)return _(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let w=i.indexOf("://");if(w!==-1){for(w+=3;w<c;w++)if(_(i.charCodeAt(w)))return i.slice(0,w+1)}return""}e.getRoot=v;function n(i){if(!y.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let c=2;const p=c;for(;c<i.length&&(s=i.charCodeAt(c),s!==92);c++);return!(p===c||(s=i.charCodeAt(c+1),isNaN(s)||s===92))}e.isUNC=n;const k=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(i,s=y.isWindows){const c=s?k:b;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||s&&m.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=u;function f(i,s,c){const p=i===s;return!c||p?p:!i||!s?!1:D.equalsIgnoreCase(i,s)}e.isEqual=f;function S(i,s,c,p=g.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(c){if(!D.startsWithIgnoreCase(i,s))return!1;if(s.length===i.length)return!0;let L=s.length;return s.charAt(s.length-1)===p&&L--,i.charAt(L)===p}return s.charAt(s.length-1)!==p&&(s+=p),i.indexOf(s)===0}e.isEqualOrParent=S;function E(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=E;function I(i,s){return y.isWindows&&i.endsWith(":")&&(i+=g.sep),g.isAbsolute(i)||(i=g.join(s,i)),i=g.normalize(i),y.isWindows?(i=D.rtrim(i,g.sep),i.endsWith(":")&&(i+=g.sep)):(i=D.rtrim(i,g.sep),i||(i=g.sep)),i}e.sanitizeFilePath=I;function h(i){const s=g.normalize(i);return y.isWindows?i.length>3?!1:a(s)&&(i.length===2||s.charCodeAt(2)===92):s===g.posix.sep}e.isRootOrDriveLetter=h;function a(i){return y.isWindows?E(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(i){return a(i)?i[0]:void 0}e.getDriveLetter=l;function t(i,s,c){return s.length>i.length?-1:i===s?0:(c&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=t;function r(i){const s=i.split(":");let c,p,w;if(s.forEach(L=>{const F=Number(L);C.isNumber(F)?p===void 0?p=F:w===void 0&&(w=F):c=c?[c,L].join(":"):L}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:p!==void 0?p:void 0,column:w!==void 0?w:p!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(fe[18],he([0,1,11]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const S=Array.isArray(f)?[]:{};return Object.keys(f).forEach(E=>{f[E]&&typeof f[E]=="object"?S[E]=D(f[E]):S[E]=f[E]}),S}e.deepClone=D;function g(f){if(!f||typeof f!="object")return f;const S=[f];for(;S.length>0;){const E=S.shift();Object.freeze(E);for(const I in E)if(C.call(E,I)){const h=E[I];typeof h=="object"&&!Object.isFrozen(h)&&S.push(h)}}return f}e.deepFreeze=g;const C=Object.prototype.hasOwnProperty;function _(f,S){return P(f,S,new Set)}e.cloneAndChange=_;function P(f,S,E){if(y.isUndefinedOrNull(f))return f;const I=S(f);if(typeof I!="undefined")return I;if(y.isArray(f)){const h=[];for(const a of f)h.push(P(a,S,E));return h}if(y.isObject(f)){if(E.has(f))throw new Error("Cannot clone recursive data-structure");E.add(f);const h={};for(let a in f)C.call(f,a)&&(h[a]=P(f[a],S,E));return E.delete(f),h}return f}function d(f,S,E=!0){return y.isObject(f)?(y.isObject(S)&&Object.keys(S).forEach(I=>{I in f?E&&(y.isObject(f[I])&&y.isObject(S[I])?d(f[I],S[I],E):f[I]=S[I]):f[I]=S[I]}),f):S}e.mixin=d;function v(f,S){if(f===S)return!0;if(f==null||S===null||S===void 0||typeof f!=typeof S||typeof f!="object"||Array.isArray(f)!==Array.isArray(S))return!1;let E,I;if(Array.isArray(f)){if(f.length!==S.length)return!1;for(E=0;E<f.length;E++)if(!v(f[E],S[E]))return!1}else{const h=[];for(I in f)h.push(I);h.sort();const a=[];for(I in S)a.push(I);if(a.sort(),!v(h,a))return!1;for(E=0;E<h.length;E++)if(!v(f[h[E]],S[h[E]]))return!1}return!0}e.equals=v;function n(f){const S=new Set;return JSON.stringify(f,(E,I)=>{if(y.isObject(I)||Array.isArray(I)){if(S.has(I))return"[Circular]";S.add(I)}return I})}e.safeStringify=n;function k(f,S,E){const I=S(f);return typeof I=="undefined"?E:I}e.getOrDefault=k;function b(f,S){const E=Object.create(null);return!f||!S||Object.keys(S).forEach(h=>{const a=f[h],l=S[h];v(a,l)||(E[h]=l)}),E}e.distinct=b;function m(f,S){const E=S.toLowerCase(),I=Object.keys(f).find(h=>h.toLowerCase()===E);return I?f[I]:f[S]}e.getCaseInsensitive=m;function u(f,S){const E=Object.create(null);for(const I of Object.keys(f))S(I,f[I])&&(E[I]=f[I]);return E}e.filter=u}),define(fe[2],he([0,1,5,4]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,C=/^\//,_=/^\/\//;function P(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!g.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!C.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(i,s){return!i&&!s?"file":i}function v(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==k&&(s=k+s):s=k;break}return s}const n="",k="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(s,c,p,w,L,F=!1){typeof s=="object"?(this.scheme=s.scheme||n,this.authority=s.authority||n,this.path=s.path||n,this.query=s.query||n,this.fragment=s.fragment||n):(this.scheme=d(s,F),this.authority=c||n,this.path=v(this.scheme,p||n),this.query=w||n,this.fragment=L||n,P(this,F))}static isUri(s){return s instanceof m?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return h(this,!1)}with(s){if(!s)return this;let{scheme:c,authority:p,path:w,query:L,fragment:F}=s;return c===void 0?c=this.scheme:c===null&&(c=n),p===void 0?p=this.authority:p===null&&(p=n),w===void 0?w=this.path:w===null&&(w=n),L===void 0?L=this.query:L===null&&(L=n),F===void 0?F=this.fragment:F===null&&(F=n),c===this.scheme&&p===this.authority&&w===this.path&&L===this.query&&F===this.fragment?this:new f(c,p,w,L,F)}static parse(s,c=!1){const p=b.exec(s);return p?new f(p[2]||n,r(p[4]||n),r(p[5]||n),r(p[7]||n),r(p[9]||n),c):new f(n,n,n,n,n)}static file(s){let c=n;if(y.isWindows&&(s=s.replace(/\\/g,k)),s[0]===k&&s[1]===k){const p=s.indexOf(k,2);p===-1?(c=s.substring(2),s=k):(c=s.substring(2,p),s=s.substring(p)||k)}return new f("file",c,s,n,n)}static from(s){const c=new f(s.scheme,s.authority,s.path,s.query,s.fragment);return P(c,!0),c}static joinPath(s,...c){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return y.isWindows&&s.scheme==="file"?p=m.file(D.win32.join(h(s,!0),...c)).path:p=D.posix.join(s.path,...c),s.with({path:p})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof m)return s;{const c=new f(s);return c._formatted=s.external,c._fsPath=s._sep===u?s.fsPath:null,c}}else return s}}e.URI=m;const u=y.isWindows?1:void 0;class f extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=u),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(i,s){let c,p=-1;for(let w=0;w<i.length;w++){const L=i.charCodeAt(w);if(L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57||L===45||L===46||L===95||L===126||s&&L===47)p!==-1&&(c+=encodeURIComponent(i.substring(p,w)),p=-1),c!==void 0&&(c+=i.charAt(w));else{c===void 0&&(c=i.substr(0,w));const F=S[L];F!==void 0?(p!==-1&&(c+=encodeURIComponent(i.substring(p,w)),p=-1),c+=F):p===-1&&(p=w)}}return p!==-1&&(c+=encodeURIComponent(i.substring(p))),c!==void 0?c:i}function I(i){let s;for(let c=0;c<i.length;c++){const p=i.charCodeAt(c);p===35||p===63?(s===void 0&&(s=i.substr(0,c)),s+=S[p]):s!==void 0&&(s+=i[c])}return s!==void 0?s:i}function h(i,s){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,y.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=h;function a(i,s){const c=s?I:E;let p="",{scheme:w,authority:L,path:F,query:o,fragment:A}=i;if(w&&(p+=w,p+=":"),(L||w==="file")&&(p+=k,p+=k),L){let N=L.indexOf("@");if(N!==-1){const Q=L.substr(0,N);L=L.substr(N+1),N=Q.indexOf(":"),N===-1?p+=c(Q,!1):(p+=c(Q.substr(0,N),!1),p+=":",p+=c(Q.substr(N+1),!1)),p+="@"}L=L.toLowerCase(),N=L.indexOf(":"),N===-1?p+=c(L,!1):(p+=c(L.substr(0,N),!1),p+=L.substr(N))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const N=F.charCodeAt(1);N>=65&&N<=90&&(F=`/${String.fromCharCode(N+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const N=F.charCodeAt(0);N>=65&&N<=90&&(F=`${String.fromCharCode(N+32)}:${F.substr(2)}`)}p+=c(F,!0)}return o&&(p+="?",p+=c(o,!1)),A&&(p+="#",p+=s?A:E(A,!1)),p}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,s=>l(s)):i}}),define(fe[118],he([0,1,2]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(v){const n=v;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=D;function g(v){const n=[];let k;try{const b=JSON.parse(v.arguments),m=b[b.length-1];m&&m.__$stack&&(b.pop(),k=m.__$stack),n.push(...b)}catch(b){n.push("Unable to log remote console arguments",v.arguments)}return{args:n,stack:k}}e.parse=g;function C(v){if(typeof v!="string")return C(g(v).stack);const n=v;if(n){const k=_(n),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(b&&b.length===4)return{uri:y.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=C;function _(v){if(!v)return v;const n=v.indexOf(`
`);return n===-1?v:v.substring(0,n)}function P(v,n){const{args:k,stack:b}=g(v),m=typeof k[0]=="string"&&k.length===1;let u=_(b);u&&(u=`(${u.trim()})`);let f=[];if(typeof k[0]=="string"?u&&m?f=[`%c[${n}] %c${k[0]} %c${u}`,d("blue"),d(""),d("grey")]:f=[`%c[${n}] %c${k[0]}`,d("blue"),d(""),...k.slice(1)]:f=[`%c[${n}]%`,d("blue"),...k],u&&!m&&f.push(u),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,f)}e.log=P;function d(v){return`color: ${v}`}});var Ct=this&&this.__classPrivateFieldSet||function(X,e,y,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!g:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(X,y):g?g.value=y:e.set(X,y),y},rt=this&&this.__classPrivateFieldGet||function(X,e,y,D){if(y==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?D:y==="a"?D.call(X):D?D.value:e.get(X)};define(fe[26],he([0,1,2,13]),function(X,e,y,D){"use strict";var g,C,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,r,i){let s=t.get(r);return s===void 0&&(s=i,t.set(r,s)),s}e.getOrSet=P;function d(t){const r=[];return t.forEach((i,s)=>{r.push(`${s} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=d;function v(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=v;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return i-s}value(){return this._value[this._pos]}}e.StringIterator=n;class k{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?D.compareSubstring(r,this._value,0,r.length,this._from,this._to):D.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class b{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?D.compareSubstring(r,this._value,0,r.length,this._from,this._to):D.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return D.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return D.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return D.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return D.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class f{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(r){this._iter=r}static forUris(r=()=>!1){return new S(new u(r))}static forPaths(){return new S(new b)}static forStrings(){return new S(new n)}static forConfigKeys(){return new S(new k)}clear(){this._root=void 0}set(r,i){const s=this._iter.reset(r);let c;for(this._root||(this._root=new f,this._root.segment=s.value()),c=this._root;;){const w=s.cmp(c.segment);if(w>0)c.left||(c.left=new f,c.left.segment=s.value()),c=c.left;else if(w<0)c.right||(c.right=new f,c.right.segment=s.value()),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new f,c.mid.segment=s.value()),c=c.mid;else break}const p=c.value;return c.value=i,c.key=r,p}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const c=i.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else break}return s}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const s=this._iter.reset(r),c=[];let p=this._root;for(;p;){const w=s.cmp(p.segment);if(w>0)c.push([1,p]),p=p.left;else if(w<0)c.push([-1,p]),p=p.right;else if(s.hasNext())s.next(),c.push([0,p]),p=p.mid;else{for(i?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;c.length>0&&p.isEmpty();){let[L,F]=c.pop();switch(L){case 1:F.left=void 0;break;case 0:F.mid=void 0;break;case-1:F.right=void 0;break}p=F}break}}}findSubstr(r){const i=this._iter.reset(r);let s=this._root,c;for(;s;){const p=i.cmp(s.segment);if(p>0)s=s.left;else if(p<0)s=s.right;else if(i.hasNext())i.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const c=i.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[i,s]of this)r(s,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const s=i.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&i.push(s.left),s.mid&&i.push(s.mid),s.right&&i.push(s.right))}}}e.TernarySearchTree=S;class E{constructor(r,i){this[g]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=i??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[s,c]of this.map)r(c,y.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield y.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[y.URI.parse(r[0]),r[1]]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[y.URI.parse(r[0]),r[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var I;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class h{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const s=this._map.get(r);if(!!s)return i!==0&&this.touch(s,i),s.value}set(r,i,s=0){let c=this._map.get(r);if(c)c.value=i,s!==0&&this.touch(c,s);else{switch(c={key:r,value:i,next:void 0,previous:void 0},s){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const s=this._state;let c=this._head;for(;c;){if(i?r.bind(i)(c.value,c.key,this):r(c.value,c.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,i=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const p={value:s.key,done:!1};return s=s.next,p}else return{value:void 0,done:!0}}};return c}values(){const r=this,i=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const p={value:s.value,done:!1};return s=s.next,p}else return{value:void 0,done:!0}}};return c}entries(){const r=this,i=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const p={value:[s.key,s.value],done:!1};return s=s.next,p}else return{value:void 0,done:!0}}};return c}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>r;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,s=r.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const s=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(s.previous=c,c.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const s=r.next,c=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=c,c.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,s)=>{r.push([s,i])}),r}fromJSON(r){this.clear();for(const[i,s]of r)this.set(i,s)}}e.LinkedMap=h;class a extends h{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class l{constructor(r){_.set(this,void 0),Ct(this,_,r,"f")}get size(){return rt(this,_,"f").size}forEach(r,i){rt(this,_,"f").forEach(r,i)}get(r){return rt(this,_,"f").get(r)}has(r){return rt(this,_,"f").has(r)}entries(){return rt(this,_,"f").entries()}keys(){return rt(this,_,"f").keys()}values(){return rt(this,_,"f").values()}[(_=new WeakMap,Symbol.iterator)](){return rt(this,_,"f").entries()}}e.ReadonlyMapView=l}),define(fe[119],he([0,1,26,13]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function g(...Ce){return function(De,_e){for(let Te=0,Me=Ce.length;Te<Me;Te++){const We=Ce[Te](De,_e);if(We)return We}return null}}e.or=g,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Ce,De,_e){if(!_e||_e.length<De.length)return null;let Te;return Ce?Te=D.startsWithIgnoreCase(_e,De):Te=_e.indexOf(De)===0,Te?De.length>0?[{start:0,end:De.length}]:[]:null}function _(Ce,De){const _e=De.toLowerCase().indexOf(Ce.toLowerCase());return _e===-1?null:[{start:_e,end:_e+Ce.length}]}e.matchesContiguousSubString=_;function P(Ce,De){return d(Ce.toLowerCase(),De.toLowerCase(),0,0)}e.matchesSubString=P;function d(Ce,De,_e,Te){if(_e===Ce.length)return[];if(Te===De.length)return null;if(Ce[_e]===De[Te]){let Me=null;return(Me=d(Ce,De,_e+1,Te+1))?E({start:Te,end:Te+1},Me):null}return d(Ce,De,_e,Te+1)}function v(Ce){return 97<=Ce&&Ce<=122}function n(Ce){return 65<=Ce&&Ce<=90}e.isUpper=n;function k(Ce){return 48<=Ce&&Ce<=57}function b(Ce){return Ce===32||Ce===9||Ce===10||Ce===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Ce=>m.add(Ce.charCodeAt(0)));function u(Ce){return b(Ce)||m.has(Ce)}function f(Ce,De){return Ce===De||u(Ce)&&u(De)}function S(Ce){return v(Ce)||n(Ce)||k(Ce)}function E(Ce,De){return De.length===0?De=[Ce]:Ce.end===De[0].start?De[0].start=Ce.start:De.unshift(Ce),De}function I(Ce,De){for(let _e=De;_e<Ce.length;_e++){const Te=Ce.charCodeAt(_e);if(n(Te)||k(Te)||_e>0&&!S(Ce.charCodeAt(_e-1)))return _e}return Ce.length}function h(Ce,De,_e,Te){if(_e===Ce.length)return[];if(Te===De.length)return null;if(Ce[_e]!==De[Te].toLowerCase())return null;{let Me=null,We=Te+1;for(Me=h(Ce,De,_e+1,Te+1);!Me&&(We=I(De,We))<De.length;)Me=h(Ce,De,_e+1,We),We++;return Me===null?null:E({start:Te,end:Te+1},Me)}}function a(Ce){let De=0,_e=0,Te=0,Me=0,We=0;for(let Se=0;Se<Ce.length;Se++)We=Ce.charCodeAt(Se),n(We)&&De++,v(We)&&_e++,S(We)&&Te++,k(We)&&Me++;const qe=De/Ce.length,Ge=_e/Ce.length,et=Te/Ce.length,ne=Me/Ce.length;return{upperPercent:qe,lowerPercent:Ge,alphaPercent:et,numericPercent:ne}}function l(Ce){const{upperPercent:De,lowerPercent:_e}=Ce;return _e===0&&De>.6}function t(Ce){const{upperPercent:De,lowerPercent:_e,alphaPercent:Te,numericPercent:Me}=Ce;return _e>.2&&De<.8&&Te>.6&&Me<.2}function r(Ce){let De=0,_e=0,Te=0,Me=0;for(let We=0;We<Ce.length;We++)Te=Ce.charCodeAt(We),n(Te)&&De++,v(Te)&&_e++,b(Te)&&Me++;return(De===0||_e===0)&&Me===0?Ce.length<=30:De<=5}function i(Ce,De){if(!De||(De=De.trim(),De.length===0)||!r(Ce)||De.length>60)return null;const _e=a(De);if(!t(_e)){if(!l(_e))return null;De=De.toLowerCase()}let Te=null,Me=0;for(Ce=Ce.toLowerCase();Me<De.length&&(Te=h(Ce,De,0,Me))===null;)Me=I(De,Me+1);return Te}e.matchesCamelCase=i;function s(Ce,De,_e=!1){if(!De||De.length===0)return null;let Te=null,Me=0;for(Ce=Ce.toLowerCase(),De=De.toLowerCase();Me<De.length&&(Te=c(Ce,De,0,Me,_e))===null;)Me=p(De,Me+1);return Te}e.matchesWords=s;function c(Ce,De,_e,Te,Me){if(_e===Ce.length)return[];if(Te===De.length)return null;if(f(Ce.charCodeAt(_e),De.charCodeAt(Te))){let We=null,qe=Te+1;if(We=c(Ce,De,_e+1,Te+1,Me),!Me)for(;!We&&(qe=p(De,qe))<De.length;)We=c(Ce,De,_e+1,qe,Me),qe++;return We===null?null:E({start:Te,end:Te+1},We)}else return null}function p(Ce,De){for(let _e=De;_e<Ce.length;_e++)if(u(Ce.charCodeAt(_e))||_e>0&&u(Ce.charCodeAt(_e-1)))return _e;return Ce.length}const w=g(e.matchesPrefix,i,_),L=g(e.matchesPrefix,i,P),F=new y.LRUCache(1e4);function o(Ce,De,_e=!1){if(typeof Ce!="string"||typeof De!="string")return null;let Te=F.get(Ce);Te||(Te=new RegExp(D.convertSimple2RegExpPattern(Ce),"i"),F.set(Ce,Te));const Me=Te.exec(De);return Me?[{start:Me.index,end:Me.index+Me[0].length}]:_e?L(Ce,De):w(Ce,De)}e.matchesFuzzy=o;function A(Ce,De){const _e=Ae(Ce,Ce.toLowerCase(),0,De,De.toLowerCase(),0,!0);return _e?Q(_e):null}e.matchesFuzzy2=A;function N(Ce,De,_e,Te,Me,We){const qe=Math.min(13,Ce.length);for(;_e<qe;_e++){const Ge=Ae(Ce,De,_e,Te,Me,We,!1);if(Ge)return Ge}return[0,We]}e.anyScore=N;function Q(Ce){if(typeof Ce=="undefined")return[];const De=[],_e=Ce[1];for(let Te=Ce.length-1;Te>1;Te--){const Me=Ce[Te]+_e,We=De[De.length-1];We&&We.end===Me?We.end=Me+1:De.push({start:Me,end:Me+1})}return De}e.createMatches=Q;const J=128;function ce(){const Ce=[],De=[];for(let _e=0;_e<=J;_e++)De[_e]=0;for(let _e=0;_e<=J;_e++)Ce.push(De.slice(0));return Ce}function se(Ce){const De=[];for(let _e=0;_e<=Ce;_e++)De[_e]=0;return De}const $=se(2*J),q=se(2*J),W=ce(),V=ce(),T=ce(),R=!1;function M(Ce,De,_e,Te,Me){function We(Ge,et,ne=" "){for(;Ge.length<et;)Ge=ne+Ge;return Ge}let qe=` |   |${Te.split("").map(Ge=>We(Ge,3)).join("|")}
`;for(let Ge=0;Ge<=_e;Ge++)Ge===0?qe+=" |":qe+=`${De[Ge-1]}|`,qe+=Ce[Ge].slice(0,Me+1).map(et=>We(et.toString(),3)).join("|")+`
`;return qe}function z(Ce,De,_e,Te){Ce=Ce.substr(De),_e=_e.substr(Te),console.log(M(V,Ce,Ce.length,_e,_e.length)),console.log(M(T,Ce,Ce.length,_e,_e.length)),console.log(M(W,Ce,Ce.length,_e,_e.length))}function j(Ce,De){if(De<0||De>=Ce.length)return!1;const _e=Ce.codePointAt(De);switch(_e){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!D.isEmojiImprecise(_e)}}function ee(Ce,De){if(De<0||De>=Ce.length)return!1;switch(Ce.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function me(Ce,De,_e){return De[Ce]!==_e[Ce]}function ge(Ce,De,_e,Te,Me,We,qe=!1){for(;De<_e&&Me<We;)Ce[De]===Te[Me]&&(qe&&($[De]=Me),De+=1),Me+=1;return De===_e}e.isPatternInWord=ge;var be;(function(Ce){Ce[Ce.Diag=1]="Diag",Ce[Ce.Left=2]="Left",Ce[Ce.LeftLeft=3]="LeftLeft"})(be||(be={}));var Ie;(function(Ce){Ce.Default=[-100,0];function De(_e){return!_e||_e.length===2&&_e[0]===-100&&_e[1]===0}Ce.isDefault=De})(Ie=e.FuzzyScore||(e.FuzzyScore={}));function Ae(Ce,De,_e,Te,Me,We,qe){const Ge=Ce.length>J?J:Ce.length,et=Te.length>J?J:Te.length;if(_e>=Ge||We>=et||Ge-_e>et-We||!ge(De,_e,Ge,Me,We,et,!0))return;Fe(Ge,et,_e,We,De,Me);let ne=1,Se=1,we=_e,Ue=We;const ue=[!1];for(ne=1,we=_e;we<Ge;ne++,we++){const te=$[we],oe=q[we],B=we+1<Ge?q[we+1]:et;for(Se=te-We+1,Ue=te;Ue<B;Se++,Ue++){let ie=Number.MIN_SAFE_INTEGER,ae=!1;Ue<=oe&&(ie=$e(Ce,De,we,_e,Te,Me,Ue,et,We,W[ne-1][Se-1]===0,ue));let de=0;ie!==Number.MAX_SAFE_INTEGER&&(ae=!0,de=ie+V[ne-1][Se-1]);const Z=Ue>te,ye=Z?V[ne][Se-1]+(W[ne][Se-1]>0?-5:0):0,ke=Ue>te+1&&W[ne][Se-1]>0,Le=ke?V[ne][Se-2]+(W[ne][Se-2]>0?-5:0):0;if(ke&&(!Z||Le>=ye)&&(!ae||Le>=de))V[ne][Se]=Le,T[ne][Se]=3,W[ne][Se]=0;else if(Z&&(!ae||ye>=de))V[ne][Se]=ye,T[ne][Se]=2,W[ne][Se]=0;else if(ae)V[ne][Se]=de,T[ne][Se]=1,W[ne][Se]=W[ne-1][Se-1]+1;else throw new Error("not possible")}}if(R&&z(Ce,_e,Te,We),!ue[0]&&!qe)return;ne--,Se--;const pe=[V[ne][Se],We];let ve=0,G=0;for(;ne>=1;){let te=Se;do{const oe=T[ne][te];if(oe===3)te=te-2;else if(oe===2)te=te-1;else break}while(te>=1);ve>1&&De[_e+ne-1]===Me[We+Se-1]&&!me(te+We-1,Te,Me)&&ve+1>W[ne][te]&&(te=Se),te===Se?ve++:ve=1,G||(G=te),ne--,Se=te-1,pe.push(Se)}et===Ge&&(pe[0]+=2);const Y=G-Ge;return pe[0]-=Y,pe}e.fuzzyScore=Ae;function Fe(Ce,De,_e,Te,Me,We){let qe=Ce-1,Ge=De-1;for(;qe>=_e&&Ge>=Te;)Me[qe]===We[Ge]&&(q[qe]=Ge,qe--),Ge--}function $e(Ce,De,_e,Te,Me,We,qe,Ge,et,ne,Se){if(De[_e]!==We[qe])return Number.MIN_SAFE_INTEGER;let we=1,Ue=!1;return qe===_e-Te?we=Ce[_e]===Me[qe]?7:5:me(qe,Me,We)&&(qe===0||!me(qe-1,Me,We))?(we=Ce[_e]===Me[qe]?7:5,Ue=!0):j(We,qe)&&(qe===0||!j(We,qe-1))?we=5:(j(We,qe-1)||ee(We,qe-1))&&(we=5,Ue=!0),we>1&&_e===Te&&(Se[0]=!0),Ue||(Ue=me(qe,Me,We)||j(We,qe-1)||ee(We,qe-1)),_e===Te?qe>et&&(we-=Ue?3:5):ne?we+=Ue?2:0:we+=Ue?0:1,qe+1===Ge&&(we-=Ue?3:5),we}function Qe(Ce,De,_e,Te,Me,We,qe){return tt(Ce,De,_e,Te,Me,We,!0,qe)}e.fuzzyScoreGracefulAggressive=Qe;function Ze(Ce,De,_e,Te,Me,We,qe){return tt(Ce,De,_e,Te,Me,We,!1,qe)}e.fuzzyScoreGraceful=Ze;function tt(Ce,De,_e,Te,Me,We,qe,Ge){let et=Ae(Ce,De,_e,Te,Me,We,Ge);if(et&&!qe)return et;if(Ce.length>=3){const ne=Math.min(7,Ce.length-1);for(let Se=_e+1;Se<ne;Se++){const we=nt(Ce,Se);if(we){const Ue=Ae(we,we.toLowerCase(),_e,Te,Me,We,Ge);Ue&&(Ue[0]-=3,(!et||Ue[0]>et[0])&&(et=Ue))}}}return et}function nt(Ce,De){if(De+1>=Ce.length)return;const _e=Ce[De],Te=Ce[De+1];if(_e!==Te)return Ce.slice(0,De)+Te+_e+Ce.slice(De+2)}}),define(fe[120],he([0,1,41,119,13]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(`(\\\\)?${C.source}`,"g");function P(f){return f.replace(_,(S,E)=>E?S:`\\${S}`)}e.escapeIcons=P;const d=new RegExp(`\\\\${C.source}`,"g");function v(f){return f.replace(d,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=v;const n=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function k(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(n,(S,E,I,h)=>I?S:E||h||"")}e.stripIcons=k;function b(f){const S=f.indexOf(e.iconStartMarker);return S===-1?{text:f}:m(f,S)}e.parseLabelWithIcons=b;function m(f,S){const E=[];let I="";function h(p){if(p){I+=p;for(const w of p)E.push(t)}}let a=-1,l="",t=0,r,i,s=S;const c=f.length;for(h(f.substr(0,S));s<c;)r=f[s],i=f[s+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(a=s,h(l),l=e.iconStartMarker,s++):r===")"&&a!==-1?(t+=s-a+1,a=-1,l=""):a!==-1?/^[a-z0-9\-]$/i.test(r)?l+=r:(h(l),a=-1,l=""):h(r),s++;return h(l),{text:I,iconOffsets:E}}function u(f,S,E=!1){const{text:I,iconOffsets:h}=S;if(!h||h.length===0)return D.matchesFuzzy(f,I,E);const a=g.ltrim(I," "),l=I.length-a.length,t=D.matchesFuzzy(f,a,E);if(t)for(const r of t){const i=h[r.start+l]+l;r.start+=i,r.end+=i}return t}e.matchesFuzzyIconAware=u}),define(fe[74],he([0,1,120,12]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(g=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(m="",u=!1){if(this.value=m,typeof this.value!="string")throw D.illegalArgument("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1)}appendText(m,u=0){return this.value+=v(this.supportThemeIcons?y.escapeIcons(m):m).replace(/([ \t]+)/g,(f,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,u){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=C;function _(b){return P(b)?!b.value:Array.isArray(b)?b.every(_):!0}e.isEmptyMarkdownString=_;function P(b){return b instanceof C?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function d(b,m){return b===m?!0:!b||!m?!1:b.value===m.value&&b.isTrusted===m.isTrusted&&b.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=d;function v(b){return b.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function n(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function k(b){const m=[],u=b.split("|").map(S=>S.trim());b=u[0];const f=u[1];if(f){const S=/height=(\d+)/.exec(f),E=/width=(\d+)/.exec(f),I=S?S[1]:"",h=E?E[1]:"",a=isFinite(parseInt(h)),l=isFinite(parseInt(I));a&&m.push(`width="${h}"`),l&&m.push(`height="${I}"`)}return{href:b,dimensions:m}}e.parseHrefAndDimensions=k}),define(fe[46],he([0,1,17,13,2]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(n){return JSON.stringify(n,d)}e.stringify=C;function _(n){let k=JSON.parse(n);return k=v(k),k}e.parse=_;var P;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function d(n,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:D.regExpFlags(k)}:k}function v(n,k=0){if(!n||k>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return g.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof y.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let b=0;b<n.length;++b)n[b]=v(n[b],k+1);else for(const b in n)Object.hasOwnProperty.call(n,b)&&(n[b]=v(n[b],k+1))}return n}e.revive=v}),define(fe[8],he([0,1,2,5]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var g;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(g=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,v,n){this._hosts[d]=v,this._ports[d]=n}setConnectionToken(d,v){this._connectionTokens[d]=v}rewrite(d){if(this._delegate)return this._delegate(d);const v=d.authority;let n=this._hosts[v];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const k=this._ports[v],b=this._connectionTokens[v];let m=`path=${encodeURIComponent(d.path)}`;return typeof b=="string"&&(m+=`&tkn=${encodeURIComponent(b)}`),y.URI.from({scheme:D.isWeb?this._preferredWebSchema:g.vscodeRemoteResource,authority:`${n}:${k}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new C;class _{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(d,v,n){const k=this.toUri(d,v);if(k.scheme===g.vscodeRemote)return e.RemoteAuthorities.rewrite(k);let b=!1;return D.isNative&&(n||D.isPreferringBrowserCodeLoad)&&k.scheme===g.file&&(b=!0),k.scheme===g.file&&typeof D.globals.importScripts=="function"&&D.globals.origin==="vscode-file://vscode-app"&&(b=!0),b?k.with({scheme:g.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(d,v){const n=this.toUri(d,v);return n.scheme===g.vscodeFileResource?n.with({scheme:g.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(d,v){return y.URI.isUri(d)?d:y.URI.parse(v.toUrl(d))}}e.FileAccess=new _}),define(fe[75],he([0,1,26]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const D=new y.LRUCache(1e4);function g(v){return d(v,"NFC",D)}e.normalizeNFC=g;const C=new y.LRUCache(1e4);function _(v){return d(v,"NFD",C)}e.normalizeNFD=_;const P=/[^\u0000-\u0080]/;function d(v,n,k){if(!e.canNormalize||!v)return v;const b=k.get(v);if(b)return b;let m;return P.test(v)?m=v.normalize(n):m=v,k.set(v,m),m}e.removeAccents=function(){if(e.canNormalize){const v=/[\u0300-\u036f]/g;return function(n){return _(n).replace(v,"")}}else return function(v){return v}}()}),define(fe[19],he([0,1,30,4,2,13,8,5]),function(X,e,y,D,g,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(m){return g.uriToFsPath(m,!0)}e.originalFSPath=d;class v{constructor(u){this._ignorePathCasing=u}compare(u,f,S=!1){return u===f?0:C.compare(this.getComparisonKey(u,S),this.getComparisonKey(f,S))}isEqual(u,f,S=!1){return u===f?!0:!u||!f?!1:this.getComparisonKey(u,S)===this.getComparisonKey(f,S)}getComparisonKey(u,f=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,f,S=!1){if(u.scheme===f.scheme){if(u.scheme===_.Schemas.file)return y.isEqualOrParent(d(u),d(f),this._ignorePathCasing(u))&&u.query===f.query&&(S||u.fragment===f.fragment);if(e.isEqualAuthority(u.authority,f.authority))return y.isEqualOrParent(u.path,f.path,this._ignorePathCasing(u),"/")&&u.query===f.query&&(S||u.fragment===f.fragment)}return!1}joinPath(u,...f){return g.URI.joinPath(u,...f)}basenameOrAuthority(u){return e.basename(u)||u.authority}basename(u){return D.posix.basename(u.path)}extname(u){return D.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let f;return u.scheme===_.Schemas.file?f=g.URI.file(D.dirname(d(u))).path:(f=D.posix.dirname(u.path),u.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),f="/")),u.with({path:f})}normalizePath(u){if(!u.path.length)return u;let f;return u.scheme===_.Schemas.file?f=g.URI.file(D.normalize(d(u))).path:f=D.posix.normalize(u.path),u.with({path:f})}relativePath(u,f){if(u.scheme!==f.scheme||!e.isEqualAuthority(u.authority,f.authority))return;if(u.scheme===_.Schemas.file){const I=D.relative(d(u),d(f));return P.isWindows?y.toSlashes(I):I}let S=u.path||"/",E=f.path||"/";if(this._ignorePathCasing(u)){let I=0;for(const h=Math.min(S.length,E.length);I<h&&!(S.charCodeAt(I)!==E.charCodeAt(I)&&S.charAt(I).toLowerCase()!==E.charAt(I).toLowerCase());I++);S=E.substr(0,I)+S.substr(I)}return D.posix.relative(S,E)}resolvePath(u,f){if(u.scheme===_.Schemas.file){const S=g.URI.file(D.resolve(d(u),f));return u.with({authority:S.authority,path:S.path})}return f=y.toPosixPath(f),u.with({path:D.posix.resolve(u.path,f)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,f){return u===f||C.equalsIgnoreCase(u,f)}hasTrailingPathSeparator(u,f=D.sep){if(u.scheme===_.Schemas.file){const S=d(u);return S.length>y.getRoot(S).length&&S[S.length-1]===f}else{const S=u.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,f=D.sep){return e.hasTrailingPathSeparator(u,f)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,f=D.sep){let S=!1;if(u.scheme===_.Schemas.file){const E=d(u);S=E!==void 0&&E.length===y.getRoot(E).length&&E[E.length-1]===f}else{f="/";const E=u.path;S=E.length===1&&E.charCodeAt(E.length-1)===47}return!S&&!e.hasTrailingPathSeparator(u,f)?u.with({path:u.path+"/"}):u}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(m=>m.scheme===_.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new v(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(m,u){const f=[];for(let S=0;S<m.length;S++){const E=u(m[S]);m.some((I,h)=>h===S?!1:e.isEqualOrParent(E,u(I)))||f.push(m[S])}return f}e.distinctParents=n;var k;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function u(f){const S=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(h=>{const[a,l]=h.split(":");a&&l&&S.set(a,l)});const I=f.path.substring(0,f.path.indexOf(";"));return I&&S.set(m.META_DATA_MIME,I),S}m.parseMetaData=u})(k=e.DataUri||(e.DataUri={}));function b(m,u,f){if(u){let S=m.path;return S&&S[0]!==D.posix.sep&&(S=D.posix.sep+S),m.with({scheme:f,authority:u,path:S})}return m.with({scheme:f})}e.toLocalResource=b}),define(fe[14],he([0,1,25,12,7,3,19]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(W){return!!W&&typeof W.then=="function"}e.isThenable=P;function d(W){const V=new y.CancellationTokenSource,T=W(V.token),R=new Promise((M,z)=>{V.token.onCancellationRequested(()=>{z(D.canceled())}),Promise.resolve(T).then(j=>{V.dispose(),M(j)},j=>{V.dispose(),z(j)})});return new class{cancel(){V.cancel()}then(M,z){return R.then(M,z)}catch(M){return this.then(void 0,M)}finally(M){return R.finally(M)}}}e.createCancelablePromise=d;function v(W,V,T){return Promise.race([W,new Promise(R=>V.onCancellationRequested(()=>R(T)))])}e.raceCancellation=v;async function n(W){let V=-1;const T=W.map((M,z)=>M.then(j=>(V=z,j))),R=await Promise.race(T);return W.forEach((M,z)=>{z!==V&&M.cancel()}),R}e.raceCancellablePromises=n;function k(W,V,T){let R;const M=setTimeout(()=>{R?.(void 0),T?.()},V);return Promise.race([W.finally(()=>clearTimeout(M)),new Promise(z=>R=z)])}e.raceTimeout=k;function b(W){return new Promise((V,T)=>{const R=W();P(R)?R.then(V,T):V(R)})}e.asPromise=b;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(V){if(this.activePromise){if(this.queuedPromiseFactory=V,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const R=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,R};this.queuedPromise=new Promise(R=>{this.activePromise.then(T,T).then(R)})}return new Promise((T,R)=>{this.queuedPromise.then(T,R)})}return this.activePromise=V(),new Promise((T,R)=>{this.activePromise.then(M=>{this.activePromise=null,T(M)},M=>{this.activePromise=null,R(M)})})}}e.Throttler=m;class u{constructor(){this.current=Promise.resolve(null)}queue(V){return this.current=this.current.then(()=>V(),()=>V())}}e.Sequencer=u;class f{constructor(){this.promiseMap=new Map}queue(V,T){const M=(this.promiseMap.get(V)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(V)===M&&this.promiseMap.delete(V)});return this.promiseMap.set(V,M),M}}e.SequencerByKey=f;class S{constructor(V){this.defaultDelay=V,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(V,T=this.defaultDelay){return this.task=V,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((R,M)=>{this.doResolve=R,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const R=this.task;return this.task=null,R()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},T),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(D.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class E{constructor(V){this.delayer=new S(V),this.throttler=new m}trigger(V,T){return this.delayer.trigger(()=>this.throttler.queue(V),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class I{constructor(){this._isOpen=!1,this._promise=new Promise((V,T)=>{this._completePromise=V})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=I;class h extends I{constructor(V){super();this._timeout=setTimeout(()=>this.open(),V)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function a(W,V){return V?new Promise((T,R)=>{const M=setTimeout(T,W);V.onCancellationRequested(()=>{clearTimeout(M),R(D.canceled())})}):d(T=>a(W,T))}e.timeout=a;function l(W,V=0){const T=setTimeout(W,V);return C.toDisposable(()=>clearTimeout(T))}e.disposableTimeout=l;function t(W){return W.then(void 0,V=>{})}e.ignoreErrors=t;function r(W){const V=[];let T=0;const R=W.length;function M(){return T<R?W[T++]():null}function z(j){j!=null&&V.push(j);const ee=M();return ee?ee.then(z):Promise.resolve(V)}return Promise.resolve(null).then(z)}e.sequence=r;function i(W,V=R=>!!R,T=null){let R=0;const M=W.length,z=()=>{if(R>=M)return Promise.resolve(T);const j=W[R++];return Promise.resolve(j()).then(me=>V(me)?Promise.resolve(me):z())};return z()}e.first=i;function s(W,V=R=>!!R,T=null){if(W.length===0)return Promise.resolve(T);let R=W.length;const M=()=>{R=-1;for(const z of W)z.cancel?.()};return new Promise((z,j)=>{for(const ee of W)ee.then(me=>{--R>=0&&V(me)?(M(),z(me)):R===0&&z(T)}).catch(me=>{--R>=0&&(M(),j(me))})})}e.firstParallel=s;class c{constructor(V){this._size=0,this.maxDegreeOfParalellism=V,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new g.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(V){return this._size++,new Promise((T,R)=>{this.outstandingPromises.push({factory:V,c:T,e:R}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const V=this.outstandingPromises.shift();this.runningPromises++;const T=V.factory();T.then(V.c,V.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class p extends c{constructor(){super(1)}}e.Queue=p;class w{constructor(){this.queues=new Map}queueFor(V,T=_.extUri){const R=T.getComparisonKey(V);let M=this.queues.get(R);return M||(M=new p,g.Event.once(M.onFinished)(()=>{M?.dispose(),this.queues.delete(R)}),this.queues.set(R,M)),M}dispose(){this.queues.forEach(V=>V.dispose()),this.queues.clear()}}e.ResourceQueue=w;class L{constructor(V,T){this._token=-1,typeof V=="function"&&typeof T=="number"&&this.setIfNotSet(V,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(V,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,V()},T)}setIfNotSet(V,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,V()},T))}}e.TimeoutTimer=L;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(V,T){this.cancel(),this._token=setInterval(()=>{V()},T)}}e.IntervalTimer=F;class o{constructor(V,T){this.timeoutToken=-1,this.runner=V,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(V=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,V)}get delay(){return this.timeout}set delay(V){this.timeout=V}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=o;class A extends o{constructor(V,T){super(V,T);this.units=[]}work(V){this.units.push(V),this.isScheduled()||this.schedule()}doRun(){const V=this.units;this.units=[],this.runner&&this.runner(V)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class N extends C.Disposable{constructor(V,T,R,M){super();this.maxWorkChunkSize=V,this.maxPendingWork=T,this.throttleDelay=R,this.handler=M,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(V){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+V.length>this.maxPendingWork)return!1}else if(this.pending+V.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...V),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new o(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=V=>{const T=setTimeout(()=>V(W));let R=!1;return{dispose(){R||(R=!0,clearTimeout(T))}}}}else e.runWhenIdle=(W,V)=>{const T=requestIdleCallback(W,typeof V=="number"?{timeout:V}:void 0);let R=!1;return{dispose(){R||(R=!0,cancelIdleCallback(T))}}}}();class Q{constructor(V){this._didRun=!1,this._executor=()=>{try{this._value=V()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=Q;async function J(W,V,T){let R;for(let M=0;M<T;M++)try{return await W()}catch(z){R=z,await a(V)}throw R}e.retry=J;class ce{hasPending(V){return this._pending?typeof V=="number"?this._pending.taskId===V:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(V,T,R){return this._pending={taskId:V,cancel:()=>R?.(),promise:T},T.then(()=>this.donePending(V),()=>this.donePending(V)),T}donePending(V){this._pending&&V===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const V=this._next;this._next=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}setNext(V){if(this._next)this._next.run=V;else{let T,R;const M=new Promise((z,j)=>{T=z,R=j});this._next={run:V,promise:M,promiseResolve:T,promiseReject:R}}return this._next.promise}}e.TaskSequentializer=ce;class se{constructor(V){this.interval=V,this.lastIncrementTime=0,this.value=0}increment(){const V=Date.now();return V-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=V,this.value=0),this.value++,this.value}}e.IntervalCounter=se;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((V,T)=>{this.completeCallback=V,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(V){return new Promise(T=>{this.completeCallback(V),this.resolved=!0,T()})}error(V){return new Promise(T=>{this.errorCallback(V),this.rejected=!0,T()})}cancel(){new Promise(V=>{this.errorCallback(D.canceled()),this.rejected=!0,V()})}}e.DeferredPromise=$;var q;(function(W){async function V(T){let R;const M=await Promise.all(T.map(z=>z.then(j=>j,j=>{R||(R=j)})));if(typeof R!="undefined")throw R;return M}W.settled=V})(q=e.Promises||(e.Promises={}))}),define(fe[47],he([0,1,13,30,4,26,14]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const d="**",v="/",n="[/\\\\]",k="[^/\\\\]",b=/\//g;function m(R){switch(R){case 0:return"";case 1:return`${k}*?`;default:return`(?:${n}|${k}+${n}|${n}${k}+)*?`}}function u(R,M){if(!R)return[];const z=[];let j=!1,ee=!1,me="";for(const ge of R){switch(ge){case M:if(!j&&!ee){z.push(me),me="";continue}break;case"{":j=!0;break;case"}":j=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}me+=ge}return me&&z.push(me),z}e.splitGlobAware=u;function f(R){if(!R)return"";let M="";const z=u(R,v);if(z.every(j=>j===d))M=".*";else{let j=!1;z.forEach((ee,me)=>{if(ee===d){j||(M+=m(2),j=!0);return}let ge=!1,be="",Ie=!1,Ae="";for(const Fe of ee){if(Fe!=="}"&&ge){be+=Fe;continue}if(Ie&&(Fe!=="]"||!Ae)){let $e;Fe==="-"?$e=Fe:(Fe==="^"||Fe==="!")&&!Ae?$e="^":Fe===v?$e="":$e=y.escapeRegExpCharacters(Fe),Ae+=$e;continue}switch(Fe){case"{":ge=!0;continue;case"[":Ie=!0;continue;case"}":M+=`(?:${u(be,",").map(Ze=>f(Ze)).join("|")})`,ge=!1,be="";break;case"]":M+="["+Ae+"]",Ie=!1,Ae="";break;case"?":M+=k;continue;case"*":M+=m(1);continue;default:M+=y.escapeRegExpCharacters(Fe)}}me<z.length-1&&(z[me+1]!==d||me+2<z.length)&&(M+=n),j=!1})}return M}const S=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new C.LRUCache(1e4),r=function(){return!1},i=function(){return null};function s(R,M){if(!R)return i;let z;typeof R!="string"?z=R.pattern:z=R,z=z.trim();const j=`${z}_${!!M.trimForExclusions}`;let ee=t.get(j);if(ee)return c(ee,R);let me;if(S.test(z)){const ge=z.substr(4);ee=function(be,Ie){return typeof be=="string"&&be.endsWith(ge)?z:null}}else(me=E.exec(p(z,M)))?ee=w(me[1],z):(M.trimForExclusions?h:I).test(z)?ee=L(z,M):(me=a.exec(p(z,M)))?ee=F(me[1].substr(1),z,!0):(me=l.exec(p(z,M)))?ee=F(me[1],z,!1):ee=o(z);return t.set(j,ee),c(ee,R)}function c(R,M){return typeof M=="string"?R:function(z,j){return D.isEqualOrParent(z,M.base)?R(g.relative(M.base,z),j):null}}function p(R,M){return M.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function w(R,M){const z=`/${R}`,j=`\\${R}`,ee=function(ge,be){return typeof ge!="string"?null:be?be===R?M:null:ge===R||ge.endsWith(z)||ge.endsWith(j)?M:null},me=[R];return ee.basenames=me,ee.patterns=[M],ee.allBasenames=me,ee}function L(R,M){const z=T(R.slice(1,-1).split(",").map(be=>s(be,M)).filter(be=>be!==i),R),j=z.length;if(!j)return i;if(j===1)return z[0];const ee=function(be,Ie){for(let Ae=0,Fe=z.length;Ae<Fe;Ae++)if(z[Ae](be,Ie))return R;return null},me=z.find(be=>!!be.allBasenames);me&&(ee.allBasenames=me.allBasenames);const ge=z.reduce((be,Ie)=>Ie.allPaths?be.concat(Ie.allPaths):be,[]);return ge.length&&(ee.allPaths=ge),ee}function F(R,M,z){const j=g.sep===g.posix.sep,ee=j?R:R.replace(b,g.sep),me=g.sep+ee,ge=g.posix.sep+R,be=z?function(Ie,Ae){return typeof Ie=="string"&&(Ie===ee||Ie.endsWith(me)||!j&&(Ie===R||Ie.endsWith(ge)))?M:null}:function(Ie,Ae){return typeof Ie=="string"&&(Ie===ee||!j&&Ie===R)?M:null};return be.allPaths=[(z?"*/":"./")+R],be}function o(R){try{const M=new RegExp(`^${f(R)}$`);return function(z){return M.lastIndex=0,typeof z=="string"&&M.test(z)?R:null}}catch(M){return i}}function A(R,M,z){return!R||typeof M!="string"?!1:N(R)(M,void 0,z)}e.match=A;function N(R,M={}){if(!R)return r;if(typeof R=="string"||se(R)){const z=s(R,M);if(z===i)return r;const j=function(ee,me){return!!z(ee,me)};return z.allBasenames&&(j.allBasenames=z.allBasenames),z.allPaths&&(j.allPaths=z.allPaths),j}return W(R,M)}e.parse=N;function Q(R){if(!R)return;let M;return z=>(M||(M=(R()||Promise.resolve([])).then(j=>j?ce(j):{})),M.then(j=>!!j[z]))}e.hasSiblingPromiseFn=Q;function J(R){if(!R)return;let M;return z=>{if(!M){const j=R();M=j?ce(j):{}}return!!M[z]}}e.hasSiblingFn=J;function ce(R){const M={};for(const z of R)M[z]=!0;return M}function se(R){const M=R;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}e.isRelativePattern=se;function $(R){return R.allBasenames||[]}e.getBasenameTerms=$;function q(R){return R.allPaths||[]}e.getPathTerms=q;function W(R,M){const z=T(Object.getOwnPropertyNames(R).map(be=>V(be,R[be],M)).filter(be=>be!==i)),j=z.length;if(!j)return i;if(!z.some(be=>!!be.requiresSiblings)){if(j===1)return z[0];const be=function(Fe,$e){for(let Qe=0,Ze=z.length;Qe<Ze;Qe++){const tt=z[Qe](Fe,$e);if(tt)return tt}return null},Ie=z.find(Fe=>!!Fe.allBasenames);Ie&&(be.allBasenames=Ie.allBasenames);const Ae=z.reduce((Fe,$e)=>$e.allPaths?Fe.concat($e.allPaths):Fe,[]);return Ae.length&&(be.allPaths=Ae),be}const ee=function(be,Ie,Ae){let Fe;for(let $e=0,Qe=z.length;$e<Qe;$e++){const Ze=z[$e];Ze.requiresSiblings&&Ae&&(Ie||(Ie=g.basename(be)),Fe||(Fe=Ie.substr(0,Ie.length-g.extname(be).length)));const tt=Ze(be,Ie,Fe,Ae);if(tt)return tt}return null},me=z.find(be=>!!be.allBasenames);me&&(ee.allBasenames=me.allBasenames);const ge=z.reduce((be,Ie)=>Ie.allPaths?be.concat(Ie.allPaths):be,[]);return ge.length&&(ee.allPaths=ge),ee}function V(R,M,z){if(M===!1)return i;const j=s(R,z);if(j===i)return i;if(typeof M=="boolean")return j;if(M){const ee=M.when;if(typeof ee=="string"){const me=(ge,be,Ie,Ae)=>{if(!Ae||!j(ge,be))return null;const Fe=ee.replace("$(basename)",Ie),$e=Ae(Fe);return _.isThenable($e)?$e.then(Qe=>Qe?R:null):$e?R:null};return me.requiresSiblings=!0,me}}return j}function T(R,M){const z=R.filter(be=>!!be.basenames);if(z.length<2)return R;const j=z.reduce((be,Ie)=>{const Ae=Ie.basenames;return Ae?be.concat(Ae):be},[]);let ee;if(M){ee=[];for(let be=0,Ie=j.length;be<Ie;be++)ee.push(M)}else ee=z.reduce((be,Ie)=>{const Ae=Ie.patterns;return Ae?be.concat(Ae):be},[]);const me=function(be,Ie){if(typeof be!="string")return null;if(!Ie){let Fe;for(Fe=be.length;Fe>0;Fe--){const $e=be.charCodeAt(Fe-1);if($e===47||$e===92)break}Ie=be.substr(Fe)}const Ae=j.indexOf(Ie);return Ae!==-1?ee[Ae]:null};me.basenames=j,me.patterns=ee,me.allBasenames=j;const ge=R.filter(be=>!be.basenames);return ge.push(me),ge}}),define(fe[52],he([0,1,2,4,13,8,5,19,30]),function(X,e,y,D,g,C,_,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function v(s,c,p){if(typeof s=="string"&&(s=y.URI.file(s)),p){const L=p.getWorkspaceFolder(s);if(L){const F=p.getWorkspace().folders.length>1;let o;if(P.isEqual(L.uri,s)?o="":o=P.relativePath(L.uri,s),F){const A=L.name?L.name:P.basename(L.uri);o=o?A+" \u2022 "+o:A}return o}}if(s.scheme!==C.Schemas.file&&s.scheme!==C.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if(d.hasDriveLetter(s.fsPath))return D.normalize(k(s.fsPath));let w=D.normalize(s.fsPath);return!_.isWindows&&c?.userHome&&(w=m(w,c.userHome.fsPath)),w}e.getPathLabel=v;function n(s){if(!s)return;typeof s=="string"&&(s=y.URI.file(s));const c=P.basename(s)||(s.scheme===C.Schemas.file?s.fsPath:s.path);return _.isWindows&&d.isRootOrDriveLetter(c)?k(c):c}e.getBaseLabel=n;function k(s){return d.hasDriveLetter(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=k;let b=Object.create(null);function m(s,c){if(_.isWindows||!s||!c)return s;let p=b.original===c?b.normalized:void 0;return p||(p=`${g.rtrim(c,D.posix.sep)}${D.posix.sep}`,b={original:c,normalized:p}),(_.isLinux?s.startsWith(p):g.startsWithIgnoreCase(s,p))&&(s=`~/${s.substr(p.length)}`),s}e.tildify=m;function u(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=u;const f="\u2026",S="\\\\",E="~";function I(s,c=D.sep){const p=new Array(s.length);let w=!1;for(let L=0;L<s.length;L++){let F=s[L];if(F===""){p[L]=`.${c}`;continue}if(!F){p[L]=F;continue}w=!0;let o="";F.indexOf(S)===0?(o=F.substr(0,F.indexOf(S)+S.length),F=F.substr(F.indexOf(S)+S.length)):F.indexOf(c)===0?(o=F.substr(0,F.indexOf(c)+c.length),F=F.substr(F.indexOf(c)+c.length)):F.indexOf(E)===0&&(o=F.substr(0,F.indexOf(E)+E.length),F=F.substr(F.indexOf(E)+E.length));const A=F.split(c);for(let N=1;w&&N<=A.length;N++)for(let Q=A.length-N;w&&Q>=0;Q--){w=!1;let J=A.slice(Q,Q+N).join(c);for(let ce=0;!w&&ce<s.length;ce++)if(ce!==L&&s[ce]&&s[ce].indexOf(J)>-1){const se=Q+N===A.length,$=Q>0&&s[ce].indexOf(c)>-1?c+J:J,q=s[ce].endsWith($);w=!se||q}if(!w){let ce="";(A[0].endsWith(":")||o!=="")&&(Q===1&&(Q=0,N++,J=A[0]+c+J),Q>0&&(ce=A[0]+c),ce=o+ce),Q>0&&(ce=ce+f+c),ce=ce+J,Q+N<A.length&&(ce=ce+c+f),p[L]=ce}}w&&(p[L]=F)}return p}e.shorten=I;var h;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function a(s,c=Object.create(null)){const p=[];let w=!1,L="";for(const F of s)if(F==="$"||w&&F==="{")L&&p.push({value:L,type:h.TEXT}),L="",w=!0;else if(F==="}"&&w){const o=c[L];if(typeof o=="string")o.length&&p.push({value:o,type:h.VARIABLE});else if(o){const A=p[p.length-1];(!A||A.type!==h.SEPARATOR)&&p.push({value:o.label,type:h.SEPARATOR})}L="",w=!1}else L+=F;return L&&!w&&p.push({value:L,type:h.TEXT}),p.filter((F,o)=>{if(F.type===h.SEPARATOR){const A=p[o-1],N=p[o+1];return[A,N].every(Q=>Q&&(Q.type===h.VARIABLE||Q.type===h.TEXT)&&Q.value.length>0)}return!0}).map(F=>F.value).join("")}e.template=a;function l(s,c){return _.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):s.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function t(s,c){return _.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,""):_.isWindows?s.replace(/&&|&/g,p=>p==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=r;function i(s){const c=s.indexOf("/")!==-1?D.posix:D.win32,p=c.basename(s),w=c.dirname(s);return p.length?{name:p,parentPath:w}:{name:w,parentPath:""}}e.splitName=i}),define(fe[53],he([0,1,4,13,47,8,19]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let d=[],v=[],n=[];function k(r,i=!1){const s=b(r);d.push(s),s.userConfigured?n.push(s):v.push(s),i&&!s.userConfigured&&d.forEach(c=>{c.mime===s.mime||c.userConfigured||(s.extension&&c.extension===s.extension&&console.warn(`Overwriting extension <<${s.extension}>> to now point to mime <<${s.mime}>>`),s.filename&&c.filename===s.filename&&console.warn(`Overwriting filename <<${s.filename}>> to now point to mime <<${s.mime}>>`),s.filepattern&&c.filepattern===s.filepattern&&console.warn(`Overwriting filepattern <<${s.filepattern}>> to now point to mime <<${s.mime}>>`),s.firstline&&c.firstline===s.firstline&&console.warn(`Overwriting firstline <<${s.firstline}>> to now point to mime <<${s.mime}>>`))})}e.registerTextMime=k;function b(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(y.posix.sep)>=0:!1}}function m(r){r?(d=d.filter(i=>!i.userConfigured),n=[]):(d=[],v=[],n=[])}e.clearTextMimes=m;function u(r,i){let s;if(r)switch(r.scheme){case C.Schemas.file:s=r.fsPath;break;case C.Schemas.data:s=_.DataUri.parseMetaData(r).get(_.DataUri.META_DATA_LABEL);break;default:s=r.path}if(!s)return[P.unknown];s=s.toLowerCase();const c=y.basename(s),p=f(s,c,n);if(p)return[p,P.text];const w=f(s,c,v);if(w)return[w,P.text];if(i){const L=S(i);if(L)return[L,P.text]}return[P.unknown]}e.guessMimeTypes=u;function f(r,i,s){let c=null,p=null,w=null;for(let L=s.length-1;L>=0;L--){const F=s[L];if(i===F.filenameLowercase){c=F;break}if(F.filepattern&&(!p||F.filepattern.length>p.filepattern.length)){const o=F.filepatternOnPath?r:i;g.match(F.filepatternLowercase,o)&&(p=F)}F.extension&&(!w||F.extension.length>w.extension.length)&&i.endsWith(F.extensionLowercase)&&(w=F)}return c?c.mime:p?p.mime:w?w.mime:null}function S(r){if(D.startsWithUTF8BOM(r)&&(r=r.substr(1)),r.length>0)for(let i=d.length-1;i>=0;i--){const s=d[i];if(!s.firstline)continue;const c=r.match(s.firstline);if(c&&c.length>0)return s.mime}return null}function E(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&E(r[0]):!0}e.isUnspecific=E;const I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function h(r){const i=y.extname(r);return I[i.toLowerCase()]}e.getMediaMime=h;function a(r){for(const i in I)if(I[i]===r)return i}e.getExtensionForMimeType=a;const l=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const s=l.exec(r);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(fe[54],he([0,1,2]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(n){return n.toJSON()}class g{constructor(k){this._uriTransformer=k}transformIncoming(k){const b=this._uriTransformer.transformIncoming(k);return b===k?k:D(y.URI.from(b))}transformOutgoing(k){const b=this._uriTransformer.transformOutgoing(k);return b===k?k:D(y.URI.from(b))}transformOutgoingURI(k){const b=this._uriTransformer.transformOutgoing(k);return b===k?k:y.URI.from(b)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=g,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function C(n,k,b){if(!n||b>200)return null;if(typeof n=="object"){if(n instanceof y.URI)return k.transformOutgoing(n);for(let m in n)if(Object.hasOwnProperty.call(n,m)){const u=C(n[m],k,b+1);u!==null&&(n[m]=u)}}return null}function _(n,k){const b=C(n,k,0);return b===null?n:b}e.transformOutgoingURIs=_;function P(n,k,b,m){if(!n||m>200)return null;if(typeof n=="object"){if(n.$mid===1)return b?y.URI.revive(k.transformIncoming(n)):k.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const f=P(n[u],k,b,m+1);f!==null&&(n[u]=f)}}return null}function d(n,k){const b=P(n,k,!1,0);return b===null?n:b}e.transformIncomingURIs=d;function v(n,k){const b=P(n,k,!0,0);return b===null?n:b}e.transformAndReviveIncomingURIs=v}),define(fe[22],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(d){return y.test(d)}e.isUUID=D;const g=new Uint8Array(16),C=[];for(let d=0;d<256;d++)C.push(d.toString(16).padStart(2,"0"));let _;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?_=crypto.getRandomValues.bind(crypto):_=function(d){for(let v=0;v<d.length;v++)d[v]=Math.floor(Math.random()*256);return d};function P(){_(g),g[6]=g[6]&15|64,g[8]=g[8]&63|128;let d=0,v="";return v+=C[g[d++]],v+=C[g[d++]],v+=C[g[d++]],v+=C[g[d++]],v+="-",v+=C[g[d++]],v+=C[g[d++]],v+="-",v+=C[g[d++]],v+=C[g[d++]],v+="-",v+=C[g[d++]],v+=C[g[d++]],v+="-",v+=C[g[d++]],v+=C[g[d++]],v+=C[g[d++]],v+=C[g[d++]],v+=C[g[d++]],v+=C[g[d++]],v}e.generateUuid=P}),define(fe[76],he([0,1,236]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class D{constructor(C="utf8"){this.stringDecoder=new y.StringDecoder(C),this.remaining=null}write(C){const _=[],P=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(P.length<1)return _;let d=0,v,n=d;for(;n<P.length;)if(v=P.charCodeAt(n),v===13||v===10){if(_.push(P.substring(d,n)),n++,n<P.length){const k=v;v=P.charCodeAt(n),(k===13&&v===10||k===10&&v===13)&&n++}d=n}else n++;return this.remaining=d<P.length?P.substr(d):null,_}end(){return this.remaining}}e.LineDecoder=D}),function(){"use strict";function X(e,y,D,g){function C(u){return new Promise(f=>D.exists(u,f))}function _(u){return new Promise((f,S)=>{const E=new Date;D.utimes(u,E,E,I=>I?S(I):f())})}function P(u){return new Promise((f,S)=>D.mkdir(u,{recursive:!0},E=>E&&E.code!=="EEXIST"?S(E):f(u)))}function d(u){return new Promise((f,S)=>D.rmdir(u,{recursive:!0},E=>E&&E.code!=="ENOENT"?S(E):f()))}function v(u){return new Promise((f,S)=>D.readFile(u,"utf8",(E,I)=>E?S(E):f(I)))}function n(u,f){return new Promise((S,E)=>D.writeFile(u,f,"utf8",I=>I?E(I):S()))}function k(u){const f=y.join(u,"languagepacks.json");try{return e(f)}catch(S){}}function b(u,f){try{for(;f;){if(u[f])return f;{const S=f.lastIndexOf("-");if(S>0)f=f.substring(0,S);else return}}}catch(S){console.error("Resolving language pack configuration failed.",S)}}function m(u,f,S,E){if(E==="pseudo")return Promise.resolve({locale:E,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:E,availableLanguages:{}});if(E&&(E==="en"||E==="en-us"))return Promise.resolve({locale:E,availableLanguages:{}});const I=E;g.mark("code/willGenerateNls");const h=function(a){return g.mark("code/didGenerateNls"),Promise.resolve({locale:a,availableLanguages:{}})};try{if(!u)return h(I);const a=k(f);if(!a||(E=b(a,E),!E))return h(I);const l=a[E];let t;return!l||typeof l.hash!="string"||!l.translations||typeof(t=l.translations.vscode)!="string"?h(I):C(t).then(r=>{if(!r)return h(I);const i=l.hash+"."+E,s=y.join(f,"clp",i),c=y.join(s,u),p=y.join(s,"tcf.json"),w=y.join(s,"corrupted.info"),L={locale:I,availableLanguages:{"*":E},_languagePackId:i,_translationsConfigFile:p,_cacheRoot:s,_resolvedLanguagePackCoreLocation:c,_corruptedFile:w};return C(w).then(F=>{let o;return F?o=d(s):o=Promise.resolve(void 0),o.then(()=>C(c).then(A=>A?(_(c).catch(()=>{}),g.mark("code/didGenerateNls"),L):P(c).then(()=>Promise.all([v(S),v(t)])).then(N=>{const Q=JSON.parse(N[0]),J=JSON.parse(N[1]).contents,ce=Object.keys(Q.bundles),se=[];for(const $ of ce){const q=Q.bundles[$],W=Object.create(null);for(const V of q){const T=Q.keys[V],R=Q.messages[V],M=J[V];let z;if(M){z=[];for(let j=0;j<T.length;j++){const ee=T[j],me=typeof ee=="string"?ee:ee.key;let ge=M[me];ge===void 0&&(ge=R[j]),z.push(ge)}}else z=R;W[V]=z}se.push(n(y.join(c,$.replace(/\//g,"!")+".nls.json"),JSON.stringify(W)))}return se.push(n(p,JSON.stringify(l.translations))),Promise.all(se)}).then(()=>(g.mark("code/didGenerateNls"),L)).catch(N=>(console.error("Generating translation files failed.",N),h(E)))))})})}catch(a){return console.error("Generating translation files failed.",a),h(E)}}return{getNLSConfiguration:m}}if(typeof define=="function")define(fe[121],he([0,77,27,48]),function(e,y,D,g){return X(e.__$__nodeRequire,y,D,g)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("fs"),D=require("../common/performance");module.exports=X(require,e,y,D)}else throw new Error("Unknown context")}(),define(fe[122],he([0,1,24]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function g(P){const d=P.replace(/\-/g,":").toLowerCase();return!D.has(d)}function C(){return new Promise(async(P,d)=>{const v=setTimeout(()=>d("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await _())}catch(n){d(n)}finally{clearTimeout(v)}})}e.getMac=C;function _(){return new Promise((P,d)=>{try{const v=y.networkInterfaces();for(let n in v){const k=v[n];if(k){for(const{mac:b}of k)if(g(b))return P(b)}}d("Unable to retrieve mac address (unexpected format)")}catch(v){d(v)}})}}),define(fe[78],he([0,1,12,22,24,26,122]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=C.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,k=0;const b=g.networkInterfaces();for(let m in b){const u=b[m];if(u)for(const{mac:f,internal:S}of u)S||(k+=1,this._isVirtualMachineMacAdress(f.toUpperCase())&&(n+=1))}this._value=k>0?n/k:0}return this._value}};let P;async function d(){return P||(P=(async()=>await v()||D.generateUuid())()),P}e.getMachineId=d;async function v(){try{const n=await new Promise((b,m)=>{X(["crypto"],b,m)}),k=await _.getMac();return n.createHash("sha256").update(k,"utf8").digest("hex")}catch(n){y.onUnexpectedError(n);return}}}),define(fe[15],he([0,1,27,24,123,4,14,5,30,22,75,19,2]),function(X,e,y,D,g,C,_,P,d,v,n,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function u($,q=m.UNLINK){if(d.isRootOrDriveLetter($))throw new Error("rimraf - will refuse to recursively delete root");return q===m.UNLINK?S($):f($)}async function f($){try{const q=C.join(D.tmpdir(),v.generateUuid());try{await e.Promises.rename($,q)}catch(W){return S($)}S(q).catch(W=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function S($){return e.Promises.rmdir($,{recursive:!0,maxRetries:3})}function E($){if(d.isRootOrDriveLetter($))throw new Error("rimraf - will refuse to recursively delete root");y.rmdirSync($,{recursive:!0})}e.rimrafSync=E;async function I($,q){return l(await(q?h($):g.promisify(y.readdir)($)))}async function h($){try{return await g.promisify(y.readdir)($,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const q=[],W=await I($);for(const V of W){let T=!1,R=!1,M=!1;try{const z=await e.Promises.lstat(C.join($,V));T=z.isFile(),R=z.isDirectory(),M=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}q.push({name:V,isFile:()=>T,isDirectory:()=>R,isSymbolicLink:()=>M})}return q}function a($){return l(y.readdirSync($))}e.readdirSync=a;function l($){return $.map(q=>typeof q=="string"?P.isMacintosh?n.normalizeNFC(q):q:(q.name=P.isMacintosh?n.normalizeNFC(q.name):q.name,q))}async function t($){const q=await I($),W=[];for(const V of q)await i.existsDirectory(C.join($,V))&&W.push(V);return W}function r($,q=1e3){return new Promise(W=>{let V=!1;const T=setInterval(()=>{V||(V=!0,y.access($,R=>{V=!1,R&&(clearInterval(T),W(void 0))}))},q)})}e.whenDeleted=r;var i;(function($){async function q(T){let R;try{if(R=await e.Promises.lstat(T),!R.isSymbolicLink())return{stat:R}}catch(M){}try{return{stat:await e.Promises.stat(T),symbolicLink:R?.isSymbolicLink()?{dangling:!1}:void 0}}catch(M){if(M.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};if(P.isWindows&&M.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(T)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};throw z}throw M}}$.stat=q;async function W(T){try{const{stat:R,symbolicLink:M}=await $.stat(T);return R.isFile()&&M?.dangling!==!0}catch(R){}return!1}$.existsFile=W;async function V(T){try{const{stat:R,symbolicLink:M}=await $.stat(T);return R.isDirectory()&&M?.dangling!==!0}catch(R){}return!1}$.existsDirectory=V})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new _.ResourceQueue;function c($,q,W){return s.queueFor(b.URI.file($),k.extUriBiasedIgnorePathCase).queue(()=>{const V=F(W);return new Promise((T,R)=>w($,q,V,M=>M?R(M):T()))})}let p=!0;function w($,q,W,V){if(!p)return y.writeFile($,q,{mode:W.mode,flag:W.flag},V);y.open($,W.flag,W.mode,(T,R)=>{if(T)return V(T);y.writeFile(R,q,M=>{if(M)return y.close(R,()=>V(M));y.fdatasync(R,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),p=!1),y.close(R,j=>V(j))))})})}function L($,q,W){const V=F(W);if(!p)return y.writeFileSync($,q,{mode:V.mode,flag:V.flag});const T=y.openSync($,V.flag,V.mode);try{y.writeFileSync(T,q);try{y.fdatasyncSync(T)}catch(R){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",R),p=!1}}finally{y.closeSync(T)}}e.writeFileSync=L;function F($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function o($,q){if($===q)return;async function W(V){try{const T=await e.Promises.lstat(V);if(T.isDirectory()||T.isSymbolicLink())return;await e.Promises.utimes(V,T.atime,new Date)}catch(T){}}try{await e.Promises.rename($,q),await W(q)}catch(V){if($.toLowerCase()!==q.toLowerCase()&&V.code==="EXDEV"||$.endsWith("."))await A($,q,{preserveSymlinks:!1}),await u($,m.MOVE),await W(q);else throw V}}async function A($,q,W){return Q($,q,{root:{source:$,target:q},options:W,handledSourcePaths:new Set})}const N=511;async function Q($,q,W){if(W.handledSourcePaths.has($))return;W.handledSourcePaths.add($);const{stat:V,symbolicLink:T}=await i.stat($);if(T){if(W.options.preserveSymlinks)try{return await se($,q,W)}catch(R){console.warn("[node.js fs] copy of symlink failed: ",R)}if(T.dangling)return}return V.isDirectory()?J($,q,V.mode&N,W):ce($,q,V.mode&N)}async function J($,q,W,V){await e.Promises.mkdir(q,{recursive:!0,mode:W});const T=await I($);for(const R of T)await Q(C.join($,R),C.join(q,R),V)}async function ce($,q,W){await e.Promises.copyFile($,q),await e.Promises.chmod(q,W)}async function se($,q,W){let V=await e.Promises.readlink($);d.isEqualOrParent(V,W.root.source,!P.isLinux)&&(V=C.join(W.root.target,V.substr(W.root.source.length+1))),await e.Promises.symlink(V,q)}e.Promises=new class{get access(){return g.promisify(y.access)}get stat(){return g.promisify(y.stat)}get lstat(){return g.promisify(y.lstat)}get utimes(){return g.promisify(y.utimes)}get read(){return g.promisify(y.read)}get readFile(){return g.promisify(y.readFile)}get write(){return g.promisify(y.write)}get appendFile(){return g.promisify(y.appendFile)}get fdatasync(){return g.promisify(y.fdatasync)}get truncate(){return g.promisify(y.truncate)}get rename(){return g.promisify(y.rename)}get copyFile(){return g.promisify(y.copyFile)}get open(){return g.promisify(y.open)}get close(){return g.promisify(y.close)}get symlink(){return g.promisify(y.symlink)}get readlink(){return g.promisify(y.readlink)}get chmod(){return g.promisify(y.chmod)}get mkdir(){return g.promisify(y.mkdir)}get unlink(){return g.promisify(y.unlink)}get rmdir(){return g.promisify(y.rmdir)}get realpath(){return g.promisify(y.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return I}get readDirsInDir(){return t}get writeFile(){return c}get rm(){return u}get move(){return o}get copy(){return A}}}),define(fe[124],he([0,1,27,13,4,15]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function _(n){const k=g.dirname(n);if(n===k)return n;const b=(g.basename(n)||n).toLowerCase();try{const u=C.readdirSync(k).filter(f=>f.toLowerCase()===b);if(u.length===1){const f=_(k);if(f)return g.join(f,u[0])}else if(u.length>1){const f=u.indexOf(b);if(f>=0){const S=_(k);if(S)return g.join(S,u[f])}}}catch(m){}return null}e.realcaseSync=_;async function P(n){try{return await C.Promises.realpath(n)}catch(k){const b=v(n);return await C.Promises.access(b,y.constants.R_OK),b}}e.realpath=P;function d(n){try{return y.realpathSync(n)}catch(k){const b=v(n);return y.accessSync(b,y.constants.R_OK),b}}e.realpathSync=d;function v(n){return D.rtrim(g.normalize(n),g.sep)}}),define(fe[125],he([0,1,79]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function D(P,d,v){let n=!1;return new Promise(k=>{const b=setTimeout(()=>{if(!n)return n=!0,k(0)},v);g(P,d,m=>{if(!n)return n=!0,clearTimeout(b),k(m)})})}e.findFreePort=D;function g(P,d,v){if(d===0)return v(0);const n=new y.Socket;n.once("connect",()=>(_(n),g(P+1,d-1,v))),n.once("data",()=>{}),n.once("error",k=>(_(n),k.code!=="ECONNREFUSED"?g(P+1,d-1,v):v(P))),n.connect(P,"127.0.0.1")}function C(P,d,v){let n=!1,k,b=1;const m=y.createServer({pauseOnConnect:!0});function u(f,S){n||(n=!0,m.removeAllListeners(),m.close(),k&&clearTimeout(k),S(f))}return new Promise(f=>{k=setTimeout(()=>{u(0,f)},v),m.on("listening",()=>{u(P,f)}),m.on("error",S=>{S&&(S.code==="EADDRINUSE"||S.code==="EACCES")&&b<d?(P++,b++,m.listen(P,"127.0.0.1")):u(0,f)}),m.on("close",()=>{u(0,f)}),m.listen(P,"127.0.0.1")})}e.findFreePortFaster=C;function _(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(d){console.error(d)}}}),define(fe[80],he([0,1,15,24,4]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,_=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var d;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(d||(d={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class k{constructor(l,t,r){this.exePath=l,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await y.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:a=!1}={}){return a?v===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:a=!1,findPreview:l=!1}={}){const t=b({useAlternateBitness:a});if(!t)return null;const r=g.join(t,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(r))return null;let i=-1,s=null;for(const w of await y.Promises.readdir(r)){let L=-1;if(l){const o=w.indexOf("-");if(o<0)continue;const A=w.substring(0,o);if(!C.test(A)||w.substring(o+1)!=="preview")continue;L=parseInt(A,10)}else{if(!C.test(w))continue;L=parseInt(w,10)}if(L<=i)continue;const F=g.join(r,w,"pwsh.exe");!await y.SymlinkSupport.existsFile(F)||(s=F,i=L)}if(!s)return null;const c=t.includes("x86")?" (x86)":"",p=l?" Preview":"";return new k(s,`PowerShell${p}${c}`,!0)}async function u({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=g.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=a?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:_,pwshMsixName:"PowerShell (Store)"};for(const i of await y.Promises.readdir(l))if(t.test(i)){const s=g.join(l,i,"pwsh.exe");return new k(s,r)}return null}function f(){const a=g.join(D.homedir(),".dotnet","tools","pwsh.exe");return new k(a,".NET Core PowerShell Global Tool")}function S(){const a=g.join(process.env.windir,v===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(a,"Windows PowerShell",!0)}async function*E(){let a=await m();a&&(yield a),a=await m({useAlternateBitness:!0}),a&&(yield a),a=await u(),a&&(yield a),a=f(),a&&(yield a),a=await m({findPreview:!0}),a&&(yield a),a=await u({findPreview:!0}),a&&(yield a),a=await m({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=S(),a&&(yield a)}async function*I(){for await(const a of E())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=I;async function h(){for await(const a of I())return a;return null}e.getFirstAvailablePowerShellInstallation=h}),define(fe[81],he([0,1,35,8]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function g(_){return new Promise((P,d)=>{let v;const n=new Map;function k(m,u,f,S,E){const I=n.get(u);if(m===_||I){const h={name:b(f),cmd:f,pid:m,ppid:u,load:S,mem:E};n.set(m,h),m===_&&(v=h),I&&(I.children||(I.children=[]),I.children.push(h),I.children.length>1&&(I.children=I.children.sort((a,l)=>a.pid-l.pid)))}}function b(m){const u=/--disable-blink-features=Auxclick/,f=/\\watcher\\win32\\CodeHelper\.exe/,S=/--crashes-directory/,E=/\\pipe\\winpty-control/,I=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(f.exec(m))return"watcherService ";if(S.exec(m))return"electron-crash-reporter";if(E.exec(m))return"winpty-process";if(I.exec(m))return"console-window-host (Windows internal process)";let a=h.exec(m);if(a&&a.length===2)return a[1]==="renderer"?u.exec(m)?"shared-process":"window":a[1];const l=/[a-zA-Z-]+\.js/g;let t="";do a=l.exec(m),a&&(t+=a+" ");while(a);return t&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${t}`:m}if(process.platform==="win32"){const m=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,f)=>{X(["windows-process-tree"],u,f)}).then(u=>{u.getProcessList(_,f=>{u.getProcessCpuUsage(f,S=>{const E=new Map;S.forEach(I=>{const h=m(I.commandLine||"");E.set(I.pid,{name:b(h),cmd:h,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),v=E.get(_),v?(E.forEach(I=>{const h=E.get(I.ppid);h&&(h.children||(h.children=[]),h.children.push(I))}),E.forEach(I=>{I.children&&(I.children=I.children.sort((h,a)=>h.pid-a.pid))}),P(v)):d(new Error(`Root process ${_} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let m=function(){let u=[v];const f=[];for(;u.length;){const E=u.shift();E&&(f.push(E.pid),E.children&&(u=u.concat(E.children)))}let S=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);S+=" "+f.join(" "),y.exec(S,{},(E,I,h)=>{if(E||h)d(E||new Error(h.toString()));else{const a=I.toString().split(`
`);for(let l=0;l<f.length;l++){const t=n.get(f[l]);t.load=parseFloat(a[l])}if(!v){d(new Error(`Root process ${_} not found`));return}P(v)}})};y.exec("which ps",{},(u,f,S)=>{if(u||S)if(process.platform!=="linux")d(u||new Error(S.toString()));else{const E=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);y.exec(E,{},(I,h,a)=>{I||a?d(I||new Error(a.toString())):(C(h,k),m())})}else{const E=f.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";y.exec(`${E} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,a,l)=>{h||l&&!l.includes("screen size is bogus")?d(h||new Error(l.toString())):(C(a,k),process.platform==="linux"?m():v?P(v):d(new Error(`Root process ${_} not found`)))})}})}})}e.listProcesses=g;function C(_,P){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=_.toString().split(`
`);for(const n of v){const k=d.exec(n.trim());k&&k.length===6&&P(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(fe[126],he([0,1,4,27,5,75,3,15]),function(X,e,y,D,g,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function d(k,b,m){return n({path:k,isDirectory:!1},b,m)}e.watchFile=d;function v(k,b,m){return n({path:k,isDirectory:!0},b,m)}e.watchFolder=v,e.CHANGE_BUFFER_DELAY=100;function n(k,b,m){const u=y.basename(k.path),f=new Map;let S=!1,E=[_.toDisposable(()=>{f.forEach(I=>_.dispose(I)),f.clear()})];try{const I=D.watch(k.path);E.push(_.toDisposable(()=>{I.removeAllListeners(),I.close()}));const h=new Set;k.isDirectory&&P.Promises.readdir(k.path).then(a=>a.forEach(l=>h.add(l))),I.on("error",(a,l)=>{S||m(`Failed to watch ${k.path} for changes using fs.watch() (${a}, ${l})`)}),I.on("change",(a,l)=>{if(S)return;let t="";if(l&&(t=l.toString(),g.isMacintosh&&(t=C.normalizeNFC(t))),!t||a!=="change"&&a!=="rename")return;const r=k.isDirectory?y.join(k.path,t):k.path;if(k.isDirectory)if(a==="rename"){const i=f.get(r);i&&_.dispose(i);const s=setTimeout(async()=>{f.delete(r);const c=await P.Promises.exists(r);if(S)return;let p;c?h.has(t)?p="changed":(p="added",h.add(t)):(h.delete(t),p="deleted"),b(p,r)},e.CHANGE_BUFFER_DELAY);f.set(r,_.toDisposable(()=>clearTimeout(s)))}else{let i;h.has(t)?i="changed":(i="added",h.add(t)),b(i,r)}else if(a==="rename"||t!==u){const i=setTimeout(async()=>{const s=await P.Promises.exists(r);S||(s?(b("changed",r),E=[n(k,b,m)]):b("deleted",r))},e.CHANGE_BUFFER_DELAY);_.dispose(E),E=[_.toDisposable(()=>clearTimeout(i))]}else b("changed",r)})}catch(I){P.Promises.exists(k.path).then(h=>{h&&!S&&m(`Failed to watch ${k.path} for changes using fs.watch() (${I.toString()})`)})}return _.toDisposable(()=>{S=!0,E=_.dispose(E)})}});var Ne=this&&this.__decorate||function(X,e,y,D){var g=arguments.length,C=g<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,y):D,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(X,e,y,D);else for(var P=X.length-1;P>=0;P--)(_=X[P])&&(C=(g<3?_(C):g>3?_(e,y,C):_(e,y))||C);return g>3&&C&&Object.defineProperty(e,y,C),C};define(fe[36],he([0,1,7,3,14,25,12,17,21,11,46,13,71]),function(X,e,y,D,g,C,_,P,d,v,n,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function u(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(f=e.ResponseType||(e.ResponseType={}));function S(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(E||(E={}));class I{constructor(R){this.buffer=R,this.pos=0}read(R){const M=this.buffer.slice(this.pos,this.pos+R);return this.pos+=M.byteLength,M}}class h{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(R){this.buffers.push(R)}}var a;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object"})(a||(a={}));function l(T){const R=P.VSBuffer.alloc(4);return R.writeUInt32BE(T,0),R}function t(T){return T.read(4).readUInt32BE(0)}function r(T){const R=P.VSBuffer.alloc(1);return R.writeUInt8(T,0),R}const i={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object)},s=typeof Buffer!="undefined";function c(T,R){if(typeof R=="undefined")T.write(i.Undefined);else if(typeof R=="string"){const M=P.VSBuffer.fromString(R);T.write(i.String),T.write(l(M.byteLength)),T.write(M)}else if(s&&Buffer.isBuffer(R)){const M=P.VSBuffer.wrap(R);T.write(i.Buffer),T.write(l(M.byteLength)),T.write(M)}else if(R instanceof P.VSBuffer)T.write(i.VSBuffer),T.write(l(R.byteLength)),T.write(R);else if(Array.isArray(R)){T.write(i.Array),T.write(l(R.length));for(const M of R)c(T,M)}else{const M=P.VSBuffer.fromString(JSON.stringify(R));T.write(i.Object),T.write(l(M.byteLength)),T.write(M)}}function p(T){switch(T.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return T.read(t(T)).toString();case a.Buffer:return T.read(t(T)).buffer;case a.VSBuffer:return T.read(t(T));case a.Array:{const M=t(T),z=[];for(let j=0;j<M;j++)z.push(p(T));return z}case a.Object:return JSON.parse(T.read(t(T)).toString())}}class w{constructor(R,M,z=null,j=1e3){this.protocol=R,this.ctx=M,this.logger=z,this.timeoutDelay=j,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(R,M){this.channels.set(R,M),setTimeout(()=>this.flushPendingRequests(R),0)}sendResponse(R){switch(R.type){case 200:{const M=this.send([R.type]);this.logger&&this.logger.logOutgoing(M,0,1,S(R.type));return}case 201:case 202:case 204:case 203:{const M=this.send([R.type,R.id],R.data);this.logger&&this.logger.logOutgoing(M,R.id,1,S(R.type),R.data);return}}}send(R,M=void 0){const z=new h;return c(z,R),c(z,M),this.sendBuffer(z.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(M){return 0}}onRawMessage(R){const M=new I(R),z=p(M),j=p(M),ee=z[0];switch(ee){case 100:return this.logger&&this.logger.logIncoming(R.byteLength,z[1],1,`${u(ee)}: ${z[2]}.${z[3]}`,j),this.onPromise({type:ee,id:z[1],channelName:z[2],name:z[3],arg:j});case 102:return this.logger&&this.logger.logIncoming(R.byteLength,z[1],1,`${u(ee)}: ${z[2]}.${z[3]}`,j),this.onEventListen({type:ee,id:z[1],channelName:z[2],name:z[3],arg:j});case 101:return this.logger&&this.logger.logIncoming(R.byteLength,z[1],1,`${u(ee)}`),this.disposeActiveRequest({type:ee,id:z[1]});case 103:return this.logger&&this.logger.logIncoming(R.byteLength,z[1],1,`${u(ee)}`),this.disposeActiveRequest({type:ee,id:z[1]})}}onPromise(R){const M=this.channels.get(R.channelName);if(!M){this.collectPendingRequest(R);return}const z=new C.CancellationTokenSource;let j;try{j=M.call(this.ctx,R.name,R.arg,z.token)}catch(ge){j=Promise.reject(ge)}const ee=R.id;j.then(ge=>{this.sendResponse({id:ee,data:ge,type:201}),this.activeRequests.delete(R.id)},ge=>{ge instanceof Error?this.sendResponse({id:ee,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split?ge.stack.split(`
`):ge.stack:void 0},type:202}):this.sendResponse({id:ee,data:ge,type:203}),this.activeRequests.delete(R.id)});const me=D.toDisposable(()=>z.cancel());this.activeRequests.set(R.id,me)}onEventListen(R){const M=this.channels.get(R.channelName);if(!M){this.collectPendingRequest(R);return}const z=R.id,ee=M.listen(this.ctx,R.name,R.arg)(me=>this.sendResponse({id:z,data:me,type:204}));this.activeRequests.set(R.id,ee)}disposeActiveRequest(R){const M=this.activeRequests.get(R.id);M&&(M.dispose(),this.activeRequests.delete(R.id))}collectPendingRequest(R){let M=this.pendingRequests.get(R.channelName);M||(M=[],this.pendingRequests.set(R.channelName,M));const z=setTimeout(()=>{console.error(`Unknown channel: ${R.channelName}`),R.type===100&&this.sendResponse({id:R.id,data:{name:"Unknown channel",message:`Channel name '${R.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:R,timeoutTimer:z})}flushPendingRequests(R){const M=this.pendingRequests.get(R);if(M){for(const z of M)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(R)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}e.ChannelServer=w;var L;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(L=e.RequestInitiator||(e.RequestInitiator={}));class F{constructor(R,M=null){this.protocol=R,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=M}getChannel(R){const M=this;return{call(z,j,ee){return M.isDisposed?Promise.reject(_.canceled()):M.requestPromise(R,z,j,ee)},listen(z,j){return M.isDisposed?Promise.reject(_.canceled()):M.requestEvent(R,z,j)}}}requestPromise(R,M,z,j=C.CancellationToken.None){const ee=this.lastRequestId++,ge={id:ee,type:100,channelName:R,name:M,arg:z};if(j.isCancellationRequested)return Promise.reject(_.canceled());let be;return new Promise((Ae,Fe)=>{if(j.isCancellationRequested)return Fe(_.canceled());const $e=()=>{const nt=Ce=>{switch(Ce.type){case 201:this.handlers.delete(ee),Ae(Ce.data);break;case 202:this.handlers.delete(ee);const De=new Error(Ce.data.message);De.stack=Ce.data.stack,De.name=Ce.data.name,Fe(De);break;case 203:this.handlers.delete(ee),Fe(Ce.data);break}};this.handlers.set(ee,nt),this.sendRequest(ge)};let Qe=null;this.state===E.Idle?$e():(Qe=g.createCancelablePromise(nt=>this.whenInitialized()),Qe.then(()=>{Qe=null,$e()}));const Ze=()=>{Qe?(Qe.cancel(),Qe=null):this.sendRequest({id:ee,type:101}),Fe(_.canceled())},tt=j.onCancellationRequested(Ze);be=D.combinedDisposable(D.toDisposable(Ze),tt),this.activeRequests.add(be)}).finally(()=>{this.activeRequests.delete(be)})}requestEvent(R,M,z){const j=this.lastRequestId++,me={id:j,type:102,channelName:R,name:M,arg:z};let ge=null;const be=new y.Emitter({onFirstListenerAdd:()=>{ge=g.createCancelablePromise(Ae=>this.whenInitialized()),ge.then(()=>{ge=null,this.activeRequests.add(be),this.sendRequest(me)})},onLastListenerRemove:()=>{ge?(ge.cancel(),ge=null):(this.activeRequests.delete(be),this.sendRequest({id:j,type:103}))}}),Ie=Ae=>be.fire(Ae.data);return this.handlers.set(j,Ie),be.event}sendRequest(R){switch(R.type){case 100:case 102:{const M=this.send([R.type,R.id,R.channelName,R.name],R.arg);this.logger&&this.logger.logOutgoing(M,R.id,0,`${u(R.type)}: ${R.channelName}.${R.name}`,R.arg);return}case 101:case 103:{const M=this.send([R.type,R.id]);this.logger&&this.logger.logOutgoing(M,R.id,0,u(R.type));return}}}send(R,M=void 0){const z=new h;return c(z,R),c(z,M),this.sendBuffer(z.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(M){return 0}}onBuffer(R){const M=new I(R),z=p(M),j=p(M),ee=z[0];switch(ee){case 200:return this.logger&&this.logger.logIncoming(R.byteLength,0,0,S(ee)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(R.byteLength,z[1],0,S(ee),j),this.onResponse({type:z[0],id:z[1],data:j})}}onResponse(R){if(R.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(R.id);M&&M(R)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}Ne([b.memoize],F.prototype,"onDidInitializePromise",null),e.ChannelClient=F;class o{constructor(R){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,R(({protocol:M,onDidClientDisconnect:z})=>{y.Event.once(M.onMessage)(ee=>{const me=new I(ee),ge=p(me),be=new w(M,ge),Ie=new F(M);this.channels.forEach((Fe,$e)=>be.registerChannel($e,Fe));const Ae={channelServer:be,channelClient:Ie,ctx:ge};this._connections.add(Ae),this._onDidAddConnection.fire(Ae),z(()=>{be.dispose(),Ie.dispose(),this._connections.delete(Ae),this._onDidRemoveConnection.fire(Ae)})})})}get connections(){const R=[];return this._connections.forEach(M=>R.push(M)),R}getChannel(R,M){const z=this;return{call(j,ee,me){let ge;if(v.isFunction(M)){let Ie=d.getRandomElement(z.connections.filter(M));ge=Ie?Promise.resolve(Ie):y.Event.toPromise(y.Event.filter(z.onDidAddConnection,M))}else ge=M.routeCall(z,j,ee);const be=ge.then(Ie=>Ie.channelClient.getChannel(R));return N(be).call(j,ee,me)},listen(j,ee){if(v.isFunction(M))return z.getMulticastEvent(R,M,j,ee);const me=M.routeEvent(z,j,ee).then(ge=>ge.channelClient.getChannel(R));return N(me).listen(j,ee)}}}getMulticastEvent(R,M,z,j){const ee=this;let me=new D.DisposableStore;const ge=new y.Emitter({onFirstListenerAdd:()=>{me=new D.DisposableStore;const be=new y.EventMultiplexer,Ie=new Map,Ae=$e=>{const Ze=$e.channelClient.getChannel(R).listen(z,j),tt=be.add(Ze);Ie.set($e,tt)},Fe=$e=>{const Qe=Ie.get($e);!Qe||(Qe.dispose(),Ie.delete($e))};ee.connections.filter(M).forEach(Ae),y.Event.filter(ee.onDidAddConnection,M)(Ae,void 0,me),ee.onDidRemoveConnection(Fe,void 0,me),be.event(ge.fire,ge,me),me.add(be)},onLastListenerRemove:()=>{me.dispose()}});return ge.event}registerChannel(R,M){this.channels.set(R,M),this._connections.forEach(z=>{z.channelServer.registerChannel(R,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class A{constructor(R,M,z=null){const j=new h;c(j,M),R.send(j.buffer),this.channelClient=new F(R,z),this.channelServer=new w(R,M,z)}getChannel(R){return this.channelClient.getChannel(R)}registerChannel(R,M){this.channelServer.registerChannel(R,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function N(T){return{call(R,M,z){return T.then(j=>j.call(R,M,z))},listen(R,M){const z=new y.Relay;return T.then(j=>z.input=j.listen(R,M)),z.event}}}e.getDelayedChannel=N;function Q(T){let R=!1;return{call(M,z,j){return R?T.call(M,z,j):g.timeout(0).then(()=>R=!0).then(()=>T.call(M,z,j))},listen(M,z){if(R)return T.listen(M,z);const j=new y.Relay;return g.timeout(0).then(()=>R=!0).then(()=>j.input=T.listen(M,z)),j.event}}}e.getNextTickChannel=Q;class J{constructor(R){this.fn=R}routeCall(R){return this.route(R)}routeEvent(R){return this.route(R)}async route(R){for(const M of R.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await y.Event.toPromise(R.onDidAddConnection),await this.route(R)}}e.StaticRouter=J;var ce;(function(T){function R(j,ee){const me=j,ge=ee&&ee.disableMarshalling,be=new Map;for(const Ie in me)z(Ie)&&be.set(Ie,y.Event.buffer(me[Ie],!0));return new class{listen(Ie,Ae){const Fe=be.get(Ae);if(Fe)return Fe;throw new Error(`Event not found: ${Ae}`)}call(Ie,Ae,Fe){const $e=me[Ae];if(typeof $e=="function"){if(!ge&&Array.isArray(Fe))for(let Qe=0;Qe<Fe.length;Qe++)Fe[Qe]=n.revive(Fe[Qe]);return $e.apply(me,Fe)}throw new Error(`Method not found: ${Ae}`)}}}T.fromService=R;function M(j,ee){const me=ee&&ee.disableMarshalling;return new Proxy({},{get(ge,be){if(typeof be=="string")return ee?.properties?.has(be)?ee.properties.get(be):z(be)?j.listen(be):async function(...Ie){let Ae;ee&&!v.isUndefinedOrNull(ee.context)?Ae=[ee.context,...Ie]:Ae=Ie;const Fe=await j.call(be,Ae);return me?Fe:n.revive(Fe)};throw new Error(`Property not found: ${String(be)}`)}})}T.toService=M;function z(j){return j[0]==="o"&&j[1]==="n"&&k.isUpperAsciiLetter(j.charCodeAt(2))}})(ce=e.ProxyChannel||(e.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){let R=T.toString();if(R!=="[object Object]")return R}return T}function q(T){return Array.isArray(T)?T.map($):$(T)}function W(T,R,M,z,j,ee,me){me=q(me);const ge=se[j],be=ge[z%ge.length];let Ie=[`%c[${T}]%c[${String(R).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${be}`];/\($/.test(ee)?(Ie=Ie.concat(me),Ie.push(")")):Ie.push(me),console.log.apply(console,Ie)}e.logWithColors=W;class V{constructor(R,M){this._outgoingPrefix=R,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(R,M,z,j,ee){this._totalOutgoing+=R,W(this._outgoingPrefix,this._totalOutgoing,R,M,z,j,ee)}logIncoming(R,M,z,j,ee){this._totalIncoming+=R,W(this._incomingPrefix,this._totalIncoming,R,M,z,j,ee)}}e.IPCLogger=V}),define(fe[82],he([0,1,7,36,3,17,5,23]),function(X,e,y,D,g,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let v=null;function n(){return v||(v=C.VSBuffer.alloc(0)),v}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,c){if(s===0)return n();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const F=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=s),F}if(this._chunks[0].byteLength>s){const F=this._chunks[0].slice(0,s);return c&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),F}let p=C.VSBuffer.alloc(s),w=0,L=0;for(;s>0;){const F=this._chunks[L];if(F.byteLength>s){const o=F.slice(0,s);p.set(o,w),w+=s,c&&(this._chunks[L]=F.slice(s),this._totalLength-=s),s-=s}else p.set(F,w),w+=F.byteLength,c?(this._chunks.shift(),this._totalLength-=F.byteLength):L++,s-=F.byteLength}return p}}e.ChunkStream=k;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(b||(b={}));var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(s,c,p,w){this.type=s,this.id=c,this.ack=p,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends g.Disposable{constructor(s){super();this._onMessage=this._register(new y.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5);else{const p=this._state.messageType,w=this._state.id,L=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new u(p,w,L,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=C.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this._writeSoon(c,s.data)}_bufferAdd(s,c){const p=this._totalLength===0;return this._data.push(s,c),this._totalLength+=s.byteLength+c.byteLength,p}_bufferTake(){const s=C.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,c){this._bufferAdd(s,c)&&_.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends g.Disposable{constructor(s){super();this._onMessage=new y.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new u(1,0,0,s))}}e.Protocol=E;class I extends D.IPCClient{constructor(s,c,p=null){super(s,c,p);this.protocol=s}static fromSocket(s,c){return new I(new E(s),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=I;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new y.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class a{constructor(s){this.data=s,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],c=0,p=this._first;for(;p;)s[c++]=p.data,p=p.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const c=new a(s);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class t{constructor(){this.lastRuns=[];const s=Date.now();for(let c=0;c<t._HISTORY_LENGTH;c++)this.lastRuns[c]=s-1e3*c;setInterval(()=>{for(let c=t._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const s=Date.now(),c=(1+t._HISTORY_LENGTH)*1e3;let p=0;for(let w=0;w<t._HISTORY_LENGTH;w++)s-this.lastRuns[w]<=c&&p++;return 1-p/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(s,c=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),c&&this._socketReader.acceptChunk(c),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=g.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new u(5,0,0,n());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const c=new u(4,0,0,n());this._socketWriter.write(c),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,c){this._isReconnecting=!0,this._socketDisposables=g.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let c=0,p=s.length;c<p;c++)this._socketWriter.write(s[c]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new u(6,0,0,n())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const c=this._outgoingUnackMsg.toArray();for(let p=0,w=c.length;p<w;p++)this._socketWriter.write(c[p]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const p=new u(1,c,this._incomingAckId,s);this._outgoingUnackMsg.push(p),this._isReconnecting||(this._socketWriter.write(p),this._recvAckCheck())}sendControl(s){const c=new u(2,0,0,s);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const s=this._outgoingUnackMsg.peek(),c=Date.now()-s.writtenTime;if(c>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-c,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new u(3,0,this._incomingAckId,n());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(fe[127],he([0,1,3,7,14,11]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var _;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(_=e.StorageHint||(e.StorageHint={}));var P;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(P||(P={}));class d extends y.Disposable{constructor(k,b=Object.create(null)){super();this.database=k,this.options=b,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new g.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(k=>this.onDidChangeItemsExternal(k)))}onDidChangeItemsExternal(k){k.changed?.forEach((b,m)=>this.accept(m,b)),k.deleted?.forEach(b=>this.accept(b,void 0))}accept(k,b){if(this.state===P.Closed)return;let m=!1;C.isUndefinedOrNull(b)?m=this.cache.delete(k):this.cache.get(k)!==b&&(this.cache.set(k,b),m=!0),m&&this._onDidChangeStorage.fire(k)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==_.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(k,b){const m=this.cache.get(k);return C.isUndefinedOrNull(m)?b:m}getBoolean(k,b){const m=this.get(k);return C.isUndefinedOrNull(m)?b:m==="true"}getNumber(k,b){const m=this.get(k);return C.isUndefinedOrNull(m)?b:parseInt(m,10)}async set(k,b){if(this.state===P.Closed)return;if(C.isUndefinedOrNull(b))return this.delete(k);const m=String(b);if(this.cache.get(k)!==m)return this.cache.set(k,m),this.pendingInserts.set(k,m),this.pendingDeletes.delete(k),this._onDidChangeStorage.fire(k),this.flushDelayer.trigger(()=>this.flushPending())}async delete(k){if(!(this.state===P.Closed||!this.cache.delete(k)))return this.pendingDeletes.has(k)||this.pendingDeletes.add(k),this.pendingInserts.delete(k),this._onDidChangeStorage.fire(k),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(k){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const k={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(k).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(k=>this.whenFlushedCallbacks.push(k))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(k){k.insert&&k.insert.forEach((b,m)=>this.items.set(m,b)),k.delete&&k.delete.forEach(b=>this.items.delete(b))}async close(){}}e.InMemoryStorageDatabase=v}),define(fe[83],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class y{constructor(g,C){this.lineNumber=g,this.column=C}with(g=this.lineNumber,C=this.column){return g===this.lineNumber&&C===this.column?this:new y(g,C)}delta(g=0,C=0){return this.with(this.lineNumber+g,this.column+C)}equals(g){return y.equals(this,g)}static equals(g,C){return!g&&!C?!0:!!g&&!!C&&g.lineNumber===C.lineNumber&&g.column===C.column}isBefore(g){return y.isBefore(this,g)}static isBefore(g,C){return g.lineNumber<C.lineNumber?!0:C.lineNumber<g.lineNumber?!1:g.column<C.column}isBeforeOrEqual(g){return y.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,C){return g.lineNumber<C.lineNumber?!0:C.lineNumber<g.lineNumber?!1:g.column<=C.column}static compare(g,C){let _=g.lineNumber|0,P=C.lineNumber|0;if(_===P){let d=g.column|0,v=C.column|0;return d-v}return _-P}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new y(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}}e.Position=y}),define(fe[55],he([0,1,83]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class D{constructor(C,_,P,d){C>P||C===P&&_>d?(this.startLineNumber=P,this.startColumn=d,this.endLineNumber=C,this.endColumn=_):(this.startLineNumber=C,this.startColumn=_,this.endLineNumber=P,this.endColumn=d)}isEmpty(){return D.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return D.containsPosition(this,C)}static containsPosition(C,_){return!(_.lineNumber<C.startLineNumber||_.lineNumber>C.endLineNumber||_.lineNumber===C.startLineNumber&&_.column<C.startColumn||_.lineNumber===C.endLineNumber&&_.column>C.endColumn)}containsRange(C){return D.containsRange(this,C)}static containsRange(C,_){return!(_.startLineNumber<C.startLineNumber||_.endLineNumber<C.startLineNumber||_.startLineNumber>C.endLineNumber||_.endLineNumber>C.endLineNumber||_.startLineNumber===C.startLineNumber&&_.startColumn<C.startColumn||_.endLineNumber===C.endLineNumber&&_.endColumn>C.endColumn)}strictContainsRange(C){return D.strictContainsRange(this,C)}static strictContainsRange(C,_){return!(_.startLineNumber<C.startLineNumber||_.endLineNumber<C.startLineNumber||_.startLineNumber>C.endLineNumber||_.endLineNumber>C.endLineNumber||_.startLineNumber===C.startLineNumber&&_.startColumn<=C.startColumn||_.endLineNumber===C.endLineNumber&&_.endColumn>=C.endColumn)}plusRange(C){return D.plusRange(this,C)}static plusRange(C,_){let P,d,v,n;return _.startLineNumber<C.startLineNumber?(P=_.startLineNumber,d=_.startColumn):_.startLineNumber===C.startLineNumber?(P=_.startLineNumber,d=Math.min(_.startColumn,C.startColumn)):(P=C.startLineNumber,d=C.startColumn),_.endLineNumber>C.endLineNumber?(v=_.endLineNumber,n=_.endColumn):_.endLineNumber===C.endLineNumber?(v=_.endLineNumber,n=Math.max(_.endColumn,C.endColumn)):(v=C.endLineNumber,n=C.endColumn),new D(P,d,v,n)}intersectRanges(C){return D.intersectRanges(this,C)}static intersectRanges(C,_){let P=C.startLineNumber,d=C.startColumn,v=C.endLineNumber,n=C.endColumn,k=_.startLineNumber,b=_.startColumn,m=_.endLineNumber,u=_.endColumn;return P<k?(P=k,d=b):P===k&&(d=Math.max(d,b)),v>m?(v=m,n=u):v===m&&(n=Math.min(n,u)),P>v||P===v&&d>n?null:new D(P,d,v,n)}equalsRange(C){return D.equalsRange(this,C)}static equalsRange(C,_){return!!C&&!!_&&C.startLineNumber===_.startLineNumber&&C.startColumn===_.startColumn&&C.endLineNumber===_.endLineNumber&&C.endColumn===_.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(C){return new y.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(C){return new y.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,_){return new D(this.startLineNumber,this.startColumn,C,_)}setStartPosition(C,_){return new D(C,_,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(C){return new D(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,_=C){return new D(C.lineNumber,C.column,_.lineNumber,_.column)}static lift(C){return C?new D(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,_){return!(C.endLineNumber<_.startLineNumber||C.endLineNumber===_.startLineNumber&&C.endColumn<_.startColumn||_.endLineNumber<C.startLineNumber||_.endLineNumber===C.startLineNumber&&_.endColumn<C.startColumn)}static areIntersecting(C,_){return!(C.endLineNumber<_.startLineNumber||C.endLineNumber===_.startLineNumber&&C.endColumn<=_.startColumn||_.endLineNumber<C.startLineNumber||_.endLineNumber===C.startLineNumber&&_.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,_){if(C&&_){const v=C.startLineNumber|0,n=_.startLineNumber|0;if(v===n){const k=C.startColumn|0,b=_.startColumn|0;if(k===b){const m=C.endLineNumber|0,u=_.endLineNumber|0;if(m===u){const f=C.endColumn|0,S=_.endColumn|0;return f-S}return m-u}return k-b}return v-n}return(C?1:0)-(_?1:0)}static compareRangesUsingEnds(C,_){return C.endLineNumber===_.endLineNumber?C.endColumn===_.endColumn?C.startLineNumber===_.startLineNumber?C.startColumn-_.startColumn:C.startLineNumber-_.startLineNumber:C.endColumn-_.endColumn:C.endLineNumber-_.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=D}),define(fe[128],he([0,1,47,4]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function g(C,_,P,d){if(Array.isArray(C)){let v=0;for(const n of C){const k=g(n,_,P,d);if(k===10)return k;k>v&&(v=k)}return v}else{if(typeof C=="string")return d?C==="*"?5:C===P?10:0:0;if(C){const{language:v,pattern:n,scheme:k,hasAccessToAllModels:b}=C;if(!d&&!b)return 0;let m=0;if(k)if(k===_.scheme)m=10;else if(k==="*")m=5;else return 0;if(v)if(v===P)m=10;else if(v==="*")m=Math.max(m,5);else return 0;if(n){let u;if(typeof n=="string"?u=n:u={...n,base:D.normalize(n.base)},u===_.fsPath||y.match(u,_.fsPath))m=10;else return 0}return m}else return 0}}e.score=g}),define(fe[129],he([0,1,7,3]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class g{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(_){this._onDidChange.fire({changedLanguages:_,changedColorMap:!1})}register(_,P){return this._map.set(_,P),this.fire([_]),D.toDisposable(()=>{this._map.get(_)===P&&(this._map.delete(_),this.fire([_]))})}registerPromise(_,P){let d=null,v=!1;return this._promises.set(_,P.then(n=>{this._promises.delete(_),!(v||!n)&&(d=this.register(_,n))})),D.toDisposable(()=>{v=!0,d&&d.dispose()})}getPromise(_){const P=this.get(_);if(P)return Promise.resolve(P);const d=this._promises.get(_);return d?d.then(v=>this.get(_)):null}get(_){return this._map.get(_)||null}setColorMap(_){this._colorMap=_,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=g}),define(fe[130],he([9,10]),function(X,e){return X.create("vs/base/common/date",e)}),define(fe[131],he([0,1,130]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,g=D*60,C=g*24,_=C*7,P=C*30,d=C*365;function v(k,b){typeof k!="number"&&(k=k.getTime());const m=Math.round((new Date().getTime()-k)/1e3);if(m<-30)return y.localize(0,null,v(new Date().getTime()+m*1e3,!1));if(m<30)return y.localize(1,null);let u;return m<D?(u=m,b?u===1?y.localize(2,null,u):y.localize(3,null,u):u===1?y.localize(4,null,u):y.localize(5,null,u)):m<g?(u=Math.floor(m/D),b?u===1?y.localize(6,null,u):y.localize(7,null,u):u===1?y.localize(8,null,u):y.localize(9,null,u)):m<C?(u=Math.floor(m/g),b?u===1?y.localize(10,null,u):y.localize(11,null,u):u===1?y.localize(12,null,u):y.localize(13,null,u)):m<_?(u=Math.floor(m/C),b?u===1?y.localize(14,null,u):y.localize(15,null,u):u===1?y.localize(16,null,u):y.localize(17,null,u)):m<P?(u=Math.floor(m/_),b?u===1?y.localize(18,null,u):y.localize(19,null,u):u===1?y.localize(20,null,u):y.localize(21,null,u)):m<d?(u=Math.floor(m/P),b?u===1?y.localize(22,null,u):y.localize(23,null,u):u===1?y.localize(24,null,u):y.localize(25,null,u)):(u=Math.floor(m/d),b?u===1?y.localize(26,null,u):y.localize(27,null,u):u===1?y.localize(28,null,u):y.localize(29,null,u))}e.fromNow=v;function n(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(fe[132],he([9,10]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(fe[43],he([0,1,132,11,21]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(v,n){return n&&(v.stack||v.stacktrace)?y.localize(0,null,P(v),_(v.stack)||_(v.stacktrace)):P(v)}function _(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?y.localize(1,null,v.message):v.message||y.localize(2,null)}function d(v=null,n=!1){if(!v)return y.localize(3,null);if(Array.isArray(v)){const k=g.coalesce(v),b=d(k[0],n);return k.length>1?y.localize(4,null,b,k.length):b}if(D.isString(v))return v;if(v.detail){const k=v.detail;if(k.error)return C(k.error,n);if(k.exception)return C(k.exception,n)}return v.stack?C(v,n):v.message?v.message:y.localize(5,null)}e.toErrorMessage=d}),define(fe[133],he([9,10]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(fe[134],he([0,1,133]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function D(g){switch(g){case 1:return y.localize(0,null);case 2:return y.localize(1,null);case 3:return y.localize(2,null);case 4:return y.localize(3,null);case 5:return y.localize(4,null);case 6:return y.localize(5,null);case 7:return y.localize(6,null);case 8:return y.localize(7,null);case 9:return y.localize(8,null);default:return""}}e.getParseErrorMessage=D}),define(fe[135],he([9,10]),function(X,e){return X.create("vs/base/node/processes",e)}),define(fe[84],he([0,1,4,15,35,135,23,11,18,30,5,76,8]),function(X,e,y,D,g,C,_,P,d,v,n,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(a,l){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};l&&(t.cwd=l);const r=g.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(i=>{r.once("error",s=>{i({success:!1,error:s})}),r.once("exit",(s,c)=>{i(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(r=>{g.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(i,s,c)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function f(a=_.env){return a.comspec||"cmd.exe"}e.getWindowsShell=f;class S{constructor(l,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=l,this.args=t,this.shell=r,this.options=i;else{const s=l;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(_.env).forEach(c=>{s[c]=_.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const t=l.lastIndexOf(y.sep);return t!==-1&&(l=l.substring(t+1)),S.WellKnowCommands[l]?l:"other"}start(l){return n.isWindows&&(this.options&&this.options.cwd&&v.isUNC(this.options.cwd)||!this.options&&v.isUNC(_.cwd()))?Promise.reject(new Error(C.localize(0,null))):this.useExec().then(t=>{let r,i;const s=new Promise((c,p)=>{r=c,i=p});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=g.exec(c,this.options,(p,w,L)=>{this.childProcess=null;const F=p;F&&F.killed?i({killed:this.terminateRequested,stdout:w.toString(),stderr:L.toString()}):this.handleExec(r,l,p,w,L)})}else{let c=null;const p=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,r,l,i);const L={terminated:this.terminateRequested};P.isNumber(w)&&(L.cmdCode=w),r(L)};if(this.shell&&n.isWindows){const w=d.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let L=!1,F=!1;const o=[];let A=this.ensureQuotes(this.cmd);o.push(A.value),L=A.quoted,this.args&&this.args.forEach(Q=>{A=this.ensureQuotes(Q),o.push(A.value),F=F&&A.quoted});const N=["/s","/c"];L?F?N.push('"'+o.join(" ")+'"'):o.length>1?N.push('"'+o[0]+'" '+o.slice(1).join(" ")):N.push('"'+o[0]+'"'):N.push(o.join(" ")),c=g.spawn(f(),N,w)}else this.cmd&&(c=g.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(P.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",w=>{this.childProcess=null,i({terminated:this.terminateRequested,error:w})}),c.pid&&(this.childProcess.on("close",p),this.handleSpawn(c,r,l,i,!0)))}return s})}handleClose(l,t,r,i){}ensureQuotes(l){return S.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,u(l,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!n.isWindows)return l(!1);const t=g.spawn(f(),["/s","/c"]);t.on("error",r=>l(!0)),t.on("exit",r=>l(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class E extends S{constructor(l,t,r,i){super(l,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,t,r,i,s){[i,s].forEach((c,p)=>{const w=new k.LineDecoder;w.write(c).forEach(o=>{t({line:o,source:p===0?0:1})});const F=w.end();F&&t({line:F,source:p===0?0:1})}),l({terminated:this.terminateRequested,error:r})}handleSpawn(l,t,r,i,s){const c=new k.LineDecoder,p=new k.LineDecoder;l.stdout.on("data",w=>{c.write(w).forEach(F=>r({line:F,source:0}))}),l.stderr.on("data",w=>{p.write(w).forEach(F=>r({line:F,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=p}handleClose(l,t,r,i){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=E;function I(a){let l=[],t=!1;const r=function(i){if(t){l.push(i);return}(!a.send(i,c=>{if(c&&console.error(c),t=!1,l.length>0){const p=l.slice(0);l=[],p.forEach(w=>r(w))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=I;var h;(function(a){async function l(t,r,i){if(y.isAbsolute(t))return t;if(r===void 0&&(r=_.cwd()),y.dirname(t)!=="."||(i===void 0&&P.isString(_.env.PATH)&&(i=_.env.PATH.split(y.delimiter)),i===void 0||i.length===0))return y.join(r,t);async function c(p){return await D.Promises.exists(p)?!(await D.Promises.stat(p)).isDirectory():!1}for(let p of i){let w;if(y.isAbsolute(p)?w=y.join(p,t):w=y.join(r,p,t),await c(w))return w;let L=w+".com";if(await c(L)||(L=w+".exe",await c(L)))return L}return y.join(r,t)}a.findExecutable=l})(h=e.win32||(e.win32={}))}),define(fe[136],he([0,1,24,5,80,84]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function _(m,u){return m===1?D.isWindows?k():C.getWindowsShell(u):v(m,u)}e.getSystemShell=_;function P(m,u){return m===1?D.isWindows?b(u):C.getWindowsShell(u):v(m,u)}e.getSystemShellSync=P;let d=null;function v(m,u){if(D.isLinux&&m===2||D.isMacintosh&&m===3)return"/bin/bash";if(!d){let f;if(D.isWindows)f="/bin/bash";else{if(f=u.SHELL,!f)try{f=y.userInfo().shell}catch(S){}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}d=f}return d}let n=null;async function k(){return n||(n=(await g.getFirstAvailablePowerShellInstallation()).exePath),n}function b(m){if(n)return n;const u=D.isWindows&&parseFloat(y.release())>=10,f=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${m.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?S:C.getWindowsShell(m)}}),define(fe[56],he([0,1,35,3,14,18,7,84,36,118,25,12,17,5]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends d.ChannelServer{constructor(E){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(h){}},onMessage:_.Event.fromNodeEventEmitter(process,"message",I=>b.VSBuffer.wrap(Buffer.from(I,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=u;class f{constructor(E,I){this.modulePath=E,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new _.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new g.Delayer(h),this.child=null,this._client=null}getChannel(E){const I=this;return{call(h,a,l){return I.requestPromise(E,h,a,l)},listen(h,a){return I.requestEvent(E,h,a)}}}requestPromise(E,I,h,a=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(k.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(E),t=g.createCancelablePromise(s=>l.call(I,h,s)),r=a.onCancellationRequested(()=>t.cancel()),i=D.toDisposable(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,I,h){if(!this.disposeDelayer)return _.Event.None;this.disposeDelayer.cancel();let a;const l=new _.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(E).listen(I,h)(l.fire,l),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env={...C.deepClone(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(I.env={...I.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),m.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=y.fork(this.modulePath,E,I);const h=new _.Emitter;_.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if(v.isRemoteConsoleLog(c)){v.log(c,`IPC Library: ${this.options.serverName}`);return}h.fire(b.VSBuffer.wrap(Buffer.from(c,"base64")))});const l=this.options.useQueue?P.createQueuedSender(this.child):this.child,t=c=>this.child&&this.child.connected&&l.send(c.buffer.toString("base64")),r=h.event,i={send:t,onMessage:r};this._client=new d.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,p)=>{process.removeListener("exit",s),this.activeRequests.forEach(w=>D.dispose(w)),this.activeRequests.clear(),c!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+p),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:p})})}return this._client}getCachedChannel(E){let I=this.channels.get(E);return I||(I=this.client.getChannel(E),this.channels.set(E,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=f}),define(fe[137],he([9,10]),function(X,e){return X.create("vs/base/node/zip",e)}),define(fe[138],he([9,10]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[139],he([9,10]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(fe[140],he([9,10]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(fe[141],he([9,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[142],he([9,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(fe[143],he([9,10]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(fe[144],he([9,10]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(fe[145],he([9,10]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(fe[146],he([9,10]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[147],he([9,10]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(fe[148],he([9,10]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(fe[149],he([9,10]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(fe[150],he([9,10]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(fe[151],he([9,10]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(fe[152],he([9,10]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(fe[153],he([9,10]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(fe[154],he([9,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(fe[155],he([9,10]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[156],he([9,10]),function(X,e){return X.create("vs/server/remoteAgentEnvironmentImpl",e)}),define(fe[157],he([9,10]),function(X,e){return X.create("vs/server/serverEnvironmentService",e)}),define(fe[158],he([9,10]),function(X,e){return X.create("vs/workbench/common/editor",e)}),define(fe[159],he([9,10]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[160],he([9,10]),function(X,e){return X.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(fe[161],he([0,1,7,3]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class g{constructor(){this._onCloseEmitter=new y.Emitter,this._onReloadEmitter=new y.Emitter,this._onTerminateEmitter=new y.Emitter,this._onAttachEmitter=new y.Emitter}call(P,d,v){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:v[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:v[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:v[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:v[0],port:v[1],subId:v[2]}))}throw new Error("Method not implemented.")}listen(P,d,v){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=g,g.ChannelName="extensionhostdebugservice";class C extends D.Disposable{constructor(P){super();this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,d,v){this.channel.call("attach",[P,d,v])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,d){this.channel.call("terminate",[P,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,d,v){return this.channel.call("openExtensionDevelopmentHostWindow",[P,d||{},v])}}e.ExtensionHostDebugChannelClient=C}),define(fe[162],he([0,1,2]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class D{constructor(_){this.service=_}listen(_,P,d){throw new Error("Invalid listen")}call(_,P,d){switch(P){case"download":return this.service.download(y.URI.revive(d[0]),y.URI.revive(d[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=D;class g{constructor(_,P){this.channel=_,this.getUriTransformer=P}async download(_,P){const d=this.getUriTransformer();d&&(_=d.transformOutgoingURI(_),P=d.transformOutgoingURI(P)),await this.channel.call("download",[_,P])}}e.DownloadServiceChannelClient=g}),define(fe[163],he([0,1,2]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=e.isResourceEditorInput=void 0;function D(d){const v=d;return y.URI.isUri(v?.resource)}e.isResourceEditorInput=D;var g;(function(d){d[d.ACTIVATE=1]="ACTIVATE",d[d.RESTORE=2]="RESTORE",d[d.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var C;(function(d){d[d.PICK=0]="PICK",d[d.DISABLED=1]="DISABLED",d[d.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(C=e.EditorOverride||(e.EditorOverride={}));var _;(function(d){d[d.API=0]="API",d[d.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(d){d[d.Center=0]="Center",d[d.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",d[d.NearTop=2]="NearTop",d[d.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[164],he([0,1,4,19,71,131,8,2,23]),function(X,e,y,D,g,C,_,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class v{constructor(u,f,S){this._args=u,this.paths=f,this.productService=S}get appRoot(){return y.dirname(_.FileAccess.asFileUri("",X).fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file(y.join(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return D.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return D.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=C.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=y.join(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file(y.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return D.joinPath(P.URI.file(y.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return P.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return P.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return D.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return D.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=d.env.VSCODE_PORTABLE;return u?P.URI.file(y.join(u,"argv.json")):D.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return D.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file(y.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return y.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?y.resolve(u):y.normalize(y.join(_.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?y.resolve(u):y.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return y.resolve(u);const f=d.env.VSCODE_EXTENSIONS;if(f)return f;const S=d.env.VSCODE_PORTABLE;return S?y.join(S,"extensions"):D.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(f=>/^[^:/?#]+?:\/\//.test(f)?P.URI.parse(f):P.URI.file(y.normalize(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?P.URI.parse(u):P.URI.file(y.normalize(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!d.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return D.joinPath(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return P.URI.file(y.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}Ne([g.memoize],v.prototype,"appRoot",null),Ne([g.memoize],v.prototype,"userHome",null),Ne([g.memoize],v.prototype,"userDataPath",null),Ne([g.memoize],v.prototype,"appSettingsHome",null),Ne([g.memoize],v.prototype,"tmpDir",null),Ne([g.memoize],v.prototype,"userRoamingDataHome",null),Ne([g.memoize],v.prototype,"settingsResource",null),Ne([g.memoize],v.prototype,"userDataSyncHome",null),Ne([g.memoize],v.prototype,"userDataSyncLogResource",null),Ne([g.memoize],v.prototype,"sync",null),Ne([g.memoize],v.prototype,"machineSettingsResource",null),Ne([g.memoize],v.prototype,"globalStorageHome",null),Ne([g.memoize],v.prototype,"workspaceStorageHome",null),Ne([g.memoize],v.prototype,"keybindingsResource",null),Ne([g.memoize],v.prototype,"keyboardLayoutResource",null),Ne([g.memoize],v.prototype,"argvResource",null),Ne([g.memoize],v.prototype,"snippetsHome",null),Ne([g.memoize],v.prototype,"isExtensionDevelopment",null),Ne([g.memoize],v.prototype,"untitledWorkspacesHome",null),Ne([g.memoize],v.prototype,"installSourcePath",null),Ne([g.memoize],v.prototype,"builtinExtensionsPath",null),Ne([g.memoize],v.prototype,"extensionsPath",null),Ne([g.memoize],v.prototype,"extensionDevelopmentLocationURI",null),Ne([g.memoize],v.prototype,"extensionDevelopmentKind",null),Ne([g.memoize],v.prototype,"extensionTestsLocationURI",null),Ne([g.memoize],v.prototype,"debugExtensionHost",null),Ne([g.memoize],v.prototype,"serviceMachineIdResource",null),Ne([g.memoize],v.prototype,"telemetryLogResource",null),Ne([g.memoize],v.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=v;function n(m,u){return b(m["inspect-extensions"],m["inspect-brk-extensions"],5870,u,m.debugId)}e.parseExtensionHostPort=n;function k(m,u){return b(m["inspect-search"],m["inspect-brk-search"],5876,u)}e.parseSearchPort=k;function b(m,u,f,S,E){const h=Number(u||m)||(S?null:f),a=h?Boolean(!!u):!1;return{port:h,break:a,debugId:E}}}),define(fe[57],he([0,1,237,139,5]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:D.localize(0,null),e:D.localize(1,null),t:D.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:D.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:D.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:D.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:D.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:D.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:D.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:D.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:D.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:D.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:D.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:D.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:D.localize(14,null)},category:{type:"string",cat:"e",description:D.localize(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:D.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:D.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:D.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:D.localize(19,null)},verbose:{type:"boolean",cat:"t",description:D.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:D.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:D.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:D.localize(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:D.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:D.localize(25,null)},sync:{type:"string",cat:"t",description:D.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:D.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:D.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:D.localize(29,null)},"max-memory":{type:"string",cat:"t",description:D.localize(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:D.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const _={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(u,f,S=_){const E={},I=[],h=[];for(let r in f){const i=f[r];i.alias&&(E[r]=i.alias),i.type==="string"||i.type==="string[]"?(I.push(r),i.deprecates&&I.push(i.deprecates)):i.type==="boolean"&&(h.push(r),i.deprecates&&h.push(i.deprecates))}const a=y(u,{string:I,boolean:h,alias:E}),l={},t=a;l._=a._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in f){const i=f[r];i.alias&&delete t[i.alias];let s=t[r];i.deprecates&&t.hasOwnProperty(i.deprecates)&&(s||(s=t[i.deprecates]),delete t[i.deprecates]),typeof s!="undefined"&&(i.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):i.type==="string"&&Array.isArray(s)&&(s=s.pop(),S.onMultipleValues(r,s)),l[r]=s),delete t[r]}for(let r in t)S.onUnknownOption(r);return l}e.parseArgs=P;function d(u,f){let S="";return f.args&&(Array.isArray(f.args)?S=` <${f.args.join("> <")}>`:S=` <${f.args}>`),f.alias?`-${f.alias} --${u}${S}`:`--${u}${S}`}function v(u,f){let S=0,E=[];for(const l in u){const t=u[l],r=d(l,t);S=Math.max(S,r.length),E.push([r,t.description])}let I=S+2+1;if(f-I<25)return E.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let h=f-I-1,a=[];for(const l of E){let t=l[0],r=k(l[1],h),i=n(I-t.length-2);a.push("  "+t+i+r[0]);for(let s=1;s<r.length;s++)a.push(n(I)+r[s])}return a}e.formatOptions=v;function n(u){return" ".repeat(u)}function k(u,f){let S=[];for(;u.length;){let E=u.length<f?u.length:u.lastIndexOf(" ",f),I=u.slice(0,E).trim();u=u.slice(E),S.push(I)}return S}function b(u,f,S,E,I=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${u} ${S}`];a.push(""),a.push(`${D.localize(32,null)}: ${f} [${D.localize(33,null)}][${D.localize(34,null)}...]`),a.push(""),I&&(g.isWindows?a.push(D.localize(35,null,f)):a.push(D.localize(36,null,f)),a.push(""));const l={};for(const t in E){const r=E[t];if(r.description&&r.cat){let i=l[r.cat];i||(l[r.cat]=i={}),i[t]=r}}for(let t in l){const r=t;let i=l[r];i&&(a.push(C[r]),a.push(...v(i,h)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=b;function m(u,f){return`${u||D.localize(37,null)}
${f||D.localize(38,null)}
${process.arch}`}e.buildVersionMessage=m}),function(){"use strict";function X(e,y,D,g){function C(P){const d=_(P),v=[d];return e.isAbsolute(d)||v.unshift(g),e.resolve(...v)}function _(P){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");const v=P["user-data-dir"];if(v)return v;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(k,"AppData","Roaming")}break;case"darwin":n=e.join(y.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,D)}return{getUserDataPath:C}}if(typeof define=="function")define(fe[165],he([0,77,24,8,19,23]),function(e,y,D,g,C,_){const P=C.dirname(g.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(C.joinPath(P,"package.json").fsPath);return X(y,D,d.name,_.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),y=require("path"),D=require("os");module.exports=X(y,D,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(fe[166],he([0,1,24,165,164]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends g.AbstractNativeEnvironmentService{constructor(P,d){super(P,{homeDir:y.homedir(),tmpDir:y.tmpdir(),userDataDir:D.getUserDataPath(P)},d)}}e.NativeEnvironmentService=C}),define(fe[167],he([0,1,7,2,54,18,3]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(u,f){return D.URI.revive(f?f.transformIncoming(u):u)}function d(u,f){return f?f.transformOutgoingURI(u):u}function v(u,f){f=f||g.DefaultURITransformer;const S=u.manifest;return{...g.transformAndReviveIncomingURIs({...u,manifest:void 0},f),manifest:S}}function n(u,f){return f?C.cloneAndChange(u,S=>S instanceof D.URI?f.transformOutgoingURI(S):void 0):u}class k{constructor(f,S){this.service=f,this.getUriTransformer=S,this.onInstallExtension=y.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtension=y.Event.buffer(f.onDidInstallExtension,!0),this.onDidInstallExtensions=y.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=y.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,S){const E=this.getUriTransformer(f);switch(S){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return y.Event.map(this.onDidInstallExtension,I=>({...I,local:I.local?n(I.local,E):I.local}));case"onDidInstallExtensions":return y.Event.map(this.onDidInstallExtensions,I=>I.map(h=>({...h,local:h.local?n(h.local,E):h.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,S,E){const I=this.getUriTransformer(f);switch(S){case"zip":return this.service.zip(v(E[0],I)).then(h=>d(h,I));case"unzip":return this.service.unzip(P(E[0],I));case"install":return this.service.install(P(E[0],I),E[1]);case"getManifest":return this.service.getManifest(P(E[0],I));case"canInstall":return this.service.canInstall(E[0]);case"installFromGallery":return this.service.installFromGallery(E[0],E[1]);case"uninstall":return this.service.uninstall(v(E[0],I),E[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(v(E[0],I));case"getInstalled":return this.service.getInstalled(E[0]).then(h=>h.map(a=>n(a,I)));case"updateMetadata":return this.service.updateMetadata(v(E[0],I),E[1]).then(h=>n(h,I));case"updateExtensionScope":return this.service.updateExtensionScope(v(E[0],I),E[1]).then(h=>n(h,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=k;class b extends _.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new y.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new y.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onDidInstallExtensions=this._register(new y.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new y.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new y.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(S=>this._onInstallExtension.fire(S))),this._register(this.channel.listen("onDidInstallExtension")(S=>this._onDidInstallExtension.fire({...S,local:S.local?v(S.local,null):S.local}))),this._register(this.channel.listen("onDidInstallExtensions")(S=>this._onDidInstallExtensions.fire(S.map(E=>({...E,local:E.local?v(E.local,null):E.local}))))),this._register(this.channel.listen("onUninstallExtension")(S=>this._onUninstallExtension.fire(S))),this._register(this.channel.listen("onDidUninstallExtension")(S=>this._onDidUninstallExtension.fire(S)))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(S=>D.URI.revive(S)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,S){return Promise.resolve(this.channel.call("install",[f,S])).then(E=>v(E,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}async canInstall(f){return!0}installFromGallery(f,S){return Promise.resolve(this.channel.call("installFromGallery",[f,S])).then(E=>v(E,null))}uninstall(f,S){return Promise.resolve(this.channel.call("uninstall",[f,S]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(S=>S.map(E=>v(E,null)))}updateMetadata(f,S){return Promise.resolve(this.channel.call("updateMetadata",[f,S])).then(E=>v(E,null))}updateExtensionScope(f,S){return Promise.resolve(this.channel.call("updateExtensionScope",[f,S])).then(E=>v(E,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=b;class m{constructor(f){this.service=f}listen(f,S){throw new Error("Invalid listen")}call(f,S,E){switch(S){case"getConfigBasedTips":return this.service.getConfigBasedTips(D.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=m}),define(fe[168],he([0,1,18]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const D=/^%([\w\d.-]+)%$/i;function g(C,_){const P=d=>{if(typeof d!="string")return;const v=D.exec(d);if(!v)return;const n=_[v[1]]??d;return typeof n=="string"?n:typeof n.message=="string"?n.message:d};return y.cloneAndChange(C,P)}e.localizeManifest=g}),define(fe[58],he([0,1,146]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function C(b){return b=b.trim(),b==="*"||D.test(b)}e.isValidVersionStr=C;function _(b){if(!C(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=b.match(D);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=_;function P(b){if(!b)return null;let m=b.majorBase,u=b.majorMustEqual,f=b.minorBase,S=b.minorMustEqual,E=b.patchBase,I=b.patchMustEqual;b.hasCaret&&(m===0||(S=!1),I=!1);let h=0;if(b.preRelease){const a=g.exec(b.preRelease);if(a){const[,l,t,r]=a;h=Date.UTC(Number(l),Number(t)-1,Number(r))}}return{majorBase:m,majorMustEqual:u,minorBase:f,minorMustEqual:S,patchBase:E,patchMustEqual:I,isMinimum:b.hasGreaterEquals,notBefore:h}}e.normalizeVersion=P;function d(b,m,u){let f;typeof b=="string"?f=P(_(b)):f=b;let S;m instanceof Date?S=m.getTime():typeof m=="string"&&(S=new Date(m).getTime());let E;if(typeof u=="string"?E=P(_(u)):E=u,!f||!E)return!1;let I=f.majorBase,h=f.minorBase,a=f.patchBase,l=E.majorBase,t=E.minorBase,r=E.patchBase,i=E.notBefore,s=E.majorMustEqual,c=E.minorMustEqual,p=E.patchMustEqual;return E.isMinimum?I>l?!0:I<l?!1:h>t?!0:h<t||S&&S<i?!1:a>=r:(I===1&&l===0&&(!s||!c||!p)&&(l=1,t=0,r=0,s=!0,c=!1,p=!1),I<l?!1:I>l?!s:h<t?!1:h>t?!c:a<r?!1:a>r?!p:!(S&&S<i))}e.isValidVersion=d;function v(b,m,u,f){return u.isBuiltin||typeof u.main=="undefined"?!0:k(b,m,u.engines.vscode,f)}e.isValidExtensionVersion=v;function n(b,m,u){return b==="*"||k(m,u,b)}e.isEngineValid=n;function k(b,m,u,f=[]){let S=P(_(u));if(!S)return f.push(y.localize(0,null,u)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return f.push(y.localize(1,null,u)),!1}else if(!S.majorMustEqual)return f.push(y.localize(2,null,u)),!1;return d(b,m,S)?!0:(f.push(y.localize(3,null,b,u)),!1)}}),define(fe[169],he([0,1,7,3,2,22,17,42,12,43]),function(X,e,y,D,g,C,_,P,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCFileSystemProvider=void 0;class n extends D.Disposable{constructor(b){super();this.channel=b,this.session=C.generateUuid(),this._onDidChange=this._register(new y.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new y.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new y.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event,this._capabilities=2|4|16|8|8192,this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(b=>{if(Array.isArray(b)){const m=b;this._onDidChange.fire(m.map(u=>({resource:g.URI.revive(u.resource),type:u.type})))}else{const m=b;this._onDidWatchErrorOccur.fire(m)}}))}setCaseSensitive(b){b?this._capabilities|=1024:this._capabilities&=~1024,this._onDidChangeCapabilities.fire(void 0)}stat(b){return this.channel.call("stat",[b])}open(b,m){return this.channel.call("open",[b,m])}close(b){return this.channel.call("close",[b])}async read(b,m,u,f,S){const[E,I]=await this.channel.call("read",[b,m,S]);return u.set(E.buffer.slice(0,I),f),I}async readFile(b){return(await this.channel.call("readFile",[b])).buffer}readFileStream(b,m,u){const f=P.newWriteableStream(E=>_.VSBuffer.concat(E.map(I=>_.VSBuffer.wrap(I))).buffer),S=this.channel.listen("readFileStream",[b,m])(E=>{if(E instanceof _.VSBuffer)f.write(E.buffer);else{if(E==="end")f.end();else{let I=E;I instanceof Error||(I=new Error(v.toErrorMessage(I))),f.error(I),f.end()}S.dispose()}});return u.onCancellationRequested(()=>{f.error(d.canceled()),f.end(),S.dispose()}),f}write(b,m,u,f,S){return this.channel.call("write",[b,m,_.VSBuffer.wrap(u),f,S])}writeFile(b,m,u){return this.channel.call("writeFile",[b,_.VSBuffer.wrap(m),u])}delete(b,m){return this.channel.call("delete",[b,m])}mkdir(b){return this.channel.call("mkdir",[b])}readdir(b){return this.channel.call("readdir",[b])}rename(b,m,u){return this.channel.call("rename",[b,m,u])}copy(b,m,u){return this.channel.call("copy",[b,m,u])}watch(b,m){const u=Math.random();return this.channel.call("watch",[this.session,u,b,m]),D.toDisposable(()=>this.channel.call("unwatch",[this.session,u]))}}e.IPCFileSystemProvider=n}),define(fe[170],he([0,1,36,56,3,8]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class _ extends g.Disposable{constructor(d,v,n,k){super();this.folders=d,this.onDidFilesChange=v,this.onLogMessage=n,this.verboseLogging=k,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new D.Client(C.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=_.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService(y.getNextTickChannel(d.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.setFolders(this.folders)}setVerboseLogging(d){this.verboseLogging=d,!this.isDisposed&&this.service&&this.service.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${d}`})}setFolders(d){this.folders=d,this.service&&this.service.setRoots(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=_,_.MAX_RESTARTS=5}),define(fe[171],he([0,1,36,56,3,8]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class _ extends g.Disposable{constructor(d,v,n,k,b={}){super();this.folders=d,this.onDidFilesChange=v,this.onLogMessage=n,this.verboseLogging=k,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new D.Client(C.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=_.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService(y.getNextTickChannel(d.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.service.setRoots(this.folders)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${d}`})}setVerboseLogging(d){this.verboseLogging=d,this.service&&this.service.setVerboseLogging(d)}setFolders(d){this.folders=d,this.service&&this.service.setRoots(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=_,_.MAX_RESTARTS=5}),define(fe[172],he([0,1,35,76,47,8]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class _{constructor(d,v,n,k,b){this.watchedFolder=d,this.eventCallback=n,this.logCallback=k,this.verboseLogging=b,this.restartCounter=0,Array.isArray(v)?this.ignored=v.map(m=>g.parse(m)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${d}, excludes: ${v.join(",")}`),this.startWatcher()}startWatcher(){const d=[this.watchedFolder];this.verboseLogging&&d.push("-verbose"),this.handle=y.spawn(C.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",X).fsPath,d);const v=new D.LineDecoder;this.handle.stdout.on("data",n=>{const k=[];for(const b of v.write(n)){const m=b.split("|");if(m.length===2){const u=Number(m[0]),f=m[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(S=>S(f))){this.verboseLogging&&this.log(f);continue}k.push({type:_.changeTypeMap[u],path:f})}else this.log(m[1])}}k.length>0&&this.eventCallback(k)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,k)=>this.onExit(n,k))}onError(d){this.error("process error: "+d.toString())}onExit(d,v){this.handle&&(this.error(`terminated unexpectedly (code: ${d}, signal: ${v})`),this.restartCounter<=_.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(d){this.logCallback({type:"error",message:`[File Watcher (C#)] ${d}`})}log(d){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${d}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=_,_.MAX_RESTARTS=5,_.changeTypeMap=[0,1,2]}),define(fe[173],he([0,1,172,4,13]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class C{constructor(P,d,v,n){this.onDidFilesChange=d,this.onLogMessage=v,this.verboseLogging=n,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=g.rtrim(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new y.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=C}),define(fe[59],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class y{constructor(g,C=[],_=!1){this.ctor=g,this.staticArguments=C,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=y}),define(fe[174],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=y;class D{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let _ of this._nodes.values())_.outgoing.size===0&&C.push(_);return C}insertEdge(C,_){const P=this.lookupOrInsertNode(C),d=this.lookupOrInsertNode(_);P.outgoing.set(this._hashFn(_),d),d.incoming.set(this._hashFn(C),P)}removeNode(C){const _=this._hashFn(C);this._nodes.delete(_);for(let P of this._nodes.values())P.outgoing.delete(_),P.incoming.delete(_)}lookupOrInsertNode(C){const _=this._hashFn(C);let P=this._nodes.get(_);return P||(P=new y(C),this._nodes.set(_,P)),P}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[_,P]of this._nodes)C.push(`${_}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,_]of this._nodes){const P=new Set([C]),d=this._findCycle(_,P);if(d)return d}}_findCycle(C,_){for(let[P,d]of C.outgoing){if(_.has(P))return[..._,P].join(" -> ");_.add(P);const v=this._findCycle(d,_);if(v)return v;_.delete(P)}}}e.Graph=D}),define(fe[6],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function d(v){return v[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=d})(y=e._util||(e._util={})),e.IInstantiationService=g("instantiationService");function D(P,d,v,n){d[y.DI_TARGET]===d?d[y.DI_DEPENDENCIES].push({id:P,index:v,optional:n}):(d[y.DI_DEPENDENCIES]=[{id:P,index:v,optional:n}],d[y.DI_TARGET]=d)}function g(P){if(y.serviceIds.has(P))return y.serviceIds.get(P);const d=function(v,n,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(d,v,k,!1)};return d.toString=()=>P,y.serviceIds.set(P,d),d}e.createDecorator=g;function C(P){return P}e.refineServiceDecorator=C;function _(P){return function(d,v,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");D(P,d,n,!0)}}e.optional=_}),define(fe[175],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=y.createDecorator("modelService");function D(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.shouldSynchronizeModel=D}),define(fe[176],he([0,1,7,117,3,26,114,128,175]),function(X,e,y,D,g,C,_,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function v(b){return typeof b=="string"?!1:Array.isArray(b)?b.every(v):!!b.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new y.Emitter}get onDidChange(){return this._onDidChange.event}register(m,u){let f={selector:m,provider:u,_score:-1,_time:this._clock++};return this._entries.push(f),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),g.toDisposable(()=>{if(f){let S=this._entries.indexOf(f);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),f=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const u=[];for(let f of this._entries)f._score>0&&u.push(f.provider);return u}ordered(m){const u=[];return this._orderedForEach(m,f=>u.push(f.provider)),u}orderedGroups(m){const u=[];let f,S;return this._orderedForEach(m,E=>{f&&S===E._score?f.push(E.provider):(S=E._score,f=[E.provider],u.push(f))}),u}_orderedForEach(m,u){if(!!m){this._updateScores(m);for(const f of this._entries)f._score>0&&u(f)}}_updateScores(m){let u={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===u.language&&this._lastCandidate.uri===u.uri)){this._lastCandidate=u;for(let f of this._entries)if(f._score=P.score(f.selector,m.uri,m.getLanguageIdentifier().language,d.shouldSynchronizeModel(m)),v(f.selector)&&f._score>0){for(let S of this._entries)S._score=0;f._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(m,u){return m._score<u._score?1:m._score>u._score?-1:m._time<u._time?1:m._time>u._time?-1:0}}e.LanguageFeatureRegistry=n;class k{constructor(m,u,f=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=u,this.max=f,this._cache=new C.LRUCache(50,.7)}_key(m){return m.id+D.hash(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const u=this._key(m),f=this._cache.get(u);return this._clamp(f?.value)}update(m,u){const f=this._key(m);let S=this._cache.get(f);return S||(S=new _.MovingAverage,this._cache.set(f,S)),S.update(u),this.get(m)}}e.LanguageFeatureRequestDelays=k}),define(fe[177],he([0,1,2,55,176,129,41]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class d{constructor(A,N){this.language=A,this.id=N}}e.LanguageIdentifier=d;var v;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(v=e.FontStyle||(e.FontStyle={}));var n;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var k;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var b;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(b=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(A){return(A&255)>>>0}static getTokenType(A){return(A&1792)>>>8}static getFontStyle(A){return(A&14336)>>>11}static getForeground(A){return(A&8372224)>>>14}static getBackground(A){return(A&4286578688)>>>23}static getClassNameFromMetadata(A){let N=this.getForeground(A),Q="mtk"+N,J=this.getFontStyle(A);return J&1&&(Q+=" mtki"),J&2&&(Q+=" mtkb"),J&4&&(Q+=" mtku"),Q}static getInlineStyleFromMetadata(A,N){const Q=this.getForeground(A),J=this.getFontStyle(A);let ce=`color: ${N[Q]};`;return J&1&&(ce+="font-style: italic;"),J&2&&(ce+="font-weight: bold;"),J&4&&(ce+="text-decoration: underline;"),ce}}e.TokenMetadata=m;var u;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(A){const N=o[A];let Q=N&&_.iconRegistry.get(N);return Q||(console.info("No codicon found for CompletionItemKind "+A),Q=_.Codicon.symbolProperty),Q.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(A,N){let Q=o[A];return typeof Q=="undefined"&&!N&&(Q=9),Q}}();var f;(function(o){o[o.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var E;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var I;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(I=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var h;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(h=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&y.URI.isUri(o.uri)&&D.Range.isIRange(o.range)&&(D.Range.isIRange(o.originSelectionRange)||D.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var r;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var i;(function(o){o[o.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var s;(function(o){const A=new Map;A.set("file",0),A.set("module",1),A.set("namespace",2),A.set("package",3),A.set("class",4),A.set("method",5),A.set("property",6),A.set("field",7),A.set("constructor",8),A.set("enum",9),A.set("interface",10),A.set("function",11),A.set("variable",12),A.set("constant",13),A.set("string",14),A.set("number",15),A.set("boolean",16),A.set("array",17),A.set("object",18),A.set("key",19),A.set("null",20),A.set("enum-member",21),A.set("struct",22),A.set("event",23),A.set("operator",24),A.set("type-parameter",25);const N=new Map;N.set(0,"file"),N.set(1,"module"),N.set(2,"namespace"),N.set(3,"package"),N.set(4,"class"),N.set(5,"method"),N.set(6,"property"),N.set(7,"field"),N.set(8,"constructor"),N.set(9,"enum"),N.set(10,"interface"),N.set(11,"function"),N.set(12,"variable"),N.set(13,"constant"),N.set(14,"string"),N.set(15,"number"),N.set(16,"boolean"),N.set(17,"array"),N.set(18,"object"),N.set(19,"key"),N.set(20,"null"),N.set(21,"enum-member"),N.set(22,"struct"),N.set(23,"event"),N.set(24,"operator"),N.set(25,"type-parameter");function Q(se){return A.get(se)}o.fromString=Q;function J(se){return N.get(se)}o.toString=J;function ce(se,$){const q=N.get(se);let W=q&&_.iconRegistry.get("symbol-"+q);return W||(console.info("No codicon found for SymbolKind "+se),W=_.Codicon.symbolProperty),`${$?"inline":"block"} ${W.classNames}`}o.toCssClassName=ce})(s=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(A){this.value=A}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var p;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(w=e.CommentMode||(e.CommentMode={}));var L;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(L=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new g.LanguageFeatureRegistry,e.RenameProviderRegistry=new g.LanguageFeatureRegistry,e.CompletionProviderRegistry=new g.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new g.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new g.LanguageFeatureRegistry,e.HoverProviderRegistry=new g.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new g.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new g.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new g.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new g.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new g.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new g.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new g.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new g.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new g.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new g.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new g.LanguageFeatureRegistry,e.LinkProviderRegistry=new g.LanguageFeatureRegistry,e.ColorProviderRegistry=new g.LanguageFeatureRegistry,e.SelectionRangeRegistry=new g.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new g.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var F;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(F=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[60],he([0,1,13,6,5]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=g.userAgent||"";const _=new Map;_.set("false",!1),_.set("true",!0),_.set("isMac",g.isMacintosh),_.set("isLinux",g.isLinux),_.set("isWindows",g.isWindows),_.set("isWeb",g.isWeb),_.set("isMacNative",g.isMacintosh&&!g.isWeb),_.set("isEdge",C.indexOf("Edg/")>=0),_.set("isFirefox",C.indexOf("Firefox")>=0),_.set("isChrome",C.indexOf("Chrome")>=0),_.set("isSafari",C.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var d;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(d=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return k.INSTANCE}static true(){return b.INSTANCE}static has(o){return m.create(o)}static equals(o,A){return u.create(o,A)}static notEquals(o,A){return E.create(o,A)}static regex(o,A){return r.create(o,A)}static in(o,A){return f.create(o,A)}static not(o){return I.create(o)}static and(...o){return s.create(o)}static or(...o){return c.create(o)}static greater(o,A){return h.create(o,A)}static less(o,A){return l.create(o,A)}static deserialize(o,A=!1){if(!!o)return this._deserializeOrExpression(o,A)}static _deserializeOrExpression(o,A){let N=o.split("||");return c.create(N.map(Q=>this._deserializeAndExpression(Q,A)))}static _deserializeAndExpression(o,A){let N=o.split("&&");return s.create(N.map(Q=>this._deserializeOne(Q,A)))}static _deserializeOne(o,A){if(o=o.trim(),o.indexOf("!=")>=0){let N=o.split("!=");return E.create(N[0].trim(),this._deserializeValue(N[1],A))}if(o.indexOf("==")>=0){let N=o.split("==");return u.create(N[0].trim(),this._deserializeValue(N[1],A))}if(o.indexOf("=~")>=0){let N=o.split("=~");return r.create(N[0].trim(),this._deserializeRegexValue(N[1],A))}if(o.indexOf(" in ")>=0){let N=o.split(" in ");return f.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const N=o.split(">=");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const N=o.split(">");return h.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const N=o.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const N=o.split("<");return l.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(o)?I.create(o.substr(1).trim()):m.create(o)}static _deserializeValue(o,A){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let N=/^'([^']*)'$/.exec(o);return N?N[1].trim():o}static _deserializeRegexValue(o,A){if(y.isFalsyOrWhitespace(o)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=o.indexOf("/"),Q=o.lastIndexOf("/");if(N===Q||N<0){if(A)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let J=o.slice(N+1,Q),ce=o[Q+1]==="i"?"i":"";try{return new RegExp(J,ce)}catch(se){if(A)throw new Error(`bad regexp-value '${o}', parse error: ${se}`);return console.warn(`bad regexp-value '${o}', parse error: ${se}`),null}}}e.ContextKeyExpr=v;function n(F,o){return F.cmp(o)}class k{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class b{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class m{constructor(o){this.key=o,this.type=2}static create(o){const A=_.get(o);return typeof A=="boolean"?A?b.INSTANCE:k.INSTANCE:new m(o)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return I.create(this.key)}}e.ContextKeyDefinedExpr=m;class u{constructor(o,A){this.key=o,this.value=A,this.type=4}static create(o,A){if(typeof A=="boolean")return A?m.create(o):I.create(o);const N=_.get(o);return typeof N=="boolean"?A===(N?"true":"false")?b.INSTANCE:k.INSTANCE:new u(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:L(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return E.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class f{constructor(o,A){this.key=o,this.valueKey=A,this.type=10}static create(o,A){return new f(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:L(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const A=o.getValue(this.valueKey),N=o.getValue(this.key);return Array.isArray(A)?A.indexOf(N)>=0:typeof N=="string"&&typeof A=="object"&&A!==null?P.call(A,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=f;class S{constructor(o){this._actual=o,this.type=11}static create(o){return new S(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new S(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class E{constructor(o,A){this.key=o,this.value=A,this.type=5}static create(o,A){if(typeof A=="boolean")return A?I.create(o):m.create(o);const N=_.get(o);return typeof N=="boolean"?A===(N?"true":"false")?k.INSTANCE:b.INSTANCE:new E(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:L(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=E;class I{constructor(o){this.key=o,this.type=3}static create(o){const A=_.get(o);return typeof A=="boolean"?A?k.INSTANCE:b.INSTANCE:new I(o)}cmp(o){return o.type!==this.type?this.type-o.type:w(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=I;class h{constructor(o,A){this.key=o,this.value=A,this.type=12}static create(o,A){return new h(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:L(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=h;class a{constructor(o,A){this.key=o,this.value=A,this.type=13}static create(o,A){return new a(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:L(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=a;class l{constructor(o,A){this.key=o,this.value=A,this.type=14}static create(o,A){return new l(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:L(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerExpr=l;class t{constructor(o,A){this.key=o,this.value=A,this.type=15}static create(o,A){return new t(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:L(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(o,A){this.key=o,this.regexp=A,this.type=7}static create(o,A){return new r(o,A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const A=this.regexp?this.regexp.source:"",N=o.regexp?o.regexp.source:"";return A<N?-1:A>N?1:0}equals(o){if(o.type===this.type){const A=this.regexp?this.regexp.source:"",N=o.regexp?o.regexp.source:"";return this.key===o.key&&A===N}return!1}evaluate(o){let A=o.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(o){this._actual=o,this.type=8}static create(o){return new i(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new i(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class s{constructor(o){this.expr=o,this.type=6}static create(o){return s._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,N=this.expr.length;A<N;A++){const Q=n(this.expr[A],o.expr[A]);if(Q!==0)return Q}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,N=this.expr.length;A<N;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,N=this.expr.length;A<N;A++)if(!this.expr[A].evaluate(o))return!1;return!0}static _normalizeArr(o){const A=[];let N=!1;for(const Q of o)if(!!Q){if(Q.type===1){N=!0;continue}if(Q.type===0)return k.INSTANCE;if(Q.type===6){A.push(...Q.expr);continue}A.push(Q)}if(A.length===0&&N)return b.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(n);A.length>1;){const Q=A[A.length-1];if(Q.type!==9)break;A.pop();const J=A.pop(),ce=c.create(Q.expr.map(se=>s.create([se,J])));ce&&(A.push(ce),A.sort(n))}return A.length===1?A[0]:new s(A)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new s(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let A of this.expr)o.push(A.negate());return c.create(o)}}e.ContextKeyAndExpr=s;class c{constructor(o){this.expr=o,this.type=9}static create(o){const A=c._normalizeArr(o);if(A.length!==0)return A.length===1?A[0]:new c(A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,N=this.expr.length;A<N;A++){const Q=n(this.expr[A],o.expr[A]);if(Q!==0)return Q}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,N=this.expr.length;A<N;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,N=this.expr.length;A<N;A++)if(this.expr[A].evaluate(o))return!0;return!1}static _normalizeArr(o){let A=[],N=!1;if(o){for(let Q=0,J=o.length;Q<J;Q++){const ce=o[Q];if(!!ce){if(ce.type===0){N=!0;continue}if(ce.type===1)return[b.INSTANCE];if(ce.type===9){A=A.concat(ce.expr);continue}A.push(ce)}}if(A.length===0&&N)return[k.INSTANCE];A.sort(n)}return A}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new c(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let N of this.expr)o.push(N.negate());const A=N=>N.type===9?N.expr:[N];for(;o.length>1;){const N=o.shift(),Q=o.shift(),J=[];for(const ce of A(N))for(const se of A(Q))J.push(v.and(ce,se));o.unshift(v.or(...J))}return o[0]}}e.ContextKeyOrExpr=c;class p extends m{constructor(o,A,N){super(o);this._defaultValue=A,typeof N=="object"?p._info.push({...N,key:o}):N!==!0&&p._info.push({key:o,description:N,type:A!=null?typeof A:void 0})}static all(){return p._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return v.not(this.key)}isEqualTo(o){return v.equals(this.key,o)}notEqualsTo(o){return v.notEquals(this.key,o)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=D.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(F,o){return F<o?-1:F>o?1:0}function L(F,o,A,N){return F<A?-1:F>A?1:o<N?-1:o>N?1:0}}),define(fe[178],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=y.createDecorator(e.ID);function D(g){return!!g.hostName&&!!g.errorMessage}e.isRemoteDiagnosticError=D}),define(fe[85],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=y.createDecorator("downloadService")}),define(fe[28],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=y.createDecorator("environmentService"),e.INativeEnvironmentService=y.refineServiceDecorator(e.IEnvironmentService)}),define(fe[33],he([0,1,141,6,8]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=C;var _;(function(k){k[k.NoneOrRelevance=0]="NoneOrRelevance",k[k.LastUpdatedDate=1]="LastUpdatedDate",k[k.Title=2]="Title",k[k.PublisherName=3]="PublisherName",k[k.InstallCount=4]="InstallCount",k[k.PublishedDate=5]="PublishedDate",k[k.AverageRating=6]="AverageRating",k[k.WeightedRating=12]="WeightedRating"})(_=e.SortBy||(e.SortBy={}));var P;(function(k){k[k.Default=0]="Default",k[k.Ascending=1]="Ascending",k[k.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var d;(function(k){k.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var v;(function(k){k[k.None=0]="None",k[k.Install=1]="Install",k[k.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=D.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(b,m){super(b);this.code=m,this.name=m}}e.ExtensionManagementError=n,e.IExtensionManagementService=D.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=D.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=D.createDecorator("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=y.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=y.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=D.createDecorator("IExtensionManagementCLIService")}),define(fe[44],he([0,1,13,6]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function g(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=g;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(_=e.ExtensionType||(e.ExtensionType={}));class P{constructor(k){this.value=k,this._lower=k.toLowerCase()}static equals(k,b){if(typeof k=="undefined"||k===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof k=="string"||typeof b=="string"){let m=typeof k=="string"?k:k.value,u=typeof b=="string"?b:b.value;return y.equalsIgnoreCase(m,u)}return k._lower===b._lower}static toKey(k){return typeof k=="string"?k.toLowerCase():k._lower}}e.ExtensionIdentifier=P;function d(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=d;function v(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=v,e.IBuiltinExtensionsScannerService=D.createDecorator("IBuiltinExtensionsScannerService")}),define(fe[34],he([0,1,13,44]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function g(u,f){return u.uuid&&f.uuid?u.uuid===f.uuid:u.id===f.id?!0:y.compareIgnoreCase(u.id,f.id)===0}e.areSameExtensions=g;class C{constructor(f,S){this.version=S,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof C?g(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=C;function _(u,f){return`${u}.${f}`}e.getExtensionId=_;function P(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function d(u,f){return P(_(u,f))}e.getGalleryExtensionId=d;function v(u,f){const S=[],E=I=>{for(const h of S)if(h.some(a=>g(f(a),f(I))))return h;return null};for(const I of u){const h=E(I);h?h.push(I):S.push([I])}return S}e.groupByExtension=v;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function k(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function b(u){const f=new Set;for(const S of u)S.malicious&&f.add(S.id.id);return f}e.getMaliciousExtensionsSet=b;function m(u,f){const S=[],E=f.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const I=E.shift();if(I&&S.every(h=>!g(h.identifier,{id:I}))){const h=u.filter(a=>g(a.identifier,{id:I}));h.length===1&&(S.push(h[0]),E.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=m});var Ke=this&&this.__param||function(X,e){return function(y,D){e(y,D,X)}};define(fe[86],he([0,1,142,12,2,49,33,34,44,52,25,8]),function(X,e,y,D,g,C,_,P,d,v,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=e.getIdAndVersion=void 0;const b=I=>y.localize(0,null,I),m=y.localize(1,null,"ms-dotnettools.csharp");function u(I,h){return h?`${I.publisher}.${I.name}@${I.version}`:`${I.publisher}.${I.name}`}const f=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function S(I){const h=f.exec(I);return h&&h[1]?[P.adoptToGalleryExtensionId(h[1]),h[2]]:[P.adoptToGalleryExtensionId(I),void 0]}e.getIdAndVersion=S;let E=class{constructor(h,a){this.extensionManagementService=h,this.extensionGalleryService=a}get location(){}async listExtensions(h,a,l=console){let t=await this.extensionManagementService.getInstalled(1);const r=d.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(a&&a!==""){if(r.indexOf(a.toLowerCase())<0){l.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}t=t.filter(s=>s.manifest.categories?s.manifest.categories.map(p=>p.toLowerCase()).indexOf(a.toLowerCase())>-1:!1)}else if(a===""){l.log("Possible Categories: "),r.forEach(s=>{l.log(s)});return}this.location&&l.log(y.localize(2,null,this.location)),t=t.sort((s,c)=>s.identifier.id.localeCompare(c.identifier.id));let i;for(let s of t)i!==s.identifier.id&&(i=s.identifier.id,l.log(u(s.manifest,h)))}async installExtensions(h,a,l,t,r=console){const i=[],s=[];h.length&&r.log(this.location?y.localize(3,null,this.location):y.localize(4,null));const c=await this.extensionManagementService.getInstalled(1),p=(F,o)=>{const A=c.find(N=>P.areSameExtensions(N.identifier,{id:F}));if(A){if(!o&&!t)return r.log(y.localize(5,null,F,A.manifest.version,F)),!1;if(o&&A.manifest.version===o)return r.log(y.localize(6,null,`${F}@${o}`)),!1}return!0},w=[],L=[];for(const F of h)if(F instanceof g.URI)w.push(F);else{const[o,A]=S(F);p(o,A)&&L.push({id:o,version:A,installOptions:{isBuiltin:!1,isMachineScoped:l}})}for(const F of a){const[o,A]=S(F);p(o,A)&&L.push({id:o,version:A,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(w.length&&await Promise.all(w.map(async F=>{try{const o=await this.installVSIX(F,{isBuiltin:!1,isMachineScoped:l},t,r);o&&s.push(o)}catch(o){r.error(o.message||o.stack||o),i.push(F.toString())}})),L.length){const F=await this.getGalleryExtensions(L);await Promise.all(L.map(async o=>{const A=F.get(o.id.toLowerCase());if(A)try{const N=await this.installFromGallery(o,A,c,t,r);N&&s.push(N)}catch(N){r.error(N.message||N.stack||N),i.push(o.id)}else r.error(`${b(o.version?`${o.id}@${o.version}`:o.id)}
${m}`),i.push(o.id)}))}if(i.length)throw new Error(y.localize(7,null,i.join(", ")))}async installVSIX(h,a,l,t){const r=await this.extensionManagementService.getManifest(h);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,l,t))try{return await this.extensionManagementService.install(h,a),t.log(y.localize(8,null,v.getBaseLabel(h))),r}catch(s){if(D.isPromiseCanceledError(s))return t.log(y.localize(9,null,v.getBaseLabel(h))),null;throw s}return null}async getGalleryExtensions(h){const a=h.filter(({version:r})=>r===void 0).map(({id:r})=>r),l=h.filter(({version:r})=>r!==void 0),t=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(a,n.CancellationToken.None)).forEach(i=>t.set(i.identifier.id.toLowerCase(),i))})(),Promise.all(l.map(async({id:r,version:i})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:r},i);s&&t.set(s.identifier.id.toLowerCase(),s)}))]),t}async installFromGallery({id:h,version:a,installOptions:l},t,r,i,s){const c=await this.extensionGalleryService.getManifest(t,n.CancellationToken.None);if(c&&!this.validateExtensionKind(c,s))return null;const p=r.find(w=>P.areSameExtensions(w.identifier,t.identifier));if(p){if(t.version===p.manifest.version)return s.log(y.localize(10,null,a?`${h}@${a}`:h)),null;s.log(y.localize(11,null,h,t.version))}try{return l.isBuiltin?s.log(a?y.localize(12,null,h,a):y.localize(13,null,h)):s.log(a?y.localize(14,null,h,a):y.localize(15,null,h)),await this.extensionManagementService.installFromGallery(t,l),s.log(y.localize(16,null,h,t.version)),c}catch(w){if(D.isPromiseCanceledError(w))return s.log(y.localize(17,null,h)),null;throw w}}validateExtensionKind(h,a){return!0}async validateVSIX(h,a,l){const t={id:P.getGalleryExtensionId(h.publisher,h.name)},i=(await this.extensionManagementService.getInstalled(1)).find(s=>P.areSameExtensions(t,s.identifier)&&C.gt(s.manifest.version,h.version));return i&&!a?(l.log(y.localize(18,null,i.identifier.id,i.manifest.version,h.version)),!1):this.validateExtensionKind(h,l)}async uninstallExtensions(h,a,l=console){const t=async i=>{if(i instanceof g.URI){const s=await this.extensionManagementService.getManifest(i);return u(s)}return i},r=[];for(const i of h){const s=await t(i),p=(await this.extensionManagementService.getInstalled()).filter(w=>P.areSameExtensions(w.identifier,{id:s}));if(!p.length)throw new Error(`${this.notInstalled(s)}
${m}`);if(p.some(w=>w.type===0)){l.log(y.localize(19,null,s));return}if(!a&&p.some(w=>w.isBuiltin)){l.log(y.localize(20,null,s));return}l.log(y.localize(21,null,s));for(const w of p)await this.extensionManagementService.uninstall(w),r.push(w);this.location?l.log(y.localize(22,null,s,this.location)):l.log(y.localize(23,null,s))}}async locateExtension(h,a=console){const l=await this.extensionManagementService.getInstalled();h.forEach(t=>{l.forEach(r=>{if(r.identifier.id===t&&r.location.scheme===k.Schemas.file){a.log(r.location.fsPath);return}})})}notInstalled(h){return this.location?y.localize(24,null,h,this.location):y.localize(25,null,h)}};E=Ne([Ke(0,_.IExtensionManagementService),Ke(1,_.IExtensionGalleryService)],E),e.ExtensionManagementCLIService=E}),define(fe[179],he([0,1,3,4,44,15]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class _ extends y.Disposable{constructor(d,v){super();this.environmentService=d,this.extensionsManifestCache=D.join(this.environmentService.userDataPath,g.MANIFEST_CACHE_FOLDER,g.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtension(n=>this.onDidInstallExtension(n))),this._register(v.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtension(d){d.error||this.invalidate()}onDidUnInstallExtension(d){d.error||this.invalidate()}invalidate(){C.Promises.rm(this.extensionsManifestCache,C.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=_}),define(fe[20],he([0,1,148,4,2,6,13,11,26]),function(X,e,y,D,g,C,_,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=C.createDecorator("fileService");function v($){return $.create===!0}e.isFileOpenForWriteOptions=v;var n;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var k;(function($){$[$.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var b;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m($){return!!($.capabilities&2)}e.hasReadWriteCapability=m;function u($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=u;function f($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function S($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=S;var E;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(q,W){super(q);this.code=W}}e.FileSystemProviderError=I;function h($,q){const W=new I($.toString(),q);return l(W,q),W}e.createFileSystemProviderError=h;function a($){return $||h(y.localize(0,null),E.Unknown)}e.ensureFileSystemProviderError=a;function l($,q){return $.name=q?`${q} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=l;function t($){if(!$)return E.Unknown;if($ instanceof I)return $.code;const q=/^(.+) \(FileSystemError\)$/.exec($.name);if(!q)return E.Unknown;switch(q[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function r($){if($ instanceof L)return $.fileOperationResult;switch(t($)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(q,W,V){this.resource=q,this.operation=W,this.target=V}isOperation(q){return this.operation===q}}e.FileOperationEvent=s;var c;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class p{constructor(q,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const V of q)switch(V.type){case 1:this.added||(this.added=d.TernarySearchTree.forUris(()=>W)),this.added.set(V.resource,V);break;case 0:this.updated||(this.updated=d.TernarySearchTree.forUris(()=>W)),this.updated.set(V.resource,V);break;case 2:this.deleted||(this.deleted=d.TernarySearchTree.forUris(()=>W)),this.deleted.set(V.resource,V);break}}contains(q,...W){return this.doContains(q,{includeChildren:!1},...W)}affects(q,...W){return this.doContains(q,{includeChildren:!0},...W)}doContains(q,W,...V){if(!q)return!1;const T=V.length>0;return!!((!T||V.includes(1))&&(this.added?.get(q)||W.includeChildren&&this.added?.findSuperstr(q))||(!T||V.includes(0))&&(this.updated?.get(q)||W.includeChildren&&this.updated?.findSuperstr(q))||(!T||V.includes(2))&&(this.deleted?.findSubstr(q)||W.includeChildren&&this.deleted?.findSuperstr(q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=p;function w($,q,W){return!$||!q||$===q||q.length>$.length?!1:(q.charAt(q.length-1)!==D.sep&&(q+=D.sep),W?_.startsWithIgnoreCase($,q):$.indexOf(q)===0)}e.isParent=w;class L extends Error{constructor(q,W,V){super(q);this.fileOperationResult=W,this.options=V}}e.FileOperationError=L;class F extends L{constructor(q,W,V){super(q,2,V);this.stat=W}}e.NotModifiedSinceFileOperationError=F;var o;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=N;async function Q($,q){if(!q.canHandleResource(g.URI.from({scheme:$.scheme})))return new Promise(W=>{const V=q.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===$.scheme&&T.added&&(V.dispose(),W())})})}e.whenProviderRegistered=Q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class J{static formatSize(q){return P.isNumber(q)||(q=0),q<J.KB?y.localize(1,null,q.toFixed(0)):q<J.MB?y.localize(2,null,(q/J.KB).toFixed(2)):q<J.GB?y.localize(3,null,(q/J.MB).toFixed(2)):q<J.TB?y.localize(4,null,(q/J.GB).toFixed(2)):y.localize(5,null,(q/J.TB).toFixed(2))}}e.ByteSize=J,J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB;var ce;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(ce=e.Arch||(e.Arch={}));function se($){return{maxFileSize:$===0?300*J.MB:16*J.GB,maxHeapSize:$===0?700*J.MB:2*700*J.MB}}e.getPlatformLimits=se}),define(fe[180],he([0,1,238,140,20,57]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function _(b,m){const u={onUnknownOption:S=>{console.warn(D.localize(0,null,S))},onMultipleValues:(S,E)=>{console.warn(D.localize(1,null,S,E))}},f=C.parseArgs(b,C.OPTIONS,m?u:void 0);return f.goto&&f._.forEach(S=>y(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),D.localize(2,null))),f["max-memory"]&&y(parseInt(f["max-memory"])>=g.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${g.MIN_MAX_MEMORY_SIZE_MB} MB.`),f}function P(b){const m=b.findIndex(u=>!/^-/.test(u));if(m>-1)return[...b.slice(0,m),...b.slice(m+1)]}function d(b){let[,...m]=b;process.env.VSCODE_DEV&&(m=P(m)||[]);const u=!k(process.env);return _(m,u)}e.parseMainProcessArgv=d;function v(b){const[,,...m]=b;return _(m,!0)}e.parseCLIProcessArgv=v;function n(b,...m){const u=b.indexOf("--");return u===-1?b.push(...m):b.splice(u,0,...m),b}e.addArg=n;function k(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),define(fe[87],he([0,1,77,35,22,5,180,43,136,25,12]),function(X,e,y,D,g,C,_,P,d,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function k(u,f,S){return f["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):_.isLaunchedFromCli(S)&&!f["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(_.isLaunchedFromCli(S)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=new Promise(async E=>{const I=new v.CancellationTokenSource,h=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),I.dispose(!0),E({})},1e4);try{const a=await m(u,I.token);E(a)}catch(a){n.isPromiseCanceledError(a)||u.error(`[resolve shell env] Unable to resolve shell environment (${a}). Proceeding without shell environment...`),E({})}finally{clearTimeout(h),I.dispose()}})),b)}e.resolveShellEnv=k;let b;async function m(u,f){const S=new Promise(async(E,I)=>{const h=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",h);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",a);const l=g.generateUuid().replace(/-/g,"").substr(0,12),t=new RegExp(l+"(.*)"+l),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const i=await d.getSystemShell(C.OS,r);if(u.trace("getUnixShellEnvironment#shell",i),f.isCancellationRequested)return I(n.canceled);const s=y.basename(i);let c,p;/^pwsh(-preview)?$/.test(s)?(c=`& '${process.execPath}' -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,p=["-Login","-Command"]):(c=`'${process.execPath}' -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,p=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),c);const w=D.spawn(i,[...p,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});f.onCancellationRequested(()=>(w.kill(),I(n.canceled))),w.on("error",o=>{u.error("getUnixShellEnvironment#errorChildProcess",P.toErrorMessage(o)),E({})});const L=[];w.stdout.on("data",o=>L.push(o));const F=[];w.stderr.on("data",o=>F.push(o)),w.on("close",(o,A)=>{const N=Buffer.concat(L).toString("utf8");u.trace("getUnixShellEnvironment#raw",N);const Q=Buffer.concat(F).toString("utf8");if(Q.trim()&&u.trace("getUnixShellEnvironment#stderr",Q),o||A)return I(new Error(`Failed to get environment (code ${o}, signal ${A})`));const J=t.exec(N),ce=J?J[1]:"{}";try{const se=JSON.parse(ce);h?se.ELECTRON_RUN_AS_NODE=h:delete se.ELECTRON_RUN_AS_NODE,a?se.ELECTRON_NO_ATTACH_CONSOLE=a:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",se),E(se)}catch(se){u.error("getUnixShellEnvironment#errorCaught",P.toErrorMessage(se)),I(se)}})});try{return await S}catch(E){return u.error("getUnixShellEnvironment#error",P.toErrorMessage(E)),{}}}}),define(fe[88],he([0,1,2,20,5]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function C(d){return d.map(v=>({type:v.type,resource:y.URI.file(v.path)}))}e.toFileChanges=C;function _(d){const v=new P;for(const n of d)v.processEvent(n);return v.normalize()}e.normalizeFileChanges=_;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(v){const n=this.mapPathToChange.get(v.path);if(n){const k=n.type,b=v.type;k===1&&b===2?(this.mapPathToChange.delete(v.path),this.normalized.splice(this.normalized.indexOf(n),1)):k===2&&b===1?n.type=0:k===1&&b===0||(n.type=b)}else this.normalized.push(v),this.mapPathToChange.set(v.path,v)}normalize(){const v=[],n=[];return this.normalized.filter(k=>k.type!==2?(v.push(k),!1):!0).sort((k,b)=>k.path.length-b.path.length).filter(k=>n.some(b=>D.isParent(k.path,b,!g.isLinux))?!1:(n.push(k.path),!0)).concat(v)}}}),define(fe[181],he([0,1,88,3,15,124,126,14,4]),function(X,e,y,D,g,C,_,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class v extends D.Disposable{constructor(k,b,m,u){super();this.path=k,this.onDidFilesChange=b,this.onLogMessage=m,this.verboseLogging=u,this.fileChangesDelayer=this._register(new P.ThrottledDelayer(_.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(k){this.verboseLogging=k}async startWatching(){try{const{stat:k,symbolicLink:b}=await g.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let m=this.path;if(b)try{m=await C.realpath(m)}catch(u){if(this.onError(u),b.dangling)return}k.isDirectory()?this._register(_.watchFolder(m,(u,f)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:d.join(this.path,d.basename(f))})},u=>this.onError(u))):this._register(_.watchFile(m,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(k){k.code!=="ENOENT"&&this.onError(k)}}onFileChange(k){this.fileChangesBuffer.push(k),this.verboseLogging&&this.onVerbose(`${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=y.normalizeFileChanges(b);if(this.verboseLogging)for(const u of m)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);m.length>0&&this.onDidFilesChange(m)})}onError(k){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${k}`})}onVerbose(k){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${k}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=v}),define(fe[61],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...g){this._entries=new Map;for(let[C,_]of g)this.set(C,_)}set(g,C){const _=this._entries.get(g);return this._entries.set(g,C),_}has(g){return this._entries.has(g)}get(g){return this._entries.get(g)}}e.ServiceCollection=y}),define(fe[89],he([0,1,12,174,59,6,61,14]),function(X,e,y,D,g,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const d=!1;class v extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new _.ServiceCollection,f=!1,S){this._activeInstantiations=new Set,this._services=u,this._strict=f,this._parent=S,this._services.set(C.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...f){let S=b.traceInvocation(u),E=!1;try{return u({get:(h,a)=>{if(E)throw y.illegalState("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(h,S);if(!l&&a!==C.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return l}},...f)}finally{E=!0,S.stop()}}createInstance(u,...f){let S,E;return u instanceof g.SyncDescriptor?(S=b.traceCreation(u.ctor),E=this._createInstance(u.ctor,u.staticArguments.concat(f),S)):(S=b.traceCreation(u),E=this._createInstance(u,f,S)),S.stop(),E}_createInstance(u,f=[],S){let E=C._util.getServiceDependencies(u).sort((a,l)=>a.index-l.index),I=[];for(const a of E){let l=this._getOrCreateServiceInstance(a.id,S);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${a.id}.`);I.push(l)}let h=E.length>0?E[0].index:f.length;if(f.length!==h){console.warn(`[createInstance] First service dependency of ${u.name} at position ${h+1} conflicts with ${f.length} static arguments`);let a=h-f.length;a>0?f=f.concat(new Array(a)):f=f.slice(0,h)}return new u(...[...f,...I])}_setServiceInstance(u,f){if(this._services.get(u)instanceof g.SyncDescriptor)this._services.set(u,f);else if(this._parent)this._parent._setServiceInstance(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let f=this._services.get(u);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):f}_getOrCreateServiceInstance(u,f){let S=this._getServiceInstanceOrDescriptor(u);return S instanceof g.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,S,f.branch(u,!0)):(f.branch(u,!1),S)}_safeCreateAndCacheServiceInstance(u,f,S){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,f,S)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,f,S){const E=new D.Graph(a=>a.id.toString());let I=0;const h=[{id:u,desc:f,_trace:S}];for(;h.length;){const a=h.pop();if(E.lookupOrInsertNode(a),I++>1e3)throw new v(E);for(let l of C._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(l.id);if(!t&&!l.optional&&console.warn(`[createInstance] ${u} depends on ${l.id} which is NOT registered.`),t instanceof g.SyncDescriptor){const r={id:l.id,desc:t,_trace:a._trace.branch(l.id,!0)};E.insertEdge(a,r),h.push(r)}}}for(;;){const a=E.roots();if(a.length===0){if(!E.isEmpty())throw new v(E);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof g.SyncDescriptor){const r=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,r)}E.removeNode(l)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,f,S=[],E,I){if(this._services.get(u)instanceof g.SyncDescriptor)return this._createServiceInstance(f,S,E,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,f,S,E,I);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(u,f=[],S,E){if(S){const I=new P.IdleValue(()=>this._createInstance(u,f,E));return new Proxy(Object.create(null),{get(h,a){if(a in h)return h[a];let l=I.value,t=l[a];return typeof t!="function"||(t=t.bind(l),h[a]=t),t},set(h,a,l){return I.value[a]=l,!0}})}else return this._createInstance(u,f,E)}}e.InstantiationService=n;var k;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(k||(k={}));class b{constructor(u,f){this.type=u,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return d?new b(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(u){return d?new b(0,u.name):b._None}branch(u,f){let S=new b(2,u.toString());return this._dep.push([u,f,S]),S}stop(){let u=Date.now()-this._start;b._totals+=u;let f=!1;function S(I,h){let a=[],l=new Array(I+1).join("	");for(const[t,r,i]of h._dep)if(r&&i){f=!0,a.push(`${l}CREATES -> ${t}`);let s=S(I+1,i);s&&a.push(s)}else a.push(`${l}uses -> ${t}`);return a.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(u>2||f)&&console.log(E.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(fe[182],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=y.createDecorator("labelService")}),define(fe[62],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=y.createDecorator("localizationsService");function D(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const C of g.translations)if(typeof C.id!="string"||typeof C.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}e.isValidLocalization=D}),define(fe[16],he([0,1,6,3,5,7,43]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=y.createDecorator("logService"),e.ILoggerService=y.createDecorator("loggerService");function P(){return new Date().toISOString()}var d;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;class v extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class n extends v{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(d.Trace)&&this.log(d.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(d.Debug)&&this.log(d.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(d.Info)&&this.log(d.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(d.Warning)&&this.log(d.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(d.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(d.Error,this.format(i))}else this.log(d.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(d.Critical)&&this.log(d.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let s=t[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch(c){}r+=(i>0?" ":"")+s}return r}}e.AbstractMessageLogger=n;class k extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!g.isWindows}trace(t,...r){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class b extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=b;class m extends v{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:_.toErrorMessage(t,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class u extends v{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class f extends D.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=f;class S extends D.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?d.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class E{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(t){}getLevel(){return d.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=E;function I(l){if(l.verbose)return d.Trace;if(typeof l.logLevel=="string"){const t=h(l.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function h(l){switch(l){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=h;function a(l){switch(l){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=a}),define(fe[183],he([0,1,15,3,20,33,28,2,19,34,16,22,49,5,14,12]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends D.Disposable{constructor(h,a,l,t){super();this.fileService=a,this.extensionGalleryService=l,this.logService=t,this.extensionsDownloadDir=P.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,a){await this.cleanUpPromise;const l=this.getName(h),t=d.joinPath(this.extensionsDownloadDir,l);if(!await this.fileService.exists(t)){const r=d.joinPath(this.extensionsDownloadDir,`.${k.generateUuid()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(h,r,a);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(s){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${f.getErrorMessage(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(h){}async rename(h,a,l){try{await y.Promises.rename(h.fsPath,a.fsPath)}catch(t){if(m.isWindows&&t&&t.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${h} to ${a} with 'EPERM' error. Trying again...`),this.rename(h,a,l);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const a=[],l=[];for(const i of h.children){const s=this.parse(i.name);s&&l.push([s,i])}const t=v.groupByExtension(l,([i])=>i),r=[];for(const i of t)i.sort((s,c)=>b.rcompare(s[0].version,c[0].version)),a.push(...i.slice(1).map(s=>s[1].resource)),r.push(i[0][1]);r.sort((i,s)=>i.mtime-s.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await u.Promises.settled(a.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?new v.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase():k.generateUuid()}parse(h){const a=S.exec(h);return a&&a[1]&&a[2]?new v.ExtensionIdentifierWithVersion({id:a[1]},a[2]):null}};E=Ne([Ke(0,_.INativeEnvironmentService),Ke(1,g.IFileService),Ke(2,C.IExtensionGalleryService),Ke(3,n.ILogService)],E),e.ExtensionsDownloader=E}),define(fe[184],he([0,1,3,16,35,43,4,14,7,8,15,28]),function(X,e,y,D,g,C,_,P,d,v,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let b=class extends y.Disposable{constructor(u,f){super();this.environmentService=u,this.logService=f,this.processesLimiter=new P.Limiter(5)}async postUninstall(u){const f=this.parseScript(u,"uninstall");return f&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(f.script,"uninstall",f.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${S}`)))),n.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(u,f){const S=`vscode:${f}`;if(u.location.scheme===v.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[S]=="string"){const E=u.manifest.scripts[S].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${S} should be a node script`),null):{script:_.join(u.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(u,f,S,E,I){return new Promise((h,a)=>{const l=this.start(u,f,S,I);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?a(i):h(void 0)};l.on("error",i=>{r(C.toErrorMessage(i)||"Unknown")}),l.on("exit",(i,s)=>{r(i?`post-${f} process exited with code ${i}`:void 0)}),E&&(t=setTimeout(()=>{t=null,l.kill(),a("timed out")},5e3))})}start(u,f,S,E){const I={silent:!0,execArgv:void 0},h=g.fork(u,[`--type=extension-post-${f}`,...S],I);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const a=d.Event.fromNodeEventEmitter(h.stdout,"data"),l=d.Event.fromNodeEventEmitter(h.stderr,"data");a(i=>this.logService.info(E.identifier.id,E.manifest.version,`post-${f}`,i)),l(i=>this.logService.error(E.identifier.id,E.manifest.version,`post-${f}`,i));const t=d.Event.any(d.Event.map(a,i=>({data:`%c${i}`,format:[""]})),d.Event.map(l,i=>({data:`%c${i}`,format:["color: red"]})));return d.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(E.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),h}getExtensionStoragePath(u){return _.join(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};b=Ne([Ke(0,k.IEnvironmentService),Ke(1,D.ILogService)],b),e.ExtensionsLifecycle=b}),define(fe[185],he([0,1,3,28,7,20,2,34,19,16]),function(X,e,y,D,g,C,_,P,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends y.Disposable{constructor(b,m,u,f){super();this.extensionsManagementService=b,this.logService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new g.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(b.onInstallExtension(I=>this.onInstallExtension(I))),this._register(b.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(b.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const S=_.URI.file(u.extensionsPath),E=new d.ExtUri(I=>!m.hasCapability(I,1024));this._register(m.watch(S)),this._register(g.Event.filter(m.onDidChangeFilesRaw,I=>I.changes.some(h=>this.doesChangeAffects(h,S,E)))(()=>this.onDidChange()))}doesChangeAffects(b,m,u){return u.isEqual(u.dirname(b.resource),m)?u.isEqual(b.resource,u.joinPath(m,".obsolete"))?!0:!(b.type!==1&&b.type!==2||u.basename(b.resource).startsWith(".")):!1}onInstallExtension(b){this.addInstallingExtension(b.identifier)}onDidInstallExtension(b){this.removeInstallingExtension(b.identifier),b.error||this.addInstalledExtension(b.identifier)}onDidUninstallExtension(b){b.error||this.removeInstalledExtension(b.identifier)}addInstallingExtension(b){this.removeInstallingExtension(b),this.installingExtensions.push(b)}removeInstallingExtension(b){this.installingExtensions=this.installingExtensions.filter(m=>!P.areSameExtensions(m,b))}addInstalledExtension(b){this.installedExtensions&&(this.removeInstalledExtension(b),this.installedExtensions.push(b))}removeInstalledExtension(b){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(m=>!P.areSameExtensions(m,b)))}async onDidChange(){if(this.installedExtensions){const b=await this.extensionsManagementService.getInstalled(1),m=b.filter(f=>[...this.installingExtensions,...this.installedExtensions].some(S=>P.areSameExtensions(S,f.identifier))?!1:f.installedTimestamp&&f.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",f.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",f.identifier.id),!1)),u=this.installedExtensions.filter(f=>this.installingExtensions.some(S=>P.areSameExtensions(S,f))?!1:b.every(S=>!P.areSameExtensions(S.identifier,f))?(this.logService.info("Detected extension removed from another source",f.id),!0):!1);this.installedExtensions=b.map(f=>f.identifier),(m.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:m,removed:u})}}};n=Ne([Ke(1,C.IFileService),Ke(2,D.INativeEnvironmentService),Ke(3,v.ILogService)],n),e.ExtensionsWatcher=n}),define(fe[90],he([0,1,15,63,33,3,28,14,34,16,62,21,7,8,4]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let f=class extends C.Disposable{constructor(I,h,a){super();this.extensionManagementService=I,this.logService=a,this._onDidLanguagesChange=this._register(new b.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new S(h,a)),this._register(I.onDidInstallExtension(({local:l})=>this.onDidInstallExtension(l))),this._register(I.onDidUninstallExtension(({identifier:l})=>this.onDidUninstallExtension(l)))}getLanguageIds(){return this.cache.getLanguagePacks().then(I=>{const h=["en",...Object.keys(I)];return k.distinct(h)})}onDidInstallExtension(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",I.identifier.id),this.update().then(h=>{h&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(I){this.cache.getLanguagePacks().then(h=>{Object.keys(h).some(a=>h[a]&&h[a].extensions.some(l=>d.areSameExtensions(l.extensionIdentifier,I)))&&(this.logService.debug("Removing language packs from the extension",I.id),this.update().then(a=>{a&&this._onDidLanguagesChange.fire()}))})}async update(){const[I,h]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),a=await this.cache.update(h);return!k.equals(Object.keys(I),Object.keys(a))}};f=Ne([Ke(0,g.IExtensionManagementService),Ke(1,_.INativeEnvironmentService),Ke(2,v.ILogService)],f),e.LocalizationsService=f;let S=class extends C.Disposable{constructor(I,h){super();this.logService=h,this.languagePacks={},this.languagePacksFilePath=u.join(I.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(I){return this.withLanguagePacks(h=>{Object.keys(h).forEach(a=>delete h[a]),this.createLanguagePacksFromExtensions(h,...I)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(I,...h){for(const a of h)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(I,a);Object.keys(I).forEach(a=>this.updateHash(I[a]))}createLanguagePacksFromExtension(I,h){const a=h.identifier,l=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const t of l)if(h.location.scheme===m.Schemas.file&&n.isValidLocalization(t)){let r=I[t.languageId];r||(r={hash:"",extensions:[],translations:{}},I[t.languageId]=r);let i=r.extensions.filter(s=>d.areSameExtensions(s.extensionIdentifier,a))[0];i?i.version=h.manifest.version:r.extensions.push({extensionIdentifier:a,version:h.manifest.version});for(const s of t.translations)r.translations[s.id]=u.join(h.location.fsPath,s.path)}}updateHash(I){if(I){const h=D.createHash("md5");for(const a of I.extensions)h.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);I.hash=h.digest("hex")}}withLanguagePacks(I=()=>null){return this.languagePacksFileLimiter.queue(()=>{let h=null;return y.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch(l){return{}}}).then(a=>(h=I(a),a)).then(a=>{for(const t of Object.keys(a))a[t]||delete a[t];this.languagePacks=a,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),y.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>h,a=>this.logService.error(a))})}};S=Ne([Ke(0,_.INativeEnvironmentService),Ke(1,v.ILogService)],S)}),define(fe[91],he([0,1,16,7,2]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(b){this.service=b,this.onDidChangeLogLevel=D.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(b,m,u){switch(m){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=C;class _{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){_.setLevel(this.channel,b)}static setLevel(b,m){return b.call("setLevel",m)}}e.LogLevelChannelClient=_;class P{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,m){throw new Error(`Event not found: ${m}`)}async call(b,m,u){switch(m){case"createLogger":this.createLogger(g.URI.revive(u[0]),u[1]);return;case"log":return this.log(g.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${m}`)}createLogger(b,m){this.loggers.set(b.toString(),this.loggerService.createLogger(b,m))}consoleLog(b,m){let u=console.log;switch(b){case y.LogLevel.Error:u=console.error;break;case y.LogLevel.Warning:u=console.warn;break;case y.LogLevel.Info:u=console.info;break}u.call(console,...m)}log(b,m){const u=this.loggers.get(b.toString());if(!u)throw new Error("Create the logger before logging");for(const[f,S]of m)switch(f){case y.LogLevel.Trace:u.trace(S);break;case y.LogLevel.Debug:u.debug(S);break;case y.LogLevel.Info:u.info(S);break;case y.LogLevel.Warning:u.warn(S);break;case y.LogLevel.Error:u.error(S);break;case y.LogLevel.Critical:u.critical(S);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class d extends y.AbstractLoggerService{constructor(b,m,u){super(b,m);this.channel=u}createConsoleMainLogger(){return new y.AdapterLogger({log:(b,m)=>{this.channel.call("consoleLog",[b,m])}})}doCreateLogger(b,m,u){return new v(this.channel,b,m,u)}}e.LoggerChannelClient=d;class v extends y.AbstractMessageLogger{constructor(b,m,u,f){super(f?.always);this.channel=b,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[m,f]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,m){const u=[[b,m]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(b){this.channel.call("log",[this.file,b])}}class n extends y.LogService{constructor(b,m){super(m);this.parent=b,this._register(b.onDidChangeLogLevel(u=>m.setLevel(u)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=n}),define(fe[92],he([0,1,16,20]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function g(d,v,n,k){try{const b=await new Promise((m,u)=>{X(["spdlog"],m,u)});return b.setFlushOn(y.LogLevel.Trace),b.createAsyncRotatingLogger(d,v,n,k)}catch(b){console.error(b)}return null}function C(d,v,n,k){const b=X.__$__nodeRequire("spdlog");return b.setFlushOn(y.LogLevel.Trace),b.createRotatingLogger(d,v,n,k)}e.createRotatingLogger=C;function _(d,v,n){switch(v){case y.LogLevel.Trace:d.trace(n);break;case y.LogLevel.Debug:d.debug(n);break;case y.LogLevel.Info:d.info(n);break;case y.LogLevel.Warning:d.warn(n);break;case y.LogLevel.Error:d.error(n);break;case y.LogLevel.Critical:d.critical(n);break;default:throw new Error("Invalid log level")}}class P extends y.AbstractMessageLogger{constructor(v,n,k,b){super();this.name=v,this.filepath=n,this.rotating=k,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const v=this.rotating?6:1,n=30/v*D.ByteSize.MB;return g(this.name,this.filepath,n,v).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:b,message:m}of this.buffer)_(this._logger,b,m);this.buffer=[]}})}log(v,n){this._logger?_(this._logger,v,n):this.getLevel()<=v&&this.buffer.push({level:v,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(fe[186],he([0,1,6,151,73]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(d){d[d.Unnecessary=1]="Unnecessary",d[d.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var _;(function(d){d[d.Hint=1]="Hint",d[d.Info=2]="Info",d[d.Warning=4]="Warning",d[d.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(d){function v(u,f){return f-u}d.compare=v;const n=Object.create(null);n[d.Error]=D.localize(0,null),n[d.Warning]=D.localize(1,null),n[d.Info]=D.localize(2,null);function k(u){return n[u]||""}d.toString=k;function b(u){switch(u){case g.default.Error:return d.Error;case g.default.Warning:return d.Warning;case g.default.Info:return d.Info;case g.default.Ignore:return d.Hint}}d.fromSeverity=b;function m(u){switch(u){case d.Error:return g.default.Error;case d.Warning:return g.default.Warning;case d.Info:return g.default.Info;case d.Hint:return g.default.Ignore}}d.toSeverity=m}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(d){const v="";function n(b){return k(b,!0)}d.makeKey=n;function k(b,m){let u=[v];return b.source?u.push(b.source.replace("\xA6","\\\xA6")):u.push(v),b.code?typeof b.code=="string"?u.push(b.code.replace("\xA6","\\\xA6")):u.push(b.code.value.replace("\xA6","\\\xA6")):u.push(v),b.severity!==void 0&&b.severity!==null?u.push(_.toString(b.severity)):u.push(v),b.message&&m?u.push(b.message.replace("\xA6","\\\xA6")):u.push(v),b.startLineNumber!==void 0&&b.startLineNumber!==null?u.push(b.startLineNumber.toString()):u.push(v),b.startColumn!==void 0&&b.startColumn!==null?u.push(b.startColumn.toString()):u.push(v),b.endLineNumber!==void 0&&b.endLineNumber!==null?u.push(b.endLineNumber.toString()):u.push(v),b.endColumn!==void 0&&b.endColumn!==null?u.push(b.endColumn.toString()):u.push(v),u.push(v),u.join("\xA6")}d.makeKeyOptionalMessage=k})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=y.createDecorator("markerService")}),define(fe[187],he([0,1,73,6,7]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=y.default,e.INotificationService=D.createDecorator("notificationService");var C;(function(v){v[v.WORKSPACE=0]="WORKSPACE",v[v.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(v){v[v.OFF=0]="OFF",v[v.SILENT=1]="SILENT",v[v.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new d,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=P;class d{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=d}),define(fe[31],he([0,1,8,5,23,19]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let _;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.context!="undefined"){const P=D.globals.vscode.context.configuration();if(P)_=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const P=C.dirname(y.FileAccess.asFileUri("",X));_=X.__$__nodeRequire(C.joinPath(P,"product.json").fsPath);const d=X.__$__nodeRequire(C.joinPath(P,"package.json").fsPath);g.env.VSCODE_DEV&&Object.assign(_,{nameShort:`${_.nameShort} Dev`,nameLong:`${_.nameLong} Dev`,dataFolderName:`${_.dataFolderName}-dev`}),Object.assign(_,{version:d.version})}else _={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://vscodeweb.azureedge.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-webview.net/{{quality}}/{{commit}}",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","msjsdiag.debugger-for-chrome":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","austin.code-gnu-global":"{**/*.c,**/*.cpp,**/*.h}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","dbaeumer.jshint":"{**/*.js,**/*.jsx,**/*.es6,**/.babelrc,**/jsconfig.json,**/.jshintrc,**/.jshintignore}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","felixfbecker.php-intellisense":"{**/*.php,**/php.ini}","felixfbecker.php-debug":"{**/*.php,**/php.ini}","ikappas.phpcs":"{**/*.php,**/php.ini}","rust-lang.rust":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc,**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.babelrc,**/jsconfig.json}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","shinnn.stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","bajdzis.vscode-database":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","hiro-sun.vscode-emacs","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","octref.vetur","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",telemetryOptOutUrl:"https://go.microsoft.com/fwlink/?linkid=870136",npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionAllowedProposedApi:["GitHub.codespaces","GitHub.copilot-nightly","GitHub.copilot","GitHub.vscode-pull-request-github-insiders","GitHub.vscode-pull-request-github","GitHub.remotehub","GitHub.remotehub-insiders","Microsoft.vscode-nmake-tools","ms-ai-tools.notebook-renderers","ms-dotnettools.dotnet-interactive-vscode","ms-python.gather","ms-python.python","ms-toolsai.jupyter","ms-toolsai.vscode-ai","ms-toolsai.vscode-ai-remote","ms-vscode-remote.remote-containers-nightly","ms-vscode-remote.remote-containers","ms-vscode-remote.remote-ssh-edit-nightly","ms-vscode-remote.remote-ssh-edit","ms-vscode-remote.remote-ssh-nightly","ms-vscode-remote.remote-ssh","ms-vscode-remote.remote-wsl-nightly","ms-vscode-remote.remote-wsl","ms-vscode-remote.remote-wsl-recommender","ms-vscode-remote.vscode-remote-extensionpack-nightly","ms-vscode-remote.vscode-remote-extensionpack","ms-vscode.azure-account","ms-vscode.azure-sphere-tools-ui","ms-vscode.azure-sphere-tools","ms-vscode.remotehub","ms-vscode.remotehub-insiders","ms-vscode.js-debug-nightly","ms-vscode.js-debug","ms-vscode.lsif-browser","ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.vscode-selfhost-test-provider","ms-vscode.test-adapter-converter","ms-vsliveshare.cloudenv-explorer","ms-vsliveshare.cloudenv","ms-vsliveshare.vsliveshare","ms-vsonline.vsonline","dbaeumer.vscode-eslint","ms-playwright.playwright","VisualStudioExptTeam.vscodeintellicode","VisualStudioExptTeam.vscodeintellicode-insiders","vscode.vscode-web-playground","sandy081.999-test-github-issue-notebooks"],tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"manasxx.background-cover":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"liviuschera.noctis":["ui","workspace"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"redhat.vscode-yaml":{default:!1},"felixfbecker.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"felixfbecker.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"batisteo.vscode-django":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://client-auth-staging-14a768b.herokuapp.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["https://management.core.windows.net/.default","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.node-debug",version:"1.44.28",repo:"https://github.com/microsoft/vscode-node-debug",metadata:{id:"b6ded8fb-a0a0-4c1c-acbd-ab2a3bc995a6",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.node-debug2",version:"1.42.7",repo:"https://github.com/microsoft/vscode-node-debug2",metadata:{id:"36d19e17-7569-4841-a001-947eb18602b2",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.references-view",version:"0.0.80",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.13",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.58.2",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.18",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.11",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.58.0",commit:"2d23c42a936db1c7b3b06f918cde29561cc47cd6",date:"2021-07-08T06:43:36.588Z"},Object.keys(_).length===0&&Object.assign(_,{version:"1.58.0-dev",nameShort:D.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:D.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=_}),define(fe[93],he([0,1,149,17,20,12,31]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(k,b,m,u,f,S){let E;try{await d(k,b,m,u,f,S)}catch(I){E=I}finally{E&&f.errorTransformer&&(E=f.errorTransformer(E)),typeof E!="undefined"&&m.error(E),m.end()}}e.readFileIntoStream=P;async function d(k,b,m,u,f,S){v(S);const E=await k.open(b,{create:!1});try{v(S);let I=0,h=0,a=f&&typeof f.length=="number"?f.length:void 0,l=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof a=="number"?a:f.bufferSize)),t=f&&typeof f.position=="number"?f.position:0,r=0;do h=await k.read(E,t,l.buffer,r,l.byteLength-r),t+=h,r+=h,I+=h,typeof a=="number"&&(a-=h),r===l.byteLength&&(await m.write(u(l)),l=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof a=="number"?a:f.bufferSize)),r=0);while(h>0&&(typeof a!="number"||a>0)&&v(S)&&n(I,f));if(r>0){let i=r;typeof a=="number"&&(i=Math.min(r,a)),m.write(u(l.slice(0,i)))}}catch(I){throw g.ensureFileSystemProviderError(I)}finally{await k.close(E)}}function v(k){if(k.isCancellationRequested)throw C.canceled();return!0}function n(k,b){if(b?.limits){if(typeof b.limits.memory=="number"&&k>b.limits.memory)throw g.createFileSystemProviderError(y.localize(0,null,_.default.nameShort),g.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&k>b.limits.size)throw g.createFileSystemProviderError(y.localize(1,null),g.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(fe[94],he([0,1,147,48,3,20,7,19,26,21,16,17,42,14,25,8,93,51]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class pt extends g.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new _.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new _.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new _.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new _.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new _.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new _.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new m.ThrottledWorker(pt.FILE_EVENTS_THROTTLING.maxChangesChunkSize,pt.FILE_EVENTS_THROTTLING.maxChangesBufferSize,pt.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new C.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new m.ThrottledWorker(pt.FILE_EVENTS_THROTTLING.maxChangesChunkSize,pt.FILE_EVENTS_THROTTLING.maxChangesBufferSize,pt.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new C.FileChangesEvent(l,!0)))),this.watchedResources=d.TernarySearchTree.forUris(l=>{const t=this.getProvider(l.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new m.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);D.mark(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const t=new g.DisposableStore;return t.add(l.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(l)))),t.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidErrorOccur=="function"&&t.add(l.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),g.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),g.dispose(t)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){l.push(t)}}),!this.provider.has(a)&&await m.Promises.settled(l)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,l){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&l)}listCapabilities(){return E.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!P.isAbsolutePath(a))throw new C.FileOperationError(y.localize(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const t=new Error;throw t.name="ENOPRO",t.message=y.localize(1,null,a.toString()),t}return l}async withReadProvider(a){const l=await this.withProvider(a);if(C.hasOpenReadWriteCloseCapability(l)||C.hasReadWriteCapability(l)||C.hasFileReadStreamCapability(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if(C.hasOpenReadWriteCloseCapability(l)||C.hasReadWriteCapability(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(t){throw C.toFileSystemProviderErrorCode(t)===C.FileSystemProviderErrorCode.FileNotFound?new C.FileOperationError(y.localize(2,null,this.resourceForError(a)),1):C.ensureFileSystemProviderError(t)}}async doResolveFile(a,l){const t=await this.withProvider(a),r=this.isPathCaseSensitive(t),i=l?.resolveTo,s=l?.resolveSingleChildDescendants,c=l?.resolveMetadata,p=await t.stat(a);let w;return this.toFileStat(t,a,p,void 0,!!c,(L,F)=>(w||(w=d.TernarySearchTree.forUris(()=>!r),w.set(a,!0),v.isNonEmptyArray(i)&&i.forEach(o=>w.set(o,!0))),Boolean(w.findSuperstr(L.resource)||w.get(L.resource))?!0:L.isDirectory&&s?F===1:!1))}async toFileStat(a,l,t,r,i,s){const{providerExtUri:c}=this.getExtUri(a),p={resource:l,name:c.basename(l),isFile:(t.type&C.FileType.File)!=0,isDirectory:(t.type&C.FileType.Directory)!=0,isSymbolicLink:(t.type&C.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&C.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:C.etag({mtime:t.mtime,size:t.size})};if(p.isDirectory&&s(p,r)){try{const w=await a.readdir(l),L=await m.Promises.settled(w.map(async([F,o])=>{try{const A=c.joinPath(l,F),N=i?await a.stat(A):{type:o};return await this.toFileStat(a,A,N,w.length,i,s)}catch(A){return this.logService.trace(A),null}}));p.children=v.coalesce(L)}catch(w){this.logService.trace(w),p.children=[]}return p}return p}async resolveAll(a){return m.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch(t){return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(t){return t}return!0}async doValidateCreateFile(a,l){if(!l?.overwrite&&await this.exists(a))throw new C.FileOperationError(y.localize(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=k.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const r=await this.writeFile(a,l);return this._onDidRunOperation.fire(new C.FileOperationEvent(a,0,r)),r}async writeFile(a,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,a,t)||await this.mkdirp(r,i.dirname(a));let c;if(C.hasReadWriteCapability(r)&&!(l instanceof k.VSBuffer))if(b.isReadableStream(l)){const p=await b.peekStream(l,3);p.ended?c=k.VSBuffer.concat(p.buffer):c=p}else c=b.peekReadable(l,p=>k.VSBuffer.concat(p),3);else c=l;!C.hasOpenReadWriteCloseCapability(r)||C.hasReadWriteCapability(r)&&c instanceof k.VSBuffer?await this.doWriteUnbuffered(r,a,t,c):await this.doWriteBuffered(r,a,t,c instanceof k.VSBuffer?k.bufferToReadable(c):c)}catch(s){throw new C.FileOperationError(y.localize(4,null,this.resourceForError(a),C.ensureFileSystemProviderError(s).toString()),C.toFileOperationResult(s),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,t){if(!!t?.unlock&&!(a.capabilities&8192))throw new Error(y.localize(5,null,this.resourceForError(l)));let i;try{i=await a.stat(l)}catch(s){return}if((i.type&C.FileType.Directory)!=0)throw new C.FileOperationError(y.localize(6,null,this.resourceForError(l)),0,t);if(this.throwIfFileIsReadonly(l,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==C.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==C.etag({mtime:t.mtime,size:i.size}))throw new C.FileOperationError(y.localize(7,null),3,t);return i}async readFile(a,l){const t=await this.withReadProvider(a);return l?.atomic?this.doReadFileAtomic(t,a,l):this.doReadFile(t,a,l)}async doReadFileAtomic(a,l,t){return new Promise((r,i)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(a,l,t);r(s)}catch(s){i(s)}})})}async doReadFile(a,l,t){const r=await this.doReadFileStream(a,l,{...t,preferUnbuffered:!0});return{...r,value:await k.streamToBuffer(r.value)}}async readFileStream(a,l){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,l)}async doReadFileStream(a,l,t){const r=new u.CancellationTokenSource,i=this.validateReadFile(l,t).then(c=>c,c=>{throw r.cancel(),c});let s;try{return t&&typeof t.etag=="string"&&t.etag!==C.ETAG_DISABLED&&await i,!(C.hasOpenReadWriteCloseCapability(a)||C.hasFileReadStreamCapability(a))||C.hasReadWriteCapability(a)&&t?.preferUnbuffered?s=this.readFileUnbuffered(a,l,t):C.hasFileReadStreamCapability(a)?s=this.readFileStreamed(a,l,r.token,t):s=this.readFileBuffered(a,l,r.token,t),{...await i,value:s}}catch(c){s&&await b.consumeStream(s);const p=y.localize(8,null,this.resourceForError(l),C.ensureFileSystemProviderError(c).toString());throw c instanceof C.NotModifiedSinceFileOperationError?new C.NotModifiedSinceFileOperationError(p,c.stat,t):new C.FileOperationError(p,C.toFileOperationResult(c),t)}}readFileStreamed(a,l,t,r=Object.create(null)){const i=a.readFileStream(l,r,t);return b.transform(i,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new C.FileOperationError(y.localize(9,null,this.resourceForError(l),C.ensureFileSystemProviderError(s).toString()),C.toFileOperationResult(s),r)},s=>k.VSBuffer.concat(s))}readFileBuffered(a,l,t,r=Object.create(null)){const i=k.newWriteableBufferStream();return S.readFileIntoStream(a,l,i,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new C.FileOperationError(y.localize(10,null,this.resourceForError(l),C.ensureFileSystemProviderError(s).toString()),C.toFileOperationResult(s),r)},t),i}readFileUnbuffered(a,l,t){const r=b.newWriteableStream(i=>k.VSBuffer.concat(i));return(async()=>{try{let i=await a.readFile(l);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(l,i.byteLength,t),r.end(k.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(a,l){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new C.FileOperationError(y.localize(11,null,this.resourceForError(a)),0,l);if(l&&typeof l.etag=="string"&&l.etag!==C.ETAG_DISABLED&&l.etag===t.etag)throw new C.NotModifiedSinceFileOperationError(y.localize(12,null),t,l);return this.validateReadFileLimits(a,t.size,l),t}validateReadFileLimits(a,l,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&l>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&l>t.limits.size&&(r=7),typeof r=="number")throw new C.FileOperationError(y.localize(13,null,this.resourceForError(a)),r)}}async canMove(a,l,t){return this.doCanMoveCopy(a,l,"move",t)}async canCopy(a,l,t){return this.doCanMoveCopy(a,l,"copy",t)}async doCanMoveCopy(a,l,t,r){if(a.toString()!==l.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(i,a,s,l,t,r)}catch(i){return i}return!0}async move(a,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),s=await this.doMoveCopy(r,a,i,l,"move",!!t),c=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,s==="move"?2:3,c)),c}async copy(a,l,t){const r=await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),s=await this.doMoveCopy(r,a,i,l,"copy",!!t),c=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,s==="copy"?3:2,c)),c}async doMoveCopy(a,l,t,r,i,s){if(l.toString()===r.toString())return i;const{exists:c,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(a,l,t,r,i,s);if(c&&!p&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(a===t&&C.hasFileFolderCopyCapability(a))await a.copy(l,r,{overwrite:s});else{const w=await this.resolve(l);w.isDirectory?await this.doCopyFolder(a,w,t,r):await this.doCopyFile(a,l,t,r)}return i}else return a===t?(await a.rename(l,r,{overwrite:s}),i):(await this.doMoveCopy(a,l,t,r,"copy",s),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,t,r){if(C.hasOpenReadWriteCloseCapability(a)&&C.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(a,l,t,r);if(C.hasOpenReadWriteCloseCapability(a)&&C.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(a,l,t,r);if(C.hasReadWriteCapability(a)&&C.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(a,l,t,r);if(C.hasReadWriteCapability(a)&&C.hasReadWriteCapability(t))return this.doPipeUnbuffered(a,l,t,r)}async doCopyFolder(a,l,t,r){await t.mkdir(r),Array.isArray(l.children)&&await m.Promises.settled(l.children.map(async i=>{const s=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(a,await this.resolve(i.resource),t,s):this.doCopyFile(a,i.resource,t,s)}))}async doValidateMoveCopy(a,l,t,r,i,s){let c=!1;if(a===t){const{providerExtUri:w,isPathCaseSensitive:L}=this.getExtUri(a);if(L||(c=w.isEqual(l,r)),c&&i==="copy")throw new Error(y.localize(14,null,this.resourceForError(l),this.resourceForError(r)));if(!c&&w.isEqualOrParent(r,l))throw new Error(y.localize(15,null,this.resourceForError(l),this.resourceForError(r)))}const p=await this.exists(r);if(p&&!c){if(!s)throw new C.FileOperationError(y.localize(16,null,this.resourceForError(l),this.resourceForError(r)),4);if(a===t){const{providerExtUri:w}=this.getExtUri(a);if(w.isEqualOrParent(l,r))throw new Error(y.localize(17,null,this.resourceForError(l),this.resourceForError(r)))}}return{exists:p,isSameResourceWithDifferentPathCase:c}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,0,t)),t}async mkdirp(a,l){const t=[],{providerExtUri:r}=this.getExtUri(a);for(;!r.isEqual(l,r.dirname(l));)try{if(((await a.stat(l)).type&C.FileType.Directory)==0)throw new Error(y.localize(18,null,this.resourceForError(l)));break}catch(i){if(C.toFileSystemProviderErrorCode(i)!==C.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(l)),l=r.dirname(l)}for(let i=t.length-1;i>=0;i--){l=r.joinPath(l,t[i]);try{await a.mkdir(l)}catch(s){if(C.toFileSystemProviderErrorCode(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(t){return t}return!0}async doValidateDelete(a,l){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!l?.useTrash&&!(t.capabilities&4096))throw new Error(y.localize(19,null,this.resourceForError(a)));let i;try{i=await t.stat(a)}catch(c){}if(i)this.throwIfFileIsReadonly(a,i);else throw new C.FileOperationError(y.localize(20,null,this.resourceForError(a)),1);if(!!!l?.recursive){const c=await this.resolve(a);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error(y.localize(21,null,this.resourceForError(a)))}return t}async del(a,l){const t=await this.doValidateDelete(a,l),r=!!l?.useTrash,i=!!l?.recursive;await t.delete(a,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new C.FileOperationEvent(a,1))}onDidChangeFile(a,l){this._onDidChangeFilesRaw.fire({changes:a});let t,r;{for(const i of a)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new C.FileChangesEvent(t,!l))}if(r){const i=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&pt.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,l={recursive:!1,excludes:[]}){const t=new g.DisposableStore;{let r=!1,i=()=>{r=!0};t.add(g.toDisposable(()=>i())),this.doWatch(a,l).then(s=>{r?g.dispose(s):i=()=>g.dispose(s)},s=>this.logService.error(s))}return l.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),t.add(g.toDisposable(()=>{const r=this.watchedResources.get(a);typeof r=="number"&&(r<=1?this.watchedResources.delete(a):this.watchedResources.set(a,r-1))}))),t}async doWatch(a,l){const t=await this.withProvider(a),r=this.toWatchKey(t,a,l),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(a,l)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,g.toDisposable(()=>{i.count--,i.count===0&&(g.dispose(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(a,l,t){const{providerExtUri:r}=this.getExtUri(a);return[r.getComparisonKey(l),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>g.dispose(a.disposable)),this.activeWatchers.clear()}async doWriteBuffered(a,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{const i=await a.open(l,{create:!0,unlock:t?.unlock??!1});try{b.isReadableStream(r)||b.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(a,i,r):await this.doWriteReadableBufferedQueued(a,i,r)}catch(s){throw C.ensureFileSystemProviderError(s)}finally{await a.close(i)}})}async doWriteStreamBufferedQueued(a,l,t){let r=0,i;if(b.isReadableBufferedStream(t)){if(t.buffer.length>0){const s=k.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,l,s,s.byteLength,r,0),r+=s.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(s,c)=>{b.listenStream(i,{onData:async p=>{i.pause();try{await this.doWriteBuffer(a,l,p,p.byteLength,r,0)}catch(w){return c(w)}r+=p.byteLength,setTimeout(()=>i.resume())},onError:p=>c(p),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(a,l,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(a,l,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(a,l,t,r,i,s){let c=0;for(;c<r;)c+=await a.write(l,i+c,t.buffer,s+c,r-c)}async doWriteUnbuffered(a,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,t,r))}async doWriteUnbufferedQueued(a,l,t,r){let i;r instanceof k.VSBuffer?i=r:b.isReadableStream(r)?i=await k.streamToBuffer(r):b.isReadableBufferedStream(r)?i=await k.bufferedStreamToBuffer(r):i=k.readableToBuffer(r),await a.writeFile(l,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(a,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,t,r))}async doPipeBufferedQueued(a,l,t,r){let i,s;try{i=await a.open(l,{create:!1}),s=await t.open(r,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,w=0,L=0;do L=await a.read(i,p,c.buffer,w,c.byteLength-w),await this.doWriteBuffer(t,s,c,L,p,w),p+=L,w+=L,w===c.byteLength&&(w=0);while(L>0)}catch(c){throw C.ensureFileSystemProviderError(c)}finally{await m.Promises.settled([typeof i=="number"?a.close(i):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(a,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,t,r))}async doPipeUnbufferedQueued(a,l,t,r){return t.writeFile(r,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,t,r))}async doPipeUnbufferedToBufferedQueued(a,l,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const s=await a.readFile(l);await this.doWriteBuffer(t,i,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw C.ensureFileSystemProviderError(s)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(a,l,t,r){const i=await k.streamToBuffer(this.readFileBuffered(a,l,u.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new C.FileOperationError(y.localize(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){if((l.permissions??0)&C.FilePermission.Readonly)throw new C.FileOperationError(y.localize(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===f.Schemas.file?a.fsPath:a.toString(!0)}};I.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},I=Ne([Ke(0,n.ILogService)],I),e.FileService=I}),define(fe[64],he([0,1,3,20,7,5,15,4,19,30,14,16,150,88,171,173,170,181,42,93,21,17]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f,S,E,I,h,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends y.Disposable{constructor(i,s){super();this.logService=i,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=g.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new g.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new g.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:c}=await _.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,c),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await _.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),c=[];return await Promise.all(s.map(async p=>{try{let w;p.isSymbolicLink()?w=(await this.stat(d.joinPath(i,p.name))).type:w=this.toType(p),c.push([p.name,w])}catch(w){this.logService.trace(w)}})),c}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let c;return s?.dangling?c=D.FileType.Unknown:i.isFile()?c=D.FileType.File:i.isDirectory()?c=D.FileType.Directory:c=D.FileType.Unknown,s&&(c|=D.FileType.SymbolicLink),c}async readFile(i){try{const s=this.toFilePath(i);return await _.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(i,s,c){const p=I.newWriteableStream(w=>l.VSBuffer.concat(w.map(L=>l.VSBuffer.wrap(L))).buffer);return h.readFileIntoStream(this,i,p,w=>w.buffer,{...s,bufferSize:this.BUFFER_SIZE},c),p}async writeFile(i,s,c){let p;try{const w=this.toFilePath(i);if(!c.create||!c.overwrite){if(await _.Promises.exists(w)){if(!c.overwrite)throw D.createFileSystemProviderError(b.localize(0,null),D.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw D.createFileSystemProviderError(b.localize(1,null),D.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(i,{create:!0,unlock:c.unlock}),await this.write(p,0,s,0,s.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(i,w)}finally{typeof p=="number"&&await this.close(p)}}async open(i,s){try{const c=this.toFilePath(i);if(D.isFileOpenForWriteOptions(s)&&s.unlock)try{const{stat:L}=await _.SymlinkSupport.stat(c);L.mode&128||await _.Promises.chmod(c,L.mode|128)}catch(L){this.logService.trace(L)}let p;if(D.isFileOpenForWriteOptions(s)){if(C.isWindows)try{await _.Promises.truncate(c,0),p="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}p||(p="w")}else p="r";const w=await _.Promises.open(c,p);return this.mapHandleToPos.set(w,0),D.isFileOpenForWriteOptions(s)&&this.writeHandles.set(w,i),w}catch(c){throw D.isFileOpenForWriteOptions(s)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await _.Promises.fdatasync(i)}catch(s){this.canFlush=!1,this.logService.error(s)}return await _.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}}async read(i,s,c,p,w){const L=this.normalizePos(i,s);let F=null;try{const o=await _.Promises.read(i,c,p,w,L);return typeof o=="number"?F=o:F=o.bytesRead,F}catch(o){throw this.toFileSystemProviderError(o)}finally{this.updatePos(i,L,F)}}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,c){const p=this.mapHandleToPos.get(i);typeof p=="number"&&(typeof s=="number"||(typeof c=="number"?this.mapHandleToPos.set(i,p+c):this.mapHandleToPos.delete(i)))}async write(i,s,c,p,w){return n.retry(()=>this.doWrite(i,s,c,p,w),100,3)}async doWrite(i,s,c,p,w){const L=this.normalizePos(i,s);let F=null;try{const o=await _.Promises.write(i,c,p,w,L);return typeof o=="number"?F=o:F=o.bytesWritten,F}catch(o){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),o)}finally{this.updatePos(i,L,F)}}async mkdir(i){try{await _.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const c=this.toFilePath(i);await this.doDelete(c,s)}catch(c){throw this.toFileSystemProviderError(c)}}async doDelete(i,s){s.recursive?await _.Promises.rm(i,_.RimRafMode.MOVE):await _.Promises.unlink(i)}async rename(i,s,c){const p=this.toFilePath(i),w=this.toFilePath(s);if(p!==w)try{await this.validateTargetDeleted(i,s,"move",c.overwrite),await _.Promises.move(p,w)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error(b.localize(2,null,P.basename(p),P.basename(P.dirname(w)),L.toString()))),this.toFileSystemProviderError(L)}}async copy(i,s,c){const p=this.toFilePath(i),w=this.toFilePath(s);if(p!==w)try{await this.validateTargetDeleted(i,s,"copy",c.overwrite),await _.Promises.copy(p,w,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error(b.localize(3,null,P.basename(p),P.basename(P.dirname(w)),L.toString()))),this.toFileSystemProviderError(L)}}async validateTargetDeleted(i,s,c,p){const w=this.toFilePath(i),L=this.toFilePath(s);let F=!1;if(!!(this.capabilities&1024)||(F=v.isEqual(w,L,!0)),F&&c==="copy")throw D.createFileSystemProviderError(b.localize(4,null),D.FileSystemProviderErrorCode.FileExists);if(!F&&await _.Promises.exists(L)){if(!p)throw D.createFileSystemProviderError(b.localize(5,null),D.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(i,s){return s.recursive?this.watchRecursive(i,s.excludes):this.watchNonRecursive(i)}watchRecursive(i,s){const c={path:this.toFilePath(i),excludes:s},p=a.insert(this.recursiveFoldersToWatch,c);return this.refreshRecursiveWatchers(),y.toDisposable(()=>{p(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof S.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(y.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,s;this.options?.watcher?.usePolling?(i=u.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?C.isWindows?i=f.FileWatcher:i=u.FileWatcher:i=S.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,c=>this._onDidChangeFile.fire(m.toFileChanges(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===k.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===k.LogLevel.Trace)}))}}watchNonRecursive(i){const s=new E.FileWatcher(this.toFilePath(i),p=>this._onDidChangeFile.fire(m.toFileChanges(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===k.LogLevel.Trace),c=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===k.LogLevel.Trace)});return y.combinedDisposable(s,c)}toFilePath(i){return P.normalize(i.fsPath)}toFileSystemProviderError(i){if(i instanceof D.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=D.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=D.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=D.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=D.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=D.FileSystemProviderErrorCode.NoPermissions;break;default:s=D.FileSystemProviderErrorCode.Unknown}return D.createFileSystemProviderError(i,s)}async toFileSystemProviderWriteError(i,s){let c=this.toFileSystemProviderError(s);if(i&&c.code===D.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await _.SymlinkSupport.stat(this.toFilePath(i));p.mode&128||(c=D.createFileSystemProviderError(s,D.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return c}dispose(){super.dispose(),y.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,y.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(fe[45],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=y.createDecorator("productService")}),define(fe[29],he([0,1,11,110]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class g{constructor(){this.data=new Map}add(_,P){D.ok(y.isString(_)),D.ok(y.isObject(P)),D.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,P)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new g}),define(fe[188],he([0,1,29,7]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function g(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class C{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,v){this.schemasById[g(d)]=v,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new C;y.Registry.add(e.Extensions.JSONContribution,_)}),define(fe[38],he([0,1,138,7,29,11,188]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const d=g.Registry.as(_.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},d.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,I=!0){this.registerConfigurations([E],I)}registerConfigurations(E,I=!0){const h=[];E.forEach(a=>{h.push(...this.validateAndRegisterProperties(a,I,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),d.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(E){const I=[],h=a=>{if(a.properties)for(const l in a.properties)I.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,a.properties[l]);a.allOf&&a.allOf.forEach(l=>h(l))};for(const a of E){h(a);const l=this.configurationContributors.indexOf(a);l!==-1&&this.configurationContributors.splice(l,1)}d.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}registerDefaultConfigurations(E){const I=[],h=[];for(const a of E)for(const l in a)if(I.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]={...this.defaultValues[l]||{},...a[l]};const t={type:"object",default:this.defaultValues[l],description:y.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};h.push(k(l)),this.configurationProperties[l]=t,this.defaultLanguageConfigurationOverridesNode.properties[l]=t}else{this.defaultValues[l]=a[l];const t=this.configurationProperties[l];t&&(this.updatePropertyDefaultValue(l,t),this.updateSchema(l,t))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}deregisterDefaultConfigurations(E){const I=[];for(const h of E)for(const a in h)if(I.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const l=this.configurationProperties[a];l&&(this.updatePropertyDefaultValue(a,l),this.updateSchema(a,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const I of E)this.overrideIdentifiers.add(I);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,I=!0,h,a=3){a=C.isUndefinedOrNull(E.scope)?a:E.scope;let l=[],t=E.properties;if(t)for(let i in t){if(I&&u(i)){delete t[i];continue}const s=t[i];if(this.updatePropertyDefaultValue(i,s),e.OVERRIDE_PROPERTY_PATTERN.test(i)?s.scope=void 0:(s.scope=C.isUndefinedOrNull(s.scope)?a:s.scope,s.restricted=C.isUndefinedOrNull(s.restricted)?!!h?.restrictedConfigurations?.includes(i):s.restricted),t[i].hasOwnProperty("included")&&!t[i].included){this.excludedConfigurationProperties[i]=t[i],delete t[i];continue}else this.configurationProperties[i]=t[i];!t[i].deprecationMessage&&t[i].markdownDeprecationMessage&&(t[i].deprecationMessage=t[i].markdownDeprecationMessage),l.push(i)}let r=E.allOf;if(r)for(let i of r)l.push(...this.validateAndRegisterProperties(i,I,h,a));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const I=h=>{let a=h.properties;if(a)for(const t in a)this.updateSchema(t,a[t]);let l=h.allOf;l&&l.forEach(I)};I(E)}updateSchema(E,I){switch(e.allSettings.properties[E]=I,I.scope){case 1:e.applicationSettings.properties[E]=I;break;case 2:e.machineSettings.properties[E]=I;break;case 6:e.machineOverridableSettings.properties[E]=I;break;case 3:e.windowSettings.properties[E]=I;break;case 4:e.resourceSettings.properties[E]=I;break;case 5:e.resourceSettings.properties[E]=I,this.resourceLanguageSettingsSchema.properties[E]=I;break}}removeFromSchema(E,I){switch(delete e.allSettings.properties[E],I.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const I=`[${E}]`,h={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(I,h),e.allSettings.properties[I]=h,e.applicationSettings.properties[I]=h,e.machineSettings.properties[I]=h,e.machineOverridableSettings.properties[I]=h,e.windowSettings.properties[I]=h,e.resourceSettings.properties[I]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,I){let h=this.defaultValues[E];C.isUndefined(h)&&(h=I.default),C.isUndefined(h)&&(h=b(I.type)),I.default=h}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function k(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=k;function b(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const m=new v;g.Registry.add(e.Extensions.Configuration,m);function u(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?y.localize(5,null,S):m.getConfigurationProperties()[S]!==void 0?y.localize(6,null,S):null:y.localize(4,null)}e.validateProperty=u;function f(){const S=[],E=m.getConfigurationProperties();for(const I of Object.keys(E))S.push([I,E[I].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=f}),define(fe[32],he([0,1,18,11,2,29,6,38]),function(X,e,y,D,g,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=_.createDecorator("configurationService");function d(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof g.URI)}e.isConfigurationOverrides=d;var v;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(v=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function k(r,i){const s=i?r?i.keys.filter(A=>r.keys.indexOf(A)===-1):[...i.keys]:[],c=r?i?r.keys.filter(A=>i.keys.indexOf(A)===-1):[...r.keys]:[],p=[];if(i&&r){for(const A of r.keys)if(i.keys.indexOf(A)!==-1){const N=E(r.contents,A),Q=E(i.contents,A);y.equals(N,Q)||p.push(A)}}const w=[],L=A=>{const N={};for(const Q of A)for(const J of Q.identifiers)N[l(J)]=Q;return N},F=i?L(i.overrides):{},o=r?L(r.overrides):{};if(Object.keys(F).length)for(const A of s){const N=F[A];N&&w.push([P.overrideIdentifierFromKey(A),N.keys])}if(Object.keys(o).length)for(const A of c){const N=o[A];N&&w.push([P.overrideIdentifierFromKey(A),N.keys])}if(Object.keys(F).length&&Object.keys(o).length)for(const A of p){const N=o[A],Q=F[A];if(N&&Q){const J=k({contents:N.contents,keys:N.keys,overrides:[]},{contents:Q.contents,keys:Q.keys,overrides:[]});w.push([P.overrideIdentifierFromKey(A),[...J.added,...J.removed,...J.updated]])}}return{added:s,removed:c,updated:p,overrides:w}}e.compare=k;function b(r,i){const s=[];for(const c of Object.keys(r))if(P.OVERRIDE_PROPERTY_PATTERN.test(c)){const p={};for(const w in r[c])p[w]=r[c][w];s.push({identifiers:[P.overrideIdentifierFromKey(c).trim()],keys:Object.keys(p),contents:m(p,i)})}return s}e.toOverrides=b;function m(r,i){const s=Object.create(null);for(let c in r)u(s,c,r[c],i);return s}e.toValuesTree=m;function u(r,i,s,c){const p=i.split("."),w=p.pop();let L=r;for(let F=0;F<p.length;F++){let o=p[F],A=L[o];switch(typeof A){case"undefined":A=L[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${i} as ${p.slice(0,F+1).join(".")} is ${JSON.stringify(A)}`);return}L=A}if(typeof L=="object"&&L!==null)try{L[w]=s}catch(F){c(`Ignoring ${i} as ${p.join(".")} is ${JSON.stringify(L)}`)}else c(`Ignoring ${i} as ${p.join(".")} is ${JSON.stringify(L)}`)}e.addToValueTree=u;function f(r,i){const s=i.split(".");S(r,s)}e.removeFromValueTree=f;function S(r,i){const s=i.shift();if(i.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const c=r[s];typeof c=="object"&&!Array.isArray(c)&&(S(c,i),Object.keys(c).length===0&&delete r[s])}}function E(r,i,s){function c(L,F){let o=L;for(const A of F){if(typeof o!="object"||o===null)return;o=o[A]}return o}const p=i.split("."),w=c(r,p);return typeof w=="undefined"?s:w}e.getConfigurationValue=E;function I(r,i,s){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in r?D.isObject(r[c])&&D.isObject(i[c])?I(r[c],i[c],s):s&&(r[c]=i[c]):r[c]=i[c])})}e.merge=I;function h(){const r=C.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=h;function a(){const r=Object.create(null),i=C.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let s in i){let c=i[s].default;u(r,s,c,p=>console.error(`Conflict in default settings: ${p}`))}return r}e.getDefaultValues=a;function l(r){return`[${r}]`}e.keyFromOverrideIdentifier=l;function t(r,i,s){const c=r.inspect(i),p=r.inspect(s);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:c.defaultValue}e.getMigratedSettingValue=t}),define(fe[189],he([0,1,37,26,21,11,18,2,38,32,29,3,7]),function(X,e,y,D,g,C,_,P,d,v,n,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?v.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?v.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const s of g.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[s],p=r[s];p&&(typeof c=="object"&&typeof p=="object"?(c=_.deepClone(c),this.mergeContents(c,p)):c=p),i[s]=c}return new m(i,this.keys,this.overrides)}merge(...t){const r=_.deepClone(this.contents),i=_.deepClone(this.overrides),s=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const p of c.overrides){const[w]=i.filter(L=>g.equals(L.identifiers,p.identifiers));w?this.mergeContents(w.contents,p.contents):i.push(_.deepClone(p))}for(const p of c.keys)s.indexOf(p)===-1&&s.push(p)}return new m(r,s,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&C.isObject(t[i])&&C.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=_.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?_.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),v.addToValueTree(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&v.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class u extends m{constructor(){const t=v.getDefaultValues(),r=v.getConfigurationKeys(),i=[];for(const s of Object.keys(t))d.OVERRIDE_PROPERTY_PATTERN.test(s)&&i.push({identifiers:[d.overrideIdentifierFromKey(s).trim()],keys:Object.keys(t[s]),contents:v.toValuesTree(t[s],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,i)}}e.DefaultConfigurationModel=u;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!C.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:s,overrides:c,restricted:p}=this.doParseRaw(t,r);this._configurationModel=new m(i,s,c),this._restrictedConfigurations=p||[]}doParseContent(t){let r={},i=null,s=[],c=[],p=[];function w(F){Array.isArray(s)?s.push(F):i&&(s[i]=F)}let L={onObjectBegin:()=>{let F={};w(F),c.push(s),s=F,i=null},onObjectProperty:F=>{i=F},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{let F=[];w(F),c.push(s),s=F,i=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:w,onError:(F,o,A)=>{p.push({error:F,offset:o,length:A})}};if(t)try{y.visit(t,L),r=s[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return r}doParseRaw(t,r){const i=n.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,i,!0,r);t=s.raw;const c=v.toValuesTree(t,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),p=Object.keys(t),w=v.toOverrides(t,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:c,keys:p,overrides:w,restricted:s.restricted}}filter(t,r,i,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const c={},p=[];for(let w in t)if(d.OVERRIDE_PROPERTY_PATTERN.test(w)&&i){const L=this.filter(t[w],r,!1,s);c[w]=L.raw,p.push(...L.restricted)}else{const L=r[w],F=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&p.push(w),(F===void 0||s.scopes===void 0||s.scopes.includes(F))&&(s.skipRestricted&&L?.restricted||(c[w]=t[w]))}return{raw:c,restricted:p}}}e.ConfigurationModelParser=f;class S extends k.Disposable{constructor(t,r,i,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class E{constructor(t,r,i=new m,s=new m,c=new D.ResourceMap,p=new m,w=new D.ResourceMap,L=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=s,this._folderConfigurations=c,this._memoryConfiguration=p,this._memoryConfigurationByResource=w,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new m,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const s=this.getConsolidateConfigurationModel(r,i),c=this.getFolderConfigurationModelForResource(r.resource,i),p=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,w=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),L=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),F=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,Q=r.overrideIdentifier?p.override(r.overrideIdentifier).getValue(t):p.getValue(t),J=s.getValue(t),ce=g.distinct(g.flatten(s.overrides.map(se=>se.identifiers))).filter(se=>s.getOverrideValue(t,se)!==void 0);return{defaultValue:w,userValue:L,userLocalValue:F,userRemoteValue:o,workspaceValue:A,workspaceFolderValue:N,memoryValue:Q,value:J,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:c?.freeze().getValue(t),override:r.overrideIdentifier?c?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:Q!==void 0?{value:p.getValue(t),override:r.overrideIdentifier?p.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ce.length?ce:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(s=>d.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const c=d.overrideIdentifierFromKey(s),p=this._defaultConfiguration.getKeysForOverrideIdentifier(c),w=t.getKeysForOverrideIdentifier(c),L=[...w.filter(F=>p.indexOf(F)===-1),...p.filter(F=>w.indexOf(F)===-1),...p.filter(F=>!_.equals(this._defaultConfiguration.override(c).getValue(F),t.override(c).getValue(F)))];return[c,L]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:c}=v.compare(this.localUserConfiguration,t),p=[...r,...i,...s];return p.length&&this.updateLocalUserConfiguration(t),{keys:p,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:c}=v.compare(this.remoteUserConfiguration,t);let p=[...r,...i,...s];return p.length&&this.updateRemoteUserConfiguration(t),{keys:p,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:s,overrides:c}=v.compare(this.workspaceConfiguration,t);let p=[...r,...i,...s];return p.length&&this.updateWorkspaceConfiguration(t),{keys:p,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:s,updated:c,removed:p,overrides:w}=v.compare(i,r);let L=[...s,...c,...p];return(L.length||!i)&&this.updateFolderConfiguration(t,r),{keys:L,overrides:w}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:s,removed:c,overrides:p}=v.compare(r,void 0);return{keys:[...i,...s,...c],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const c=this._memoryConfigurationByResource.get(t);c&&(i=i.merge(c))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=i.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:s,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:s,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((p,w)=>(p.set(P.URI.revive(w[0]),this.parseConfigurationModel(w[1])),p),new D.ResourceMap);return new E(r,i,new m,s,c,new m,new D.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function I(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const t=new Set,r=new Map;for(const s of l)s.keys.forEach(c=>t.add(c)),s.overrides.forEach(([c,p])=>{const w=D.getOrSet(r,c,new Set);p.forEach(L=>w.add(L))});const i=[];return r.forEach((s,c)=>i.push([c,[...s.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=I;class h{constructor(t,r,i,s){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(w=>c.add(w)),t.overrides.forEach(([,w])=>w.forEach(L=>c.add(L))),this.affectedKeys=[...c.values()];const p=new m;this.affectedKeys.forEach(w=>p.setValue(w,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!_.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=v.toValuesTree({[r]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(t=t[s],!t)return!1;i=i[s]}return!0}}e.ConfigurationChangeEvent=h;class a extends h{constructor(t,r,i,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=a}),define(fe[95],he([0,1,29,38,3,32,189,7,14,19]),function(X,e,y,D,g,C,_,P,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends g.Disposable{constructor(b,m){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new _.UserSettings(this.settingsResource,void 0,v.extUriBiasedIgnorePathCase,m)),this.configuration=new _.Configuration(new _.DefaultConfigurationModel,new _.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new d.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(y.Registry.as(D.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new _.Configuration(new _.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,m){const u=typeof b=="string"?b:void 0,f=C.isConfigurationOverrides(b)?b:C.isConfigurationOverrides(m)?m:{};return this.configuration.getValue(u,f,void 0)}updateValue(b,m,u,f){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const m=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(u,m,1)}onDidDefaultConfigurationChange(b){const m=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new _.DefaultConfigurationModel,b);this.trigger(u,m,6)}trigger(b,m,u){const f=new _.ConfigurationChangeEvent(b,{data:m},this.configuration);f.source=u,f.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(fe[96],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=y.createDecorator("remoteAuthorityResolverService");var D;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class g extends Error{constructor(_,P=D.Unknown,d){super(_);this._message=_,this._code=P,this._detail=d,this.isHandled=P===D.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,g.prototype)}static isTemporarilyNotAvailable(_){return _ instanceof g&&_._code===D.TemporarilyNotAvailable}static isNoResolverFound(_){return _ instanceof g&&_._code===D.NoResolverFound}static isHandled(_){return _ instanceof g&&_.isHandled}}e.RemoteAuthorityResolverError=g}),define(fe[190],he([0,1,8]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function D(v){return v.scheme===y.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=D;function g(v){if(!v)return;const n=v.indexOf("+");return n<0?v:v.substr(0,n)}e.getRemoteName=g;function C(v){return v.scheme!==y.Schemas.file&&v.scheme!==y.Schemas.vscodeRemote}e.isVirtualResource=C;function _(v){if(v.folders.length)return v.folders.every(n=>C(n.uri))?v.folders[0].uri:void 0;if(v.configuration&&C(v.configuration))return v.configuration}e.getVirtualWorkspaceLocation=_;function P(v){return _(v)?.scheme}e.getVirtualWorkspaceScheme=P;function d(v){return _(v)!==void 0}e.isVirtualWorkspace=d}),define(fe[65],he([0,1,152,6,38,29,17]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=D.createDecorator("requestService");function P(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=P;function d(u){return u.res.statusCode===204}async function v(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);return d(u)?null:(await _.streamToBuffer(u.stream)).toString()}e.asText=v;async function n(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);if(d(u))return null;const S=(await _.streamToBuffer(u.stream)).toString();try{return JSON.parse(S)}catch(E){throw E.message+=`:
`+S,E}}e.asJson=n;function k(u){m(u)}e.updateProxyConfigurationsScope=k;let b;function m(u){const f=C.Registry.as(g.Extensions.Configuration);b&&f.deregisterConfigurations([b]),b={id:"http",order:15,title:y.localize(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:y.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:y.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:y.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[y.localize(4,null),y.localize(5,null),y.localize(6,null),y.localize(7,null)],default:"override",description:y.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:y.localize(9,null),restricted:!0}}},f.registerConfiguration(b)}m(2)}),define(fe[191],he([0,1,25,17]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class g{constructor(P){this.service=P}listen(P,d){throw new Error("Invalid listen")}call(P,d,v){switch(d){case"request":return this.service.request(v[0],y.CancellationToken.None).then(async({res:n,stream:k})=>{const b=await D.streamToBuffer(k);return[{statusCode:n.statusCode,headers:n.headers},b]})}throw new Error("Invalid call")}}e.RequestChannel=g;class C{constructor(P){this.channel=P}async request(P,d){return C.request(this.channel,P,d)}static async request(P,d,v){const[n,k]=await P.call("request",[d]);return{res:n,stream:D.bufferToStream(k)}}}e.RequestChannelClient=C}),define(fe[192],he([0,1,66,11]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function g(_,P){return _.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:_.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function C(_,P,d={}){const v=y.parse(_),n=d.proxyUrl||g(v,P);if(!n)return null;const k=y.parse(n);if(!/^https?:$/.test(k.protocol||""))return null;const b={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:D.isBoolean(d.strictSSL)?d.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((m,u)=>{X(["http-proxy-agent"],m,u)}))(b):new(await new Promise((m,u)=>{X(["https-proxy-agent"],m,u)}))(b)}e.getProxyAgent=C}),define(fe[193],he([0,1,22,17]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function g(C,_,P){let d=P&&P.get("storage.serviceMachineId",0)||null;if(d)return d;try{const n=(await _.readFile(C.serviceMachineIdResource)).value.toString();d=y.isUUID(n)?n:null}catch(v){d=null}if(!d){d=y.generateUuid();try{await _.writeFile(C.serviceMachineIdResource,D.VSBuffer.fromString(d))}catch(v){}}return P&&P.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=g}),define(fe[194],he([0,1,6,7,3,11,127,14]),function(X,e,y,D,g,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";e.IStorageService=y.createDecorator("storageService");var v;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var k;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(k=e.StorageTarget||(e.StorageTarget={}));class b extends g.Disposable{constructor(S={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new g.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=P.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){g.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,E){E===d?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:E,target:this.getKeyTargets(S)[E]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,E,I){return this.getStorage(E)?.get(S,I)}getBoolean(S,E,I){return this.getStorage(E)?.getBoolean(S,I)}getNumber(S,E,I){return this.getStorage(E)?.getNumber(S,I)}store(S,E,I,h){if(C.isUndefinedOrNull(E)){this.remove(S,I);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,I,h),this.getStorage(I)?.set(S,E)})}remove(S,E){this.withPausedEmitters(()=>{this.updateKeyTarget(S,E,void 0),this.getStorage(E)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,E){const I=[],h=this.getKeyTargets(S);for(const a of Object.keys(h))h[a]===E&&I.push(a);return I}updateKeyTarget(S,E,I){const h=this.getKeyTargets(E);typeof I=="number"?h[S]!==I&&(h[S]=I,this.getStorage(E)?.set(d,JSON.stringify(h))):typeof h[S]=="number"&&(delete h[S],this.getStorage(E)?.set(d,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const E=this.get(d,S);if(E)try{return JSON.parse(E)}catch(I){}return Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(){this._onWillSaveState.fire({reason:v.NONE}),await P.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const S=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return u(S,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class m extends b{constructor(){super();this.globalStorage=this._register(new _.Storage(new _.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new _.Storage(new _.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}e.InMemoryStorageService=m;async function u(f,S,E,I){const h=c=>{try{return JSON.parse(c)}catch(p){return c}},a=new Map,l=new Map;f.forEach((c,p)=>{a.set(p,c),l.set(p,h(c))});const t=new Map,r=new Map;S.forEach((c,p)=>{t.set(p,c),r.set(p,h(c))}),console.group(`Storage: Global (path: ${E})`);let i=[];a.forEach((c,p)=>{i.push({key:p,value:c})}),console.table(i),console.groupEnd(),console.log(l),console.group(`Storage: Workspace (path: ${I})`);let s=[];t.forEach((c,p)=>{s.push({key:p,value:c})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=u}),define(fe[195],he([0,1,5,23,22,2]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function _(v){if(y.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function P(v,n,k,b,m,u,f,S,E,I){const h=Object.create(null);h["common.machineId"]=f,h.sessionID=g.generateUuid()+Date.now(),h.commitHash=m,h.version=u,h["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=y.PlatformToString(y.platform),h["common.nodePlatform"]=D.platform,h["common.nodeArch"]=b,h["common.product"]=I||"desktop";const a=d(S||[]);a&&(h["common.msftInternal"]=a);let l=0;const t=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),y.isLinuxSnap&&(h["common.snap"]="true");const r=_(k);r&&(h["common.platformDetail"]=r);try{const i=await v.readFile(C.URI.file(E));h["common.source"]=i.value.toString().slice(0,30)}catch(i){}return h}e.resolveCommonProperties=P;function d(v){const n=D.env.USERDNSDOMAIN;if(!n)return!1;const k=n.toLowerCase();return v.some(b=>k===b)}e.verifyMicrosoftInternalDomain=d}),define(fe[196],he([0,1,21,12,3,18]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var _;(function(d){function v(n,k){return n.callstack<k.callstack?-1:n.callstack>k.callstack?1:0}d.compare=v})(_=e.ErrorEvent||(e.ErrorEvent={}));class P{constructor(v,n=P.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new g.DisposableStore,this._telemetryService=v,this._flushDelay=n;const k=D.errorHandler.addListener(b=>this._onErrorEvent(b));this._disposables.add(g.toDisposable(k)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(v){if(!v)return;v.detail&&v.detail.stack&&(v=v.detail);let n=Array.isArray(v.stack)?v.stack.join(`
`):v.stack,k=v.message?v.message:C.safeStringify(v);!n||this._enqueue({msg:k,callstack:n})}_enqueue(v){const n=y.binarySearch(this._buffer,v,_.compare);n<0?(v.count=1,this._buffer.splice(~n,0,v)):(this._buffer[n].count||(this._buffer[n].count=0),this._buffer[n].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let v of this._buffer)this._telemetryService.publicLogError2("UnhandledError",v);this._buffer.length=0}}e.default=P,P.ERROR_FLUSH_TIMEOUT=5*1e3}),define(fe[39],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=y.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=y.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(fe[197],he([0,1,24,78,178,4,37,81,45,5,2,39,51,8,20,15]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function S(l,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,s=new Map,c=2e4;function p(F,o,A,N){const Q=o.substring(F.length+1);return new Promise(async J=>{let ce;try{ce=await f.Promises.readdir(o,{withFileTypes:!0})}catch(q){J();return}if(N.count>=c){N.count+=ce.length,N.maxReached=!0,J();return}let se=ce.length;if(se===0){J();return}let $=ce;N.count+ce.length>c&&(N.maxReached=!0,se=c-N.count,$=ce.slice(0,se)),N.count+=ce.length;for(const q of $)if(q.isDirectory()){if(A.includes(q.name)||await p(F,C.join(o,q.name),A,N),--se==0){J();return}}else{const W=q.name.lastIndexOf(".");if(W>=0){const V=q.name.substring(W+1);V&&i.set(V,(i.get(V)??0)+1)}for(const V of r)V.relativePathPattern?.test(Q)!==!1&&V.filePattern.test(q.name)&&s.set(V.tag,(s.get(V.tag)??0)+1);if(--se==0){J();return}}})}const w={count:0,maxReached:!1};await p(l,l,t,w);const L=await h(l);return{configFiles:E(s),fileTypes:E(i),fileCount:w.count,maxFilesReached:w.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=S;function E(l){return[...b.Iterable.map(l.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function I(){const l={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(D.virtualMachineHint.value()*100)}%`},t=y.cpus();return t&&t.length>0&&(l.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),l}e.getMachineInfo=I;async function h(l){try{const t=new Map,r=C.join(l,".vscode","launch.json"),i=await f.Promises.readFile(r),s=[],c=_.parse(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if(_.getNodeType(c)==="object"&&c.configurations)for(const p of c.configurations){const w=p.type;w&&(t.has(w)?t.set(w,t.get(w)+1):t.set(w,1))}return E(t)}catch(t){return[]}}e.collectLaunchConfigs=h;let a=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const i=y.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(y.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),v.isWindows||r.push(`Load (avg):       ${y.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(D.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([P.listProcesses(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[s,c]=i,p=this.formatProcessList(t,s);return r.forEach(w=>{if(g.isRemoteDiagnosticError(w))p+=`
${w.errorMessage}`,c+=`
${w.errorMessage}`;else if(p+=`

Remote: ${w.hostName}`,w.processes&&(p+=`
${this.formatProcessList(t,w.processes)}`),w.workspaceMetadata){c+=`
|  Remote: ${w.hostName}`;for(const L of Object.keys(w.workspaceMetadata)){const F=w.workspaceMetadata[L];let o=`${F.fileCount} files`;F.maxFilesReached&&(o=`more than ${o}`),c+=`|    Folder (${L}): ${o}`,c+=this.formatWorkspaceStats(F)}}}),{processInfo:p,workspaceInfo:c}})}async getSystemInfo(t,r){const{memory:i,vmHint:s,os:c,cpus:p}=I(),w={os:c,memory:i,cpus:p,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return v.isWindows||(w.load=`${y.loadavg().map(L=>Math.round(L)).join(", ")}`),v.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(t,r){const i=[];return P.listProcesses(t.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,s)),t.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(c=>{if(g.isRemoteDiagnosticError(c))i.push(`
${c.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${c.hostName}`),i.push(this.formatMachineInfo(c.machineInfo)),c.processes&&i.push(this.formatProcessList(t,c.processes)),c.workspaceMetadata)for(const p of Object.keys(c.workspaceMetadata)){const w=c.workspaceMetadata[p];let L=`${w.fileCount} files`;w.maxFilesReached&&(L=`more than ${L}`),i.push(`Folder (${p}): ${L}`),i.push(this.formatWorkspaceStats(w))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let s=0;const c=(F,o)=>{const A=` ${F}(${o})`;s+A.length>i?(r.push(p),p="|                 ",s=p.length):s+=A.length,p+=A};let p="|      File types:";const w=10;let L=t.fileTypes.length>w?w:t.fileTypes.length;for(let F=0;F<L;F++){const o=t.fileTypes[F];c(o.name,o.count)}if(r.push(p),t.configFiles.length>=0&&(p="|      Conf files:",s=0,t.configFiles.forEach(F=>{c(F.name,F.count)}),r.push(p)),t.launchConfigFiles.length>0){let F="|      Launch Configs:";t.launchConfigFiles.forEach(o=>{F+=o.count>1?` ${o.name}(${o.count})`:` ${o.name}`}),r.push(F)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const p=n.URI.revive(c);if(p.scheme===m.Schemas.file){const w=p.fsPath;i.push(S(w,["node_modules",".git"]).then(L=>{let F=`${L.fileCount} files`;L.maxFilesReached&&(F=`more than ${F}`),r.push(`|    Folder (${C.basename(w)}): ${F}`),r.push(this.formatWorkspaceStats(L))}).catch(L=>{r.push(`|      Error: Unable to collect workspace stats for folder ${w} (${L.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(c=>i.set(c.pid,c.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,s,r,0),s.join(`
`)}formatProcessItem(t,r,i,s,c){const p=c===0;let w;p?w=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(w=`${"  ".repeat(c)} ${s.name}`,s.name==="window"&&(w=`${w} (${r.get(s.pid)})`));const L=process.platform==="win32"?s.mem:y.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(L/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(s.children)&&s.children.forEach(F=>this.formatProcessItem(t,r,i,F,c+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==m.Schemas.file)continue;const s=i.fsPath;try{const c=await S(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),c.fileTypes.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:p.name,count:p.count})}),c.launchConfigFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:p.name,count:p.count})}),c.configFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};a=Ne([Ke(0,k.ITelemetryService),Ke(1,d.IProductService)],a),e.DiagnosticsService=a}),define(fe[97],he([0,1,12,33,34,18,39,65,58,28,25,16,20,2,45,194,193,6]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var I;(function(q){q[q.None=0]="None",q[q.IncludeVersions=1]="IncludeVersions",q[q.IncludeFiles=2]="IncludeFiles",q[q.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",q[q.IncludeSharedAccounts=8]="IncludeSharedAccounts",q[q.IncludeVersionProperties=16]="IncludeVersionProperties",q[q.ExcludeNonValidated=32]="ExcludeNonValidated",q[q.IncludeInstallationTargets=64]="IncludeInstallationTargets",q[q.IncludeAssetUri=128]="IncludeAssetUri",q[q.IncludeStatistics=256]="IncludeStatistics",q[q.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",q[q.Unpublished=4096]="Unpublished"})(I||(I={}));function h(...q){return String(q.reduce((W,V)=>W|V,0))}var a;(function(q){q[q.Tag=1]="Tag",q[q.ExtensionId=4]="ExtensionId",q[q.Category=5]="Category",q[q.ExtensionName=7]="ExtensionName",q[q.Target=8]="Target",q[q.Featured=9]="Featured",q[q.SearchText=10]="SearchText",q[q.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},t={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},i={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:I.None,criteria:[],assetTypes:[]};class s{constructor(W=i){this.state=W}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(W,V=this.state.pageSize){return new s({...this.state,pageNumber:W,pageSize:V})}withFilter(W,...V){const T=[...this.state.criteria,...V.length?V.map(R=>({filterType:W,value:R})):[{filterType:W}]];return new s({...this.state,criteria:T})}withSortBy(W){return new s({...this.state,sortBy:W})}withSortOrder(W){return new s({...this.state,sortOrder:W})}withFlags(...W){return new s({...this.state,flags:W.reduce((V,T)=>V|T,0)})}withAssetTypes(...W){return new s({...this.state,assetTypes:W})}get raw(){const{criteria:W,pageNumber:V,pageSize:T,sortBy:R,sortOrder:M,flags:z,assetTypes:j}=this.state;return{filters:[{criteria:W,pageNumber:V,pageSize:T,sortBy:R,sortOrder:M}],assetTypes:j,flags:z}}get searchText(){const W=this.state.criteria.filter(V=>V.filterType===a.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(W=>String(W.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(q,W){const V=(q||[]).filter(T=>T.statisticName===W)[0];return V?V.value:0}function p(q){const W="Microsoft.VisualStudio.Code.Translation.";return q.files.filter(T=>T.assetType.indexOf(W)===0).reduce((T,R)=>{const M=o(q,R.assetType);return M&&T.push([R.assetType.substring(W.length),M]),T},[])}function w(q){if(q.properties){const W=q.properties.filter(R=>R.key===l.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),T=W.filter(R=>V.test(R.value))[0];return T?{uri:T.value,fallbackUri:T.value}:null}return o(q,l.Repository)}function L(q){return{uri:`${q.fallbackAssetUri}/${l.VSIX}?redirect=true`,fallbackUri:`${q.fallbackAssetUri}/${l.VSIX}`}}function F(q){const W=o(q,l.Icon);if(W)return W;const V=D.DefaultIconPath;return{uri:V,fallbackUri:V}}function o(q,W){return q.files.filter(T=>T.assetType===W)[0]?{uri:`${q.assetUri}/${W}`,fallbackUri:`${q.fallbackAssetUri}/${W}`}:null}function A(q,W){const V=q.properties?q.properties.filter(R=>R.key===W):[],T=V.length>0&&V[0].value;return T?T.split(",").map(R=>g.adoptToGalleryExtensionId(R)):[]}function N(q){const W=q.properties?q.properties.filter(V=>V.key===t.Engine):[];return W.length>0&&W[0].value||""}function Q(q){const W=q.properties?q.properties.filter(T=>T.key===t.LocalizedLanguages):[],V=W.length>0&&W[0].value||"";return V?V.split(","):[]}function J(q){return q.indexOf("preview")!==-1}function ce(q,W,V,T,R){const M={manifest:o(W,l.Manifest),readme:o(W,l.Details),changelog:o(W,l.Changelog),license:o(W,l.License),repository:w(W),download:L(W),icon:F(W),coreTranslations:p(W)};return{identifier:{id:g.getGalleryExtensionId(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},name:q.extensionName,version:W.version,date:W.lastUpdated,displayName:q.displayName,publisherId:q.publisher.publisherId,publisher:q.publisher.publisherName,publisherDisplayName:q.publisher.displayName,description:q.shortDescription||"",installCount:c(q.statistics,"install"),rating:c(q.statistics,"averagerating"),ratingCount:c(q.statistics,"ratingcount"),assetUri:m.URI.parse(W.assetUri),webExtension:!!q.tags?.includes(D.WEB_EXTENSION_TAG),assetTypes:W.files.map(({assetType:z})=>z),assets:M,properties:{dependencies:A(W,t.Dependency),extensionPack:A(W,t.ExtensionPack),engine:N(W),localizedLanguages:Q(W)},telemetryData:{index:(T.pageNumber-1)*T.pageSize+V,querySource:R},preview:J(q.flags)}}let se=class{constructor(W,V,T,R,M,z,j){this.requestService=W,this.logService=V,this.environmentService=T,this.telemetryService=R,this.fileService=M,this.productService=z;const ee=z.extensionsGallery;this.extensionsGalleryUrl=ee&&ee.serviceUrl,this.extensionsControlUrl=ee&&ee.controlUrl,this.commonHeadersPromise=$(z.version,this.environmentService,this.fileService,j)}api(W=""){return`${this.extensionsGalleryUrl}${W}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(W,V){const T=[];let{total:R,firstPage:M,getPage:z}=await this.query({names:W,pageSize:W.length},V);T.push(...M);for(let j=1;T.length<R&&(M=await z(j,V),M.length);j++)T.push(...M);return T}async getCompatibleExtension(W,V){return this.getCompatibleExtensionByEngine(W,V)}async getCompatibleExtensionByEngine(W,V){const T=D.isIExtensionIdentifier(W)?null:W;if(T&&T.properties.engine&&d.isEngineValid(T.properties.engine,this.productService.version,this.productService.date))return T;const{id:R,uuid:M}=T?T.identifier:W;let z=new s().withFlags(I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");M?z=z.withFilter(a.ExtensionId,M):z=z.withFilter(a.ExtensionName,R);const{galleryExtensions:j}=await this.queryGallery(z,n.CancellationToken.None),[ee]=j;if(!ee||!ee.versions.length)return null;if(V){const ge=ee.versions.filter(be=>be.version===V)[0];if(ge){const be=ce(ee,ge,0,z);if(be.properties.engine&&d.isEngineValid(be.properties.engine,this.productService.version,this.productService.date))return be}return null}const me=await this.getLastValidExtensionVersion(ee,ee.versions);return me?ce(ee,me,0,z):null}async query(W,V){const T=n.CancellationToken.isCancellationToken(W)?{}:W,R=n.CancellationToken.isCancellationToken(W)?W:V;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=T.text||"";const z=C.getOrDefault(T,Ie=>Ie.pageSize,50);let j=new s().withFlags(I.IncludeLatestVersionOnly,I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,z).withFilter(a.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ie,Ae,Fe)=>(j=j.withFilter(a.Category,Fe||Ae),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ie,Ae,Fe)=>(j=j.withFilter(a.Tag,Fe||Ae),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(j=j.withFilter(a.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),j=j.withFilter(a.SearchText,M)),j=j.withSortBy(0)):T.ids?j=j.withFilter(a.ExtensionId,...T.ids):T.names?j=j.withFilter(a.ExtensionName,...T.names):j=j.withSortBy(4),typeof T.sortBy=="number"&&(j=j.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(j=j.withSortOrder(T.sortOrder));const{galleryExtensions:ee,total:me}=await this.queryGallery(j,R),ge=ee.map((Ie,Ae)=>ce(Ie,Ie.versions[0],Ae,j,T.source)),be=async(Ie,Ae)=>{if(Ae.isCancellationRequested)throw y.canceled();const Fe=j.withPage(Ie+1),{galleryExtensions:$e}=await this.queryGallery(Fe,Ae);return $e.map((Qe,Ze)=>ce(Qe,Qe.versions[0],Ze,Fe,T.source))};return{firstPage:ge,total:me,pageSize:j.pageSize,getPage:be}}async queryGallery(W,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,I.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,h(I.Unpublished));const T=await this.commonHeadersPromise,R=JSON.stringify(W.raw),M={...T,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(R.length)},z=new Date().getTime();let j,ee,me=0;try{if(j=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:R,headers:M},V),j.res.statusCode&&j.res.statusCode>=400&&j.res.statusCode<500)return{galleryExtensions:[],total:me};const ge=await P.asJson(j);if(ge){const be=ge.results[0],Ie=be.extensions,Ae=be.resultMetadata&&be.resultMetadata.filter(Fe=>Fe.metadataType==="ResultCount")[0];return me=Ae&&Ae.metadataItems.filter(Fe=>Fe.name==="TotalCount")[0].count||0,{galleryExtensions:Ie,total:me}}return{galleryExtensions:[],total:me}}catch(ge){throw ee=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(R.length),duration:new Date().getTime()-z,success:!!j&&P.isSuccess(j),responseBodySize:j?.res.headers["Content-Length"],statusCode:j?String(j.res.statusCode):void 0,errorCode:ee?y.isPromiseCanceledError(ee)?"canceled":y.getErrorMessage(ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(W,V,T,R){if(!this.isEnabled())return;const z={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${W}/extensions/${V}/${T}/stats?statType=${R}`),headers:z},n.CancellationToken.None)}catch(j){}}async download(W,V,T){this.logService.trace("ExtensionGalleryService#download",W.identifier.id);const R=g.getGalleryExtensionTelemetryData(W),M=new Date().getTime(),z=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...R,duration:ge}),j=T===1?"install":T===2?"update":"",ee=j?{uri:`${W.assets.download.uri}&${j}=true`,fallbackUri:`${W.assets.download.fallbackUri}?${j}=true`}:W.assets.download,me=await this.getAsset(ee);await this.fileService.writeFile(V,me.stream),z(new Date().getTime()-M)}async getReadme(W,V){if(W.assets.readme){const T=await this.getAsset(W.assets.readme,{},V);return await P.asText(T)||""}return""}async getManifest(W,V){if(W.assets.manifest){const T=await this.getAsset(W.assets.manifest,{},V),R=await P.asText(T);return R?JSON.parse(R):null}return null}async getCoreTranslation(W,V){const T=W.assets.coreTranslations.filter(R=>R[0]===V.toUpperCase())[0];if(T){const R=await this.getAsset(T[1]),M=await P.asText(R);return M?JSON.parse(M):null}return null}async getChangelog(W,V){if(W.assets.changelog){const T=await this.getAsset(W.assets.changelog,{},V);return await P.asText(T)||""}return""}async getAllVersions(W,V){let T=new s().withFlags(I.IncludeVersions,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");W.identifier.uuid?T=T.withFilter(a.ExtensionId,W.identifier.uuid):T=T.withFilter(a.ExtensionName,W.identifier.id);const R=[],{galleryExtensions:M}=await this.queryGallery(T,n.CancellationToken.None);return M.length&&(V?await Promise.all(M[0].versions.map(async z=>{let j;try{j=await this.getEngine(z)}catch(ee){}j&&d.isEngineValid(j,this.productService.version,this.productService.date)&&R.push({version:z.version,date:z.lastUpdated})})):R.push(...M[0].versions.map(z=>({version:z.version,date:z.lastUpdated})))),R}async getAsset(W,V={},T=n.CancellationToken.None){const R=await this.commonHeadersPromise,M={type:"GET"},z={...R,...V.headers||{}};V={...V,...M,headers:z};const j=W.uri,ee=W.fallbackUri,me={...V,url:j};try{const ge=await this.requestService.request(me,T);if(ge.res.statusCode===200)return ge;const be=await P.asText(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${be}`)}catch(ge){if(y.isPromiseCanceledError(ge))throw ge;const be=y.getErrorMessage(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:j,message:be});const Ie={...V,url:ee};return this.requestService.request(Ie,T)}}async getLastValidExtensionVersion(W,V){const T=this.getLastValidExtensionVersionFromProperties(W,V);return T||this.getLastValidExtensionVersionRecursively(W,V)}getLastValidExtensionVersionFromProperties(W,V){for(const T of V){const R=N(T);if(!R)return null;if(d.isEngineValid(R,this.productService.version,this.productService.date))return T}return null}async getEngine(W){const V=N(W);if(V)return V;const T=o(W,l.Manifest);if(!T)throw new Error("Manifest was not found");const R={"Accept-Encoding":"gzip"},M=await this.getAsset(T,{headers:R}),z=await P.asJson(M);if(z)return z.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(W,V){if(!V.length)return null;const T=V[0],R=await this.getEngine(T);return d.isEngineValid(R,this.productService.version,this.productService.date)?{...T,properties:[...T.properties||[],{key:t.Engine,value:R}]}:this.getLastValidExtensionVersionRecursively(W,V.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const W=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await P.asJson(W),T=new Map;if(V)for(const R of V.malicious){const M=T.get(R)||{id:{id:R},malicious:!0,slow:!1};M.malicious=!0,T.set(R,M)}return[...T.values()]}};se=Ne([Ke(0,P.IRequestService),Ke(1,k.ILogService),Ke(2,v.IEnvironmentService),Ke(3,_.ITelemetryService),Ke(4,b.IFileService),Ke(5,u.IProductService),Ke(6,E.optional(f.IStorageService))],se),e.ExtensionGalleryService=se;async function $(q,W,V,T){const R={"X-Market-Client-Id":`VSCode ${q}`,"User-Agent":`VSCode ${q}`},M=await S.getServiceMachineId(W,V,T);return R["X-Market-User-Id"]=M,R}e.resolveMarketplaceHeaders=$}),define(fe[198],he([0,1,31,153,13,6,32,38,3,18,29]),function(X,e,y,D,g,C,_,P,d,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let k=class{constructor(u,f){this._configurationService=f,this._experimentProperties={},this._disposables=new d.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp(g.escapeRegExpCharacters(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const E=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(u,f){this._experimentProperties[u]=f}setEnabled(u){this._enabled=u}_updateUserOptIn(){const u=this._configurationService?.getValue(b);this._userOptIn=u?u.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let f=u.sessionID,S=u["common.instanceId"],E=u["common.machineId"],I=u["common.firstSessionDate"],h=u["common.msftInternal"];return{sessionId:f,instanceId:S,machineId:E,firstSessionDate:I,msftInternal:h}}dispose(){this._disposables.dispose()}publicLog(u,f,S){return this.isOptedIn?this._commonProperties.then(E=>{f=v.mixin(f,E),f=v.mixin(f,this._experimentProperties),f=v.cloneAndChange(f,I=>{if(typeof I=="string")return this._cleanupInfo(I,S)}),this._appender.log(u,f)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(u,f,S){return this.publicLog(u,f,S)}publicLogError(u,f){return this.sendErrorTelemetry?this.publicLog(u,f,!0):Promise.resolve(void 0)}publicLogError2(u,f){return this.publicLogError(u,f)}_cleanupInfo(u,f){let S=u;if(f){const E=[];for(let l of this._cleanupPatterns)for(;;){const t=l.exec(u);if(!t)break;E.push([t.index,l.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(S="";;){const l=h.exec(u);if(!l)break;!I.test(l[0])&&E.every(([t,r])=>l.index<t||l.index>=r)&&(S+=u.substring(a,l.index)+"<REDACTED: user-file-path>",a=h.lastIndex)}a<u.length&&(S+=u.substr(a))}for(let E of this._cleanupPatterns)S=S.replace(E,"");return S}};k.IDLE_START_EVENT_NAME="UserIdleStart",k.IDLE_STOP_EVENT_NAME="UserIdleStop",k=Ne([Ke(1,C.optional(_.IConfigurationService))],k),e.TelemetryService=k;const b="telemetry";n.Registry.as(P.Extensions.Configuration).registerConfiguration({id:b,order:110,type:"object",title:D.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:y.default.privacyStatementUrl?D.localize(2,null,y.default.privacyStatementUrl):D.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(fe[67],he([0,1,32,18,11,14]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(u,f){return Promise.resolve(void 0)}publicLog2(u,f){return this.publicLog(u,f)}publicLogError(u,f){return Promise.resolve(void 0)}publicLogError2(u,f){return this.publicLogError(u,f)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class _{async publicLog(f,S,E){}async publicLogError(f,S,E){}}e.NullEndpointTelemetryService=_;function P(...u){return{log:(f,S)=>u.forEach(E=>E.log(f,S)),flush:()=>C.Promises.settled(u.map(f=>f.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(u,f){return f.onDidChangeConfiguration(S=>{S.source!==6&&u.publicLog2("updateConfiguration",{configurationSource:y.ConfigurationTargetToString(S.source),configurationKeys:b(S.sourceConfig)})})}e.configurationTelemetry=d;function v(u){const f=Object.create(null),S=Object.create(null),E=Object.create(null);k(u,E);for(let I in E){I=I.length>150?I.substr(I.length-149):I;const h=E[I];typeof h=="number"?S[I]=h:typeof h=="boolean"?S[I]=h?1:0:typeof h=="string"?f[I]=h.substring(0,1023):typeof h!="undefined"&&h!==null&&(f[I]=h)}return{properties:f,measurements:S}}e.validateTelemetryData=v;function n(u){if(!u)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{u.indexOf(`${E}+`)===0&&(f=E)}),f}e.cleanRemoteAuthority=n;function k(u,f,S=0,E){if(!!u)for(let I of Object.getOwnPropertyNames(u)){const h=u[I],a=E?E+I:I;Array.isArray(h)?f[a]=D.safeStringify(h):h instanceof Date?f[a]=h.toISOString():g.isObject(h)?S<2?k(h,f,S+1,a+"."):f[a]=D.safeStringify(h):f[a]=h}}function b(u){if(!u)return[];const f=[];return m(f,"",u),f}function m(u,f,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(E=>m(u,f?`${f}.${E}`:E,S[E])):u.push(f)}}),define(fe[199],he([0,1,12,18,67]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function C(P){const d=await new Promise((n,k)=>{X(["applicationinsights"],n,k)});let v;return d.defaultClient?(v=new d.TelemetryClient(P),v.channel.setUseDiskRetryCaching(!0)):(d.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),v=d.defaultClient),P.indexOf("AIF-")===0&&(v.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),v}class _{constructor(d,v,n){this._eventPrefix=d,this._defaultData=v,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(d){if(!!this._aiClient){if(typeof this._aiClient!="string"){d(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=C(this._aiClient)),this._asyncAIClient.then(v=>{d(v)},v=>{y.onUnexpectedError(v),console.error(v)})}}log(d,v){!this._aiClient||(v=D.mixin(v,this._defaultData),v=g.validateTelemetryData(v),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+d,properties:v.properties,measurements:v.measurements})))}flush(){return this._aiClient?new Promise(d=>{this._withAIClient(v=>{v.flush({callback:()=>{this._aiClient=void 0,d(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=_}),define(fe[200],he([0,1,12,196]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class g extends D.default{installErrorListeners(){y.setUnexpectedErrorHandler(P=>console.error(P));const _=[];process.on("unhandledRejection",(P,d)=>{_.push(d),setTimeout(()=>{const v=_.indexOf(d);v>=0&&d.catch(n=>{_.splice(v,1),y.isPromiseCanceledError(n)||(console.warn(`rejected promise not handled within 1 second: ${n}`),n.stack&&console.warn(`stack trace: ${n.stack}`),y.onUnexpectedError(P))})},1e3)}),process.on("rejectionHandled",P=>{const d=_.indexOf(P);d>=0&&_.splice(d,1)}),process.on("uncaughtException",P=>{y.onUnexpectedError(P)})}}e.default=g}),define(fe[98],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var D;(function(m){m.Shell="terminal.integrated.shell.",m.ShellArgs="terminal.integrated.shellArgs.",m.DefaultProfile="terminal.integrated.defaultProfile.",m.Profiles="terminal.integrated.profiles."})(D=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var g;(function(m){m.ShellLinux="terminal.integrated.shell.linux",m.ShellMacOs="terminal.integrated.shell.osx",m.ShellWindows="terminal.integrated.shell.windows",m.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",m.AutomationShellLinux="terminal.integrated.automationShell.linux",m.AutomationShellMacOs="terminal.integrated.automationShell.osx",m.AutomationShellWindows="terminal.integrated.automationShell.windows",m.ShellArgsLinux="terminal.integrated.shellArgs.linux",m.ShellArgsMacOs="terminal.integrated.shellArgs.osx",m.ShellArgsWindows="terminal.integrated.shellArgs.windows",m.ProfilesWindows="terminal.integrated.profiles.windows",m.ProfilesMacOs="terminal.integrated.profiles.osx",m.ProfilesLinux="terminal.integrated.profiles.linux",m.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",m.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",m.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",m.UseWslProfiles="terminal.integrated.useWslProfiles",m.TabsEnabled="terminal.integrated.tabs.enabled",m.TabsHideCondition="terminal.integrated.tabs.hideCondition",m.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",m.TabsShowActions="terminal.integrated.tabs.showActions",m.TabsLocation="terminal.integrated.tabs.location",m.TabsFocusMode="terminal.integrated.tabs.focusMode",m.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",m.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",m.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",m.CopyOnSelection="terminal.integrated.copyOnSelection",m.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",m.FontFamily="terminal.integrated.fontFamily",m.FontSize="terminal.integrated.fontSize",m.LetterSpacing="terminal.integrated.letterSpacing",m.LineHeight="terminal.integrated.lineHeight",m.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",m.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",m.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",m.BellDuration="terminal.integrated.bellDuration",m.FontWeight="terminal.integrated.fontWeight",m.FontWeightBold="terminal.integrated.fontWeightBold",m.CursorBlinking="terminal.integrated.cursorBlinking",m.CursorStyle="terminal.integrated.cursorStyle",m.CursorWidth="terminal.integrated.cursorWidth",m.Scrollback="terminal.integrated.scrollback",m.DetectLocale="terminal.integrated.detectLocale",m.DefaultLocation="terminal.integrated.defaultLocation",m.GpuAcceleration="terminal.integrated.gpuAcceleration",m.RightClickBehavior="terminal.integrated.rightClickBehavior",m.Cwd="terminal.integrated.cwd",m.ConfirmOnExit="terminal.integrated.confirmOnExit",m.EnableBell="terminal.integrated.enableBell",m.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",m.AllowChords="terminal.integrated.allowChords",m.AllowMnemonics="terminal.integrated.allowMnemonics",m.EnvMacOs="terminal.integrated.env.osx",m.EnvLinux="terminal.integrated.env.linux",m.EnvWindows="terminal.integrated.env.windows",m.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",m.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",m.ShowExitAlert="terminal.integrated.showExitAlert",m.SplitCwd="terminal.integrated.splitCwd",m.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",m.WordSeparators="terminal.integrated.wordSeparators",m.TitleMode="terminal.integrated.titleMode",m.EnableFileLinks="terminal.integrated.enableFileLinks",m.UnicodeVersion="terminal.integrated.unicodeVersion",m.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",m.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",m.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",m.LocalEchoStyle="terminal.integrated.localEchoStyle",m.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",m.InheritEnv="terminal.integrated.inheritEnv",m.ShowLinkHover="terminal.integrated.showLinkHover"})(g=e.TerminalSettingId||(e.TerminalSettingId={}));var C;(function(m){m.CommandPrompt="cmd",m.PowerShell="pwsh",m.Wsl="wsl",m.GitBash="gitbash"})(C=e.WindowsShellType||(e.WindowsShellType={}));var _;(function(m){m[m.Api=0]="Api",m[m.Process=1]="Process",m[m.Sequence=2]="Sequence"})(_=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(m){m.LocalPty="localPty",m.PtyHost="ptyHost",m.Log="log",m.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=y.createDecorator("localTerminalService"),e.IPtyService=y.createDecorator("ptyService");var d;(function(m){m[m.BeatInterval=5e3]="BeatInterval",m[m.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",m[m.SecondWaitMultiplier=1]="SecondWaitMultiplier",m[m.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(d=e.HeartbeatConstants||(e.HeartbeatConstants={}));var v;(function(m){m.TerminalView="view",m.Editor="editor"})(v=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(m){m[m.GraceTime=6e4]="GraceTime",m[m.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var k;(function(m){m[m.HighWatermarkChars=1e5]="HighWatermarkChars",m[m.LowWatermarkChars=5e3]="LowWatermarkChars",m[m.CharCountAckSize=5e3]="CharCountAckSize"})(k=e.FlowControlConstants||(e.FlowControlConstants={}));var b;(function(m){m.GitBash="Git Bash",m.Pwsh="PowerShell"})(b=e.ProfileSource||(e.ProfileSource={}))}),define(fe[201],he([0,1,24,4,23,15,11,18,5]),function(X,e,y,D,g,C,_,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function v(){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let b=0;return k&&k.length===4&&(b=parseInt(k[3])),b}e.getWindowsBuildNumber=v;async function n(k,b,m,u=g.env,f=C.Promises.exists){if(D.isAbsolute(k))return await f(k)?k:void 0;if(b===void 0&&(b=g.cwd()),D.dirname(k)!=="."){const h=D.join(b,k);return await f(h)?h:void 0}const E=P.getCaseInsensitive(u,"PATH");if(m===void 0&&_.isString(E)&&(m=E.split(D.delimiter)),m===void 0||m.length===0){const h=D.join(b,k);return await f(h)?h:void 0}for(let h of m){let a;if(D.isAbsolute(h)?a=D.join(h,k):a=D.join(b,h,k),await f(a))return a;if(d.isWindows){let l=a+".com";if(await f(l)||(l=a+".exe",await f(l)))return l}}const I=D.join(b,k);return await f(I)?I:void 0}e.findExecutable=n}),define(fe[202],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var y;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST="hc"})(y=e.ColorScheme||(e.ColorScheme={}))}),define(fe[99],he([0,1,6,3,29,7,202,41]),function(X,e,y,D,g,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=y.createDecorator("themeService");var d;(function(S){function E(I){return I&&typeof I=="object"&&typeof I.id=="string"}S.isThemeColor=E})(d=e.ThemeColor||(e.ThemeColor={}));function v(S){return{id:S}}e.themeColorFromId=v;var n;(function(S){function E(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||d.isThemeColor(r.color))}S.isThemeIcon=E;const I=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function h(r){const i=I.exec(r);if(!i)return;let[,s]=i;return{id:s}}S.fromString=h;function a(r,i){let s=r.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),i&&(s=`${s}~${i}`),{id:s}}S.modify=a;function l(r,i){return r.id===i.id&&r.color?.id===i.color?.id}S.isEqual=l;function t(r){return{id:r.id}}S.asThemeIcon=t,S.asClassNameArray=P.CSSIcon.asClassNameArray,S.asClassName=P.CSSIcon.asClassName,S.asCSSSelector=P.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function k(S){switch(S){case _.ColorScheme.DARK:return"vs-dark";case _.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new C.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),D.toDisposable(()=>{const I=this.themingParticipants.indexOf(E);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new b;g.Registry.add(e.Extensions.ThemingContribution,m);function u(S){return m.onColorThemeChange(S)}e.registerThemingParticipant=u;class f extends D.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,I){let h=this.theme.getColor(E);return h&&I&&(h=I(h,this.theme)),h?h.toString():null}}e.Themable=f}),define(fe[203],he([0,1,38,154,29,41,99]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:D.localize(0,null),type:"array",items:{type:"string"}},overrideName:{description:D.localize(1,null),type:"boolean"},icon:{description:D.localize(2,null),type:"string",enum:Array.from(C.iconRegistry.all,E=>E.id),markdownEnumDescriptions:Array.from(C.iconRegistry.all,E=>`$(${E.id})`)},color:{description:D.localize(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:D.localize(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},d={type:"object",required:["path"],properties:{path:{description:D.localize(5,null),type:["string","array"],items:{type:"string"}},...P}},v=D.localize(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=D.localize(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),k=D.localize(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),b={id:"terminal",order:100,title:D.localize(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:D.localize(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:D.localize(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:D.localize(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:D.localize(13,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:D.localize(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:D.localize(15,null),type:["string","null"],default:null,markdownDeprecationMessage:k},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:D.localize(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:v},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:D.localize(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:D.localize(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:D.localize(19,null)}},{type:"string",markdownDescription:D.localize(20,null)}],default:[],markdownDeprecationMessage:k},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:D.localize(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:D.localize(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"null"},d]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:D.localize(23,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},d]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:D.localize(24,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},d]}},["terminal.integrated.useWslProfiles"]:{description:D.localize(25,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:D.localize(26,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:D.localize(27,null),type:"boolean",default:!0}}};function m(){g.Registry.as(y.Extensions.Configuration).registerConfiguration(b),f()}e.registerTerminalPlatformConfiguration=m;let u;function f(E){const I=g.Registry.as(y.Extensions.Configuration);u&&I.deregisterConfigurations([u]);let h,a;if(E){const l=E.profiles.map(t=>({name:t.profileName,description:S(t)}));h=l.map(t=>t.name),a=l.map(t=>t.description)}u={id:"terminal",order:100,title:D.localize(28,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:D.localize(29,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:E?.os===3?h:void 0,markdownEnumDescriptions:E?.os===3?a:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:D.localize(30,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:E?.os===2?h:void 0,markdownEnumDescriptions:E?.os===2?a:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:D.localize(31,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:E?.os===1?h:void 0,markdownEnumDescriptions:E?.os===1?a:void 0}}},I.registerConfiguration(u)}e.registerTerminalDefaultProfileConfiguration=f;function S(E){let I=`$(${_.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:C.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?I+=`
- args: "${E.args}"`:I+=`
- args: [${E.args.length===0?"":E.args.join("','")}]`),E.overrideName!==void 0&&(I+=`
- overrideName: ${E.overrideName}`),E.color&&(I+=`
- color: ${E.color}`),E.env&&(I+=`
- env: ${JSON.stringify(E.env)}`),I}}),define(fe[204],he([0,1,4,80,201,35,15,41,5,99]),function(X,e,y,D,g,C,_,P,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function k(t,r,i,s,c,p,w,L){return c=c||{existsFile:_.SymlinkSupport.existsFile,readFile:_.Promises.readFile},d.isWindows?b(i,c,p,s.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),L,w):h(c,p,i,t&&typeof t=="object"?{...t}:s.getValue(d.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(d.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),L,w)}e.detectAvailableProfiles=k;async function b(t,r,i,s,c,p,w,L){const F=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),o=`${process.env.windir}\\${F?"Sysnative":"System32"}`;let A=!1;g.getWindowsBuildNumber()>=16299&&(A=!0),await f(w);const N=new Map;t&&(N.set("PowerShell",{source:"PowerShell",icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${o}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),N.set("Command Prompt",{path:`${o}\\cmd.exe`,icon:P.Codicon.terminalCmd,isAutoDetected:!0})),a(c,N);const Q=await m(N.entries(),p,r,i,L);if(t||!t&&s)try{const J=await E(`${o}\\${A?"wsl":"bash"}.exe`,p);for(const ce of J)(!c||!(ce.profileName in c))&&Q.push(ce)}catch(J){i?.info("WSL is not installed, so could not detect WSL profiles")}return Q}async function m(t,r,i,s,c){const p=[];for(const[w,L]of t){if(L===null)continue;let F,o,A;if("source"in L){const J=n?.get(L.source);if(!J)continue;F=J.paths,o=L.args||J.args,L.icon?A=u(L.icon):J.icon&&(A=J.icon)}else F=Array.isArray(L.path)?L.path:[L.path],o=d.isWindows||Array.isArray(L.args)?L.args:void 0,A=u(L.icon)||void 0;const N=await c?.(F)||F.slice(),Q=await l(w,r,N,i,o,L.env,L.overrideName,L.isAutoDetected,s);Q?(Q.isAutoDetected=L.isAutoDetected,Q.icon=A,Q.color=L.color,p.push(Q)):s?.trace("profile not validated",w,F)}return p}function u(t){return typeof t=="string"?{id:t}:t}async function f(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await S(),icon:v.ThemeIcon.asThemeIcon(P.Codicon.terminalPowershell)}))}async function S(){const t=[];for await(const r of D.enumeratePowerShellInstallations())t.push(r.exePath);return t}async function E(t,r){const i=[],s=await new Promise((w,L)=>{C.exec("wsl.exe -l -q",{encoding:"utf16le"},(F,o)=>{if(F)return L("Problem occurred when getting wsl distros");w(o)})});if(!s)return[];const c=new RegExp(/[\r?\n]/),p=s.split(c).filter(w=>w.trim().length>0&&w!=="");for(const w of p){if(w===""||w.startsWith("docker-desktop"))continue;const L=`${w} (WSL)`,F={profileName:L,path:t,args:["-d",`${w}`],isDefault:L===r,icon:I(w)};i.push(F)}return i}function I(t){return t.includes("Ubuntu")?v.ThemeIcon.asThemeIcon(P.Codicon.terminalUbuntu):t.includes("Debian")?v.ThemeIcon.asThemeIcon(P.Codicon.terminalDebian):v.ThemeIcon.asThemeIcon(P.Codicon.terminalLinux)}async function h(t,r,i,s,c,p,w){const L=new Map;if(i){const F=(await t.readFile("/etc/shells")).toString(),o=p||F.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),A=new Map;for(const N of o){let Q=y.basename(N),J=A.get(Q)||0;J++,J>1&&(Q=`${Q} (${J})`),A.set(Q,J),L.set(Q,{path:N,isAutoDetected:!0})}}return a(s,L),await m(L.entries(),c,t,r,w)}function a(t,r){if(!!t)for(const[i,s]of Object.entries(t))s===null||!("path"in s)&&!("source"in s)?r.delete(i):r.set(i,s)}async function l(t,r,i,s,c,p,w,L,F){if(i.length===0)return Promise.resolve(void 0);const o=i.shift();if(o==="")return l(t,r,i,s,c,p,w,L);const A={profileName:t,path:o,args:c,env:p,overrideName:w,isAutoDetected:L,isDefault:t===r};if(y.basename(o)===o){const Q=process.env.PATH?process.env.PATH.split(y.delimiter):void 0;return await g.findExecutable(o,void 0,Q,void 0,s.existsFile)?A:l(t,r,i,s,c)}return await s.existsFile(y.normalize(o))?A:l(t,r,i,s,c,p,w,L)}}),define(fe[205],he([0,1,3,16,98,56,8,36,7,91,39,204,32,203]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var u;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(u||(u={}));let f=0,S=0,E=class extends y.Disposable{constructor(h,a,l,t){super();this._reconnectConstants=h,this._configurationService=a,this._logService=l,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new d.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new d.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new d.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new d.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new d.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new d.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new d.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new d.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new d.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new d.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new d.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new d.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new d.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new d.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,m.registerTerminalPlatformConfiguration(),this._register(y.toDisposable(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const h=new C.Client(_.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:f,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),P.ProxyChannel.toService(h.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(h.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=u.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const l=h.getChannel(g.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(l,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(l,this._logService.getLevel())}));const t=P.ProxyChannel.toService(h.getChannel(g.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),[h,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(h,a,l,t,r,i,s,c,p,w){const L=setTimeout(()=>this._handleUnresponsiveCreateProcess(),g.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(h,a,l,t,r,i,s,c,p,w);return clearTimeout(L),f=Math.max(f,F),F}updateTitle(h,a,l){return this._proxy.updateTitle(h,a,l)}updateIcon(h,a,l){return this._proxy.updateIcon(h,a,l)}attachToProcess(h){return this._proxy.attachToProcess(h)}detachFromProcess(h){return this._proxy.detachFromProcess(h)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(h){return this._proxy.start(h)}shutdown(h,a){return this._proxy.shutdown(h,a)}input(h,a){return this._proxy.input(h,a)}processBinary(h,a){return this._proxy.processBinary(h,a)}resize(h,a,l){return this._proxy.resize(h,a,l)}acknowledgeDataEvent(h,a){return this._proxy.acknowledgeDataEvent(h,a)}getInitialCwd(h){return this._proxy.getInitialCwd(h)}getCwd(h){return this._proxy.getCwd(h)}getLatency(h){return this._proxy.getLatency(h)}orphanQuestionReply(h){return this._proxy.orphanQuestionReply(h)}getDefaultSystemShell(h){return this._proxy.getDefaultSystemShell(h)}async getProfiles(h,a,l=!1){return k.detectAvailableProfiles(h,a,l,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(h){return this._proxy.getWslPath(h)}setTerminalLayoutInfo(h){return this._proxy.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return await this._proxy.getTerminalLayoutInfo(h)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(h){return new Promise(a=>{const l=++S;this._pendingResolveVariablesRequests.set(l,a),this._onPtyHostRequestResolveVariables.fire({id:l,originalText:h})})}async acceptPtyHostResolvedVariables(h,a){const l=this._pendingResolveVariablesRequests.get(h);l?(l(a),this._pendingResolveVariablesRequests.delete(h)):this._logService.warn(`Resolved variables received without matching request ${h}`)}};E=Ne([Ke(1,b.IConfigurationService),Ke(2,D.ILogService),Ke(3,n.ITelemetryService)],E),e.PtyHostService=E}),define(fe[100],he([0,1,2,19,6,26]),function(X,e,y,D,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=g.createDecorator("contextService");var _;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(_=e.WorkbenchState||(e.WorkbenchState={}));function P(b){const m=b;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=P;function d(b){const m=b;return!!(m&&typeof m=="object"&&y.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=d;class v{constructor(m,u,f,S){this._id=m,this._configuration=f,this._ignorePathCasing=S,this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=v;class n{constructor(m,u){this.raw=u,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return D.joinPath(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function k(b){return new n({uri:b,index:0,name:D.basenameOrAuthority(b)},{uri:b.toString()})}e.toWorkspaceFolder=k}),define(fe[206],he([0,1,6,155,100,2,5,4,19,112,37,8,52,30,190]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:D.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S($){return(typeof $=="string"?P.extname($):d.extname($))===f}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=y.createDecorator("workspacesService");function E($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=E;function I($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=I;function h($){return $.hasOwnProperty("fileUri")}e.isRecentFile=h;function a($){const q=$;return typeof q?.id=="string"&&C.URI.isUri(q.uri)}e.isSingleFolderWorkspaceIdentifier=a;function l($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=l;function t($){const q=$;return typeof q?.id=="string"&&C.URI.isUri(q.configPath)}e.isWorkspaceIdentifier=t;function r($){const q=$;if(q?.uri)return{id:q.id,uri:C.URI.revive(q.uri)};const W=$;if(W?.configPath)return{id:W.id,configPath:C.URI.revive(W.configPath)};if($?.id)return{id:$.id}}e.reviveIdentifier=r;function i($,q){return d.extUriBiasedIgnorePathCase.isEqualOrParent($,q.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function s($){return c($)||p($)}e.isStoredWorkspaceFolder=s;function c($){const q=$;return typeof q?.path=="string"&&(!q.name||typeof q.name=="string")}e.isRawFileWorkspaceFolder=c;function p($){const q=$;return typeof q?.uri=="string"&&(!q.name||typeof q.name=="string")}e.isRawUriWorkspaceFolder=p;function w($,q,W,V,T=!_.isWindows,R){if($.scheme!==V.scheme)return{name:W,uri:$.toString(!0)};let M=q?void 0:R.relativePath(V,$);if(M!==void 0)M.length===0?M=".":_.isWindows&&$.scheme===k.Schemas.file&&!T&&(M=M.replace(/\//g,"\\"));else if($.scheme===k.Schemas.file)M=$.fsPath,_.isWindows&&(M=b.normalizeDriveLetter(M),T&&(M=m.toSlashes(M)));else{if(!R.isEqualAuthority($.authority,V.authority))return{name:W,uri:$.toString(!0)};M=$.path}return{name:W,path:M}}e.getStoredWorkspaceFolder=w;function L($,q,W){let V=[],T=new Set;const R=W.dirname(q);for(let M of $){let z;if(c(M))M.path&&(z=W.resolvePath(R,M.path));else if(p(M))try{z=C.URI.parse(M.uri),z.path[0]!=="/"&&(z=z.with({path:"/"+z.path}))}catch(j){console.warn(j)}if(z){let j=W.getComparisonKey(z);if(!T.has(j)){T.add(j);const ee=M.name||W.basenameOrAuthority(z);V.push(new g.WorkspaceFolder({uri:z,name:ee,index:V.length},M))}}}return V}e.toWorkspaceFolders=L;function F($,q,W,V,T){let R=o(q,$);const M=T.dirname(q),z=T.dirname(V),j=[],ee=A(R.folders);for(const Ie of R.folders){const Ae=c(Ie)?T.resolvePath(M,Ie.path):C.URI.parse(Ie.uri);let Fe;W?Fe=!1:Fe=!c(Ie)||P.isAbsolute(Ie.path),j.push(w(Ae,Fe,Ie.name,z,ee,T))}const me={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},ge=v.setProperty($,["folders"],j,me);let be=v.applyEdits($,ge);return R.remoteAuthority===u.getRemoteAuthority(V)&&(be=v.applyEdits(be,v.removeProperty(be,["remoteAuthority"],me))),be}e.rewriteWorkspaceFileForNewLocation=F;function o($,q){let W=n.parse(q);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(V=>s(V));else throw new Error(`${$} looks like an invalid workspace file.`);return W}function A($){return _.isWindows?$.some(q=>c(q)&&q.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function N($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function Q($){return typeof $.folderUri=="string"}function J($){return typeof $.fileUri=="string"}function ce($,q){const W={workspaces:[],files:[]};if($){const V=function(R,M){for(let z=0;z<R.length;z++)try{M(R[z],z)}catch(j){q.warn(`Error restoring recent entry ${JSON.stringify(R[z])}: ${j.toString()}. Skip entry.`)}},T=$;if(Array.isArray(T.entries))V(T.entries,R=>{const M=R.label,z=R.remoteAuthority;N(R)?W.workspaces.push({label:M,remoteAuthority:z,workspace:{id:R.workspace.id,configPath:C.URI.parse(R.workspace.configPath)}}):Q(R)?W.workspaces.push({label:M,remoteAuthority:z,folderUri:C.URI.parse(R.folderUri)}):J(R)&&W.files.push({label:M,remoteAuthority:z,fileUri:C.URI.parse(R.fileUri)})});else{const R=$;Array.isArray(R.workspaces3)&&V(R.workspaces3,(M,z)=>{const j=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[z]||void 0;typeof M=="object"&&typeof M.id=="string"&&typeof M.configURIPath=="string"?W.workspaces.push({label:j,workspace:{id:M.id,configPath:C.URI.parse(M.configURIPath)}}):typeof M=="string"&&W.workspaces.push({label:j,folderUri:C.URI.parse(M)})}),Array.isArray(R.files2)&&V(R.files2,(M,z)=>{const j=Array.isArray(R.fileLabels)&&R.fileLabels[z]||void 0;typeof M=="string"&&W.files.push({label:j,fileUri:C.URI.parse(M)})})}}return W}e.restoreRecentlyOpened=ce;function se($){const q={entries:[]};for(const W of $.workspaces)I(W)?q.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):q.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of $.files)q.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return q}e.toStoreData=se}),define(fe[207],he([0,1,7,14]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function g(_){let P=0,d=0,v=0;_>=1e3&&(v=Math.floor(_/1e3),_-=v*1e3),v>=60&&(d=Math.floor(v/60),v-=d*60),d>=60&&(P=Math.floor(d/60),d-=P*60);const n=P?`${P}h`:"",k=d?`${d}m`:"",b=v?`${v}s`:"",m=_?`${_}ms`:"";return`${n}${k}${b}${m}`}e.printTime=g;class C{constructor(P,d,v,n){this._logService=P,this._reconnectionToken=d,this._onClose=new y.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=v,this.protocol=n,this._disposed=!1,this._disconnectRunner1=new D.RunOnceScheduler(()=>{this._log(`The reconnection grace time of ${g(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new D.RunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${g(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${g(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(P){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${P}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${g(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const P=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),P.end(),this._onClose.fire(void 0)}acceptReconnection(P,d,v){this._remoteAddress=P,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(d,v),this.protocol.endAcceptReconnection()}}e.ManagementConnection=C}),define(fe[101],he([0,1,27,8,4,121,31]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const P=g.join(D.FileAccess.asFileUri("",X).fsPath,"nls.metadata.json"),d=new Map;function v(b){return new Promise(m=>y.exists(b,m))}function n(b,m){return v(P).then(u=>{if(!u||!_.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let f=`${b}||${m}`,S=d.get(f);return S||(S=C.getNLSConfiguration(_.default.commit,m,P,b).then(E=>(k.is(E)&&(E._languagePackSupport=!0),E)),d.set(f,S)),S})}e.getNLSConfiguration=n;var k;(function(b){function m(u){let f=u;return f&&typeof f._languagePackId=="string"}b.is=m})(k=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(fe[40],he([0,1,54,8]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createRemoteURITransformer=e.uriTransformerPath=void 0,e.uriTransformerPath=D.FileAccess.asFileUri("vs/server/uriTransformer.js",X).fsPath;function g(C){const P=X.__$__nodeRequire(e.uriTransformerPath)(C);return new y.URITransformer(P)}e.createRemoteURITransformer=g}),define(fe[208],he([0,1,7,3,2,40,64,17,4,42,25]),function(X,e,y,D,g,C,_,P,d,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemChannel=void 0;class k extends D.Disposable{constructor(u,f,S,E){super();this.logService=u,this.environmentService=f,this.uriTransformer=S,this.watcherRequests=new Map,this.fileWatcher=this._register(new _.DiskFileSystemProvider(this.logService,{watcher:this.getWatcherOptions()})),this.registerListeners(E)}registerListeners(u){const f=this._register(new y.Emitter);this._register(f.event(S=>{u.fire(S.map(E=>({resource:this.uriTransformer.transformOutgoingURI(E.resource),type:E.type})))})),this._register(this.fileWatcher.onDidChangeFile(S=>f.fire(S))),this._register(this.fileWatcher.onDidErrorOccur(S=>u.fire(S)))}getWatcherOptions(){const u=this.environmentService.args.fileWatcherPolling;if(u){const f=u.split(d.delimiter),S=Number(f[0]);if(S>0)return{usePolling:f.length>1?f.slice(1):!0,pollingInterval:S}}}watch(u,f,S){const E=g.URI.revive(this.uriTransformer.transformIncoming(f));return this.environmentService.extensionsPath&&(S.excludes=[...S.excludes||[],d.posix.join(this.environmentService.extensionsPath,"**")]),this.watcherRequests.set(u,this.fileWatcher.watch(E,S)),D.toDisposable(()=>{D.dispose(this.watcherRequests.get(u)),this.watcherRequests.delete(u)})}dispose(){super.dispose(),this.watcherRequests.forEach(u=>D.dispose(u)),this.watcherRequests.clear()}}class b extends D.Disposable{constructor(u,f){super();this.logService=u,this.environmentService=f,this.BUFFER_SIZE=256*1024,this.uriTransformerCache=new Map,this.fileWatchers=new Map,this.fsProvider=this._register(new _.DiskFileSystemProvider(this.logService,{bufferSize:this.BUFFER_SIZE})),this.watchRequests=new Map}call(u,f,S){const E=this.getUriTransformer(u.remoteAuthority);switch(f){case"stat":return this.stat(E,S[0]);case"readdir":return this.readdir(E,S[0]);case"open":return this.open(E,S[0],S[1]);case"close":return this.close(S[0]);case"read":return this.read(S[0],S[1],S[2]);case"readFile":return this.readFile(E,S[0]);case"write":return this.write(S[0],S[1],S[2],S[3],S[4]);case"writeFile":return this.writeFile(E,S[0],S[1],S[2]);case"rename":return this.rename(E,S[0],S[1],S[2]);case"copy":return this.copy(E,S[0],S[1],S[2]);case"mkdir":return this.mkdir(E,S[0]);case"delete":return this.delete(E,S[0],S[1]);case"watch":return Promise.resolve(this.watch(S[0],S[1],S[2],S[3]));case"unwatch":return Promise.resolve(this.unwatch(S[0],S[1]))}throw new Error(`IPC Command ${f} not found`)}listen(u,f,S){const E=this.getUriTransformer(u.remoteAuthority);switch(f){case"filechange":return this.onFileChange(E,S[0]);case"readFileStream":return this.onReadFileStream(E,S[0],S[1])}throw new Error(`Unknown event ${f}`)}onFileChange(u,f){const S=new y.Emitter({onFirstListenerAdd:()=>{this.fileWatchers.set(f,new k(this.logService,this.environmentService,u,S))},onLastListenerRemove:()=>{D.dispose(this.fileWatchers.get(f)),this.fileWatchers.delete(f)}});return S.event}onReadFileStream(u,f,S){const E=this.transformIncoming(u,f,!0),I=new n.CancellationTokenSource,h=new y.Emitter({onLastListenerRemove:()=>{I.cancel()}}),a=this.fsProvider.readFileStream(E,S,I.token);return v.listenStream(a,{onData:l=>h.fire(P.VSBuffer.wrap(l)),onError:l=>h.fire(l),onEnd:()=>{h.fire("end"),h.dispose(),I.dispose()}}),h.event}getUriTransformer(u){let f=this.uriTransformerCache.get(u);return f||(f=C.createRemoteURITransformer(u),this.uriTransformerCache.set(u,f)),f}stat(u,f){const S=this.transformIncoming(u,f,!0);return this.fsProvider.stat(S)}readdir(u,f){const S=this.transformIncoming(u,f);return this.fsProvider.readdir(S)}open(u,f,S){const E=this.transformIncoming(u,f,!0);return this.fsProvider.open(E,S)}close(u){return this.fsProvider.close(u)}async read(u,f,S){const E=P.VSBuffer.alloc(S),I=0,h=await this.fsProvider.read(u,f,E.buffer,I,S);return[E,h]}async readFile(u,f){const S=this.transformIncoming(u,f,!0),E=await this.fsProvider.readFile(S);return P.VSBuffer.wrap(E)}write(u,f,S,E,I){return this.fsProvider.write(u,f,S.buffer,E,I)}writeFile(u,f,S,E){const I=this.transformIncoming(u,f);return this.fsProvider.writeFile(I,S.buffer,E)}rename(u,f,S,E){const I=g.URI.revive(u.transformIncoming(f)),h=g.URI.revive(u.transformIncoming(S));return this.fsProvider.rename(I,h,E)}copy(u,f,S,E){const I=this.transformIncoming(u,f),h=this.transformIncoming(u,S);return this.fsProvider.copy(I,h,E)}mkdir(u,f){const S=this.transformIncoming(u,f);return this.fsProvider.mkdir(S)}delete(u,f,S){const E=this.transformIncoming(u,f);return this.fsProvider.delete(E,S)}transformIncoming(u,f,S=!1){if(S&&f.path==="/vscode-resource"&&f.query){const E=JSON.parse(f.query).requestResourcePath;return g.URI.from({scheme:"file",path:E})}return g.URI.revive(u.transformIncoming(f))}watch(u,f,S,E){const I=u+f,h=this.fileWatchers.get(u);if(h){const a=h.watch(f,S,E);this.watchRequests.set(I,a)}}unwatch(u,f){const S=u+f,E=this.watchRequests.get(S);E&&(D.dispose(E),this.watchRequests.delete(S))}dispose(){super.dispose(),this.watchRequests.forEach(u=>D.dispose(u)),this.watchRequests.clear(),this.fileWatchers.forEach(u=>D.dispose(u)),this.fileWatchers.clear()}}e.RemoteAgentFileSystemChannel=b}),define(fe[68],he([0,1,157,166,57,6,28]),function(X,e,y,D,g,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={port:{type:"string"},connectionToken:{type:"string"},"connection-secret":{type:"string",description:y.localize(0,null)},host:{type:"string"},"socket-path":{type:"string"},driver:{type:"string"},"start-server":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"disable-websocket-compression":{type:"boolean"},fileWatcherPolling:{type:"string"},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"without-browser-env-var":{type:"boolean"},"disable-telemetry":g.OPTIONS["disable-telemetry"],"extensions-dir":g.OPTIONS["extensions-dir"],"extensions-download-dir":g.OPTIONS["extensions-download-dir"],"install-extension":g.OPTIONS["install-extension"],"install-builtin-extension":g.OPTIONS["install-builtin-extension"],"uninstall-extension":g.OPTIONS["uninstall-extension"],"locate-extension":g.OPTIONS["locate-extension"],"list-extensions":g.OPTIONS["list-extensions"],force:g.OPTIONS.force,"show-versions":g.OPTIONS["show-versions"],category:g.OPTIONS.category,"do-not-sync":g.OPTIONS["do-not-sync"],"force-disable-user-env":g.OPTIONS["force-disable-user-env"],folder:{type:"string"},workspace:{type:"string"},"web-user-data-dir":{type:"string"},"use-host-proxy":{type:"string"},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},log:{type:"string"},logsPath:{type:"string"},_:g.OPTIONS._},e.IServerEnvironmentService=C.refineServiceDecorator(_.IEnvironmentService);class P extends D.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=P}),define(fe[209],he([0,1,27,66,123,239,63,30,53,5,2,40,31,4,8,22,23]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.serveError=void 0;const E={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function I(t,r,i,s){r.writeHead(i,{"Content-Type":"text/plain"}),r.end(s)}e.serveError=I;async function h(t,r,i,s,c=Object.create(null)){try{const p=await g.promisify(y.stat)(s),w=`W/"${[p.ino,p.size,p.mtime.getTime()].join("-")}"`;if(r.headers["if-none-match"]===w)return i.writeHead(304),i.end();c["Content-Type"]=E[m.extname(s)]||d.getMediaMime(s)||"text/plain",c.Etag=w,i.writeHead(200,c),y.createReadStream(s).pipe(i)}catch(p){return p.code!=="ENOENT"&&(t.error(p),console.error(p.toString())),i.writeHead(404,{"Content-Type":"text/plain"}),i.end("Not found")}}e.serveFile=h;const a=m.dirname(u.FileAccess.asFileUri("",X).fsPath);class l{constructor(r,i,s){this._connectionToken=r,this._environmentService=i,this._logService=s,this._webviewEndpoint="https://{{uuid}}.vscode-webview-test.com/{{commit}}",this._mapCallbackUriToRequestId=new Map}async handle(r,i,s){try{const c=s.pathname;return c==="/favicon.ico"||c==="/manifest.json"||c==="/code-192.png"||c==="/code-512.png"?h(this._logService,r,i,m.join(a,"resources","server",c.substr(1))):/^\/static\//.test(c)?this._handleStatic(r,i,s):c==="/"?this._handleRoot(r,i,s):c==="/callback"?this._handleCallback(r,i,s):c==="/fetch-callback"?this._handleFetchCallback(r,i,s):I(r,i,404,"Not found.")}catch(c){return this._logService.error(c),console.error(c.toString()),I(r,i,500,"Internal Server Error.")}}_hasCorrectTokenCookie(r){return C.parse(r.headers.cookie||"")["vscode-tkn"]===this._connectionToken}async _handleStatic(r,i,s){const c=Object.create(null),p=decodeURIComponent(s.pathname),w=m.normalize(p.substr("/static/".length)),L=m.join(a,w);return P.isEqualOrParent(L,a,!v.isLinux)?h(this._logService,r,i,L,c):I(r,i,400,"Bad request.")}async _handleRoot(r,i,s){if(!r.headers.host)return I(r,i,400,"Bad request.");const c=s.query.tkn;if(typeof c=="string"){const se=Object.create(null);se["Set-Cookie"]=C.serialize("vscode-tkn",c,{sameSite:"strict",maxAge:60*60*24*7});const $=Object.create(null);for(let W in s.query)W!=="tkn"&&($[W]=s.query[W]);const q=D.format({pathname:"/",query:$});return se.Location=q,i.writeHead(302,se),i.end()}if(this._environmentService.isBuilt&&!this._hasCorrectTokenCookie(r))return I(r,i,403,"Forbidden.");const p=r.headers.host,w=k.createRemoteURITransformer(p),{workspacePath:L,isFolder:F}=await this._getWorkspaceFromCLI();function o(se){return se.replace(/"/g,"&quot;")}let A;this._environmentService.driverHandle&&(A=!1);const N=u.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",X).fsPath,Q=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:f.generateUuid(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,J=(await g.promisify(y.readFile)(N)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",o(JSON.stringify({folderUri:L&&F?w.transformOutgoing(n.URI.file(L)):void 0,workspaceUri:L&&!F?w.transformOutgoing(n.URI.file(L)):void 0,remoteAuthority:p,webviewEndpoint:this._webviewEndpoint,_wrapWebWorkerExtHostInIframe:A,developmentOptions:{enableSmokeTestDriver:this._environmentService.driverHandle==="web"?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>Q?o(JSON.stringify(Q)):""),ce=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' 'unsafe-eval' https://az416426.vo.msecnd.net ${this._getScriptCspHashes(J).join(" ")} 'sha256-O98pkmgtvUCQGVoddaGy891K52PVRnySDRxRszVLPNQ=' http://${p};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview-test.com https://vscodeweb.azureedge.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ");return i.writeHead(200,{"Content-Type":"text/html","Set-Cookie":C.serialize("vscode-tkn",this._connectionToken,{sameSite:"strict",maxAge:60*60*24*7}),"Content-Security-Policy":ce}),i.end(J)}_getScriptCspHashes(r){const i=/<script>([\s\S]+?)<\/script>/img,s=[];let c;for(;c=i.exec(r);){const p=_.createHash("sha256"),w=c[1].replace(/\r\n/g,`
`),L=p.update(Buffer.from(w)).digest().toString("base64");s.push(`'sha256-${L}'`)}return s}async _getWorkspaceFromCLI(){const r=this._environmentService.args.workspace;if(r&&r.length>0){const s=P.sanitizeFilePath(r,S.cwd());if(await g.promisify(y.exists)(s))return{workspacePath:s}}const i=this._environmentService.args.folder;if(i&&i.length>0){const s=P.sanitizeFilePath(i,S.cwd());if(await g.promisify(y.exists)(s))return{workspacePath:s,isFolder:!0}}return{}}_getFirstQueryValue(r,i){const s=r.query[i];return Array.isArray(s)?s[0]:s}_getFirstQueryValues(r,i){const s=new Map;for(const c in r.query){if(i&&i.indexOf(c)>=0)continue;const p=this._getFirstQueryValue(r,c);typeof p=="string"&&s.set(c,p)}return s}async _handleCallback(r,i,s){const c=["vscode-requestId","vscode-scheme","vscode-authority","vscode-path","vscode-query","vscode-fragment"],[p,w,L,F,o,A]=c.map(J=>{const ce=this._getFirstQueryValue(s,J);return ce&&decodeURIComponent(ce)});if(!p)return i.writeHead(400,{"Content-Type":"text/plain"}),i.end("Bad request.");let N=o,Q=0;return this._getFirstQueryValues(s,c).forEach((J,ce)=>{N||(N=""),N+=`${Q++==0?"":"&"}${ce}=${J}`}),this._mapCallbackUriToRequestId.set(p,n.URI.from({scheme:w||b.default.urlProtocol,authority:L,path:F,query:N,fragment:A}).toJSON()),h(this._logService,r,i,u.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",X).fsPath,{"Content-Type":"text/html"})}async _handleFetchCallback(r,i,s){const c=this._getFirstQueryValue(s,"vscode-requestId");if(!c)return i.writeHead(400,{"Content-Type":"text/plain"}),i.end("Bad request.");const p=this._mapCallbackUriToRequestId.get(c);return p&&this._mapCallbackUriToRequestId.delete(c),i.writeHead(200,{"Content-Type":"text/json"}),i.end(JSON.stringify(p))}}e.WebClientServer=l}),define(fe[210],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=y.createDecorator("IExtHostRpcService");class D{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=D}),define(fe[211],he([0,1,7]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var D;(function(_){_[_.NewChild=0]="NewChild",_[_.Disposed=1]="Disposed",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp"})(D=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const g=new WeakMap,C=_=>{let P=g.get(_);return P||(P={children:new Map,bus:new y.Emitter},g.set(_,P)),P};e.getPrivateApiFor=C});var Ct=this&&this.__classPrivateFieldSet||function(X,e,y,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!g:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(X,y):g?g.value=y:e.set(X,y),y},rt=this&&this.__classPrivateFieldGet||function(X,e,y,D){if(y==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?D:y==="a"?D.call(X):D?D.value:e.get(X)};define(fe[102],he([0,1,21,12,74,26,53,11,2,22,20,96,211]),function(X,e,y,D,g,C,_,P,d,v,n,k,b){"use strict";var m,u,f,S,E,I,h,a,l,t,r,i,s,c,p,w,L,F,o,A;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestItemImpl=e.TestRunRequest=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function N(U){function O(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(O,U),Object.setPrototypeOf(O.prototype,U.prototype),O}let Q=E=class{constructor(O){m.set(this,void 0),Ct(this,m,O,"f")}static from(...O){let x=O;return new E(function(){if(x){for(const Ee of x)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();x=void 0}})}dispose(){typeof rt(this,m,"f")=="function"&&(rt(this,m,"f").call(this),Ct(this,m,void 0,"f"))}};m=new WeakMap,Q=E=Ne([N],Q),e.Disposable=Q;let J=I=class{constructor(O,x){if(O<0)throw D.illegalArgument("line must be non-negative");if(x<0)throw D.illegalArgument("character must be non-negative");this._line=O,this._character=x}static Min(...O){if(O.length===0)throw new TypeError;let x=O[0];for(let Ee=1;Ee<O.length;Ee++){const ze=O[Ee];ze.isBefore(x)&&(x=ze)}return x}static Max(...O){if(O.length===0)throw new TypeError;let x=O[0];for(let Ee=1;Ee<O.length;Ee++){const ze=O[Ee];ze.isAfter(x)&&(x=ze)}return x}static isPosition(O){if(!O)return!1;if(O instanceof I)return!0;let{line:x,character:Ee}=O;return typeof x=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,x=0){if(O===null||x===null)throw D.illegalArgument();let Ee;return typeof O=="undefined"?Ee=0:typeof O=="number"?Ee=O:(Ee=typeof O.lineDelta=="number"?O.lineDelta:0,x=typeof O.characterDelta=="number"?O.characterDelta:0),Ee===0&&x===0?this:new I(this.line+Ee,this.character+x)}with(O,x=this.character){if(O===null||x===null)throw D.illegalArgument();let Ee;return typeof O=="undefined"?Ee=this.line:typeof O=="number"?Ee=O:(Ee=typeof O.line=="number"?O.line:this.line,x=typeof O.character=="number"?O.character:this.character),Ee===this.line&&x===this.character?this:new I(Ee,x)}toJSON(){return{line:this.line,character:this.character}}};J=I=Ne([N],J),e.Position=J;let ce=h=class{constructor(O,x,Ee,ze){let Ve,Xe;if(typeof O=="number"&&typeof x=="number"&&typeof Ee=="number"&&typeof ze=="number"?(Ve=new J(O,x),Xe=new J(Ee,ze)):O instanceof J&&x instanceof J&&(Ve=O,Xe=x),!Ve||!Xe)throw new Error("Invalid arguments");Ve.isBefore(Xe)?(this._start=Ve,this._end=Xe):(this._start=Xe,this._end=Ve)}static isRange(O){return O instanceof h?!0:O?J.isPosition(O.start)&&J.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof h?this.contains(O._start)&&this.contains(O._end):O instanceof J?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const x=J.Max(O.start,this._start),Ee=J.Min(O.end,this._end);if(!x.isAfter(Ee))return new h(x,Ee)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const x=J.Min(O.start,this._start),Ee=J.Max(O.end,this.end);return new h(x,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,x=this.end){if(O===null||x===null)throw D.illegalArgument();let Ee;return O?J.isPosition(O)?Ee=O:(Ee=O.start||this.start,x=O.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&x.isEqual(this.end)?this:new h(Ee,x)}toJSON(){return[this.start,this.end]}};ce=h=Ne([N],ce),e.Range=ce;let se=a=class extends ce{constructor(O,x,Ee,ze){let Ve,Xe;if(typeof O=="number"&&typeof x=="number"&&typeof Ee=="number"&&typeof ze=="number"?(Ve=new J(O,x),Xe=new J(Ee,ze)):O instanceof J&&x instanceof J&&(Ve=O,Xe=x),!Ve||!Xe)throw new Error("Invalid arguments");super(Ve,Xe);this._anchor=Ve,this._active=Xe}static isSelection(O){return O instanceof a?!0:O?ce.isRange(O)&&J.isPosition(O.anchor)&&J.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};se=a=Ne([N],se),e.Selection=se;class ${constructor(O,x,Ee){if(typeof O!="string"||O.length===0)throw D.illegalArgument("host");if(typeof x!="number"||x===0||Math.round(x)!==x)throw D.illegalArgument("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw D.illegalArgument("connectionToken");this.host=O,this.port=Math.round(x),this.connectionToken=Ee}}e.ResolvedAuthority=$;class q extends Error{constructor(O,x=k.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(O);this._message=O,this._code=x,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,q.prototype)}static NotAvailable(O,x){return new q(O,k.RemoteAuthorityResolverErrorCode.NotAvailable,x)}static TemporarilyNotAvailable(O){return new q(O,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=q;var W;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var V;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let T=l=class{constructor(O,x){this._range=O,this._newText=x}static isTextEdit(O){return O instanceof l?!0:O?ce.isRange(O)&&typeof O.newText=="string":!1}static replace(O,x){return new l(O,x)}static insert(O,x){return l.replace(new ce(O,O),x)}static delete(O){return l.replace(O,"")}static setEndOfLine(O){const x=new l(new ce(new J(0,0),new J(0,0)),"");return x.newEol=O,x}get range(){return this._range}set range(O){if(O&&!ce.isRange(O))throw D.illegalArgument("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw D.illegalArgument("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw D.illegalArgument("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};T=l=Ne([N],T),e.TextEdit=T;var R;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(R=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,x,Ee,ze){this._edits.push({_type:1,from:O,to:x,options:Ee,metadata:ze})}createFile(O,x,Ee){this._edits.push({_type:1,from:void 0,to:O,options:x,metadata:Ee})}deleteFile(O,x,Ee){this._edits.push({_type:1,from:O,to:void 0,options:x,metadata:Ee})}replaceNotebookMetadata(O,x,Ee){this._edits.push({_type:3,metadata:Ee,uri:O,edit:{editType:5,metadata:x},notebookMetadata:x})}replaceNotebookCells(O,x,Ee,ze,Ve){let Xe,Je,st=[],ot;if(Dt.isNotebookRange(x)&&wt.isNotebookCellDataArray(Ee)&&!wt.isNotebookCellDataArray(ze)?(Xe=x.start,Je=x.end,st=Ee,ot=ze):typeof x=="number"&&typeof Ee=="number"&&wt.isNotebookCellDataArray(ze)&&(Xe=x,Je=Ee,st=ze,ot=Ve),Xe===void 0||Je===void 0)throw new Error("Invalid arguments");(Xe!==Je||st.length>0)&&this._edits.push({_type:5,uri:O,index:Xe,count:Je-Xe,cells:st,metadata:ot})}replaceNotebookCellMetadata(O,x,Ee,ze){this._edits.push({_type:3,metadata:ze,uri:O,edit:{editType:8,index:x,metadata:Ee}})}replace(O,x,Ee,ze){this._edits.push({_type:2,uri:O,edit:new T(x,Ee),metadata:ze})}insert(O,x,Ee,ze){this.replace(O,new ce(x,x),Ee,ze)}delete(O,x,Ee){this.replace(O,x,"",Ee)}has(O){return this._edits.some(x=>x._type===2&&x.uri.toString()===O.toString())}set(O,x){if(x)for(const Ee of x)Ee&&this._edits.push({_type:2,uri:O,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const ze=this._edits[Ee];ze._type===2&&ze.uri.toString()===O.toString()&&(this._edits[Ee]=void 0)}y.coalesceInPlace(this._edits)}}get(O){const x=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===O.toString()&&x.push(Ee.edit);return x}entries(){const O=new C.ResourceMap;for(let x of this._edits)if(x._type===2){let Ee=O.get(x.uri);Ee||(Ee=[x.uri,[]],O.set(x.uri,Ee)),Ee[1].push(x.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=Ne([N],M),e.WorkspaceEdit=M;let z=t=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof t?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=t._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,x=this._tabstop++){if(typeof O=="function"){const Ee=new t;Ee._tabstop=this._tabstop,O(Ee),this._tabstop=Ee._tabstop,O=Ee.value}else O=t._escape(O);return this.value+="${",this.value+=x,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,x=this._tabstop++){const Ee=O.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=x,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(O,x){if(typeof x=="function"){const Ee=new t;Ee._tabstop=this._tabstop,x(Ee),this._tabstop=Ee._tabstop,x=Ee.value}else typeof x=="string"&&(x=x.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,x&&(this.value+=":",this.value+=x),this.value+="}",this}};z=t=Ne([N],z),e.SnippetString=z;var j;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(j=e.DiagnosticTag||(e.DiagnosticTag={}));var ee;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ee=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let me=r=class{constructor(O,x){if(this.uri=O,x)if(x instanceof ce)this.range=x;else if(x instanceof J)this.range=new ce(x,x);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof r?!0:O?ce.isRange(O.range)&&d.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};me=r=Ne([N],me),e.Location=me;let ge=class{constructor(O,x){this.location=O,this.message=x}static is(O){return O?typeof O.message=="string"&&O.location&&ce.isRange(O.location.range)&&d.URI.isUri(O.location.uri):!1}static isEqual(O,x){return O===x?!0:!O||!x?!1:O.message===x.message&&O.location.range.isEqual(x.location.range)&&O.location.uri.toString()===x.location.uri.toString()}};ge=Ne([N],ge),e.DiagnosticRelatedInformation=ge;let be=class{constructor(O,x,Ee=ee.Error){if(!ce.isRange(O))throw new TypeError("range must be set");if(!x)throw new TypeError("message must be set");this.range=O,this.message=x,this.severity=Ee}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,x){return O===x?!0:!O||!x?!1:O.message===x.message&&O.severity===x.severity&&O.code===x.code&&O.severity===x.severity&&O.source===x.source&&O.range.isEqual(x.range)&&y.equals(O.tags,x.tags)&&y.equals(O.relatedInformation,x.relatedInformation,ge.isEqual)}};be=Ne([N],be),e.Diagnostic=be;let Ie=class{constructor(O,x){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=x}};Ie=Ne([N],Ie),e.Hover=Ie;var Ae;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Fe=class{constructor(O,x=Ae.Text){this.range=O,this.kind=x}toJSON(){return{range:this.range,kind:Ae[this.kind]}}};Fe=Ne([N],Fe),e.DocumentHighlight=Fe;var $e;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})($e=e.SymbolKind||(e.SymbolKind={}));var Qe;(function(U){U[U.Deprecated=1]="Deprecated"})(Qe=e.SymbolTag||(e.SymbolTag={}));let Ze=i=class{constructor(O,x,Ee,ze,Ve){this.name=O,this.kind=x,this.containerName=Ve,typeof Ee=="string"&&(this.containerName=Ee),ze instanceof me?this.location=ze:Ee instanceof ce&&(this.location=new me(ze,Ee)),i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:$e[this.kind],location:this.location,containerName:this.containerName}}};Ze=i=Ne([N],Ze),e.SymbolInformation=Ze;let tt=s=class{constructor(O,x,Ee,ze,Ve){this.name=O,this.detail=x,this.kind=Ee,this.range=ze,this.selectionRange=Ve,this.children=[],s.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(s.validate)}};tt=s=Ne([N],tt),e.DocumentSymbol=tt;var nt;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Ce=class{constructor(O,x){this.title=O,this.kind=x}};Ce=Ne([N],Ce),e.CodeAction=Ce;let De=c=class{constructor(O){this.value=O}append(O){return new c(this.value?this.value+c.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+c.sep)}};De.sep=".",De=c=Ne([N],De),e.CodeActionKind=De,De.Empty=new De(""),De.QuickFix=De.Empty.append("quickfix"),De.Refactor=De.Empty.append("refactor"),De.RefactorExtract=De.Refactor.append("extract"),De.RefactorInline=De.Refactor.append("inline"),De.RefactorRewrite=De.Refactor.append("rewrite"),De.Source=De.Empty.append("source"),De.SourceOrganizeImports=De.Source.append("organizeImports"),De.SourceFixAll=De.Source.append("fixAll");let _e=class{constructor(O,x){if(this.range=O,this.parent=x,x&&!x.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};_e=Ne([N],_e),e.SelectionRange=_e;class Te{constructor(O,x,Ee,ze,Ve,Xe){this.kind=O,this.name=x,this.detail=Ee,this.uri=ze,this.range=Ve,this.selectionRange=Xe}}e.CallHierarchyItem=Te;class Me{constructor(O,x){this.fromRanges=x,this.from=O}}e.CallHierarchyIncomingCall=Me;class We{constructor(O,x){this.fromRanges=x,this.to=O}}e.CallHierarchyOutgoingCall=We;let qe=class{constructor(O,x){this.range=O,this.command=x}get isResolved(){return!!this.command}};qe=Ne([N],qe),e.CodeLens=qe;let Ge=p=class{constructor(O,x=!1){u.set(this,void 0),Ct(this,u,new g.MarkdownString(O,{supportThemeIcons:x}),"f")}static isMarkdownString(O){return O instanceof p?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return rt(this,u,"f").value}set value(O){rt(this,u,"f").value=O}get isTrusted(){return rt(this,u,"f").isTrusted}set isTrusted(O){rt(this,u,"f").isTrusted=O}get supportThemeIcons(){return rt(this,u,"f").supportThemeIcons}set supportThemeIcons(O){rt(this,u,"f").supportThemeIcons=O}appendText(O){return rt(this,u,"f").appendText(O),this}appendMarkdown(O){return rt(this,u,"f").appendMarkdown(O),this}appendCodeblock(O,x){return rt(this,u,"f").appendCodeblock(x??"",O),this}};u=new WeakMap,Ge=p=Ne([N],Ge),e.MarkdownString=Ge;let et=class{constructor(O,x){this.label=O,this.documentation=x}};et=Ne([N],et),e.ParameterInformation=et;let ne=class{constructor(O,x){this.label=O,this.documentation=x,this.parameters=[]}};ne=Ne([N],ne),e.SignatureInformation=ne;let Se=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Se=Ne([N],Se),e.SignatureHelp=Se;var we;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(we=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ue;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Ue=e.InlayHintKind||(e.InlayHintKind={}));let ue=class{constructor(O,x,Ee){this.text=O,this.position=x,this.kind=Ee}};ue=Ne([N],ue),e.InlayHint=ue;var pe;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ve;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(ve=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(U){U[U.Deprecated=1]="Deprecated"})(G=e.CompletionItemTag||(e.CompletionItemTag={}));let Y=class{constructor(O,x){this.label=O,this.kind=x}toJSON(){return{label:this.label,kind:this.kind&&ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Y=Ne([N],Y),e.CompletionItem=Y;let te=class{constructor(O=[],x=!1){this.items=O,this.isIncomplete=x}};te=Ne([N],te),e.CompletionList=te;let oe=class{constructor(O,x,Ee){this.text=O,this.range=x,this.command=Ee}};oe=Ne([N],oe),e.InlineSuggestion=oe;let B=class{constructor(O){this.items=O}};B=Ne([N],B),e.InlineSuggestions=B;var ie;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(ie=e.ViewColumn||(e.ViewColumn={}));var ae;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(ae=e.StatusBarAlignment||(e.StatusBarAlignment={}));var de;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(de=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Z;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ke;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Le;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Le=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function O(x){switch(x){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=O}(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Oe=class{constructor(O,x){if(x&&!d.URI.isUri(x))throw D.illegalArgument("target");if(!ce.isRange(O)||O.isEmpty)throw D.illegalArgument("range");this.range=O,this.target=x}};Oe=Ne([N],Oe),e.DocumentLink=Oe;let He=class{constructor(O,x,Ee,ze){this.red=O,this.green=x,this.blue=Ee,this.alpha=ze}};He=Ne([N],He),e.Color=He;let xe=class{constructor(O,x){if(x&&!(x instanceof He))throw D.illegalArgument("color");if(!ce.isRange(O)||O.isEmpty)throw D.illegalArgument("range");this.range=O,this.color=x}};xe=Ne([N],xe),e.ColorInformation=xe;let re=class{constructor(O){if(!O||typeof O!="string")throw D.illegalArgument("label");this.label=O}};re=Ne([N],re),e.ColorPresentation=re;var le;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(le=e.ColorFormat||(e.ColorFormat={}));var K;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(K=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class H{constructor(O,x,Ee){if(this.startIndex=O,this.length=x,this.tooltip=Ee,typeof O!="number"||O<0)throw D.illegalArgument("startIndex");if(typeof x!="number"||x<1)throw D.illegalArgument("length");if(Ee!==void 0&&typeof Ee!="string")throw D.illegalArgument("tooltip")}}e.TerminalLink=H;class Pe{constructor(O){this.options=O,typeof O!="object"&&D.illegalArgument("options")}}e.TerminalProfile=Pe;var Re;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(Re=e.TaskRevealKind||(e.TaskRevealKind={}));var je;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(je=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=w=class{constructor(O,x){if(typeof O!="string"||typeof x!="string")throw D.illegalArgument("name");this._id=O}static from(O){switch(O){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}get id(){return this._id}};Be.Clean=new w("clean","Clean"),Be.Build=new w("build","Build"),Be.Rebuild=new w("rebuild","Rebuild"),Be.Test=new w("test","Test"),Be=w=Ne([N],Be),e.TaskGroup=Be;function Ye(U){let O="";for(let x=0;x<U.length;x++)O+=U[x].replace(/,/g,",,")+",";return O}let it=class{constructor(O,x,Ee){if(typeof O!="string")throw D.illegalArgument("process");this._args=[],this._process=O,x!==void 0&&(Array.isArray(x)?(this._args=x,this._options=Ee):this._options=x)}get process(){return this._process}set process(O){if(typeof O!="string")throw D.illegalArgument("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let x of this._args)O.push(x);return Ye(O)}};it=Ne([N],it),e.ProcessExecution=it;let at=class{constructor(O,x,Ee){if(this._args=[],Array.isArray(x)){if(!O)throw D.illegalArgument("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw D.illegalArgument("command");this._command=O,this._args=x,this._options=Ee}else{if(typeof O!="string")throw D.illegalArgument("commandLine");this._commandLine=O,this._options=x}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw D.illegalArgument("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw D.illegalArgument("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let x of this._args)O.push(typeof x=="string"?x:x.value);return Ye(O)}};at=Ne([N],at),e.ShellExecution=at;var ft;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ft=e.ShellQuoting||(e.ShellQuoting={}));var lt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(lt=e.TaskScope||(e.TaskScope={}));class ht{constructor(O){this._callback=O}computeId(){return"customExecution"+v.generateUuid()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=ht;let yt=L=class{constructor(O,x,Ee,ze,Ve,Xe){this.__deprecated=!1,this._definition=this.definition=O;let Je;typeof x=="string"?(this._name=this.name=x,this._source=this.source=Ee,this.execution=ze,Je=Ve,this.__deprecated=!0):x===lt.Global||x===lt.Workspace?(this.target=x,this._name=this.name=Ee,this._source=this.source=ze,this.execution=Ve,Je=Xe):(this.target=x,this._name=this.name=Ee,this._source=this.source=ze,this.execution=Ve,Je=Xe),typeof Je=="string"?(this._problemMatchers=[Je],this._hasDefinedMatchers=!0):Array.isArray(Je)?(this._problemMatchers=Je,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof it?this._definition={type:L.ProcessType,id:this._execution.computeId()}:this._execution instanceof at?this._definition={type:L.ShellType,id:this._execution.computeId()}:this._execution instanceof ht?this._definition={type:L.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:L.EmptyType,id:v.generateUuid()}}get definition(){return this._definition}set definition(O){if(O==null)throw D.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw D.illegalArgument("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const x=this._definition.type;(L.EmptyType===x||L.ProcessType===x||L.ShellType===x||L.ExtensionCallbackType===x)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw D.illegalArgument("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};yt.ExtensionCallbackType="customExecution",yt.ProcessType="process",yt.ShellType="shell",yt.EmptyType="$empty",yt=L=Ne([N],yt),e.Task=yt;var on;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(on=e.ProgressLocation||(e.ProgressLocation={}));let At=class{constructor(O,x=nn.None){this.collapsibleState=x,d.URI.isUri(O)?this.resourceUri=O:this.label=O}};At=Ne([N],At),e.TreeItem=At;var nn;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(nn=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let gt=class{constructor(O,x){this.id=O,this.color=x}};gt=Ne([N],gt),e.ThemeIcon=gt,gt.File=new gt("file"),gt.Folder=new gt("folder");let Rt=class{constructor(O){this.id=O}};Rt=Ne([N],Rt),e.ThemeColor=Rt;var an;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(an=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Tt=class{constructor(O,x){if(typeof O!="string"&&(!O||!d.URI.isUri(O)&&!d.URI.isUri(O.uri)))throw D.illegalArgument("base");if(typeof x!="string")throw D.illegalArgument("pattern");typeof O=="string"?(this.baseFolder=d.URI.file(O),this.base=O):d.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=x}};Tt=Ne([N],Tt),e.RelativePattern=Tt;let bt=class{constructor(O,x,Ee,ze){this.enabled=typeof O=="boolean"?O:!0,typeof x=="string"&&(this.condition=x),typeof Ee=="string"&&(this.hitCondition=Ee),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=v.generateUuid()),this._id}};bt=Ne([N],bt),e.Breakpoint=bt;let Ft=class extends bt{constructor(O,x,Ee,ze,Ve){super(x,Ee,ze,Ve);if(O===null)throw D.illegalArgument("location");this.location=O}};Ft=Ne([N],Ft),e.SourceBreakpoint=Ft;let Lt=class extends bt{constructor(O,x,Ee,ze,Ve){super(x,Ee,ze,Ve);this.functionName=O}};Lt=Ne([N],Lt),e.FunctionBreakpoint=Lt;let Ot=class extends bt{constructor(O,x,Ee,ze,Ve,Xe,Je){super(ze,Ve,Xe,Je);if(!x)throw D.illegalArgument("dataId");this.label=O,this.dataId=x,this.canPersist=Ee}};Ot=Ne([N],Ot),e.DataBreakpoint=Ot;let Nt=class{constructor(O,x,Ee){this.command=O,this.args=x||[],this.options=Ee}};Nt=Ne([N],Nt),e.DebugAdapterExecutable=Nt;let Mt=class{constructor(O,x){this.port=O,this.host=x}};Mt=Ne([N],Mt),e.DebugAdapterServer=Mt;let Ut=class{constructor(O){this.path=O}};Ut=Ne([N],Ut),e.DebugAdapterNamedPipeServer=Ut;let Bt=class{constructor(O){this.implementation=O}};Bt=Ne([N],Bt),e.DebugAdapterInlineImplementation=Bt;let zt=class{constructor(O,x){this.range=O,this.expression=x}};zt=Ne([N],zt),e.EvaluatableExpression=zt;var ln;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(ln=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let $t=class{constructor(O,x){this.range=O,this.text=x}};$t=Ne([N],$t),e.InlineValueText=$t;let Wt=class{constructor(O,x,Ee=!0){this.range=O,this.variableName=x,this.caseSensitiveLookup=Ee}};Wt=Ne([N],Wt),e.InlineValueVariableLookup=Wt;let jt=class{constructor(O,x){this.range=O,this.expression=x}};jt=Ne([N],jt),e.InlineValueEvaluatableExpression=jt;let Ht=class{constructor(O,x){this.frameId=O,this.stoppedLocation=x}};Ht=Ne([N],Ht),e.InlineValueContext=Ht;var cn;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(cn=e.FileChangeType||(e.FileChangeType={}));let qt=F=class extends Error{constructor(O,x=n.FileSystemProviderErrorCode.Unknown,Ee){super(d.URI.isUri(O)?O.toString(!0):O);this.code=Ee?.name??"Unknown",n.markAsFileSystemProviderError(this,x),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,F.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(O){return new F(O,n.FileSystemProviderErrorCode.FileExists,F.FileExists)}static FileNotFound(O){return new F(O,n.FileSystemProviderErrorCode.FileNotFound,F.FileNotFound)}static FileNotADirectory(O){return new F(O,n.FileSystemProviderErrorCode.FileNotADirectory,F.FileNotADirectory)}static FileIsADirectory(O){return new F(O,n.FileSystemProviderErrorCode.FileIsADirectory,F.FileIsADirectory)}static NoPermissions(O){return new F(O,n.FileSystemProviderErrorCode.NoPermissions,F.NoPermissions)}static Unavailable(O){return new F(O,n.FileSystemProviderErrorCode.Unavailable,F.Unavailable)}};qt=F=Ne([N],qt),e.FileSystemError=qt;let Vt=class{constructor(O,x,Ee){this.start=O,this.end=x,this.kind=Ee}};Vt=Ne([N],Vt),e.FoldingRange=Vt;var un;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(un=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var hn;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(hn=e.CommentMode||(e.CommentMode={}));class dn{constructor(O,x=[]){this.tokenTypes=O,this.tokenModifiers=x}}e.SemanticTokensLegend=dn;function mn(U){return typeof U=="undefined"||P.isStringArray(U)}class xt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let x=0,Ee=O.tokenTypes.length;x<Ee;x++)this._tokenTypeStrToInt.set(O.tokenTypes[x],x);for(let x=0,Ee=O.tokenModifiers.length;x<Ee;x++)this._tokenModifierStrToInt.set(O.tokenModifiers[x],x)}}push(O,x,Ee,ze,Ve){if(typeof O=="number"&&typeof x=="number"&&typeof Ee=="number"&&typeof ze=="number"&&(typeof Ve=="number"||typeof Ve=="undefined"))return typeof Ve=="undefined"&&(Ve=0),this._pushEncoded(O,x,Ee,ze,Ve);if(ce.isRange(O)&&typeof x=="string"&&mn(Ee))return this._push(O,x,Ee);throw D.illegalArgument()}_push(O,x,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(x))throw new Error("`tokenType` is not in the provided legend");const ze=O.start.line,Ve=O.start.character,Xe=O.end.character-O.start.character,Je=this._tokenTypeStrToInt.get(x);let st=0;if(Ee)for(const ot of Ee){if(!this._tokenModifierStrToInt.has(ot))throw new Error("`tokenModifier` is not in the provided legend");const ut=this._tokenModifierStrToInt.get(ot);st|=1<<ut>>>0}this._pushEncoded(ze,Ve,Xe,Je,st)}_pushEncoded(O,x,Ee,ze,Ve){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&x<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const st=this._data.length/5|0;let ot=0,ut=0;for(let dt=0;dt<st;dt++){let mt=this._data[5*dt],It=this._data[5*dt+1];mt===0?(mt=ot,It+=ut):mt+=ot,this._data[5*dt]=mt,this._data[5*dt+1]=It,ot=mt,ut=It}}let Xe=O,Je=x;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Xe-=this._prevLine,Xe===0&&(Je-=this._prevChar)),this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Ve,this._prevLine=O,this._prevChar=x}static _sortAndDeltaEncode(O){let x=[];const Ee=O.length/5|0;for(let Je=0;Je<Ee;Je++)x[Je]=Je;x.sort((Je,st)=>{const ot=O[5*Je],ut=O[5*st];if(ot===ut){const dt=O[5*Je+1],mt=O[5*st+1];return dt-mt}return ot-ut});const ze=new Uint32Array(O.length);let Ve=0,Xe=0;for(let Je=0;Je<Ee;Je++){const st=5*x[Je],ot=O[st+0],ut=O[st+1],dt=O[st+2],mt=O[st+3],It=O[st+4],sn=ot-Ve,Wn=sn===0?ut-Xe:ut,Pt=5*Je;ze[Pt+0]=sn,ze[Pt+1]=Wn,ze[Pt+2]=dt,ze[Pt+3]=mt,ze[Pt+4]=It,Ve=ot,Xe=ut}return ze}build(O){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),O):new Gt(xt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=xt;class Gt{constructor(O,x){this.resultId=x,this.data=O}}e.SemanticTokens=Gt;class gn{constructor(O,x,Ee){this.start=O,this.deleteCount=x,this.data=Ee}}e.SemanticTokensEdit=gn;class vn{constructor(O,x){this.resultId=x,this.edits=O}}e.SemanticTokensEdits=vn;var pn;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(pn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yn;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(yn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let kt=class{constructor(){}};kt.Back={iconPath:new gt("arrow-left")},kt=Ne([N],kt),e.QuickInputButtons=kt;var wn;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(wn=e.ExtensionKind||(e.ExtensionKind={}));class En{constructor(O,x,Ee){this.badge=O,this.tooltip=x,this.color=Ee}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=En;let Kt=class{constructor(O){this.kind=O}};Kt=Ne([N],Kt),e.ColorTheme=Kt;var bn;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(bn=e.ColorThemeKind||(e.ColorThemeKind={}));class Dt{constructor(O,x){if(O<0)throw D.illegalArgument("start must be positive");if(x<0)throw D.illegalArgument("end must be positive");O<=x?(this._start=O,this._end=x):(this._start=x,this._end=O)}static isNotebookRange(O){return O instanceof Dt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let x=this._start,Ee=this._end;return O.start!==void 0&&(x=O.start),O.end!==void 0&&(Ee=O.end),x===this._start&&Ee===this._end?this:new Dt(x,Ee)}}e.NotebookRange=Dt;class wt{constructor(O,x,Ee,ze,Ve,Xe,Je){this.kind=O,this.value=x,this.languageId=Ee,this.mime=ze,this.outputs=Ve??[],this.metadata=Xe,this.executionSummary=Je,wt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(x=>wt.isNotebookCellData(x))}static isNotebookCellData(O){return!0}}e.NotebookCellData=wt;class Sn{constructor(O){this.cells=O}}e.NotebookData=Sn;class ct{constructor(O,x){this.data=O,this.mime=x;const Ee=_.normalizeMimeType(x,!0);if(!Ee)throw new Error("INVALID mime type, must not be empty or falsy: "+x);this.mime=Ee}static isNotebookCellOutputItem(O){return O instanceof ct?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const x={name:O.name,message:O.message,stack:O.stack};return ct.json(x,"application/vnd.code.notebook.error")}static stdout(O){return ct.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ct.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,x="application/octet-stream"){return new ct(O,x)}static text(O,x=_.Mimes.text){const Ee=rt(ct,f,"f",S).encode(String(O));return new ct(Ee,x)}static json(O,x="application/json"){const Ee=JSON.stringify(O,void 0,"	");return ct.text(Ee,x)}}e.NotebookCellOutputItem=ct,f=ct,S={value:new TextEncoder};class _t{constructor(O,x,Ee){this.items=_t.ensureUniqueMimeTypes(O,!0),typeof x=="string"?(this.id=x,this.metadata=Ee):(this.id=v.generateUuid(),this.metadata=x??Ee)}static isNotebookCellOutput(O){return O instanceof _t?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&P.isArray(O.items)}static ensureUniqueMimeTypes(O,x=!1){const Ee=new Set,ze=new Set;for(let Ve=0;Ve<O.length;Ve++){const Xe=O[Ve],Je=_.normalizeMimeType(Xe.mime);if(!Ee.has(Je)){Ee.add(Je);continue}ze.add(Ve),x&&console.warn(`DUPLICATED mime type '${Xe.mime}' will be dropped`)}return ze.size===0?O:O.filter((Ve,Xe)=>!ze.has(Xe))}}e.NotebookCellOutput=_t;var Cn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Cn=e.NotebookCellKind||(e.NotebookCellKind={}));var Dn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Dn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class kn{constructor(O,x){this.text=O,this.alignment=x}}e.NotebookCellStatusBarItem=kn;var _n;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(_n=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(O,x=[]){this.uri=O,this.provides=y.asArray(x)}}e.NotebookRendererScript=An;let Xt=class{constructor(O,x){this.label=O,this.timestamp=x}};Xt=Ne([N],Xt),e.TimelineItem=Xt;var Rn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Rn=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Fn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(O,x){this.ranges=O,this.wordPattern=x}}e.LinkedEditingRanges=Ln;class On{constructor(O,x){this._port=O,this._autoForwardAction=x}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=On;var Nn;(function(U){U[U.Unset=0]="Unset",U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Nn=e.TestResultState||(e.TestResultState={}));var rn;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information",U[U.Hint=3]="Hint"})(rn=e.TestMessageSeverity||(e.TestMessageSeverity={}));const vt=(U,O,x,Ee)=>{let ze=x;return{enumerable:!0,configurable:!1,get(){return ze},set(Ve){Ee(ze,Ve)||(ze=Ve,U.bus.fire([3,O,Ve]))}}},Et=(U,O)=>U===O,Mn=(U,O)=>U===O?!0:!U||!O?!1:U.isEqual(O);class Un{constructor(O,x,Ee=!1){this.tests=O,this.exclude=x,this.debug=Ee}}e.TestRunRequest=Un;class Yt{constructor(O,x,Ee,ze,Ve){this.data=ze;const Xe=b.getPrivateApiFor(this);if(Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:Ee,enumerable:!0,writable:!1},parent:{enumerable:!1,value:Ve,writable:!1},children:{value:new C.ReadonlyMapView(Xe.children),enumerable:!0,writable:!1},range:vt(Xe,"range",void 0,Mn),label:vt(Xe,"label",x,Et),description:vt(Xe,"description",void 0,Et),runnable:vt(Xe,"runnable",!0,Et),debuggable:vt(Xe,"debuggable",!1,Et),canResolveChildren:vt(Xe,"canResolveChildren",!1,Et),busy:vt(Xe,"busy",!1,Et),error:vt(Xe,"error",void 0,Et)}),Ve){if(!(Ve instanceof Yt))throw new Error(`The "parent" passed in for TestItem ${O} is invalid`);const Je=b.getPrivateApiFor(Ve);if(Je.children.has(O))throw new Error(`Attempted to insert a duplicate test item ID ${O}`);Je.children.set(O,this),Je.bus.fire([0,this])}}invalidate(){return this.invalidateResults()}invalidateResults(){b.getPrivateApiFor(this).bus.fire([2])}dispose(){this.parent&&b.getPrivateApiFor(this.parent).children.delete(this.id),b.getPrivateApiFor(this).bus.fire([1])}}e.TestItemImpl=Yt;let Qt=o=class{constructor(O){this.message=O,this.severity=rn.Error}static diff(O,x,Ee){const ze=new o(O);return ze.expectedOutput=x,ze.actualOutput=Ee,ze}};Qt=o=Ne([N],Qt),e.TestMessage=Qt;let St=class{constructor(O,x){this.covered=O,this.total=x}};St=Ne([N],St),e.CoveredCount=St;let Jt=A=class{constructor(O,x,Ee,ze){this.uri=O,this.statementCoverage=x,this.branchCoverage=Ee,this.functionCoverage=ze}static fromDetails(O,x){const Ee=new St(0,0),ze=new St(0,0),Ve=new St(0,0);for(const Je of x)if("branches"in Je){Ee.total+=1,Ee.covered+=Je.executionCount>0?1:0;for(const st of Je.branches)ze.total+=1,ze.covered+=st.executionCount>0?1:0}else Ve.total+=1,Ve.covered+=Je.executionCount>0?1:0;const Xe=new A(O,Ee,ze.total>0?ze:void 0,Ve.total>0?Ve:void 0);return Xe.detailedCoverage=x,Xe}};Jt=A=Ne([N],Jt),e.FileCoverage=Jt;let Zt=class{constructor(O,x,Ee=[]){this.executionCount=O,this.location=x,this.branches=Ee}};Zt=Ne([N],Zt),e.StatementCoverage=Zt;let en=class{constructor(O,x){this.executionCount=O,this.location=x}};en=Ne([N],en),e.BranchCoverage=en;let tn=class{constructor(O,x){this.executionCount=O,this.location=x}};tn=Ne([N],tn),e.FunctionCoverage=tn;var Bn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(zn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var $n;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})($n=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(fe[212],he([0,1,47,53,8,4,5,60]),function(X,e,y,D,g,C,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var d;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(d=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",D.Mimes.markdown,"image/png","image/jpeg",D.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[D.Mimes.markdown,"application/json",D.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var v;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(v=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var S;(function(o){o.scheme=g.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function N($,q){return $.with({scheme:o.scheme,fragment:`ch${q.toString().padStart(7,"0")}${$.scheme!==g.Schemas.file?$.scheme:""}`})}o.generate=N;function Q($){if($.scheme!==o.scheme)return;const q=A.exec($.fragment);return q?{handle:Number(q[1]),notebook:$.with({scheme:$.fragment.substr(q[0].length)||g.Schemas.file,fragment:null})}:void 0}o.parse=Q;function J($){if($.scheme!==g.Schemas.vscodeNotebookCellMetadata)return;const q=A.exec($.fragment);return q?{handle:Number(q[1]),notebook:$.with({scheme:$.fragment.substr(q[0].length)||g.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=J;function ce($,q,W){return $.with({scheme:W,fragment:`ch${q.toString().padStart(7,"0")}${$.scheme!==g.Schemas.file?$.scheme:""}`})}o.generateCellUri=ce;function se($,q){if($.scheme!==q)return;const W=A.exec($.fragment);return W?{handle:Number(W[1]),notebook:$.with({scheme:$.fragment.substr(W[0].length)||g.Schemas.file,fragment:null})}:void 0}o.parseCellUri=se})(S=e.CellUri||(e.CellUri={}));const E=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function I(o){return E.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=I;function h(o){return E.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=h;function a(o){return E.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=a;function l(o,A){return _.isWindows&&(o=o.replace(/\//g,"\\"),A=A.replace(/\//g,"\\")),y.match(o,A)}function t(o,A,N){let Q=0;for(let J=0;J<A.length;J++){if(l(A[J],o))return Q;Q++}for(let J=0;J<N.length;J++){if(l(N[J],o))return Q;Q++}return Q}function r(o,A,N){return o.sort((Q,J)=>t(Q,A,N)-t(J,A,N))}e.sortMimeTypes=r;function i(o,A,N,Q=(J,ce)=>J===ce){const J=[];function ce(q,W,V){if(W===0&&V.length===0)return;const T=J[J.length-1];T&&T.start+T.deleteCount===q?(T.deleteCount+=W,T.toInsert.push(...V)):J.push({start:q,deleteCount:W,toInsert:V})}let se=0,$=0;for(;;){if(se===o.length){ce(se,0,A.slice($));break}if($===A.length){ce(se,o.length-se,[]);break}const q=o[se],W=A[$];if(Q(q,W)){se+=1,$+=1;continue}N(W)?(ce(se,1,[]),se+=1):(ce(se,0,[W]),$+=1)}return J}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(o){o.default="default",o.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(o){const A=o;return!!((typeof A.include=="string"||y.isRelativePattern(A.include))&&(typeof A.exclude=="string"||y.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=c;function p(o,A,N){if(Array.isArray(o.viewType)&&o.viewType.indexOf(A)>=0||o.viewType===A)return!0;if(o.filenamePattern){let Q=c(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,J=c(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(y.match(Q,C.basename(N.fsPath).toLowerCase()))return!(J&&y.match(J,C.basename(N.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=p;class w{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let N=0;N<this.textModel.cells.length;N++)A[N]=this.textModel.cells[N].getHashValue();return A}}e.CellSequence=w,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var L;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(L=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class F{static create(A){return`${F._prefix}${A}`}static parse(A){if(A.startsWith(F._prefix))return A.substr(F._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=F,F._prefix="notebook/"}),define(fe[103],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=y.createDecorator("environmentVariableService");var D;(function(g){g[g.Replace=1]="Replace",g[g.Append=2]="Append",g[g.Prepend=3]="Prepend"})(D=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(fe[213],he([0,1,5,103]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class g{constructor(d){this.map=new Map,d.forEach((v,n)=>{const k=v.map.entries();let b=k.next();for(;!b.done;){const m=b.value[0];let u=this.map.get(m);if(u||(u=[],this.map.set(m,u)),u.length>0&&u[0].type===D.EnvironmentVariableMutatorType.Replace){b=k.next();continue}const f=b.value[1];u.unshift({extensionIdentifier:n,value:f.value,type:f.type}),b=k.next()}})}applyToProcessEnvironment(d,v){let n;y.isWindows&&(n={},Object.keys(d).forEach(k=>n[k.toLowerCase()]=k)),this.map.forEach((k,b)=>{const m=y.isWindows&&n[b.toLowerCase()]||b;k.forEach(u=>{const f=v?v(u.value):u.value;switch(u.type){case D.EnvironmentVariableMutatorType.Append:d[m]=(d[m]||"")+f;break;case D.EnvironmentVariableMutatorType.Prepend:d[m]=f+(d[m]||"");break;case D.EnvironmentVariableMutatorType.Replace:d[m]=f;break}})})}diff(d){const v=new Map,n=new Map,k=new Map;if(d.map.forEach((b,m)=>{const u=this.map.get(m),f=C(b,u);f&&v.set(m,f)}),this.map.forEach((b,m)=>{const u=d.map.get(m),f=C(b,u);f&&k.set(m,f)}),this.map.forEach((b,m)=>{const u=d.map.get(m),f=_(b,u);f&&n.set(m,f)}),!(v.size===0&&n.size===0&&k.size===0))return{added:v,changed:n,removed:k}}}e.MergedEnvironmentVariableCollection=g;function C(P,d){if(!d)return P;const v=new Set;d.forEach(k=>v.add(k.extensionIdentifier));const n=[];return P.forEach(k=>{v.has(k.extensionIdentifier)||n.push(k)}),n.length===0?void 0:n}function _(P,d){if(!d)return;const v=new Map;d.forEach(k=>v.set(k.extensionIdentifier,k));const n=[];return P.forEach(k=>{const b=v.get(k.extensionIdentifier);b&&(k.type!==b.type||k.value!==b.value)&&n.push(b)}),n.length===0?void 0:n}}),define(fe[104],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function y(g){return[...g.entries()]}e.serializeEnvironmentVariableCollection=y;function D(g){return new Map(g)}e.deserializeEnvironmentVariableCollection=D}),define(fe[214],he([0,1,4,115,5]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function C(a,l){if(!!l)if(g.isWindows)for(const t in l){let r=t;for(const s in a)if(t.toLowerCase()===s.toLowerCase()){r=s;break}const i=l[t];i!==void 0&&_(a,r,i)}else Object.keys(l).forEach(t=>{const r=l[t];r!==void 0&&_(a,t,r)})}e.mergeEnvironments=C;function _(a,l,t){typeof t=="string"?a[l]=t:delete a[l]}function P(a,l,t,r){a.TERM_PROGRAM="vscode",l&&(a.TERM_PROGRAM_VERSION=l),n(a,r)&&(a.LANG=k(t)),a.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function d(a,l){if(!!l)for(const t of Object.keys(l)){const r=l[t];r&&(a[t]=r)}}function v(a,l){return Object.keys(l).forEach(t=>{const r=l[t];if(typeof r=="string")try{l[t]=a(r)}catch(i){l[t]=r}}),l}function n(a,l){if(l==="on")return!0;if(l==="auto"){const t=a.LANG;return!t||t.search(/\.UTF\-8$/)===-1&&t.search(/\.utf8$/)===-1&&t.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=n;function k(a){const l=a?a.split("-"):[],t=l.length;if(t===0)return"en_US.UTF-8";if(t===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};l[0]in r&&l.push(r[l[0]])}else l[1]=l[1].toUpperCase();return l.join("_")+".UTF-8"}e.getLangEnvVariable=k;function b(a,l,t,r,i,s){if(a.cwd){const p=typeof a.cwd=="object"?a.cwd.fsPath:a.cwd,w=m(p,t);return u(w||p)}let c;return!a.ignoreConfigurationCwd&&i&&(t&&(i=m(i,t,s)),i&&(y.isAbsolute(i)?c=i:r&&(c=y.join(r.fsPath,i)))),c||(c=r?r.fsPath:l||""),u(c)}e.getCwd=b;function m(a,l,t){if(l)try{return l(a)}catch(r){t?.error("Could not resolve terminal cwd",r);return}return a}function u(a){return g.OS===1&&a&&a[1]===":"?a[0].toUpperCase()+a.substr(1):a}function f(a,l,t){if(!!t)return r=>t.resolveWithEnvironment(l,a,r)}e.createVariableResolver=f;function S(a,l,t,r,i,s,c,p=g.platform){let w;c&&(w=I(a,"automationShell",p)),w||(w=I(a,"shell",p));let L=w||l;if(p===3&&!t&&r){const F=y.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();L&&L.toLowerCase().indexOf(F)===0&&(L=y.join(r,"System32",L.substr(F.length+1)))}if(L&&p===3&&(L=L.replace(/\//g,"\\")),i)try{L=i(L)}catch(F){s.error("Could not resolve shell",F)}return L}e.getDefaultShell=S;function E(a,l,t,r,i=g.platform){if(l&&I(a,"automationShell",i))return[];const s=i===3?"windows":i===1?"osx":"linux";let c=a(`terminal.integrated.shellArgs.${s}`);if(!c)return[];if(typeof c=="string"&&i===3)return t?t(c):c;if(t){const p=[];for(const w of c)try{p.push(t(w))}catch(L){r.error(`Could not resolve terminal.integrated.shellArgs.${s}`,L),p.push(w)}c=p}return c}e.getDefaultShellArgs=E;function I(a,l,t=g.platform){return a(`terminal.integrated.${l}.${t===3?"windows":t===1?"osx":"linux"}`)}function h(a,l,t,r,i,s){const c={};if(a.strictEnv)d(c,a.env);else{d(c,s);const p={...l};t&&(p&&v(t,p),a.env&&v(t,a.env)),D.sanitizeProcessEnvironment(c,"VSCODE_IPC_HOOK_CLI"),C(c,p),C(c,a.env),P(c,r,g.locale,i)}return c}e.createTerminalEnvironment=h}),define(fe[215],he([0,1,32,6]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=D.refineServiceDecorator(y.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(fe[216],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=y.createDecorator("configurationResolverService")}),define(fe[217],he([0,1,4,23,11,18,5,52,159]),function(X,e,y,D,g,C,_,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class v{constructor(k,b,m){this._contributedVariables=new Map,this._context=k,this._labelService=b,m&&(this._envVariablesPromise=m.then(u=>this.prepareEnv(u)))}prepareEnv(k){if(_.isWindows){const b=Object.create(null);return Object.keys(k).forEach(m=>{b[m.toLowerCase()]=k[m]}),b}return k}resolveWithEnvironment(k,b,m){return this.recursiveResolve(this.prepareEnv(k),b?b.uri:void 0,m)}async resolveAsync(k,b){return this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,b)}async resolveAnyBase(k,b,m,u){const f=C.deepClone(b);return _.isWindows&&f.windows?Object.keys(f.windows).forEach(S=>f[S]=f.windows[S]):_.isMacintosh&&f.osx?Object.keys(f.osx).forEach(S=>f[S]=f.osx[S]):_.isLinux&&f.linux&&Object.keys(f.linux).forEach(S=>f[S]=f.linux[S]),delete f.windows,delete f.osx,delete f.linux,this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,f,m,u)}async resolveAnyAsync(k,b,m){return this.resolveAnyBase(k,b,m)}async resolveAnyMap(k,b,m){const u=new Map;return{newConfig:await this.resolveAnyBase(k,b,m,u),resolvedVariables:u}}resolveWithInteractionReplace(k,b,m,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,b,m,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,b){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,b)}recursiveResolve(k,b,m,u,f){if(g.isString(m))return this.resolveString(k,b,m,u,f);if(g.isArray(m))return m.map(S=>this.recursiveResolve(k,b,S,u,f));if(g.isObject(m)){let S=Object.create(null);return Object.keys(m).forEach(E=>{const I=this.resolveString(k,b,E,u,f);S[I]=this.recursiveResolve(k,b,m[E],u,f)}),S}return m}resolveString(k,b,m,u,f){return m.replace(v.VARIABLE_REGEXP,(E,I)=>{if(I.includes(v.VARIABLE_LHS))return E;let h=this.evaluateSingleVariable(k,E,I,b,u);return f&&f.set(I,h),h!==E&&g.isString(h)&&h.match(v.VARIABLE_REGEXP)&&(h=this.resolveString(k,b,h,u,f)),h})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,b,m,u,f){let S;const E=m.split(":");E.length>1&&(m=E[0],S=E[1]);const I=()=>{const l=this._context.getFilePath();if(l)return l;throw new Error(d.localize(0,null,b))},h=()=>{const l=I();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(d.localize(1,null,b,y.basename(l)))},a=()=>{if(S){const l=this._context.getFolderUri(S);if(l)return l;throw new Error(d.localize(2,null,b,S))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error(d.localize(3,null,b)):new Error(d.localize(4,null,b))};switch(m){case"env":if(S){if(k){const l=k[_.isWindows?S.toLowerCase():S];if(g.isString(l))return l}return""}throw new Error(d.localize(5,null,b));case"config":if(S){const l=this._context.getConfigurationValue(u,S);if(g.isUndefinedOrNull(l))throw new Error(d.localize(6,null,b,S));if(g.isObject(l))throw new Error(d.localize(7,null,b,S));return l}throw new Error(d.localize(8,null,b));case"command":return this.resolveFromMap(b,S,f,"command");case"input":return this.resolveFromMap(b,S,f,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return P.normalizeDriveLetter(this.fsPath(a()));case"cwd":return u||S?P.normalizeDriveLetter(this.fsPath(a())):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return y.basename(this.fsPath(a()));case"lineNumber":const l=this._context.getLineNumber();if(l)return l;throw new Error(d.localize(9,null,b));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(d.localize(10,null,b));case"file":return I();case"fileWorkspaceFolder":return h();case"relativeFile":return u||S?y.relative(this.fsPath(a()),I()):I();case"relativeFileDirname":const r=y.dirname(I());if(u||S){const p=y.relative(this.fsPath(a()),r);return p.length===0?".":p}return r;case"fileDirname":return y.dirname(I());case"fileExtname":return y.extname(I());case"fileBasename":return y.basename(I());case"fileBasenameNoExtension":const i=y.basename(I());return i.slice(0,i.length-y.extname(i).length);case"fileDirnameBasename":return y.basename(y.dirname(I()));case"execPath":const s=this._context.getExecPath();return s||b;case"execInstallFolder":const c=this._context.getAppRoot();return c||b;case"pathSeparator":return y.sep;default:try{const p=S?`${m}:${S}`:m;return this.resolveFromMap(b,p,f,void 0)}catch(p){return b}}}}resolveFromMap(k,b,m,u){if(b&&m){const f=u===void 0?m[b]:m[u+":"+b];if(typeof f=="string")return f;throw new Error(d.localize(11,null,k))}return k}}e.AbstractVariableResolverService=v,v.VARIABLE_LHS="${",v.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[69],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=y.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(fe[218],he([0,1,21,74,240,46,18,11,2,55,177,163,186,212,69,102]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(re){function le(H){const{selectionStartLineNumber:Pe,selectionStartColumn:Re,positionLineNumber:je,positionColumn:Be}=H,Ye=new f.Position(Pe-1,Re-1),it=new f.Position(je-1,Be-1);return new f.Selection(Ye,it)}re.to=le;function K(H){const{anchor:Pe,active:Re}=H;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}re.from=K})(S=e.Selection||(e.Selection={}));var E;(function(re){function le(H){if(!H)return;const{start:Pe,end:Re}=H;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}re.from=le;function K(H){if(!H)return;const{startLineNumber:Pe,startColumn:Re,endLineNumber:je,endColumn:Be}=H;return new f.Range(Pe-1,Re-1,je-1,Be-1)}re.to=K})(E=e.Range||(e.Range={}));var I;(function(re){function le(K){switch(K){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 4:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}re.to=le})(I=e.TokenType||(e.TokenType={}));var h;(function(re){function le(H){return new f.Position(H.lineNumber-1,H.column-1)}re.to=le;function K(H){return{lineNumber:H.line+1,column:H.character+1}}re.from=K})(h=e.Position||(e.Position={}));var a;(function(re){function le(H){switch(H){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}re.from=le;function K(H){switch(H){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}re.to=K})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var l;(function(re){function le(H){let Pe;return H.code&&(P.isString(H.code)||P.isNumber(H.code)?Pe=String(H.code):Pe={value:String(H.code.value),target:H.code.target}),{...E.from(H.range),message:H.message,source:H.source,code:Pe,severity:r.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(t.from),tags:Array.isArray(H.tags)?y.coalesce(H.tags.map(a.from)):void 0}}re.from=le;function K(H){const Pe=new f.Diagnostic(E.to(H),H.message,r.to(H.severity));return Pe.source=H.source,Pe.code=P.isString(H.code)?H.code:H.code?.value,Pe.relatedInformation=H.relatedInformation&&H.relatedInformation.map(t.to),Pe.tags=H.tags&&y.coalesce(H.tags.map(a.to)),Pe}re.to=K})(l=e.Diagnostic||(e.Diagnostic={}));var t;(function(re){function le(H){return{...E.from(H.location.range),message:H.message,resource:H.location.uri}}re.from=le;function K(H){return new f.DiagnosticRelatedInformation(new f.Location(H.resource,E.to(H)),H.message)}re.to=K})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(re){function le(H){switch(H){case f.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}re.from=le;function K(H){switch(H){case b.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}re.to=K})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var i;(function(re){function le(H){return typeof H=="number"&&H>=f.ViewColumn.One?H-1:H===f.ViewColumn.Beside?u.SIDE_GROUP:u.ACTIVE_GROUP}re.from=le;function K(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}re.to=K})(i=e.ViewColumn||(e.ViewColumn={}));function s(re){return typeof re.range!="undefined"}function c(re){return re.length===0?!0:!!s(re[0])}e.isDecorationOptionsArr=c;var p;(function(re){function le(Be){return Be.map(re.from)}re.fromMany=le;function K(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function H(Be){let Ye;if(K(Be)){const{language:lt,value:ht}=Be;Ye={value:"```"+lt+`
`+ht+"\n```\n"}}else f.MarkdownString.isMarkdownString(Be)?Ye={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons}:typeof Be=="string"?Ye={value:Be}:Ye={value:""};const it=Object.create(null);Ye.uris=it;const at=lt=>{try{let ht=d.URI.parse(lt,!0);ht=ht.with({query:Pe(ht.query,it)}),it[lt]=ht}catch(ht){}return""},ft=new g.Renderer;return ft.link=at,ft.image=lt=>at(D.parseHrefAndDimensions(lt).href),g(Ye.value,{renderer:ft}),Ye}re.from=H;function Pe(Be,Ye){if(!Be)return Be;let it;try{it=C.parse(Be)}catch(ft){}if(!it)return Be;let at=!1;return it=_.cloneAndChange(it,ft=>{if(d.URI.isUri(ft)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ye[lt]=ft,at=!0,lt}else return}),at?JSON.stringify(it):Be}function Re(Be){const Ye=new f.MarkdownString(Be.value,Be.supportThemeIcons);return Ye.isTrusted=Be.isTrusted,Ye}re.to=Re;function je(Be){if(!!Be)return typeof Be=="string"?Be:re.from(Be)}re.fromStrict=je})(p=e.MarkdownString||(e.MarkdownString={}));function w(re){return c(re)?re.map(le=>({range:E.from(le.range),hoverMessage:Array.isArray(le.hoverMessage)?p.fromMany(le.hoverMessage):le.hoverMessage?p.from(le.hoverMessage):void 0,renderOptions:le.renderOptions})):re.map(le=>({range:E.from(le)}))}e.fromRangeOrRangeWithMessage=w;function L(re){return typeof re=="undefined"?re:typeof re=="string"?d.URI.file(re):re}e.pathOrURIToURI=L;var F;(function(re){function le(K){return typeof K=="undefined"?K:{contentText:K.contentText,contentIconPath:K.contentIconPath?L(K.contentIconPath):void 0,border:K.border,borderColor:K.borderColor,fontStyle:K.fontStyle,fontWeight:K.fontWeight,textDecoration:K.textDecoration,color:K.color,backgroundColor:K.backgroundColor,margin:K.margin,width:K.width,height:K.height}}re.from=le})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var o;(function(re){function le(K){return typeof K=="undefined"?K:{backgroundColor:K.backgroundColor,outline:K.outline,outlineColor:K.outlineColor,outlineStyle:K.outlineStyle,outlineWidth:K.outlineWidth,border:K.border,borderColor:K.borderColor,borderRadius:K.borderRadius,borderSpacing:K.borderSpacing,borderStyle:K.borderStyle,borderWidth:K.borderWidth,fontStyle:K.fontStyle,fontWeight:K.fontWeight,textDecoration:K.textDecoration,cursor:K.cursor,color:K.color,opacity:K.opacity,letterSpacing:K.letterSpacing,gutterIconPath:K.gutterIconPath?L(K.gutterIconPath):void 0,gutterIconSize:K.gutterIconSize,overviewRulerColor:K.overviewRulerColor,before:K.before?F.from(K.before):void 0,after:K.after?F.from(K.after):void 0}}re.from=le})(o=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var A;(function(re){function le(K){if(typeof K=="undefined")return K;switch(K){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}re.from=le})(A=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(re){function le(K){return{isWholeLine:K.isWholeLine,rangeBehavior:K.rangeBehavior?A.from(K.rangeBehavior):void 0,overviewRulerLane:K.overviewRulerLane,light:K.light?o.from(K.light):void 0,dark:K.dark?o.from(K.dark):void 0,backgroundColor:K.backgroundColor,outline:K.outline,outlineColor:K.outlineColor,outlineStyle:K.outlineStyle,outlineWidth:K.outlineWidth,border:K.border,borderColor:K.borderColor,borderRadius:K.borderRadius,borderSpacing:K.borderSpacing,borderStyle:K.borderStyle,borderWidth:K.borderWidth,fontStyle:K.fontStyle,fontWeight:K.fontWeight,textDecoration:K.textDecoration,cursor:K.cursor,color:K.color,opacity:K.opacity,letterSpacing:K.letterSpacing,gutterIconPath:K.gutterIconPath?L(K.gutterIconPath):void 0,gutterIconSize:K.gutterIconSize,overviewRulerColor:K.overviewRulerColor,before:K.before?F.from(K.before):void 0,after:K.after?F.from(K.after):void 0}}re.from=le})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Q;(function(re){function le(H){return{text:H.newText,eol:H.newEol&&Ge.from(H.newEol),range:E.from(H.range)}}re.from=le;function K(H){const Pe=new f.TextEdit(E.to(H.range),H.text);return Pe.newEol=typeof H.eol=="undefined"?void 0:Ge.to(H.eol),Pe}re.to=K})(Q=e.TextEdit||(e.TextEdit={}));var J;(function(re){function le(H,Pe,Re){const je={edits:[]};if(H instanceof f.WorkspaceEdit)for(let Be of H._allEntries())if(Be._type===1)je.edits.push({_type:1,oldUri:Be.from,newUri:Be.to,options:Be.options,metadata:Be.metadata});else if(Be._type===2){const Ye=Pe?.getDocument(Be.uri);je.edits.push({_type:2,resource:Be.uri,edit:Q.from(Be.edit),modelVersionId:Ye?.version,metadata:Be.metadata})}else Be._type===3?je.edits.push({_type:3,metadata:Be.metadata,resource:Be.uri,edit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Re?.getNotebookDocument(Be.uri,!0)?.apiNotebook.version}):Be._type===5&&je.edits.push({_type:3,metadata:Be.metadata,resource:Be.uri,notebookVersionId:Re?.getNotebookDocument(Be.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(te.from)}});return je}re.from=le;function K(H){const Pe=new f.WorkspaceEdit;for(const Re of H.edits)Re.edit?Pe.replace(d.URI.revive(Re.resource),E.to(Re.edit.range),Re.edit.text):Pe.renameFile(d.URI.revive(Re.oldUri),d.URI.revive(Re.newUri),Re.options);return Pe}re.to=K})(J=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ce;(function(re){const le=Object.create(null);le[f.SymbolKind.File]=0,le[f.SymbolKind.Module]=1,le[f.SymbolKind.Namespace]=2,le[f.SymbolKind.Package]=3,le[f.SymbolKind.Class]=4,le[f.SymbolKind.Method]=5,le[f.SymbolKind.Property]=6,le[f.SymbolKind.Field]=7,le[f.SymbolKind.Constructor]=8,le[f.SymbolKind.Enum]=9,le[f.SymbolKind.Interface]=10,le[f.SymbolKind.Function]=11,le[f.SymbolKind.Variable]=12,le[f.SymbolKind.Constant]=13,le[f.SymbolKind.String]=14,le[f.SymbolKind.Number]=15,le[f.SymbolKind.Boolean]=16,le[f.SymbolKind.Array]=17,le[f.SymbolKind.Object]=18,le[f.SymbolKind.Key]=19,le[f.SymbolKind.Null]=20,le[f.SymbolKind.EnumMember]=21,le[f.SymbolKind.Struct]=22,le[f.SymbolKind.Event]=23,le[f.SymbolKind.Operator]=24,le[f.SymbolKind.TypeParameter]=25;function K(Pe){return typeof le[Pe]=="number"?le[Pe]:6}re.from=K;function H(Pe){for(const Re in le)if(le[Re]===Pe)return Number(Re);return f.SymbolKind.Property}re.to=H})(ce=e.SymbolKind||(e.SymbolKind={}));var se;(function(re){function le(H){switch(H){case f.SymbolTag.Deprecated:return 1}}re.from=le;function K(H){switch(H){case 1:return f.SymbolTag.Deprecated}}re.to=K})(se=e.SymbolTag||(e.SymbolTag={}));var $;(function(re){function le(H){return{name:H.name,kind:ce.from(H.kind),tags:H.tags&&H.tags.map(se.from),containerName:H.containerName,location:R.from(H.location)}}re.from=le;function K(H){const Pe=new f.SymbolInformation(H.name,ce.to(H.kind),H.containerName,R.to(H.location));return Pe.tags=H.tags&&H.tags.map(se.to),Pe}re.to=K})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var q;(function(re){function le(H){const Pe={name:H.name||"!!MISSING: name!!",detail:H.detail,range:E.from(H.range),selectionRange:E.from(H.selectionRange),kind:ce.from(H.kind),tags:H.tags?.map(se.from)??[]};return H.children&&(Pe.children=H.children.map(le)),Pe}re.from=le;function K(H){const Pe=new f.DocumentSymbol(H.name,H.detail,ce.to(H.kind),E.to(H.range),E.to(H.selectionRange));return y.isNonEmptyArray(H.tags)&&(Pe.tags=H.tags.map(se.to)),H.children&&(Pe.children=H.children.map(K)),Pe}re.to=K})(q=e.DocumentSymbol||(e.DocumentSymbol={}));var W;(function(re){function le(K){const H=new f.CallHierarchyItem(ce.to(K.kind),K.name,K.detail||"",d.URI.revive(K.uri),E.to(K.range),E.to(K.selectionRange));return H._sessionId=K._sessionId,H._itemId=K._itemId,H}re.to=le})(W=e.CallHierarchyItem||(e.CallHierarchyItem={}));var V;(function(re){function le(K){return new f.CallHierarchyIncomingCall(W.to(K.from),K.fromRanges.map(H=>E.to(H)))}re.to=le})(V=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var T;(function(re){function le(K){return new f.CallHierarchyOutgoingCall(W.to(K.to),K.fromRanges.map(H=>E.to(H)))}re.to=le})(T=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var R;(function(re){function le(H){return{range:H.range&&E.from(H.range),uri:H.uri}}re.from=le;function K(H){return new f.Location(d.URI.revive(H.uri),E.to(H.range))}re.to=K})(R=e.location||(e.location={}));var M;(function(re){function le(H){const Pe=H,Re=H;return{originSelectionRange:Pe.originSelectionRange?E.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Re.uri,range:E.from(Pe.targetRange?Pe.targetRange:Re.range),targetSelectionRange:Pe.targetSelectionRange?E.from(Pe.targetSelectionRange):void 0}}re.from=le;function K(H){return{targetUri:d.URI.revive(H.uri),targetRange:E.to(H.range),targetSelectionRange:H.targetSelectionRange?E.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?E.to(H.originSelectionRange):void 0}}re.to=K})(M=e.DefinitionLink||(e.DefinitionLink={}));var z;(function(re){function le(H){return{range:E.from(H.range),contents:p.fromMany(H.contents)}}re.from=le;function K(H){return new f.Hover(H.contents.map(p.to),E.to(H.range))}re.to=K})(z=e.Hover||(e.Hover={}));var j;(function(re){function le(H){return{range:E.from(H.range),expression:H.expression}}re.from=le;function K(H){return new f.EvaluatableExpression(E.to(H.range),H.expression)}re.to=K})(j=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ee;(function(re){function le(H){if(H instanceof f.InlineValueText)return{type:"text",range:E.from(H.range),text:H.text};if(H instanceof f.InlineValueVariableLookup)return{type:"variable",range:E.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:E.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}re.from=le;function K(H){switch(H.type){case"text":return{range:E.to(H.range),text:H.text};case"variable":return{range:E.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:E.to(H.range),expression:H.expression}}}re.to=K})(ee=e.InlineValue||(e.InlineValue={}));var me;(function(re){function le(H){return{frameId:H.frameId,stoppedLocation:E.from(H.stoppedLocation)}}re.from=le;function K(H){return new f.InlineValueContext(H.frameId,E.to(H.stoppedLocation))}re.to=K})(me=e.InlineValueContext||(e.InlineValueContext={}));var ge;(function(re){function le(H){return{range:E.from(H.range),kind:H.kind}}re.from=le;function K(H){return new f.DocumentHighlight(E.to(H.range),H.kind)}re.to=K})(ge=e.DocumentHighlight||(e.DocumentHighlight={}));var be;(function(re){function le(K){switch(K){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}re.to=le})(be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ie;(function(re){function le(K){return{triggerKind:be.to(K.triggerKind),triggerCharacter:K.triggerCharacter}}re.to=le})(Ie=e.CompletionContext||(e.CompletionContext={}));var Ae;(function(re){function le(H){switch(H){case f.CompletionItemTag.Deprecated:return 1}}re.from=le;function K(H){switch(H){case 1:return f.CompletionItemTag.Deprecated}}re.to=K})(Ae=e.CompletionItemTag||(e.CompletionItemTag={}));var Fe;(function(re){const le=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function K(Re){return le.get(Re)??9}re.from=K;const H=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function Pe(Re){return H.get(Re)??f.CompletionItemKind.Property}re.to=Pe})(Fe=e.CompletionItemKind||(e.CompletionItemKind={}));var $e;(function(re){function le(K,H){const Pe=new f.CompletionItem(K.label);return Pe.insertText=K.insertText,Pe.kind=Fe.to(K.kind),Pe.tags=K.tags?.map(Ae.to),Pe.detail=K.detail,Pe.documentation=D.isMarkdownString(K.documentation)?p.to(K.documentation):K.documentation,Pe.sortText=K.sortText,Pe.filterText=K.filterText,Pe.preselect=K.preselect,Pe.commitCharacters=K.commitCharacters,v.Range.isIRange(K.range)?Pe.range=E.to(K.range):typeof K.range=="object"&&(Pe.range={inserting:E.to(K.range.insert),replacing:E.to(K.range.replace)}),Pe.keepWhitespace=typeof K.insertTextRules=="undefined"?!1:Boolean(K.insertTextRules&1),typeof K.insertTextRules!="undefined"&&K.insertTextRules&4?Pe.insertText=new f.SnippetString(K.insertText):(Pe.insertText=K.insertText,Pe.textEdit=Pe.range instanceof f.Range?new f.TextEdit(Pe.range,Pe.insertText):void 0),K.additionalTextEdits&&K.additionalTextEdits.length>0&&(Pe.additionalTextEdits=K.additionalTextEdits.map(Re=>Q.to(Re))),Pe.command=H&&K.command?H.fromInternal(K.command):void 0,Pe}re.to=le})($e=e.CompletionItem||(e.CompletionItem={}));var Qe;(function(re){function le(H){return{label:H.label,documentation:H.documentation?p.fromStrict(H.documentation):void 0}}re.from=le;function K(H){return{label:H.label,documentation:D.isMarkdownString(H.documentation)?p.to(H.documentation):H.documentation}}re.to=K})(Qe=e.ParameterInformation||(e.ParameterInformation={}));var Ze;(function(re){function le(H){return{label:H.label,documentation:H.documentation?p.fromStrict(H.documentation):void 0,parameters:Array.isArray(H.parameters)?H.parameters.map(Qe.from):[],activeParameter:H.activeParameter}}re.from=le;function K(H){return{label:H.label,documentation:D.isMarkdownString(H.documentation)?p.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(Qe.to):[],activeParameter:H.activeParameter}}re.to=K})(Ze=e.SignatureInformation||(e.SignatureInformation={}));var tt;(function(re){function le(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(Ze.from):[]}}re.from=le;function K(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(Ze.to):[]}}re.to=K})(tt=e.SignatureHelp||(e.SignatureHelp={}));var nt;(function(re){function le(H){return{text:H.text,position:h.from(H.position),kind:Ce.from(H.kind??f.InlayHintKind.Other),whitespaceBefore:H.whitespaceBefore,whitespaceAfter:H.whitespaceAfter}}re.from=le;function K(H){const Pe=new f.InlayHint(H.text,h.to(H.position),Ce.to(H.kind));return Pe.whitespaceAfter=H.whitespaceAfter,Pe.whitespaceBefore=H.whitespaceBefore,Pe}re.to=K})(nt=e.InlayHint||(e.InlayHint={}));var Ce;(function(re){function le(H){return H}re.from=le;function K(H){return H}re.to=K})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var De;(function(re){function le(H){return{range:E.from(H.range),url:H.target,tooltip:H.tooltip}}re.from=le;function K(H){let Pe;if(H.url)try{Pe=typeof H.url=="string"?d.URI.parse(H.url,!0):d.URI.revive(H.url)}catch(Re){}return new f.DocumentLink(E.to(H.range),Pe)}re.to=K})(De=e.DocumentLink||(e.DocumentLink={}));var _e;(function(re){function le(H){const Pe=new f.ColorPresentation(H.label);return H.textEdit&&(Pe.textEdit=Q.to(H.textEdit)),H.additionalTextEdits&&(Pe.additionalTextEdits=H.additionalTextEdits.map(Re=>Q.to(Re))),Pe}re.to=le;function K(H){return{label:H.label,textEdit:H.textEdit?Q.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Pe=>Q.from(Pe)):void 0}}re.from=K})(_e=e.ColorPresentation||(e.ColorPresentation={}));var Te;(function(re){function le(H){return new f.Color(H[0],H[1],H[2],H[3])}re.to=le;function K(H){return[H.red,H.green,H.blue,H.alpha]}re.from=K})(Te=e.Color||(e.Color={}));var Me;(function(re){function le(H){return{range:E.from(H.range)}}re.from=le;function K(H){return new f.SelectionRange(E.to(H.range))}re.to=K})(Me=e.SelectionRange||(e.SelectionRange={}));var We;(function(re){function le(K){switch(K){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}re.to=le})(We=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var qe;(function(re){function le(H){switch(H){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}re.from=le;function K(H){switch(H){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}re.to=K})(qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(re){function le(H){if(H===f.EndOfLine.CRLF)return 1;if(H===f.EndOfLine.LF)return 0}re.from=le;function K(H){if(H===1)return f.EndOfLine.CRLF;if(H===0)return f.EndOfLine.LF}re.to=K})(Ge=e.EndOfLine||(e.EndOfLine={}));var et;(function(re){function le(K){if(typeof K=="object")return K.viewId;switch(K){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}re.from=le})(et=e.ProgressLocation||(e.ProgressLocation={}));var ne;(function(re){function le(K){const H={start:K.start+1,end:K.end+1};return K.kind&&(H.kind=Se.from(K.kind)),H}re.from=le})(ne=e.FoldingRange||(e.FoldingRange={}));var Se;(function(re){function le(K){if(K)switch(K){case f.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}re.from=le})(Se=e.FoldingRangeKind||(e.FoldingRangeKind={}));var we;(function(re){function le(K){if(K)return{pinned:typeof K.preview=="boolean"?!K.preview:void 0,inactive:K.background,preserveFocus:K.preserveFocus,selection:typeof K.selection=="object"?E.from(K.selection):void 0,override:typeof K.override=="boolean"?k.EditorOverride.DISABLED:void 0}}re.from=le})(we=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ue;(function(re){function le(H){return H instanceof f.RelativePattern||typeof H=="string"?H:K(H)?new f.RelativePattern(H.base,H.pattern):H}re.from=le;function K(H){const Pe=H;return Pe&&typeof Pe.base=="string"&&typeof Pe.pattern=="string"}})(Ue=e.GlobPattern||(e.GlobPattern={}));var ue;(function(re){function le(K){if(K){if(Array.isArray(K))return K.map(le);if(typeof K=="string")return K;{const H=K;return{language:H.language,scheme:H.scheme,pattern:typeof H.pattern=="undefined"?void 0:Ue.from(H.pattern),exclusive:H.exclusive}}}else return}re.from=le})(ue=e.LanguageSelector||(e.LanguageSelector={}));var pe;(function(re){function le(H){return{start:H.start,end:H.end}}re.from=le;function K(H){return new f.NotebookRange(H.start,H.end)}re.to=K})(pe=e.NotebookRange||(e.NotebookRange={}));var ve;(function(re){function le(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}re.to=le;function K(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}re.from=K})(ve=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var G;(function(re){function le(H){switch(H){case f.NotebookCellKind.Markup:return m.CellKind.Markup;case f.NotebookCellKind.Code:default:return m.CellKind.Code}}re.from=le;function K(H){switch(H){case m.CellKind.Markup:return f.NotebookCellKind.Markup;case m.CellKind.Code:default:return f.NotebookCellKind.Code}}re.to=K})(G=e.NotebookCellKind||(e.NotebookCellKind={}));var Y;(function(re){function le(H){const Pe={metadata:H.metadata??Object.create(null),cells:[]};for(let Re of H.cells)f.NotebookCellData.validate(Re),Pe.cells.push(te.from(Re));return Pe}re.from=le;function K(H){const Pe=new f.NotebookData(H.cells.map(te.to));return P.isEmptyObject(H.metadata)||(Pe.metadata=H.metadata),Pe}re.to=K})(Y=e.NotebookData||(e.NotebookData={}));var te;(function(re){function le(H){return{cellKind:G.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:ve.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(B.from):[]}}re.from=le;function K(H){return new f.NotebookCellData(G.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(B.to):void 0,H.metadata,H.internalMetadata?ve.to(H.internalMetadata):void 0)}re.to=K})(te=e.NotebookCellData||(e.NotebookCellData={}));var oe;(function(re){function le(H){return{mime:H.mime,valueBytes:Array.from(H.data)}}re.from=le;function K(H){return new f.NotebookCellOutputItem(new Uint8Array(H.valueBytes),H.mime)}re.to=K})(oe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var B;(function(re){function le(H){return{outputId:H.id,items:H.items.map(oe.from),metadata:H.metadata}}re.from=le;function K(H){const Pe=H.items.map(oe.to);return new f.NotebookCellOutput(Pe,H.outputId,H.metadata)}re.to=K})(B=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ie;(function(re){function le(Re){if(Re!=null){if(Re instanceof f.RelativePattern||typeof Re=="string")return Re;if(Pe(Re))return new f.RelativePattern(Re.base,Re.pattern);if(H(Re))return{include:Ue.from(Re.include)||void 0,exclude:Ue.from(Re.exclude)||void 0}}}re.from=le;function K(Re){return typeof Re=="string"?Re:Pe(Re)?{base:Re.base,pattern:Re.pattern}:{include:Re.include,exclude:Re.exclude}}re.to=K;function H(Re){const je=Re,Be=Ue.from(je.include);if(!(Be&&Be instanceof f.RelativePattern||typeof Be=="string"))return!1;const Ye=Ue.from(je.exclude);return!!(Ye&&Ye instanceof f.RelativePattern||typeof Ye=="string")}function Pe(Re){const je=Re;return je&&typeof je.base=="string"&&typeof je.pattern=="string"}})(ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ae;(function(re){function le(K){return{backgroundColor:K.backgroundColor,borderColor:K.borderColor,top:K.top?F.from(K.top):void 0}}re.from=le})(ae=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var de;(function(re){function le(K,H,Pe){const Re=typeof K.command=="string"?{title:"",command:K.command}:K.command;return{alignment:K.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Re,Pe),text:K.text,tooltip:K.tooltip,accessibilityInformation:K.accessibilityInformation,priority:K.priority}}re.from=le})(de=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Z;(function(re){function le(K){return{transientOutputs:K?.transientOutputs??!1,transientCellMetadata:K?.transientCellMetadata??{},transientDocumentMetadata:K?.transientDocumentMetadata??{}}}re.from=le})(Z=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ye;(function(re){function le(H){return{uri:H.uri,provides:H.provides}}re.from=le;function K(H){return new f.NotebookRendererScript(d.URI.revive(H.uri),H.provides)}re.to=K})(ye=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ke;(function(re){function le(H){return{message:p.fromStrict(H.message)||"",severity:H.severity,expectedOutput:H.expectedOutput,actualOutput:H.actualOutput,location:H.location?R.from(H.location):void 0}}re.from=le;function K(H){const Pe=new f.TestMessage(typeof H.message=="string"?H.message:p.to(H.message));return Pe.severity=H.severity,Pe.actualOutput=H.actualOutput,Pe.expectedOutput=H.expectedOutput,Pe}re.to=K})(ke=e.TestMessage||(e.TestMessage={}));var Le;(function(re){function le(je){return{extId:je.id,label:je.label,uri:je.uri,range:E.from(je.range)||null,debuggable:je.debuggable??!1,description:je.description||null,runnable:je.runnable??!0,error:je.error&&p.fromStrict(je.error)||null}}re.from=le;function K(je){return{extId:je.id,label:je.label,uri:je.uri,range:E.from(je.range)||null,debuggable:!1,description:je.description||null,error:null,runnable:!0}}re.fromResultSnapshot=K;function H(je){return{id:je.extId,label:je.label,uri:d.URI.revive(je.uri),range:E.to(je.range||void 0),dispose:()=>{},invalidateResults:()=>{},canResolveChildren:!1,busy:!1,debuggable:je.debuggable,description:je.description||void 0,runnable:je.runnable}}re.toPlain=H;function Pe(je,Be){const Ye=new f.TestItemImpl(je.extId,je.label,d.URI.revive(je.uri),void 0,Be);return Ye.range=E.to(je.range||void 0),Ye.debuggable=je.debuggable,Ye.description=je.description||void 0,Ye.runnable=je.runnable,Ye}re.to=Pe;function Re(je){let Be;for(const Ye of je.tests)Be=Pe(Ye.item,Be);return Be}re.toItemFromContext=Re})(Le=e.TestItem||(e.TestItem={}));var Oe;(function(re){const le=(H,Pe)=>({...Le.toPlain(H.item),taskStates:H.tasks.map(Re=>({state:Re.state,duration:Re.duration,messages:Re.messages.map(ke.to)})),children:H.children.map(Re=>Pe.get(Re)).filter(P.isDefined).map(Re=>le(Re,Pe))});function K(H){const Pe=[],Re=new Map;for(const je of H.items)Re.set(je.item.extId,je),je.direct&&Pe.push(je);return{completedAt:H.completedAt,results:Pe.map(je=>le(je,Re))}}re.to=K})(Oe=e.TestResults||(e.TestResults={}));var He;(function(re){function le(Re){return{covered:Re.covered,total:Re.covered}}function K(Re){return"line"in Re?h.from(Re):E.from(Re)}function H(Re){return"branches"in Re?{count:Re.executionCount,location:K(Re.location),type:1,branches:Re.branches.length?Re.branches.map(je=>({count:je.executionCount,location:je.location&&K(je.location)})):void 0}:{type:0,count:Re.executionCount,location:K(Re.location)}}re.fromDetailed=H;function Pe(Re){return{uri:Re.uri,statement:le(Re.statementCoverage),branch:Re.branchCoverage&&le(Re.branchCoverage),function:Re.functionCoverage&&le(Re.functionCoverage),details:Re.detailedCoverage?.map(H)}}re.fromFile=Pe})(He=e.TestCoverage||(e.TestCoverage={}));var xe;(function(re){function le(K){switch(K){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}re.to=le})(xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(fe[219],he([0,1,158,11,2,3,6,60,29,21,69,8]),function(X,e,y,D,g,C,_,P,d,v,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.editorGroupToViewColumn=e.viewColumnToEditorGroup=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptions=e.isEditorInputWithPreferredResource=e.UntypedEditorContext=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={Editors:"workbench.contributions.editors",Associations:"workbench.editors.associations",EditorInputFactories:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:y.localize(0,null),providerDisplayName:y.localize(1,null)},e.ActiveEditorDirtyContext=new P.RawContextKey("activeEditorIsDirty",!1,y.localize(2,null)),e.ActiveEditorPinnedContext=new P.RawContextKey("activeEditorIsNotPreview",!1,y.localize(3,null)),e.ActiveEditorStickyContext=new P.RawContextKey("activeEditorIsPinned",!1,y.localize(4,null)),e.ActiveEditorReadonlyContext=new P.RawContextKey("activeEditorIsReadonly",!1,y.localize(5,null)),e.ActiveEditorCanRevertContext=new P.RawContextKey("activeEditorCanRevert",!1,y.localize(6,null)),e.ActiveEditorContext=new P.RawContextKey("activeEditor",null,{type:"string",description:y.localize(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new P.RawContextKey("activeEditorAvailableEditorIds","",y.localize(8,null)),e.TextCompareEditorVisibleContext=new P.RawContextKey("textCompareEditorVisible",!1,y.localize(9,null)),e.TextCompareEditorActiveContext=new P.RawContextKey("textCompareEditorActive",!1,y.localize(10,null)),e.EditorGroupEditorsCountContext=new P.RawContextKey("groupEditorsCount",0,y.localize(11,null)),e.ActiveEditorGroupEmptyContext=new P.RawContextKey("activeEditorGroupEmpty",!1,y.localize(12,null)),e.ActiveEditorGroupIndexContext=new P.RawContextKey("activeEditorGroupIndex",0,y.localize(13,null)),e.ActiveEditorGroupLastContext=new P.RawContextKey("activeEditorGroupLast",!1,y.localize(14,null)),e.MultipleEditorGroupsContext=new P.RawContextKey("multipleEditorGroups",!1,y.localize(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new P.RawContextKey("editorIsOpen",!1,y.localize(16,null)),e.InEditorZenModeContext=new P.RawContextKey("inZenMode",!1,y.localize(17,null)),e.IsCenteredLayoutContext=new P.RawContextKey("isCenteredLayout",!1,y.localize(18,null)),e.SplitEditorsVertically=new P.RawContextKey("splitEditorsVertically",!1,y.localize(19,null)),e.EditorAreaVisibleContext=new P.RawContextKey("editorAreaVisible",!0,y.localize(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function b(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=b;function m(o){const A=o;return A.originalInput!==void 0&&A.modifiedInput!==void 0}e.isResourceDiffEditorInput=m;function u(o){const A=o;return A.resource===void 0||A.resource.scheme===k.Schemas.untitled||A.forceUntitled===!0}e.isUntitledResourceEditorInput=u;var f;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(f=e.Verbosity||(e.Verbosity={}));var S;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var E;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(E=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));var I;(function(o){o[o.Default=0]="Default",o[o.Full=1]="Full"})(I=e.UntypedEditorContext||(e.UntypedEditorContext={}));function h(o){const A=o;return A?g.URI.isUri(A.preferredResource):!1}e.isEditorInputWithPreferredResource=h;function a(o){const A=o;return A?!!A.primary&&!!A.secondary:!1}function l(o){const A=o;return!!A&&!!A.editor}e.isEditorInputWithOptions=l;function t(o){const A=o;return A?typeof A.groupId=="number"&&!D.isUndefinedOrNull(A.editor):!1}e.isEditorIdentifier=t;var r;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(r=e.SideBySideEditor||(e.SideBySideEditor={}));class i{getOriginalUri(A,N){if(!A)return;const Q=a(A)?A.primary:m(A)?A.modifiedInput:void 0,J=a(A)?A.secondary:m(A)?A.originalInput:void 0;if(N?.supportSideBySide&&Q&&J){if(N?.supportSideBySide===r.BOTH)return{primary:this.getOriginalUri(Q,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(J,{filterByScheme:N.filterByScheme})};A=N.supportSideBySide===r.PRIMARY?Q:J}if(m(A))return;const ce=h(A)?A.preferredResource:A.resource;return!ce||!N||!N.filterByScheme?ce:this.filterUri(ce,N.filterByScheme)}getCanonicalUri(A,N){if(!A)return;const Q=a(A)?A.primary:m(A)?A.modifiedInput:void 0,J=a(A)?A.secondary:m(A)?A.originalInput:void 0;if(N?.supportSideBySide&&Q&&J){if(N?.supportSideBySide===r.BOTH)return{primary:this.getCanonicalUri(Q,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(J,{filterByScheme:N.filterByScheme})};A=N.supportSideBySide===r.PRIMARY?Q:J}if(m(A))return;const ce=A.resource;return!ce||!N||!N.filterByScheme?ce:this.filterUri(ce,N.filterByScheme)}filterUri(A,N){if(Array.isArray(N)){if(N.some(Q=>A.scheme===Q))return A}else if(N===A.scheme)return A}}e.EditorResourceAccessor=new i;var s;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(s=e.CloseDirection||(e.CloseDirection={}));class c{constructor(){this.editorInputSerializerConstructors=new Map,this.editorInputSerializerInstances=new Map}start(A){const N=this.instantiationService=A.get(_.IInstantiationService);for(const[Q,J]of this.editorInputSerializerConstructors)this.createEditorInputSerializer(Q,J,N);this.editorInputSerializerConstructors.clear()}createEditorInputSerializer(A,N,Q){const J=Q.createInstance(N);this.editorInputSerializerInstances.set(A,J)}registerFileEditorInputFactory(A){if(this.fileEditorInputFactory)throw new Error("Can only register one file editor input factory.");this.fileEditorInputFactory=A}getFileEditorInputFactory(){return D.assertIsDefined(this.fileEditorInputFactory)}registerEditorInputSerializer(A,N){if(this.editorInputSerializerConstructors.has(A)||this.editorInputSerializerInstances.has(A))throw new Error(`A editor input serializer with type ID '${A}' was already registered.`);return this.instantiationService?this.createEditorInputSerializer(A,N,this.instantiationService):this.editorInputSerializerConstructors.set(A,N),C.toDisposable(()=>{this.editorInputSerializerConstructors.delete(A),this.editorInputSerializerInstances.delete(A)})}getEditorInputSerializer(A){return this.editorInputSerializerInstances.get(typeof A=="string"?A:A.typeId)}}d.Registry.add(e.EditorExtensions.EditorInputFactories,new c);async function p(o,A){if(!o||!o.length)return[];const N=await Promise.all(o.map(async Q=>{const J=g.URI.revive(Q.fileUri);if(!J||!A.canHandleResource(J))return;const ce=typeof Q.exists=="boolean"?Q.exists:await A.exists(J);if(!ce&&Q.openOnlyIfExists)return;const se=ce&&typeof Q.lineNumber=="number"?{selection:{startLineNumber:Q.lineNumber,startColumn:Q.columnNumber||1},pinned:!0,override:Q.editorOverrideId}:{pinned:!0,override:Q.editorOverrideId};let $;return ce?$={resource:J,options:se,forceFile:!0}:$={resource:J,options:se,forceUntitled:!0},$}));return v.coalesce(N)}e.pathsToEditors=p;var w;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(w=e.EditorsOrder||(e.EditorsOrder={}));function L(o,A){if(typeof A!="number"||A===n.ACTIVE_GROUP)return n.ACTIVE_GROUP;const N=o.getGroups(2);let Q=N[A];if(Q)return Q.id;let J=N[0];return N.length===1&&J.count===0?J.id:n.SIDE_GROUP}e.viewColumnToEditorGroup=L;function F(o,A){let N=typeof A=="number"?o.getGroup(A):A;return N=N??o.activeGroup,o.getGroups(2).indexOf(N)}e.editorGroupToViewColumn=F}),define(fe[220],he([0,1,11,215,16,96,100,104,216,219,69,8,182,103]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let u=class{constructor(S,E,I,h,a,l,t,r,i,s){this._remoteAuthority=S,this._channel=E,this._configurationService=I,this._workspaceContextService=h,this._resolverService=a,this._environmentVariableService=l,this._remoteAuthorityResolverService=t,this._logService=r,this._editorService=i,this._labelService=s}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessTitleChanged(){return this._channel.listen("$onProcessTitleChangedEvent")}get onProcessShellTypeChanged(){return this._channel.listen("$onProcessShellTypeChangedEvent")}get onProcessOverrideDimensions(){return this._channel.listen("$onProcessOverrideDimensionsEvent")}get onProcessResolvedShellLaunchConfig(){return this._channel.listen("$onProcessResolvedShellLaunchConfigEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(S,E,I,h,a,l){await this._configurationService.whenRemoteConfigurationLoaded();const t=Object.create(null),r=I?y.withNullAsUndefined(this._workspaceContextService.getWorkspaceFolder(I)):void 0;let i;try{i=(await this._resolverService.resolveAnyMap(r,{shellLaunchConfig:S,configuration:E})).resolvedVariables}catch(N){this._logService.error(N)}if(i)for(const[N,Q]of i.entries())(/^config:/.test(N)||N==="selectedText"||N==="lineNumber")&&(t[N]=Q);const s=[];for(const[N,Q]of this._environmentVariableService.collections.entries())s.push([N,P.serializeEnvironmentVariableCollection(Q.map)]);const c=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),p=c.options&&c.options.extensionHostEnv,w=this._workspaceContextService.getWorkspace(),L=w.folders,F=I?this._workspaceContextService.getWorkspaceFolder(I):null,o=v.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:v.SideBySideEditor.PRIMARY,filterByScheme:[k.Schemas.file,k.Schemas.userData,k.Schemas.vscodeRemote]}),A={configuration:E,resolvedVariables:t,envVariableCollections:s,shellLaunchConfig:S,workspaceId:w.id,workspaceName:this._labelService.getWorkspaceLabel(w),workspaceFolders:L,activeWorkspaceFolder:F,activeFileResource:o,shouldPersistTerminal:h,cols:a,rows:l,resolverEnv:p};return await this._channel.call("$createProcess",A)}attachToProcess(S){return this._channel.call("$attachToProcess",[S])}detachFromProcess(S){return this._channel.call("$detachFromProcess",[S])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(S,E){return this._channel.call("$processBinary",[S,E])}start(S){return this._channel.call("$start",[S])}input(S,E){return this._channel.call("$input",[S,E])}acknowledgeDataEvent(S,E){return this._channel.call("$acknowledgeDataEvent",[S,E])}shutdown(S,E){return this._channel.call("$shutdown",[S,E])}resize(S,E,I){return this._channel.call("$resize",[S,E,I])}getInitialCwd(S){return this._channel.call("$getInitialCwd",[S])}getCwd(S){return this._channel.call("$getCwd",[S])}orphanQuestionReply(S){return this._channel.call("$orphanQuestionReply",[S])}sendCommandResult(S,E,I){return this._channel.call("$sendCommandResult",[S,E,I])}getDefaultSystemShell(S){return this._channel.call("$getDefaultSystemShell",[S])}getProfiles(S,E,I){return this._channel.call("$getProfiles",[S,E,I])}acceptPtyHostResolvedVariables(S,E){return this._channel.call("$acceptPtyHostResolvedVariables",[S,E])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(S){return this._channel.call("$getWslPath",[S])}setTerminalLayoutInfo(S){const I={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:S.tabs};return this._channel.call("$setTerminalLayoutInfo",I)}updateTitle(S,E){return this._channel.call("$updateTitle",[S,E])}updateIcon(S,E,I){return this._channel.call("$updateIcon",[S,E,I])}getTerminalLayoutInfo(){const E={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",E)}};u=Ne([Ke(2,D.IWorkbenchConfigurationService),Ke(3,_.IWorkspaceContextService),Ke(4,d.IConfigurationResolverService),Ke(5,m.IEnvironmentVariableService),Ke(6,C.IRemoteAuthorityResolverService),Ke(7,g.ILogService),Ke(8,n.IEditorService),Ke(9,b.ILabelService)],u),e.RemoteTerminalChannelClient=u}),define(fe[221],he([0,1,187]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var D;(function(C){function _(P,d){if(P===d)return!0;let v=Object.keys(P),n=new Set;for(let k of Object.keys(d))n.add(k);if(v.length!==n.size)return!1;for(let k of v){if(P[k]!==d[k])return!1;n.delete(k)}return n.size===0}C.equals=_})(D=e.Translations||(e.Translations={}));class g{constructor(_){this._messageHandler=_}error(_,P){this._messageHandler(y.Severity.Error,_,P)}warn(_,P){this._messageHandler(y.Severity.Warning,_,P)}info(_,P){this._messageHandler(y.Severity.Info,_,P)}}e.Logger=g}),define(fe[222],he([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class y{constructor(d,v){this._proxyIdentifierBrand=void 0,this.isMain=d,this.sid=v,this.nid=++y.count}}e.ProxyIdentifier=y,y.count=0;const D=[];function g(P){const d=new y(!0,P);return D[d.nid]=d,d}e.createMainContextProxyIdentifier=g;function C(P){const d=new y(!1,P);return D[d.nid]=d,d}e.createExtHostContextProxyIdentifier=C;function _(P){return D[P].sid}e.getStringIdentifierForProxy=_}),define(fe[223],he([0,1,46,2,222]),function(X,e,y,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(h){h[h.Desktop=1]="Desktop",h[h.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var _;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(_=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var d;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(d=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var v;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(v=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var b;(function(h){h.name="$ident";function a(t,r){return Object.defineProperty(t,h.name,{value:r,enumerable:!0}),t}h.mixin=a;function l(t){return t[h.name]}h.of=l})(b=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(a){return a._id=m._n++,a}}e.IdObject=m,m._n=0;var u;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.command="m",h.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(h){h[h.File=1]="File",h[h.Text=2]="Text",h[h.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function E(h){if(h&&h.edits)for(const a of h.edits)typeof a.resource=="object"?a.resource=D.URI.revive(a.resource):(a.newUri=D.URI.revive(a.newUri),a.oldUri=D.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=y.revive(a.metadata));return h}e.reviveWorkspaceEditDto=E;var I;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(I=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:g.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:g.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:g.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:g.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:g.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:g.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:g.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:g.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:g.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:g.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:g.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:g.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:g.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:g.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:g.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:g.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:g.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:g.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:g.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:g.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:g.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:g.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:g.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:g.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:g.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:g.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:g.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:g.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:g.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:g.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:g.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:g.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:g.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:g.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:g.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:g.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:g.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:g.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:g.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:g.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:g.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:g.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:g.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:g.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:g.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:g.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:g.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:g.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:g.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:g.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:g.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadInteractive:g.createMainContextProxyIdentifier("MainThreadInteractive"),MainThreadTheming:g.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:g.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:g.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:g.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:g.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:g.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:g.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:g.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:g.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:g.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:g.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:g.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:g.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:g.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:g.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:g.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:g.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:g.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:g.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:g.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:g.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:g.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:g.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:g.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:g.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:g.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:g.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:g.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:g.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:g.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:g.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:g.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:g.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:g.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:g.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:g.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:g.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:g.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:g.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:g.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:g.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:g.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:g.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:g.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:g.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:g.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:g.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostInteractive:g.createMainContextProxyIdentifier("ExtHostInteractive"),ExtHostTheming:g.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:g.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:g.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:g.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:g.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:g.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(fe[224],he([0,1,11,102,218,18,223,21,16,46,55,83,2,3,6,210]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadCommands),this._logService=r,this.converter=new E(this,i=>{const s=this._apiCommands.get(i);return s?.result===h.Void?s:void 0},r),this._argumentProcessors=[{processArgument(i){return v.revive(i)}},{processArgument(i){return C.cloneAndChange(i,function(s){if(n.Range.isIRange(s))return g.Range.to(s);if(k.Position.isIPosition(s))return g.Position.to(s);if(n.Range.isIRange(s.range)&&b.URI.isUri(s.uri))return g.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...i)=>{const s=t.args.map((p,w)=>{if(!p.validate(i[w]))throw new Error(`Invalid argument '${p.name}' when running '${t.id}', received: ${i[w]}`);return p.convert(i[w])}),c=await this.executeCommand(t.internalId,...s);return t.result.convert(c,i,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new D.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,i,s,c){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:i,thisArg:s,description:c}),t&&this._proxy.$registerCommand(r),new D.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,i){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const s=C.cloneAndChange(r,function(c){if(c instanceof D.Position)return g.Position.from(c);if(c instanceof D.Range)return g.Range.from(c);if(c instanceof D.Location)return g.location.from(c);if(D.NotebookRange.isNotebookRange(c))return g.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,s,i);return v.revive(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw c}}}async _executeContributedCommand(t,r){const i=this._commands.get(t);if(!i)throw new Error("Unknown command");let{callback:s,thisArg:c,description:p}=i;if(p)for(let w=0;w<p.args.length;w++)try{y.validateConstraint(r[w],p.args[w].constraint)}catch(L){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${p.args[w].name}' - ${p.args[w].description}`)}try{return await s.apply(c,r)}catch(w){if(t===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...r);L&&(t=L.command)}throw this._logService.error(w,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(i=>this._argumentProcessors.reduce((s,c)=>c.processArgument(s),i)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(i=>i[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,i]of this._commands){let{description:s}=i;s&&(t[r]=s)}return Promise.resolve(t)}};S=Ne([Ke(0,f.IExtHostRpcService),Ke(1,d.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=u.createDecorator("IExtHostCommands");class E{constructor(t,r,i){this._commands=t,this._lookupApiCommand=r,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const i={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return i;const s=this._lookupApiCommand(t.command);if(s)i.id=s.internalId,i.arguments=s.args.map((c,p)=>c.convert(t.arguments&&t.arguments[p]));else if(P.isNonEmptyArray(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),r.add(m.toDisposable(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),i.$ident=c,i.id=this.delegatingCommandId,i.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return i}fromInternal(t){const r=_.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=E;class I{constructor(t,r,i,s){this.name=t,this.description=r,this.validate=i,this.convert=s}optional(){return new I(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new I(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=I,I.Uri=new I("uri","Uri of a text document",l=>b.URI.isUri(l),l=>l),I.Position=new I("position","A position in a text document",l=>D.Position.isPosition(l),g.Position.from),I.Range=new I("range","A range in a text document",l=>D.Range.isRange(l),g.Range.from),I.Selection=new I("selection","A selection in a text document",l=>D.Selection.isSelection(l),g.Selection.from),I.Number=new I("number","",l=>typeof l=="number",l=>l),I.String=new I("string","",l=>typeof l=="string",l=>l),I.CallHierarchyItem=new I("item","A call hierarchy item",l=>l instanceof D.CallHierarchyItem,g.CallHierarchyItem.to);class h{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=h,h.Void=new h("no result",l=>l);class a{constructor(t,r,i,s,c){this.id=t,this.internalId=r,this.description=i,this.args=s,this.result=c}}e.ApiCommand=a}),define(fe[225],he([0,1,160,4,49,37,21,134,11,2,15,34,58,44,221]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const f="package.json";class S{constructor(i,s,c,p,w,L){this._ourVersion=i,this._ourProductDate=s,this._log=c,this._absoluteFolderPath=p,this._isBuiltin=w,this._isUnderDevelopment=L,this._absoluteManifestPath=D.join(p,f)}}class E extends S{static _fastParseJSON(i,s){try{return JSON.parse(i)}catch(c){return C.parse(i,s)}}parse(){return n.Promises.readFile(this._absoluteManifestPath).then(i=>{const s=[],c=E._fastParseJSON(i.toString(),s);if(C.getNodeType(c)!=="object")this._log.error(this._absoluteFolderPath,y.localize(0,null,this._absoluteManifestPath));else{if(s.length===0)return c.__metadata&&(c.uuid=c.__metadata.id),c.isUserBuiltin=!!c.__metadata?.isBuiltin,delete c.__metadata,c;s.forEach(p=>{this._log.error(this._absoluteFolderPath,y.localize(1,null,this._absoluteManifestPath,p.offset,p.length,P.getParseErrorMessage(p.error)))})}return null},i=>(i.code==="ENOENT"||this._log.error(this._absoluteFolderPath,y.localize(2,null,this._absoluteManifestPath,i.message)),null))}}class I extends S{constructor(i,s,c,p,w,L,F){super(i,s,c,p,w,L);this._nlsConfig=F}replaceNLS(i){const s=(A,N)=>{N.forEach(Q=>{this._log.error(this._absoluteFolderPath,y.localize(3,null,A,P.getParseErrorMessage(Q.error)))})},c=A=>{this._log.error(this._absoluteFolderPath,y.localize(4,null,A))};let p=D.extname(this._absoluteManifestPath),w=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-p.length);const L=`${i.publisher}.${i.name}`;let F=this._nlsConfig.translations[L],o;return F?o=n.Promises.readFile(F,"utf8").then(A=>{let N=[],Q=C.parse(A,N);return N.length>0?(s(F,N),{values:void 0,default:`${w}.nls.json`}):C.getNodeType(Q)!=="object"?(c(F),{values:void 0,default:`${w}.nls.json`}):{values:Q.contents?Q.contents.package:void 0,default:`${w}.nls.json`}},A=>({values:void 0,default:`${w}.nls.json`})):o=n.SymlinkSupport.existsFile(w+".nls"+p).then(A=>{if(!!A)return I.findMessageBundles(this._nlsConfig,w).then(N=>N.localized?n.Promises.readFile(N.localized,"utf8").then(Q=>{let J=[],ce=C.parse(Q,J);return J.length>0?(s(N.localized,J),{values:void 0,default:N.original}):C.getNodeType(ce)!=="object"?(c(N.localized),{values:void 0,default:N.original}):{values:ce,default:N.original}},Q=>({values:void 0,default:N.original})):{values:void 0,default:N.original},N=>{})}),o.then(A=>{if(A===void 0)return i;let N=[];return I.resolveOriginalMessageBundle(A.default,N).then(Q=>{if(N.length>0)return s(A.default,N),i;if(C.getNodeType(A)!=="object")return c(A.default),i;const J=A.values||Object.create(null);return I._replaceNLStrings(this._nlsConfig,i,J,Q,this._log,this._absoluteFolderPath),i})},A=>i)}static resolveOriginalMessageBundle(i,s){return new Promise((c,p)=>{i?n.Promises.readFile(i).then(w=>{c(C.parse(w.toString(),s))},w=>{c(null)}):c(null)})}static findMessageBundles(i,s){return new Promise((c,p)=>{function w(L,F){let o=`${L}.nls.${F}.json`;n.SymlinkSupport.existsFile(o).then(A=>{A&&c({localized:o,original:`${L}.nls.json`});let N=F.lastIndexOf("-");N===-1?c({localized:`${L}.nls.json`,original:null}):(F=F.substring(0,N),w(L,F))})}if(i.devMode||i.pseudo||!i.locale)return c({localized:s+".nls.json",original:null});w(s,i.locale)})}static _replaceNLStrings(i,s,c,p,w,L){function F(o,A,N){let Q=o[A];if(d.isString(Q)){let J=Q,ce=J.length;if(ce>1&&J[0]==="%"&&J[ce-1]==="%"){let se=J.substr(1,ce-2),$=c[se];$===void 0&&p&&($=p[se]),$?(i.pseudo&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),o[A]=N&&(A==="title"||A==="category")&&p?{value:$,original:p[se]}:$):w.warn(L,y.localize(5,null,se))}}else if(d.isObject(Q))for(let J in Q)Q.hasOwnProperty(J)&&(J==="commands"?F(Q,J,!0):F(Q,J,N));else if(d.isArray(Q))for(let J=0;J<Q.length;J++)F(Q,J,N)}for(let o in s)s.hasOwnProperty(o)&&F(s,o)}}class h extends S{validate(i){let s=i;s.isBuiltin=this._isBuiltin,s.isUserBuiltin=!this._isBuiltin&&!!s.isUserBuiltin,s.isUnderDevelopment=this._isUnderDevelopment;let c=[];return h.isValidExtensionDescription(this._ourVersion,this._ourProductDate,this._absoluteFolderPath,s,c)?(c.forEach(p=>{this._log.warn(this._absoluteFolderPath,p)}),s.publisher||(s.publisher="undefined_publisher"),s.id=k.getExtensionId(s.publisher,s.name),s.identifier=new m.ExtensionIdentifier(s.id),s.extensionLocation=v.URI.file(this._absoluteFolderPath),s):(c.forEach(p=>{this._log.error(this._absoluteFolderPath,p)}),null)}static isValidExtensionDescription(i,s,c,p,w){return h.baseIsValidExtensionDescription(c,p,w)?g.valid(p.version)?b.isValidExtensionVersion(i,s,p,w):(w.push(y.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(i,s,c){if(!s)return c.push(y.localize(7,null)),!1;if(typeof s.publisher!="undefined"&&typeof s.publisher!="string")return c.push(y.localize(8,null)),!1;if(typeof s.name!="string")return c.push(y.localize(9,null,"name")),!1;if(typeof s.version!="string")return c.push(y.localize(10,null,"version")),!1;if(!s.engines)return c.push(y.localize(11,null,"engines")),!1;if(typeof s.engines.vscode!="string")return c.push(y.localize(12,null,"engines.vscode")),!1;if(typeof s.extensionDependencies!="undefined"&&!h._isStringArray(s.extensionDependencies))return c.push(y.localize(13,null,"extensionDependencies")),!1;if(typeof s.activationEvents!="undefined"){if(!h._isStringArray(s.activationEvents))return c.push(y.localize(14,null,"activationEvents")),!1;if(typeof s.main=="undefined"&&typeof s.browser=="undefined")return c.push(y.localize(15,null,"activationEvents","main")),!1}if(typeof s.main!="undefined"){if(typeof s.main!="string")return c.push(y.localize(16,null,"main")),!1;{const p=D.join(i,s.main);p.startsWith(i)||c.push(y.localize(17,null,p,i))}if(typeof s.activationEvents=="undefined")return c.push(y.localize(18,null,"activationEvents","main")),!1}if(typeof s.browser!="undefined"){if(typeof s.browser!="string")return c.push(y.localize(19,null,"browser")),!1;{const p=D.join(i,s.browser);p.startsWith(i)||c.push(y.localize(20,null,p,i))}if(typeof s.activationEvents=="undefined")return c.push(y.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(i){if(!Array.isArray(i))return!1;for(let s=0,c=i.length;s<c;s++)if(typeof i[s]!="string")return!1;return!0}}class a{constructor(i,s,c,p,w,L,F,o,A){this.ourVersion=i,this.ourProductDate=s,this.commit=c,this.locale=p,this.devMode=w,this.absoluteFolderPath=L,this.isBuiltin=F,this.isUnderDevelopment=o,this.translations=A}static createNLSConfig(i){return{devMode:i.devMode,locale:i.locale,pseudo:i.locale==="pseudo",translations:i.translations}}static equals(i,s){return i.ourVersion===s.ourVersion&&i.ourProductDate===s.ourProductDate&&i.commit===s.commit&&i.locale===s.locale&&i.devMode===s.devMode&&i.absoluteFolderPath===s.absoluteFolderPath&&i.isBuiltin===s.isBuiltin&&i.isUnderDevelopment===s.isUnderDevelopment&&i.mtime===s.mtime&&u.Translations.equals(i.translations,s.translations)}}e.ExtensionScannerInput=a;class l{constructor(i){this.root=i}resolveExtensions(){return n.Promises.readDirsInDir(this.root).then(i=>i.map(s=>({name:s,path:D.join(this.root,s)})))}}class t{static scanExtension(i,s,c,p,w,L,F){return p=D.normalize(p),new E(i,s,c,p,w,L).parse().then(A=>A===null?null:new I(i,s,c,p,w,L,F).replaceNLS(A)).then(A=>A===null?null:new h(i,s,c,p,w,L).validate(A))}static async scanExtensions(i,s,c=null){const p=i.absoluteFolderPath,w=i.isBuiltin,L=i.isUnderDevelopment;c||(c=new l(p));try{let F={};if(!w)try{const J=await n.Promises.readFile(D.join(p,".obsolete"),"utf8");F=JSON.parse(J)}catch(J){}let o=await c.resolveExtensions();o.sort((J,ce)=>J.name<ce.name?-1:1),w||(o=o.filter(J=>J.name.indexOf(".")!==0));const A=a.createNLSConfig(i);let N=await Promise.all(o.map(J=>this.scanExtension(i.ourVersion,i.ourProductDate,s,J.path,w,L,A))),Q=_.coalesce(N);return Q=Q.filter(J=>J!==null&&!F[new k.ExtensionIdentifierWithVersion({id:k.getGalleryExtensionId(J.publisher,J.name)},J.version).key()]),w||(Q=k.groupByExtension(Q,ce=>({id:ce.identifier.value,uuid:ce.uuid})).map(ce=>ce.sort((se,$)=>g.rcompare(se.version,$.version))[0])),Q.sort((J,ce)=>J.extensionLocation.fsPath<ce.extensionLocation.fsPath?-1:1),Q}catch(F){return s.error(p,F),[]}}static scanOneOrMultipleExtensions(i,s){const c=i.absoluteFolderPath,p=i.isBuiltin,w=i.isUnderDevelopment;return n.SymlinkSupport.existsFile(D.join(c,f)).then(L=>{if(L){const F=a.createNLSConfig(i);return this.scanExtension(i.ourVersion,i.ourProductDate,s,c,p,w,F).then(o=>o===null?[]:[o])}return this.scanExtensions(i,s)},L=>(s.error(c,L),[]))}static scanSingleExtension(i,s){const c=i.absoluteFolderPath,p=i.isBuiltin,w=i.isUnderDevelopment,L=a.createNLSConfig(i);return this.scanExtension(i.ourVersion,i.ourProductDate,s,c,p,w,L)}static mergeBuiltinExtensions(i,s){return Promise.all([i,s]).then(([c,p])=>{let w=Object.create(null);for(let F=0,o=c.length;F<o;F++)w[m.ExtensionIdentifier.toKey(c[F].identifier)]=c[F];for(let F=0,o=p.length;F<o;F++)w[m.ExtensionIdentifier.toKey(p[F].identifier)]=p[F];let L=Object.keys(w).map(F=>w[F]);return L.sort((F,o)=>{const A=D.basename(F.extensionLocation.fsPath),N=D.basename(o.extensionLocation.fsPath);return A<N?-1:A>N?1:0}),L})}}e.ExtensionScanner=t}),define(fe[226],he([0,1,5,48,2,40,156,27,8,31,225,44,54,101,60,81,197,4,23]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f,S,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let h=null;function a(){return h||(h=E.normalize(E.join(d.FileAccess.asFileUri("",X).fsPath,"..","extensions"))),h}let l=null;function t(){return l||(l=E.normalize(E.join(d.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions"))),l}class r{constructor(s,c,p,w,L,F){this._connectionToken=s,this.environmentService=c,this.logService=w,this.telemetryService=L,this.telemetryAppender=F,this._logger=new class{error(A,N){w.error(A,N)}warn(A,N){w.warn(A,N)}info(A,N){w.info(A,N)}},c.args["install-builtin-extension"]?this.whenExtensionsReady=p.installExtensions([],c.args["install-builtin-extension"],!!c.args["do-not-sync"],!!c.args.force).then(null,A=>{w.error(A)}):this.whenExtensionsReady=Promise.resolve();const o=c.args["install-extension"];if(o){const A=o.map(N=>/\.vsix$/i.test(N)?g.URI.file(E.isAbsolute(N)?N:E.join(I.cwd(),N)):N);this.whenExtensionsReady.then(()=>p.installExtensions(A,[],!!c.args["do-not-sync"],!!c.args.force)).then(null,N=>{w.error(N)})}}async call(s,c,p){switch(c){case"disableTelemetry":{this.telemetryService.setEnabled(!1);return}case"getEnvironmentData":{const w=p,L=C.createRemoteURITransformer(w.remoteAuthority);let F=await this._getEnvironmentData();return F=b.transformOutgoingURIs(F,L),F}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const w=p,L=w.language;this.logService.trace(`Scanning extensions using UI language: ${L}`);const F=C.createRemoteURITransformer(w.remoteAuthority),o=w.extensionDevelopmentPath&&w.extensionDevelopmentPath.map(Q=>g.URI.revive(F.transformIncoming(Q))),A=o?o.filter(Q=>Q.scheme===d.Schemas.file).map(Q=>Q.fsPath):void 0;let N=await this._scanExtensions(L,A);return N=b.transformOutgoingURIs(N,F),this.logService.trace("Scanned Extensions",N),r._massageWhenConditions(N),N}case"scanSingleExtension":{await this.whenExtensionsReady;const w=p,L=w.language,F=w.isBuiltin,o=C.createRemoteURITransformer(w.remoteAuthority),A=g.URI.revive(o.transformIncoming(w.extensionLocation)),N=A.scheme===d.Schemas.file?A.fsPath:null;if(!N)return null;const Q=await this._getTranslations(L);let J=await this._scanSingleExtension(N,F,L,Q);return J?(J=b.transformOutgoingURIs(J,o),r._massageWhenConditions([J]),J):null}case"getDiagnosticInfo":{const w=p,L={machineInfo:S.getMachineInfo()},F=w.includeProcesses?f.listProcesses(process.pid):Promise.resolve();let o=[];const A={};if(w.folders){const N=C.createRemoteURITransformer("");o=w.folders.map(J=>g.URI.revive(N.transformIncoming(J))).filter(J=>J.scheme==="file").map(J=>S.collectWorkspaceStats(J.fsPath,["node_modules",".git"]).then(ce=>{A[E.basename(J.fsPath)]=ce}))}return Promise.all([F,...o]).then(([N,Q])=>(L.processes=N||void 0,L.workspaceMetadata=w.folders?A:void 0,L))}case"logTelemetry":{const{eventName:w,data:L}=p;return this.telemetryAppender?this.telemetryAppender.log(w,L):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${c} not found`)}listen(s,c,p){throw new Error("Not supported")}static _massageWhenConditions(s){const c=(A,N)=>A.replace(/file/g,"vscode-remote"),p=A=>{let N="";return N+=A.global?"g":"",N+=A.ignoreCase?"i":"",N+=A.multiline?"m":"",new RegExp(c(A.source,!0),N)},w=new class{mapDefined(A){return u.ContextKeyDefinedExpr.create(A)}mapNot(A){return u.ContextKeyNotExpr.create(A)}mapEquals(A,N){return A==="resourceScheme"&&typeof N=="string"?u.ContextKeyEqualsExpr.create(A,c(N,!1)):u.ContextKeyEqualsExpr.create(A,N)}mapNotEquals(A,N){return A==="resourceScheme"&&typeof N=="string"?u.ContextKeyNotEqualsExpr.create(A,c(N,!1)):u.ContextKeyNotEqualsExpr.create(A,N)}mapGreater(A,N){return u.ContextKeyGreaterExpr.create(A,N)}mapGreaterEquals(A,N){return u.ContextKeyGreaterEqualsExpr.create(A,N)}mapSmaller(A,N){return u.ContextKeySmallerExpr.create(A,N)}mapSmallerEquals(A,N){return u.ContextKeySmallerEqualsExpr.create(A,N)}mapRegex(A,N){return A==="resourceScheme"&&N?u.ContextKeyRegexExpr.create(A,p(N)):u.ContextKeyRegexExpr.create(A,N)}mapIn(A,N){return u.ContextKeyInExpr.create(A,N)}},L=A=>{if(!A||!A.when||!/resourceScheme/.test(A.when))return;const N=u.ContextKeyExpr.deserialize(A.when);if(!N)return;const Q=N.map(w);A.when=Q.serialize()},F=A=>{if(Array.isArray(A))for(let N of A)L(N);else L(A)},o=A=>{for(let N in A)F(A[N])};s.forEach(A=>{A.contributes&&(A.contributes.menus&&o(A.contributes.menus),A.contributes.keybindings&&F(A.contributes.keybindings),A.contributes.views&&o(A.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken,appRoot:g.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:g.URI.file(this.environmentService.logsPath),extensionsPath:g.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:g.URI.file(E.join(this.environmentService.logsPath,`exthost${r._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:y.OS,marks:D.getMarks(),useHostProxy:this.environmentService.args["use-host-proxy"]!==void 0}}async _getTranslations(s){const c=await m.getNLSConfiguration(s,this.environmentService.userDataPath);if(m.InternalNLSConfiguration.is(c))try{const p=await P.promises.readFile(c._translationsConfigFile,"utf8");return JSON.parse(p)}catch(p){return Object.create(null)}else return Object.create(null)}async _scanExtensions(s,c){const p=await this._getTranslations(s),[w,L,F]=await Promise.all([this._scanBuiltinExtensions(s,p),this._scanInstalledExtensions(s,p),this._scanDevelopedExtensions(s,p,c)]);let o=new Map;w.forEach(N=>{!N||o.set(k.ExtensionIdentifier.toKey(N.identifier),N)}),L.forEach(N=>{!N||(o.has(k.ExtensionIdentifier.toKey(N.identifier))&&console.warn(_.localize(0,null,o.get(k.ExtensionIdentifier.toKey(N.identifier)).extensionLocation.fsPath,N.extensionLocation.fsPath)),o.set(k.ExtensionIdentifier.toKey(N.identifier),N))}),F.forEach(N=>{!N||o.set(k.ExtensionIdentifier.toKey(N.identifier),N)});const A=[];return o.forEach(N=>A.push(N)),A}_scanDevelopedExtensions(s,c,p){if(p){const w=p.map(L=>n.ExtensionScanner.scanOneOrMultipleExtensions(new n.ExtensionScannerInput(v.default.version,v.default.date,v.default.commit,s,!0,L,!1,!0,c),this._logger));return Promise.all(w).then(L=>{let F=[];for(let o of L)F=F.concat(o);return F})}return Promise.resolve([])}_scanBuiltinExtensions(s,c){const p=v.default.version,w=v.default.commit,L=v.default.date,F=!!process.env.VSCODE_DEV,o=new n.ExtensionScannerInput(p,L,w,s,F,a(),!0,!1,c),A=n.ExtensionScanner.scanExtensions(o,this._logger);let N=A;if(F){class Q{constructor(q){this.builtInExtensions=q}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(q=>({name:q.name,path:E.join(t(),q.name)})))}}const J=Promise.resolve(v.default.builtInExtensions||[]),ce=new n.ExtensionScannerInput(p,L,w,s,F,t(),!0,!1,{}),se=J.then($=>new Q($)).then($=>n.ExtensionScanner.scanExtensions(ce,this._logger,$));N=n.ExtensionScanner.mergeBuiltinExtensions(A,se)}return N}_scanInstalledExtensions(s,c){const p=!!process.env.VSCODE_DEV,w=new n.ExtensionScannerInput(v.default.version,v.default.date,v.default.commit,s,p,this.environmentService.extensionsPath,!1,!1,c);return n.ExtensionScanner.scanExtensions(w,this._logger)}_scanSingleExtension(s,c,p,w){const L=!!process.env.VSCODE_DEV,F=new n.ExtensionScannerInput(v.default.version,v.default.date,v.default.commit,p,L,s,c,!1,w);return n.ExtensionScanner.scanSingleExtension(F,this._logger)}}e.RemoteAgentEnvironmentChannel=r,r._namePool=1}),define(fe[227],he([0,1,169]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProvider=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class D extends y.IPCFileSystemProvider{constructor(C){super(C.getConnection().getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME));this.setCaseSensitive(!0),(async()=>{const _=await C.getEnvironment();this.setCaseSensitive(_?.os===3)})()}}e.RemoteFileSystemProvider=D}),define(fe[105],he([0,1,6]),function(X,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=y.createDecorator("remoteAgentService")}),define(fe[70],he([0,1,137,4,27,14,15,241,242,11]),function(X,e,y,D,g,C,_,P,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function k(l){const t=l.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function b(l){if(l instanceof n)return l;let t;return/end of central directory record signature not found/.test(l.message)&&(t="CorruptZip"),new n(t,l)}function m(l,t,r,i,s,c){const p=D.dirname(t),w=D.join(i,p);if(!w.startsWith(i))return Promise.reject(new Error(y.localize(0,null,t)));const L=D.join(i,t);let F;return c.onCancellationRequested(()=>{F&&F.destroy()}),Promise.resolve(_.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((o,A)=>{if(!c.isCancellationRequested)try{F=g.createWriteStream(L,{mode:r}),F.once("close",()=>o()),F.once("error",A),l.once("error",A),l.pipe(F)}catch(N){A(N)}}))}function u(l,t,r,i){let s=C.createCancelablePromise(()=>Promise.resolve()),c=0;return i.onCancellationRequested(()=>{s.cancel(),l.close()}),new Promise((p,w)=>{const L=new C.Sequencer,F=o=>{o.isCancellationRequested||(c++,l.readEntry())};l.once("error",w),l.once("close",()=>s.then(()=>{i.isCancellationRequested||l.entryCount===c?p():w(new n("Incomplete",new Error(y.localize(1,null,c,l.entryCount))))},w)),l.readEntry(),l.on("entry",o=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(o.fileName)){F(i);return}const A=o.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(A)){const J=D.join(t,A);s=C.createCancelablePromise(ce=>_.Promises.mkdir(J,{recursive:!0}).then(()=>F(ce)).then(void 0,w));return}const N=S(l,o),Q=k(o);s=C.createCancelablePromise(J=>L.queue(()=>N.then(ce=>m(ce,A,Q,t,r,J).then(()=>F(J)))).then(null,w))})})}function f(l,t=!1){return new Promise((r,i)=>{P.open(l,t?{lazyEntries:!0}:void 0,(s,c)=>{s?i(b(s)):r(v.assertIsDefined(c))})})}function S(l,t){return new Promise((r,i)=>{l.openReadStream(t,(s,c)=>{s?i(b(s)):r(v.assertIsDefined(c))})})}function E(l,t){return new Promise((r,i)=>{const s=new d.ZipFile;t.forEach(p=>{p.contents?s.addBuffer(typeof p.contents=="string"?Buffer.from(p.contents,"utf8"):p.contents,p.path):p.localPath&&s.addFile(p.localPath,p.path)}),s.end();const c=g.createWriteStream(l);s.outputStream.pipe(c),s.outputStream.once("error",i),c.once("error",i),c.once("finish",()=>r(l))})}e.zip=E;function I(l,t,r={},i){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=f(l,!0);return r.overwrite&&(c=c.then(p=>_.Promises.rm(t).then(()=>p))),c.then(p=>u(p,t,{sourcePathRegex:s},i))}e.extract=I;function h(l,t){return f(l).then(r=>new Promise((i,s)=>{r.on("entry",c=>{c.fileName===t&&S(r,c).then(p=>i(p),p=>s(p))}),r.once("close",()=>s(new Error(y.localize(2,null,t))))}))}function a(l,t){return h(l,t).then(r=>new Promise((i,s)=>{const c=[];r.once("error",s),r.on("data",p=>c.push(p)),r.on("end",()=>i(Buffer.concat(c)))}))}e.buffer=a}),define(fe[228],he([0,1,70,144]),function(X,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function g(C){return y.buffer(C,"extension/package.json").then(_=>{try{return JSON.parse(_.toString("utf8"))}catch(P){throw new Error(D.localize(0,null))}})}e.getManifest=g}),define(fe[229],he([0,1,49,3,15,4,16,33,34,14,2,28,168,145,45,70,5,21,8,20,19,22,12]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f,S,E,I,h,a,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",s="extracting",c="deleting",p="renaming";let w=class extends D.Disposable{constructor(F,o,A,N,Q){super();this.beforeRemovingExtension=F,this.fileService=o,this.logService=A,this.environmentService=N,this.productService=Q,this._devSystemExtensionsPath=null,this.systemExtensionsPath=N.builtinExtensionsPath,this.extensionsPath=N.extensionsPath,this.uninstalledPath=C.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new v.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(F){const o=[];(F===null||F===0)&&o.push(this.scanSystemExtensions().then(null,A=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(A).message,r)))),(F===null||F===1)&&o.push(this.scanUserExtensions(!0).then(null,A=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(A).message,i))));try{const A=await Promise.all(o);return E.flatten(A)}catch(A){throw this.joinErrors(A)}}async scanUserExtensions(F){this.logService.trace("Started scanning user extensions");let[o,A]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return A=A.filter(N=>!o[new d.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).key()]),F&&(A=d.groupByExtension(A,Q=>Q.identifier).map(Q=>Q.sort((J,ce)=>y.rcompare(J.manifest.version,ce.manifest.version))[0])),this.logService.trace("Scanned user extensions:",A.length),A}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(F,o,A){const N=F.key(),Q=C.join(this.extensionsPath,`.${l.generateUuid()}`),J=C.join(this.extensionsPath,N);try{await g.Promises.rm(J)}catch(se){try{await g.Promises.rm(J)}catch($){}throw new P.ExtensionManagementError(m.localize(0,null,J,F.id),c)}await this.extractAtLocation(F,o,Q,A);let ce=await this.scanExtension(n.URI.file(Q),1);if(!ce)throw new Error(m.localize(1,null,Q));await this.storeMetadata(ce,{installedTimestamp:Date.now()});try{await this.rename(F,Q,J,Date.now()+2*60*1e3),this.logService.info("Renamed to",J)}catch(se){try{await g.Promises.rm(Q)}catch($){}if(se.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.logService.info(`Rename failed because of ${t.getErrorMessage(se)}. Deleted from extracted location`,Q),se}try{ce=await this.scanExtension(n.URI.file(J),1)}catch(se){}if(ce)return ce;throw new Error(m.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(F,o){return this.setMetadata(F,o),await this.storeMetadata(F,{...o,installedTimestamp:F.installedTimestamp}),F}async storeMetadata(F,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const A=C.join(F.location.fsPath,"package.json"),N=await g.Promises.readFile(A,"utf8"),{manifest:Q}=await this.parseManifest(N);return Q.__metadata=o,await g.Promises.writeFile(A,JSON.stringify(Q,null,"	")),F}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...F){const o=F.map(A=>new d.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version));await this.withUninstalledExtensions(A=>{o.forEach(N=>A[N.key()]=!0)})}async setInstalled(F){await this.withUninstalledExtensions(N=>delete N[F.key()]);const A=(await this.scanExtensions(1)).find(N=>new d.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(F))||null;return A?(await this.storeMetadata(A,{installedTimestamp:Date.now()}),this.scanExtension(A.location,1)):null}async withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await g.Promises.readFile(this.uninstalledPath,"utf8")}catch(N){if(N.code!=="ENOENT")throw N}let A={};if(o)try{A=JSON.parse(o)}catch(N){}return F&&(F(A),Object.keys(A).length?await g.Promises.writeFile(this.uninstalledPath,JSON.stringify(A)):await g.Promises.rm(this.uninstalledPath)),A})}async removeExtension(F,o){this.logService.trace(`Deleting ${o} extension from disk`,F.identifier.id,F.location.fsPath),await g.Promises.rm(F.location.fsPath),this.logService.info("Deleted from disk",F.identifier.id,F.location.fsPath)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new d.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()])}async extractAtLocation(F,o,A,N){this.logService.trace(`Started extracting the extension from ${o} to ${A}`);try{await g.Promises.rm(A)}catch(Q){throw new P.ExtensionManagementError(this.joinErrors(Q).message,c)}try{await f.extract(o,A,{sourcePath:"extension",overwrite:!0},N),this.logService.info(`Extracted extension to ${A}:`,F.id)}catch(Q){try{await g.Promises.rm(A)}catch(J){}throw new P.ExtensionManagementError(Q.message,Q instanceof f.ExtractError&&Q.type?Q.type:s)}}async rename(F,o,A,N){try{await g.Promises.rename(o,A)}catch(Q){if(S.isWindows&&Q&&Q.code==="EPERM"&&Date.now()<N)return this.logService.info(`Failed renaming ${o} to ${A} with 'EPERM' error. Trying again...`,F.id),this.rename(F,o,A,N);throw new P.ExtensionManagementError(Q.message||m.localize(3,null,o,A),Q.code||p)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const F=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return F;const o=this.scanDevSystemExtensions(),[A,N]=await Promise.all([F,o]);return[...A,...N]}async scanExtensionsInDir(F,o){const A=new v.Limiter(10),N=await this.fileService.resolve(n.URI.file(F));return N.children?(await Promise.all(N.children.filter(J=>J.isDirectory).map(J=>A.queue(async()=>o===1&&a.basename(J.resource).indexOf(".")===0?null:this.scanExtension(J.resource,o))))).filter(J=>J&&J.identifier):[]}async scanExtension(F,o){try{const A=await this.fileService.resolve(F);if(A.children){const{manifest:N,metadata:Q}=await this.readManifest(F.fsPath),J=A.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,ce=A.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource,se={id:d.getGalleryExtensionId(N.publisher,N.name)},$={type:o,identifier:se,manifest:N,location:F,readmeUrl:J,changelogUrl:ce,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return Q&&(this.setMetadata($,Q),$.installedTimestamp=Q.installedTimestamp),$}}catch(A){o!==0&&this.logService.trace(A)}return null}async scanDefaultSystemExtensions(){const F=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",F.length),F}async scanDevSystemExtensions(){const F=this.getDevSystemExtensionsList();if(F.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(A=>F.some(N=>d.areSameExtensions(A.identifier,{id:N})))}else return[]}setMetadata(F,o){F.publisherDisplayName=o.publisherDisplayName||null,F.publisherId=o.publisherId||null,F.identifier.uuid=o.id,F.isMachineScoped=!!o.isMachineScoped,F.isBuiltin=F.type===0||!!o.isBuiltin}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),A=new Set;for(const J of o)F[new d.ExtensionIdentifierWithVersion(J.identifier,J.manifest.version).key()]||A.add(J.identifier.id.toLowerCase());const N=d.groupByExtension(o,J=>J.identifier);await v.Promises.settled(N.map(async J=>{const ce=J.sort((se,$)=>y.rcompare(se.manifest.version,$.manifest.version))[0];A.has(ce.identifier.id.toLowerCase())||await this.beforeRemovingExtension(ce)}));const Q=o.filter(J=>F[new d.ExtensionIdentifierWithVersion(J.identifier,J.manifest.version).key()]);await v.Promises.settled(Q.map(J=>this.removeUninstalledExtension(J)))}async removeOutdatedExtensions(){const F=await this.scanAllUserExtensions(),o=[],A=d.groupByExtension(F,N=>N.identifier);o.push(...E.flatten(A.map(N=>N.sort((Q,J)=>y.rcompare(Q.manifest.version,J.manifest.version)).slice(1)))),await v.Promises.settled(o.map(N=>this.removeExtension(N,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(F=>F.name)}joinErrors(F){const o=Array.isArray(F)?F:[F];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((A,N)=>new Error(`${A.message}${A.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=C.normalize(C.join(I.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(F){const o=[g.Promises.readFile(C.join(F,"package.json"),"utf8").then(J=>this.parseManifest(J)),g.Promises.readFile(C.join(F,"package.nls.json"),"utf8").then(void 0,J=>J.code!=="ENOENT"?Promise.reject(J):"{}").then(J=>JSON.parse(J))],[{manifest:A,metadata:N},Q]=await Promise.all(o);return{manifest:b.localizeManifest(A,Q),metadata:N}}parseManifest(F){return new Promise((o,A)=>{try{const N=JSON.parse(F),Q=N.__metadata||null;o({manifest:N,metadata:Q})}catch(N){A(new Error(m.localize(4,null)))}})}};w=Ne([Ke(1,h.IFileService),Ke(2,_.ILogService),Ke(3,k.INativeEnvironmentService),Ke(4,u.IProductService)],w),e.ExtensionsScanner=w}),define(fe[106],he([0,1,143,4,15,3,21,70,33,34,28,14,7,49,2,31,5,16,179,43,39,58,19,22,85,6,8,25,228,183,229,184,185,20]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f,S,E,I,h,a,l,t,r,i,s,c,p,w,L,F,o,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const Q="unsetUninstalled",J="downloading",ce="validating",se="local",$="cancelled",q="unknown";let W=class extends C.Disposable{constructor(T,R,M,z,j,ee,me){super();this.environmentService=T,this.galleryService=R,this.logService=M,this.downloadService=z,this.telemetryService=j,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new b.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new b.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onDidInstallExtensions=this._register(new b.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new b.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new b.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const ge=this._register(ee.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(ee.createInstance(F.ExtensionsScanner,Ie=>ge.postUninstall(Ie))),this.manifestCache=this._register(new I.ExtensionsManifestCache(T,this)),this.extensionsDownloader=this._register(ee.createInstance(L.ExtensionsDownloader));const be=this._register(new A.ExtensionsWatcher(this,me,T,M));this._register(be.onDidChangeExtensionsByAnotherSource(({added:Ie,removed:Ae})=>{Ie.forEach(Fe=>this._onDidInstallExtension.fire({identifier:Fe.identifier,operation:0,local:Fe})),Ae.forEach(Fe=>this._onDidUninstallExtension.fire({identifier:Fe}))})),this._register(C.toDisposable(()=>{this.installingExtensions.forEach(Ie=>Ie.cancel()),this.uninstallingExtensions.forEach(Ie=>Ie.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(T){this.logService.trace("ExtensionManagementService#zip",T.identifier.id);const R=await this.collectFiles(T),M=await P.zip(t.joinPath(this.environmentService.tmpDir,r.generateUuid()).fsPath,R);return u.URI.file(M)}async unzip(T){return this.logService.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const R=await this.downloadVsix(T),M=D.resolve(R.fsPath);return w.getManifest(M)}async collectFiles(T){const R=async z=>{let j=await g.Promises.readdir(z);j=j.map(ge=>D.join(z,ge));const ee=await Promise.all(j.map(ge=>g.Promises.stat(ge)));let me=Promise.resolve([]);return ee.forEach((ge,be)=>{const Ie=j[be];ge.isFile()&&(me=me.then(Ae=>[...Ae,Ie])),ge.isDirectory()&&(me=me.then(Ae=>R(Ie).then(Fe=>[...Ae,...Fe])))}),me};return(await R(T.location.fsPath)).map(z=>({path:`extension/${D.relative(T.location.fsPath,z)}`,localPath:z}))}async install(T,R={}){return this.logService.trace("ExtensionManagementService#install",T.toString()),k.createCancelablePromise(async M=>{const z=await this.downloadVsix(T),j=D.resolve(z.fsPath),ee=await w.getManifest(j),me={id:v.getGalleryExtensionId(ee.publisher,ee.name)};let ge=1;if(ee.engines&&ee.engines.vscode&&!l.isEngineValid(ee.engines.vscode,f.default.version,f.default.date))throw new Error(y.localize(0,null,me.id,f.default.version));const be=new v.ExtensionIdentifierWithVersion(me,ee.version),Ae=(await this.getInstalled(1)).find($e=>v.areSameExtensions(me,$e.identifier));if(Ae)if(R.isMachineScoped=R.isMachineScoped||Ae.isMachineScoped,R.isBuiltin=R.isBuiltin||Ae.isBuiltin,ge=2,be.equals(new v.ExtensionIdentifierWithVersion(Ae.identifier,Ae.manifest.version)))try{await this.extensionsScanner.removeExtension(Ae,"existing")}catch($e){throw new Error(y.localize(1,null,ee.displayName||ee.name))}else m.gt(Ae.manifest.version,ee.version)&&await this.uninstallExtension(Ae);else{const $e=await this.unsetUninstalledAndGetLocal(be);if($e)try{await this.extensionsScanner.removeExtension($e,"existing")}catch(Qe){throw new Error(y.localize(2,null,ee.displayName||ee.name))}}this.logService.info("Installing the extension:",me.id),this._onInstallExtension.fire({identifier:me,zipPath:j});let Fe;try{Fe=await this.getGalleryMetadata(v.getGalleryExtensionId(ee.publisher,ee.name))}catch($e){}try{const $e=await this.installFromZipPath(be,j,R.installOnlyNewlyAddedFromExtensionPack?Ae:void 0,{...Fe||{},...R},R,ge,M);return this.logService.info("Successfully installed the extension:",me.id),$e}catch($e){throw this.logService.error("Failed to install the extension:",me.id,$e.message),$e}})}async downloadVsix(T){if(T.scheme===c.Schemas.file)return T;if(!this.downloadService)throw new Error("Download service is not available");const R=t.joinPath(this.environmentService.tmpDir,r.generateUuid());return await this.downloadService.download(T,R),R}async installFromZipPath(T,R,M,z,j,ee,me){try{const ge=await this.installExtension({zipPath:R,identifierWithVersion:T,metadata:z},me);try{j.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(ge,M,j)}catch(be){_.isNonEmptyArray(ge.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",ge.identifier.id,be.message),_.isNonEmptyArray(ge.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",ge.identifier.id,be.message)}return this._onDidInstallExtension.fire({identifier:T,zipPath:R,local:ge,operation:ee}),ge}catch(ge){throw this._onDidInstallExtension.fire({identifier:T,zipPath:R,operation:ee,error:ge}),ge}}async canInstall(T){return!0}async installFromGallery(T,R={}){if(!this.galleryService.isEnabled())throw new Error(y.localize(3,null));try{T=await this.checkAndGetCompatibleVersion(T)}catch(z){const j=z&&z.code?z.code:q;throw this.logService.error("Failed to install extension:",T.identifier.id,z?z.message:j),this.reportTelemetry(this.getTelemetryEvent(1),v.getGalleryExtensionTelemetryData(T),void 0,z),z instanceof Error&&(z.name=j),z}let M=this.installingExtensions.get(new v.ExtensionIdentifierWithVersion(T.identifier,T.version).key());if(M)return this.logService.info("Extensions is already requested to install",T.identifier.id),(await M.resultPromise).local;{const z=["ms-python.python","ms-python.vscode-pylance"].includes(T.identifier.id.toLowerCase());return M=this.createInstallFromGalleryExtensionTask(T,R,z),(await this.runInstallGalleryExtensionTask(M,R,z)).local}}createInstallFromGalleryExtensionTask(T,R,M){const z=new v.ExtensionIdentifierWithVersion(T.identifier,T.version).key();this._onInstallExtension.fire({identifier:T.identifier,gallery:T}),this.logService.info("Installing extension:",T.identifier.id);let j;const ee=new k.Barrier,me={extension:T,get resultPromise(){return ee.wait().then(()=>j)},run:async()=>(j||(j=k.createCancelablePromise(async ge=>{try{const be=await this.installGalleryExtension(T,R,ge);return this.logService.info("Extensions installed successfully:",T.identifier.id),this._onDidInstallExtension.fire({identifier:T.identifier,gallery:be.gallery,local:be.local,operation:be.operation,isBulkInstall:M}),be}catch(be){const Ie=be&&be.code?be.code:q;throw this.logService.error("Failed to install extension:",T.identifier.id,be?be.message:Ie),this._onDidInstallExtension.fire({identifier:T.identifier,gallery:T,operation:1,error:Ie}),be instanceof Error&&(be.name=Ie),be}})),ee.open(),j.finally(()=>this.installingExtensions.delete(z)),j),cancel:()=>{j?j.cancel():this._onDidInstallExtension.fire({identifier:T.identifier,gallery:T,operation:1,error:$})}};return this.installingExtensions.set(z,me),me}async runInstallGalleryExtensionTask(T,R,M){if(R.donotIncludePackAndDependencies)return this.logService.info("Installing the extension without checking dependencies and pack",T.extension.identifier.id),T.run();const z=new Map,j=[];try{const ee=await this.galleryService.getManifest(T.extension,p.CancellationToken.None);if(ee===null){const Ie=new d.ExtensionManagementError(`Missing manifest for extension ${T.extension.identifier.id}`,ce);throw this.logService.error("Failed to install extension:",T.extension.identifier.id,Ie.message),Ie}z.set(T.extension.identifier.id.toLowerCase(),{task:T,manifest:ee});const me=await this.getAllDepsAndPackExtensionsToInstall(T.extension.identifier,ee,p.CancellationToken.None);let ge=!1;for(const{gallery:Ie,manifest:Ae}of me)if(ge=ge||!!Ae.extensionDependencies?.some(Fe=>v.areSameExtensions({id:Fe},T.extension.identifier)),this.installingExtensions.has(new v.ExtensionIdentifierWithVersion(Ie.identifier,Ie.version).key()))this.logService.info("Extension is already requested to install",Ie.identifier.id);else{const Fe=this.createInstallFromGalleryExtensionTask(Ie,{...R,donotIncludePackAndDependencies:!0},M);z.set(Ie.identifier.id.toLowerCase(),{task:Fe,manifest:Ae})}for(;z.size;){const Ie=[...z.values()].filter(({manifest:Fe})=>!Fe.extensionDependencies?.some($e=>z.has($e.toLowerCase())));let Ae;Ie.length?Ae=z.size===1?Ie:Ie.filter(({task:Fe})=>!(Fe===T&&!ge)):(this.logService.info("Found extensions with circular dependencies",Ie.map(({task:Fe})=>Fe.extension.identifier.id)),Ae=[...z.values()]),await Promise.all(Ae.map(async({task:Fe})=>{j.push(await Fe.run()),z.delete(Fe.extension.identifier.id.toLowerCase())}))}const be=j.find(({local:Ie})=>v.areSameExtensions(Ie.identifier,T.extension.identifier));if(be)return be;throw new Error("Extension is not installed")}catch(ee){throw z.size?z.forEach(({task:me})=>me.cancel()):T.cancel(),ee}finally{j.length&&M&&this._onDidInstallExtensions.fire(j.map(({gallery:ee,local:me,operation:ge})=>({identifier:me.identifier,gallery:ee,local:me,operation:ge})))}}async installGalleryExtension(T,R,M){const z=new Date().getTime();let j=1;try{const me=(await this.getInstalled()).find(Ie=>v.areSameExtensions(Ie.identifier,T.identifier));me&&(j=2);const ge=await this.downloadInstallableExtension(T,j);ge.metadata.isMachineScoped=R.isMachineScoped||me?.isMachineScoped,ge.metadata.isBuiltin=R.isBuiltin||me?.isBuiltin;const be=await this.installExtension(ge,M);me&&m.neq(me.manifest.version,T.version)&&await this.extensionsScanner.setUninstalled(me);try{await this.extensionsDownloader.delete(u.URI.file(ge.zipPath))}catch(Ie){}return this.reportTelemetry(this.getTelemetryEvent(j),v.getGalleryExtensionTelemetryData(T),new Date().getTime()-z,void 0),{local:be,operation:j,gallery:T}}catch(ee){throw this.reportTelemetry(this.getTelemetryEvent(j),v.getGalleryExtensionTelemetryData(T),new Date().getTime()-z,ee),ee}}async getAllDepsAndPackExtensionsToInstall(T,R,M){let z=await this.getInstalled();const j=[T,...z.map(ge=>ge.identifier)],ee=[],me=async(ge,be)=>{const Ie=be.extensionDependencies||[];if(be.extensionPack){const Ae=z.find(Fe=>v.areSameExtensions(Fe.identifier,ge));for(const Fe of be.extensionPack)Ae&&Ae.manifest.extensionPack&&Ae.manifest.extensionPack.some($e=>v.areSameExtensions({id:$e},{id:Fe}))||Ie.every($e=>!v.areSameExtensions({id:$e},{id:Fe}))&&Ie.push(Fe)}if(Ie.length){const Ae=[...j,...ee.map($e=>$e.gallery.identifier)],Fe=Ie.filter($e=>Ae.every(Qe=>!v.areSameExtensions(Qe,{id:$e})));if(Fe.length){const $e=await this.galleryService.query({names:Fe,pageSize:Ie.length},p.CancellationToken.None);for(const Qe of $e.firstPage){if(Ae.find(nt=>v.areSameExtensions(nt,Qe.identifier)))continue;const Ze=await this.checkAndGetCompatibleVersion(Qe),tt=await this.galleryService.getManifest(Ze,p.CancellationToken.None);if(tt===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${Ze.identifier.id}`,ce);ee.push({gallery:Ze,manifest:tt}),await me(Ze.identifier,tt)}}}};return await me(T,R),z=await this.getInstalled(),ee.filter(ge=>!z.some(be=>v.areSameExtensions(be.identifier,ge.gallery.identifier)))}async checkAndGetCompatibleVersion(T){if(await this.isMalicious(T))throw new d.ExtensionManagementError(y.localize(4,null),d.INSTALL_ERROR_MALICIOUS);const R=await this.galleryService.getCompatibleExtension(T);if(!R)throw new d.ExtensionManagementError(y.localize(5,null,T.identifier.id,f.default.version),d.INSTALL_ERROR_INCOMPATIBLE);return R}async reinstallFromGallery(T){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.galleryService.isEnabled())throw new Error(y.localize(6,null));const R=await this.findGalleryExtension(T);if(!R)throw new Error(y.localize(7,null));await this.extensionsScanner.setUninstalled(T);try{await this.extensionsScanner.removeUninstalledExtension(T)}catch(M){throw new Error(y.localize(8,null,h.toErrorMessage(M)))}await this.installFromGallery(R)}getTelemetryEvent(T){return T===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(T){const R=await this.getExtensionsReport();return v.getMaliciousExtensionsSet(R).has(T.identifier.id)}async downloadInstallableExtension(T,R){const M={id:T.identifier.uuid,publisherId:T.publisherId,publisherDisplayName:T.publisherDisplayName};let z;try{this.logService.trace("Started downloading extension:",T.identifier.id),z=(await this.extensionsDownloader.downloadExtension(T,R)).fsPath,this.logService.info("Downloaded extension:",T.identifier.id,z)}catch(j){throw new d.ExtensionManagementError(this.joinErrors(j).message,J)}try{const j=await w.getManifest(z);return{zipPath:z,identifierWithVersion:new v.ExtensionIdentifierWithVersion(T.identifier,j.version),metadata:M}}catch(j){throw new d.ExtensionManagementError(this.joinErrors(j).message,ce)}}async installExtension(T,R){try{const M=await this.unsetUninstalledAndGetLocal(T.identifierWithVersion);if(M)return T.metadata?this.extensionsScanner.saveMetadataForLocalExtension(M,T.metadata):M}catch(M){throw S.isMacintosh?new d.ExtensionManagementError(y.localize(9,null),Q):new d.ExtensionManagementError(y.localize(10,null),Q)}return this.extractAndInstall(T,R)}async unsetUninstalledAndGetLocal(T){if(!await this.isUninstalled(T))return null;this.logService.trace("Removing the extension from uninstalled list:",T.id);const M=await this.extensionsScanner.setInstalled(T);return this.logService.info("Removed the extension from uninstalled list:",T.id),M}async extractAndInstall({zipPath:T,identifierWithVersion:R,metadata:M},z){let j=await this.extensionsScanner.extractUserExtension(R,T,z);return this.logService.info("Installation completed.",R.id),M&&(j=await this.extensionsScanner.saveMetadataForLocalExtension(j,M)),j}async installDependenciesAndPackExtensions(T,R,M){if(!this.galleryService.isEnabled())return;const z=T.manifest.extensionDependencies||[];if(T.manifest.extensionPack)for(const j of T.manifest.extensionPack)R&&R.manifest.extensionPack&&R.manifest.extensionPack.some(ee=>v.areSameExtensions({id:ee},{id:j}))||z.every(ee=>!v.areSameExtensions({id:ee},{id:j}))&&z.push(j);if(z.length){const j=await this.getInstalled(),ee=z.filter(me=>j.every(({identifier:ge})=>!v.areSameExtensions(ge,{id:me})));if(ee.length){const ge=(await this.galleryService.query({names:ee,pageSize:z.length},p.CancellationToken.None)).firstPage;try{await k.Promises.settled(ge.map(be=>this.installFromGallery(be,M)))}catch(be){try{await this.rollback(ge)}catch(Ie){}throw be}}}}async rollback(T){const M=(await this.getInstalled(1)).filter(z=>T.some(j=>new v.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).equals(new v.ExtensionIdentifierWithVersion(j.identifier,j.version))));await k.Promises.settled(M.map(z=>this.uninstall(z)))}async uninstall(T,R={}){this.logService.trace("ExtensionManagementService#uninstall",T.identifier.id);const M=await this.getInstalled(1),z=M.find(j=>v.areSameExtensions(j.identifier,T.identifier));if(!z)throw new Error(y.localize(11,null,T.manifest.displayName||T.manifest.name));try{await this.checkForDependenciesAndUninstall(z,M,R)}catch(j){throw this.joinErrors(j)}}async updateMetadata(T,R){return this.logService.trace("ExtensionManagementService#updateMetadata",T.identifier.id),T=await this.extensionsScanner.saveMetadataForLocalExtension(T,{...T.manifest.__metadata||{},...R}),this.manifestCache.invalidate(),T}async updateExtensionScope(T,R){return this.logService.trace("ExtensionManagementService#updateExtensionScope",T.identifier.id),T=await this.extensionsScanner.saveMetadataForLocalExtension(T,{...T.manifest.__metadata||{},isMachineScoped:R}),this.manifestCache.invalidate(),T}async getGalleryMetadata(T){const R=await this.findGalleryExtensionByName(T);return R?{id:R.identifier.uuid,publisherDisplayName:R.publisherDisplayName,publisherId:R.publisherId}:void 0}async findGalleryExtension(T){if(T.identifier.uuid){const R=await this.findGalleryExtensionById(T.identifier.uuid);return R||this.findGalleryExtensionByName(T.identifier.id)}return this.findGalleryExtensionByName(T.identifier.id)}async findGalleryExtensionById(T){return(await this.galleryService.query({ids:[T],pageSize:1},p.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(T){return(await this.galleryService.query({names:[T],pageSize:1},p.CancellationToken.None)).firstPage[0]}joinErrors(T){const R=Array.isArray(T)?T:[T];return R.length===1?R[0]instanceof Error?R[0]:new Error(R[0]):R.reduce((M,z)=>new Error(`${M.message}${M.message?",":""}${z instanceof Error?z.message:z}`),new Error(""))}async checkForDependenciesAndUninstall(T,R,M){try{await this.preUninstallExtension(T);const z=M.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(T,R);await this.uninstallExtensions(T,z,R,M)}catch(z){throw await this.postUninstallExtension(T,new d.ExtensionManagementError(z instanceof Error?z.message:z,se)),z}await this.postUninstallExtension(T)}async uninstallExtensions(T,R,M,z){const j=[T,...R];if(!z.donotCheckDependents)for(const ee of j)this.checkForDependents(ee,j,M,T);await k.Promises.settled([this.uninstallExtension(T),...R.map(ee=>this.doUninstall(ee))])}checkForDependents(T,R,M,z){const j=this.getDependents(T,M);if(j.length){const ee=j.filter(me=>R.indexOf(me)===-1);if(ee.length)throw new Error(this.getDependentsErrorMessage(T,ee,z))}}getDependentsErrorMessage(T,R,M){return M===T?R.length===1?y.localize(12,null,M.manifest.displayName||M.manifest.name,R[0].manifest.displayName||R[0].manifest.name):R.length===2?y.localize(13,null,M.manifest.displayName||M.manifest.name,R[0].manifest.displayName||R[0].manifest.name,R[1].manifest.displayName||R[1].manifest.name):y.localize(14,null,M.manifest.displayName||M.manifest.name,R[0].manifest.displayName||R[0].manifest.name,R[1].manifest.displayName||R[1].manifest.name):R.length===1?y.localize(15,null,M.manifest.displayName||M.manifest.name,T.manifest.displayName||T.manifest.name,R[0].manifest.displayName||R[0].manifest.name):R.length===2?y.localize(16,null,M.manifest.displayName||M.manifest.name,T.manifest.displayName||T.manifest.name,R[0].manifest.displayName||R[0].manifest.name,R[1].manifest.displayName||R[1].manifest.name):y.localize(17,null,M.manifest.displayName||M.manifest.name,T.manifest.displayName||T.manifest.name,R[0].manifest.displayName||R[0].manifest.name,R[1].manifest.displayName||R[1].manifest.name)}getAllPackExtensionsToUninstall(T,R,M=[]){if(M.indexOf(T)!==-1)return[];M.push(T);const z=T.manifest.extensionPack?T.manifest.extensionPack:[];if(z.length){const j=R.filter(me=>!me.isBuiltin&&z.some(ge=>v.areSameExtensions({id:ge},me.identifier))),ee=[];for(const me of j)ee.push(...this.getAllPackExtensionsToUninstall(me,R,M));return[...j,...ee]}return[]}getDependents(T,R){return R.filter(M=>M.manifest.extensionDependencies&&M.manifest.extensionDependencies.some(z=>v.areSameExtensions({id:z},T.identifier)))}async doUninstall(T){try{await this.preUninstallExtension(T),await this.uninstallExtension(T)}catch(R){throw await this.postUninstallExtension(T,new d.ExtensionManagementError(R instanceof Error?R.message:R,se)),R}await this.postUninstallExtension(T)}async preUninstallExtension(T){if(!await g.Promises.exists(T.location.fsPath))throw new Error(y.localize(18,null));this.logService.info("Uninstalling extension:",T.identifier.id),this._onUninstallExtension.fire(T.identifier)}async uninstallExtension(T){let R=this.uninstallingExtensions.get(T.identifier.id);return R||(R=k.createCancelablePromise(async()=>{const M=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...M.filter(z=>v.areSameExtensions(z.identifier,T.identifier)))}),this.uninstallingExtensions.set(T.identifier.id,R),R.finally(()=>this.uninstallingExtensions.delete(T.identifier.id))),R}async postUninstallExtension(T,R){if(R)this.logService.error("Failed to uninstall extension:",T.identifier.id,R.message);else if(this.logService.info("Successfully uninstalled extension:",T.identifier.id),T.identifier.uuid)try{await this.galleryService.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"uninstall")}catch(z){}this.reportTelemetry("extensionGallery:uninstall",v.getLocalExtensionTelemetryData(T),void 0,R);const M=R?R instanceof d.ExtensionManagementError?R.code:q:void 0;this._onDidUninstallExtension.fire({identifier:T.identifier,error:M})}getInstalled(T=null){return this.extensionsScanner.scanExtensions(T)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(T){return(await this.filterUninstalled(T)).length===1}async filterUninstalled(...T){const R=[],M=await this.extensionsScanner.getUninstalledExtensions();for(const z of T)M[z.key()]&&R.push(z.key());return R}getExtensionsReport(){const T=new Date().getTime();return(!this.reportedExtensions||T-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=T),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const T=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${T.length} reported extensions from service`),T}catch(T){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(T,R,M,z){const j=z?z instanceof d.ExtensionManagementError?z.code:q:void 0;this.telemetryService.publicLogError(T,{...R,success:!z,duration:M,errorcode:j})}};W=Ne([Ke(0,n.INativeEnvironmentService),Ke(1,d.IExtensionGalleryService),Ke(2,E.ILogService),Ke(3,s.optional(i.IDownloadService)),Ke(4,a.ITelemetryService),Ke(5,s.IInstantiationService),Ke(6,N.IFileService)],W),e.ExtensionManagementService=W}),define(fe[50],he([0,1,63,79,230,7,36,4,24,22,3,17,82,12,5]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class f{constructor(w){this.socket=w,this._errorListener=L=>{if(L){if(L.code==="EPIPE")return;m.onUnexpectedError(L)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const L=F=>w(k.VSBuffer.wrap(F));return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(w){const L=F=>{w({type:0,hadError:F,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(w){return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(w){if(!this.socket.destroyed)try{this.socket.write(w.buffer,L=>{if(L){if(L.code==="EPIPE")return;m.onUnexpectedError(L)}})}catch(L){if(L.code==="EPIPE")return;m.onUnexpectedError(L)}}end(){this.socket.end()}drain(){return new Promise((w,L)=>{if(this.socket.bufferSize===0){w();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),w()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=f;var S;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var E;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(E||(E={}));class I extends n.Disposable{constructor(w,L,F,o){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=w,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=L,this._recordInflateBytes=o,L?(this._zlibInflate=g.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),m.onUnexpectedError(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),F&&(this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=g.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),m.onUnexpectedError(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new b.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(A=>this._onClose.fire(A)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._totalOutgoingDataBytes+=w.byteLength,this._zlibDeflate?(this._zlibDeflate.write(w.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let L=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,L=L.slice(0,L.length-4),this._isEnded||this._write(k.VSBuffer.wrap(L),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(w,!1)}_write(w,L){let F=2;w.byteLength<126?F+=0:w.byteLength<2**16?F+=2:F+=8;const o=k.VSBuffer.alloc(F);if(L?o.writeUInt8(194,0):o.writeUInt8(130,0),w.byteLength<126)o.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){o.writeUInt8(126,1);let A=1;o.writeUInt8(w.byteLength>>>8&255,++A),o.writeUInt8(w.byteLength>>>0&255,++A)}else{o.writeUInt8(127,1);let A=1;o.writeUInt8(0,++A),o.writeUInt8(0,++A),o.writeUInt8(0,++A),o.writeUInt8(0,++A),o.writeUInt8(w.byteLength>>>24&255,++A),o.writeUInt8(w.byteLength>>>16&255,++A),o.writeUInt8(w.byteLength>>>8&255,++A),o.writeUInt8(w.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=o.byteLength+w.byteLength,this.socket.write(k.VSBuffer.concat([o,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._totalIncomingWireBytes+=w.byteLength,this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const L=this._incomingData.peek(this._state.readLen),o=(L.readUInt8(0)&128)>>>7,A=L.readUInt8(1),N=(A&128)>>>7,Q=A&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(Q===126?2:0)+(Q===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const L=this._incomingData.read(this._state.readLen),F=L.readUInt8(1),o=(F&128)>>>7;let A=F&127,N=1;A===126?A=L.readUInt8(++N)*2**8+L.readUInt8(++N):A===127&&(A=L.readUInt8(++N)*0+L.readUInt8(++N)*0+L.readUInt8(++N)*0+L.readUInt8(++N)*0+L.readUInt8(++N)*2**24+L.readUInt8(++N)*2**16+L.readUInt8(++N)*2**8+L.readUInt8(++N));let Q=0;o&&(Q=L.readUInt8(++N)*2**24+L.readUInt8(++N)*2**16+L.readUInt8(++N)*2**8+L.readUInt8(++N)),this._state.state=3,this._state.readLen=A,this._state.mask=Q}else if(this._state.state===3){const L=this._incomingData.read(this._state.readLen);h(L,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(L.buffer)),this._zlibInflate.write(L.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const F=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=F.length,this._onData.fire(k.VSBuffer.wrap(F))})):(this._totalIncomingDataBytes+=L.byteLength,this._onData.fire(L))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=I;function h(p,w){if(w===0)return;let L=p.byteLength>>>2;for(let J=0;J<L;J++){const ce=p.readUInt32BE(J*4);p.writeUInt32BE(ce^w,J*4)}let F=L*4,o=p.byteLength-F;const A=w>>>24&255,N=w>>>16&255,Q=w>>>8&255;o>=1&&p.writeUInt8(p.readUInt8(F)^A,F),o>=2&&p.writeUInt8(p.readUInt8(F+1)^N,F+1),o>=3&&p.writeUInt8(p.readUInt8(F+2)^Q,F+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function l(){const p=v.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let w;return e.XDG_RUNTIME_DIR?w=P.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):w=P.join(d.tmpdir(),`vscode-ipc-${p}.sock`),r(w),w}e.createRandomIPCHandle=l;function t(p,w,L){const F=y.createHash("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${L}-${w}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=P.join(e.XDG_RUNTIME_DIR,`vscode-${F.substr(0,8)}-${L}-${w}.sock`):o=P.join(p,`${L}-${w}.sock`),r(o),o}e.createStaticIPCHandle=t;function r(p){const w=a[u.platform];typeof w=="number"&&p.length>=w&&console.warn(`WARNING: IPC handle "${p}" is longer than ${w} chars, try a shorter --user-data-dir`)}class i extends _.IPCServer{constructor(w){super(i.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const L=C.Event.fromNodeEventEmitter(w,"connection");return C.Event.map(L,F=>({protocol:new b.Protocol(new f(F)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(F,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function s(p){return new Promise((w,L)=>{const F=D.createServer();F.on("error",L),F.listen(p,()=>{F.removeListener("error",L),w(new i(F))})})}e.serve=s;function c(p,w){return new Promise((L,F)=>{const o=D.createConnection(p,()=>{o.removeListener("error",F),L(b.Client.fromSocket(new f(o),w))});o.once("error",F)})}e.connect=c}),define(fe[107],he([0,1,230,66,3,11,12,192,32,16,17,28,87]),function(X,e,y,D,g,C,_,P,d,v,n,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends g.Disposable{constructor(f,S,E){super();this.environmentService=S,this.logService=E,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,S){this.logService.trace("RequestService#request",f.url);const{proxyUrl:E,strictSSL:I}=this,h={...process.env,...await b.resolveShellEnv(this.logService,this.environmentService.args,process.env)},a=f.agent?f.agent:await P.getProxyAgent(f.url||"",h,{proxyUrl:E,strictSSL:I});return f.agent=a,f.strictSSL=I,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization}),this._request(f,S)}async getNodeRequest(f){return(D.parse(f.url).protocol==="https:"?await new Promise((I,h)=>{X(["https"],I,h)}):await new Promise((I,h)=>{X(["http"],I,h)})).request}_request(f,S){return new Promise(async(E,I)=>{let h;const a=D.parse(f.url),l=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),t={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:C.isBoolean(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(t.auth=f.user+":"+f.password),h=l(t,r=>{const i=C.isNumber(f.followRedirects)?f.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)this._request({...f,url:r.headers.location,followRedirects:i-1},S).then(E,I);else{let s=r;r.headers["content-encoding"]==="gzip"&&(s=r.pipe(y.createGunzip())),E({res:r,stream:n.streamToBufferReadableStream(s)})}}),h.on("error",I),f.timeout&&h.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&h.write(f.data),h.end(),S.onCancellationRequested(()=>{h.abort(),I(_.canceled())})})}async resolveProxy(f){}};m=Ne([Ke(0,d.IConfigurationService),Ke(1,k.INativeEnvironmentService),Ke(2,v.ILogService)],m),e.RequestService=m}),define(fe[108],he([0,1,35,101,40,8,4,17,7,50,87,5]),function(X,e,y,D,g,C,_,P,d,v,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function b(E={},I,h,a,l){const t=await D.getNLSConfiguration(I,a.userDataPath),r=await n.resolveShellEnv(l,a.args,process.env),i=a.isBuilt?_.join(a.appRoot,"bin"):_.join(a.appRoot,"resources","server","bin-dev"),s=process.env;let c=E.PATH||(r?r.PATH:void 0)||s.PATH;c?c=i+_.delimiter+c:c=i;const p={...s,...r,VSCODE_LOG_NATIVE:String(h),VSCODE_AMD_ENTRYPOINT:"vs/server/remoteExtensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(t,void 0,0),...E};return a.args["without-browser-env-var"]||(p.BROWSER=_.join(i,"helpers",k.isWindows?"browser.cmd":"browser.sh")),f(p,"PATH",c),S(p),p}e.buildUserEnvironment=b;class m{constructor(I,h,a,l,t,r){this.socket=I,this.socketDrain=h,this.initialDataChunk=a,this.skipWebSocketFrames=l,this.permessageDeflate=t,this.inflateBytes=r}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}class u{constructor(I,h,a,l,t,r){this._environmentService=I,this._logService=h,this._reconnectionToken=a,this._onClose=new d.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=l,this._extensionHostProcess=null,this._connectionData=u._toConnectionData(t,r),this._connectionData.socket.pause(),this._log("New connection established.")}_log(I){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${I}`)}_logError(I){this._logService.error(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${I}`)}static _toConnectionData(I,h){return I instanceof v.NodeSocket?new m(I.socket,I.drain(),h,!0,!1,P.VSBuffer.alloc(0)):new m(I.socket.socket,I.drain(),h,!1,I.permessageDeflate,I.recordedInflateBytes)}async _sendSocketToExtensionHost(I,h){await h.socketDrain;const a=h.toIExtHostSocketMessage();I.send(a,h.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const I={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(I)}acceptReconnection(I,h,a){this._remoteAddress=I,this._log("The client has reconnected.");const l=u._toConnectionData(h,a);if(l.socket.pause(),!this._extensionHostProcess){this._connectionData=l;return}this._sendSocketToExtensionHost(this._extensionHostProcess,l)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(I){try{let h=[];I.port&&!process.pkg&&(h=[`--inspect${I.break?"-brk":""}=0.0.0.0:${I.port}`]);const l={env:await b(I.env,I.language,!!I.debugId,this._environmentService,this._logService),execArgv:h,silent:!0},t=["--type=extensionHost",`--uriTransformerPath=${g.uriTransformerPath}`],r=this._environmentService.args["use-host-proxy"];r!==void 0&&t.push(`--useHostProxy=${r}`),this._extensionHostProcess=y.fork(C.FileAccess.asFileUri("bootstrap-fork",X).fsPath,t,l);const i=this._extensionHostProcess.pid;this._log(`<${i}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const s=d.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),c=d.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");s(w=>console.log("EXTHOST-STDOUT::::::::"+w)),c(w=>console.log("EXTHOST-STDERR::::::::"+w)),this._extensionHostProcess.on("message",w=>{w&&w.type==="__$console"&&(console.log("EXTHOST-LOG:::::"),console.log(w.arguments))}),this._extensionHostProcess.on("error",w=>{this._logError(`<${i}> Extension Host Process had an error`),this._logService.error(w),this._cleanResources()}),this._extensionHostProcess.on("exit",(w,L)=>{this._log(`<${i}> Extension Host Process exited with code: ${w}, signal: ${L}.`),this._cleanResources()});const p=w=>{w.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",p),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",p)}catch(h){console.error("ExtensionHostConnection errored"),h&&console.error(h)}}}e.ExtensionHostConnection=u;function f(E,I,h){const a=Object.keys(E).filter(t=>t.toLowerCase()===I.toLowerCase()),l=a.length>0?a[0]:I;E[l]=h}function S(E){for(let I of Object.keys(E))E[I]===null&&delete E[I]}}),define(fe[231],he([0,1,61,16,59,95,32,65,107,67,39,33,97,106,89,31,3,94,64,8,20,45,92,105,68,86,62,90,12,2,4,23]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f,S,E,I,h,a,l,t,r,i,s,c,p,w,L,F,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class A extends S.Disposable{constructor(ce,se){super();this.args=ce,this.remoteDataFolder=se,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async se=>{const $=se.get(D.ILogService),q=se.get(k.IExtensionManagementCLIService);try{await this.doRun(q)}catch(W){throw $.error(W),console.error(w.getErrorMessage(W)),W}})}async initServices(){const ce=new y.ServiceCollection,se={_serviceBrand:void 0,...f.default};ce.set(l.IProductService,se);const $=new i.ServerEnvironmentService(this.args,se);ce.set(i.IServerEnvironmentService,$);const q=new D.LogService(new t.SpdLogLogger(r.RemoteExtensionLogFileName,F.join($.logsPath,`${r.RemoteExtensionLogFileName}.log`),!0,D.getLogLevel($)));ce.set(D.ILogService,q),q.trace(`Remote configuration data at ${this.remoteDataFolder}`),q.trace("process arguments:",this.args);const W=this._register(new E.FileService(q));ce.set(a.IFileService,W),W.registerProvider(h.Schemas.file,this._register(new I.DiskFileSystemProvider(q)));const V=this._register(new C.ConfigurationService($.settingsResource,W));return await V.initialize(),ce.set(_.IConfigurationService,V),ce.set(P.IRequestService,new g.SyncDescriptor(d.RequestService)),ce.set(n.ITelemetryService,v.NullTelemetryService),ce.set(k.IExtensionGalleryService,new g.SyncDescriptor(b.ExtensionGalleryService)),ce.set(k.IExtensionManagementService,new g.SyncDescriptor(m.ExtensionManagementService)),ce.set(k.IExtensionManagementCLIService,new g.SyncDescriptor(s.ExtensionManagementCLIService)),ce.set(c.ILocalizationsService,new g.SyncDescriptor(p.LocalizationsService)),new u.InstantiationService(ce)}async doRun(ce){if(this.args["list-extensions"])return ce.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"])return ce.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],!!this.args["do-not-sync"],!!this.args.force);if(this.args["uninstall-extension"])return ce.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return ce.locateExtension(this.args["locate-extension"])}asExtensionIdOrVSIX(ce){return ce.map(se=>/\.vsix$/i.test(se)?L.URI.file(F.isAbsolute(se)?se:F.join(o.cwd(),se)):se)}}function N(J){setTimeout(()=>process.exit(J),0)}async function Q(J,ce){const se=new A(J,ce);try{await se.run(),N(0)}catch($){N(1)}finally{se.dispose()}}e.run=Q}),define(fe[232],he([0,1,50,243,27,224,2,206,16]),function(X,e,y,D,g,C,_,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class v{constructor(b,m,u){this._commands=b,this.logService=m,this._ipcHandlePath=u,this._server=D.createServer((f,S)=>this.onRequest(f,S)),this.setup().catch(f=>(m.error(f),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",b=>this.logService.error(b))}catch(b){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(b,m){const u=[];b.setEncoding("utf8"),b.on("data",f=>u.push(f)),b.on("end",()=>{const f=JSON.parse(u.join(""));switch(f.type){case"open":this.open(f,m);break;case"openExternal":this.openExternal(f,m);break;case"status":this.getStatus(f,m);break;case"extensionManagement":this.manageExtensions(f,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${f.type}`,S=>{S&&this.logService.error(S)}),m.end();break}})}open(b,m){let{fileURIs:u,folderURIs:f,forceNewWindow:S,diffMode:E,addMode:I,forceReuseWindow:h,gotoLineMode:a,waitMarkerFilePath:l}=b;const t=[];if(Array.isArray(f))for(const r of f)try{t.push({folderUri:_.URI.parse(r)})}catch(i){}if(Array.isArray(u))for(const r of u)try{P.hasWorkspaceFileExtension(r)?t.push({workspaceUri:_.URI.parse(r)}):t.push({fileUri:_.URI.parse(r)})}catch(i){}if(t.length){const r=l?_.URI.file(l):void 0,s={forceNewWindow:S,diffMode:E,addMode:I,gotoLineMode:a,forceReuseWindow:h,preferNewWindow:!h&&!r&&!I,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,s)}m.writeHead(200),m.end()}async openExternal(b,m){for(const u of b.uris){const f=_.URI.parse(u),S=f.scheme==="file"?f:u;await this._commands.executeCommand("_remoteCLI.openExternal",S)}m.writeHead(200),m.end()}async manageExtensions(b,m){try{const u=E=>E?.map(I=>/\.vsix$/i.test(I)?_.URI.parse(I):I),f={list:b.list,install:u(b.install),uninstall:u(b.uninstall),force:b.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",f);m.writeHead(200),m.write(S)}catch(u){m.writeHead(500),m.write(String(u),f=>{f&&this.logService.error(f)})}m.end()}async getStatus(b,m){try{const u=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(u),m.end()}catch(u){m.writeHead(500),m.write(String(u),f=>{f&&this.logService.error(f)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&g.existsSync(this._ipcHandlePath)&&g.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=v;let n=class extends v{constructor(b,m){super(b,m,y.createRandomIPCHandle())}};n=Ne([Ke(0,C.IExtHostCommands),Ke(1,d.ILogService)],n),e.CLIServer=n}),define(fe[233],he([0,1,24,7,18,3,4,5,2,50,31,40,232,213,104,214,217,108]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class I extends S.AbstractVariableResolverService{constructor(l,t,r,i){super({getFolderUri:s=>{const c=t.filter(p=>p.name===s);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.length,getConfigurationValue:(s,c)=>i[`config:${c}`],getExecPath:()=>l.VSCODE_EXEC_PATH,getAppRoot:()=>l.VSCODE_CWD,getFilePath:()=>{if(r)return _.normalize(r.fsPath)},getSelectedText:()=>i.selectedText,getLineNumber:()=>i.lineNumber},void 0,Promise.resolve(l))}}class h extends C.Disposable{constructor(l,t,r){super();this._environmentService=l,this._logService=t,this._ptyService=r,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new D.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(l,t,r){switch(t){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,r);case"$createProcess":{const i=k.createRemoteURITransformer(l.remoteAuthority);return this._createProcess(i,r)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,r);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,r);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,r);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,r);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,r);case"$start":return this._ptyService.start.apply(this._ptyService,r);case"$input":return this._ptyService.input.apply(this._ptyService,r);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,r);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,r);case"$resize":return this._ptyService.resize.apply(this._ptyService,r);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,r);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,r);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,r);case"$sendCommandResult":return this._sendCommandResult(r[0],r[1],r[2]);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,r);case"$getProfiles":return this._getProfiles.apply(this,r);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(r[0]);case"$getTerminalLayoutInfo":return this._getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this._setTerminalLayoutInfo(r);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,r);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,r)}throw new Error(`IPC Command ${t} not found`)}listen(l,t,r){switch(t){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||D.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||D.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||D.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||D.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||D.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessTitleChangedEvent":return this._ptyService.onProcessTitleChanged;case"$onProcessShellTypeChangedEvent":return this._ptyService.onProcessShellTypeChanged;case"$onProcessOverrideDimensionsEvent":return this._ptyService.onProcessOverrideDimensions;case"$onProcessResolvedShellLaunchConfigEvent":return this._ptyService.onProcessResolvedShellLaunchConfig;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;default:break}throw new Error("Not supported")}async _createProcess(l,t){const r={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:typeof t.shellLaunchConfig.cwd=="string"||typeof t.shellLaunchConfig.cwd=="undefined"?t.shellLaunchConfig.cwd:d.URI.revive(l.transformIncoming(t.shellLaunchConfig.cwd)),env:t.shellLaunchConfig.env,useShellEnvironment:t.shellLaunchConfig.useShellEnvironment};let i;t.shellLaunchConfig.useShellEnvironment?(this._logService.trace("*"),i=await E.buildUserEnvironment(t.resolverEnv,P.language,!1,this._environmentService,this._logService)):i=this._getEnvironment(),this._logService.trace("baseEnv",i);const s=q=>({uri:d.URI.revive(l.transformIncoming(q.uri)),name:q.name,index:q.index,toResource:()=>{throw new Error("Not implemented")}}),c=t.workspaceFolders.map(s),p=t.activeWorkspaceFolder?s(t.activeWorkspaceFolder):void 0,w=t.activeFileResource?d.URI.revive(l.transformIncoming(t.activeFileResource)):void 0,L=new I(i,c,w,t.resolvedVariables),F=f.createVariableResolver(p,process.env,L),o=f.getCwd(r,y.homedir(),F,p?.uri,t.configuration["terminal.integrated.cwd"],this._logService);r.cwd=o;const A=P.isWindows?"terminal.integrated.env.windows":P.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",N=t.configuration[A],Q=f.createTerminalEnvironment(r,N,F,n.default.version,t.configuration["terminal.integrated.detectLocale"],i);if(!r.strictEnv){const q=[];for(const[T,R]of t.envVariableCollections)q.push([T,{map:u.deserializeEnvironmentVariableCollection(R)}]);const W=new Map(q);new m.MergedEnvironmentVariableCollection(W).applyToProcessEnvironment(Q)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:o,cols:t.cols,rows:t.rows,env:Q});const J=v.createRandomIPCHandle();Q.VSCODE_IPC_HOOK_CLI=J;const ce={executeCommand:(q,...W)=>this._executeCommand(q,W,l)},se=new b.CLIServerBase(ce,this._logService,J),$=await this._ptyService.createProcess(r,o,t.cols,t.rows,Q,i,!1,t.shouldPersistTerminal,t.workspaceId,t.workspaceName);return this._ptyService.onProcessExit(q=>q.id===$&&se.dispose()),{persistentTerminalId:$,resolvedShellLaunchConfig:r}}_executeCommand(l,t,r){let i,s;const c=new Promise((L,F)=>{i=L,s=F}),p=++this._lastReqId;this._pendingCommands.set(p,{resolve:i,reject:s,uriTransformer:r});const w=g.cloneAndChange(t,L=>{if(L&&L.$mid===1)return r.transformOutgoing(L);if(L&&L instanceof d.URI)return r.transformOutgoingURI(L)});return this._onExecuteCommand.fire({reqId:p,commandId:l,commandArgs:w}),c}_sendCommandResult(l,t,r){const i=this._pendingCommands.get(l);if(!i)return;this._pendingCommands.delete(l);const s=g.cloneAndChange(r,c=>{if(c&&c.$mid===1)return i.uriTransformer.transformIncoming(c)});t?i.reject(s):i.resolve(s)}_getDefaultSystemShell(l){return this._ptyService.getDefaultSystemShell(l)}async _getProfiles(l,t,r){return this._ptyService.getProfiles?.(l,t,r)||[]}_getEnvironment(){return{...process.env}}_getWslPath(l){return this._ptyService.getWslPath(l)}_setTerminalLayoutInfo(l){this._ptyService.setTerminalLayoutInfo(l)}async _getTerminalLayoutInfo(l){return this._ptyService.getTerminalLayoutInfo(l)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=h}),define(fe[234],he([0,1,63,27,79,66,24,48,235,17,3,22,15,125,5,82,50,108,207,40,16,8,31,28,61,59,95,32,65,107,67,39,33,97,106,89,85,162,62,90,199,198,195,78,94,64,20,45,36,7,226,208,227,191,167,200,161,91,209,2,30,68,4,220,233,109,105,86,92,98,205]),function(X,e,y,D,g,C,_,P,d,v,n,k,b,m,u,f,S,E,I,h,a,l,t,r,i,s,c,p,w,L,F,o,A,N,Q,J,ce,se,$,q,W,V,T,R,M,z,j,ee,me,ge,be,Ie,Ae,Fe,$e,Qe,Ze,tt,nt,Ce,De,_e,Te,Me,We,qe,Ge,et,ne,Se,we){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const Ue=5*60*1e3,ue=`

*
* Visual Studio Code Server
*
* Reminder: You may only use this software with Visual Studio family products,
* as described in the license https://aka.ms/vscode-remote/license
*

`,pe="monacoworkbench";class ve extends me.IPCServer{constructor(){const Z=new ge.Emitter;super(Z.event);this._onDidConnectEmitter=Z}acceptConnection(Z,ye){this._onDidConnectEmitter.fire({protocol:Z,onDidClientDisconnect:ye})}}function G(de){return de<10?`0${de}`:String(de)}function Y(){const de=new Date;return`${G(de.getHours())}:${G(de.getMinutes())}:${G(de.getSeconds())}`}class te extends a.AbstractLogger{constructor(Z=a.DEFAULT_LOG_LEVEL){super();this.setLevel(Z),this.useColors=Boolean(process.stdout.isTTY)}trace(Z,...ye){this.getLevel()<=a.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Y()}][0m`,Z,...ye):console.log(`[${Y()}]`,Z,...ye))}debug(Z,...ye){this.getLevel()<=a.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Y()}][0m`,Z,...ye):console.log(`[${Y()}]`,Z,...ye))}info(Z,...ye){this.getLevel()<=a.LogLevel.Info&&(this.useColors?console.log(`[90m[${Y()}][0m`,Z,...ye):console.log(`[${Y()}]`,Z,...ye))}warn(Z,...ye){this.getLevel()<=a.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Y()}][0m`,Z,...ye):console.warn(`[${Y()}]`,Z,...ye))}error(Z,...ye){this.getLevel()<=a.LogLevel.Error&&(this.useColors?console.error(`[91m[${Y()}][0m`,Z,...ye):console.error(`[${Y()}]`,Z,...ye))}critical(Z,...ye){this.getLevel()<=a.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Y()}][0m`,Z,...ye):console.error(`[${Y()}]`,Z,...ye))}dispose(){}flush(){}}class oe extends n.Disposable{constructor(Z,ye,ke,Le,Oe,He){super();this._environmentService=Z,this._productService=ye,this._connectionToken=ke,this._connectionTokenIsMandatory=Le;const xe=ae(this._environmentService);xe.trace(`Remote configuration data at ${He}`),xe.trace("process arguments:",this._environmentService.args),xe.info(ue),this._logService=new a.MultiplexLogService([new te(a.getLogLevel(this._environmentService)),xe]),this._socketServer=new ve,this._uriTransformerCache=Object.create(null),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),Oe?this._webClientServer=new nt.WebClientServer(this._connectionToken,this._environmentService,this._logService):this._webClientServer=null,this._logService.info("Extension host agent started.")}async initialize(){const Z=await this._createServices();return setTimeout(()=>this._cleanupOlderLogs(this._environmentService.logsPath).then(null,ye=>this._logService.error(ye)),1e4),Z}async _createServices(){const Z=new i.ServiceCollection;this._socketServer.registerChannel(Ze.ExtensionHostDebugBroadcastChannel.ChannelName,new Ze.ExtensionHostDebugBroadcastChannel);const ye=new me.StaticRouter(le=>le.clientId==="renderer");this._socketServer.registerChannel("logger",new tt.LogLevelChannel(this._logService)),Z.set(r.IEnvironmentService,this._environmentService),Z.set(r.INativeEnvironmentService,this._environmentService),Z.set(a.ILogService,this._logService),Z.set(ee.IProductService,this._productService);const ke=this._register(new M.FileService(this._logService));Z.set(j.IFileService,ke),ke.registerProvider(l.Schemas.file,this._register(new z.DiskFileSystemProvider(this._logService))),Z.set(p.IConfigurationService,new s.SyncDescriptor(c.ConfigurationService,[this._environmentService.machineSettingsResource,ke])),Z.set(w.IRequestService,new s.SyncDescriptor(L.RequestService));let Le=F.NullAppender;if(!this._environmentService.args["disable-telemetry"]&&t.default.enableTelemetry){t.default.aiConfig&&t.default.aiConfig.asimovKey&&(Le=new W.AppInsightsAppender(pe,null,t.default.aiConfig.asimovKey),this._register(n.toDisposable(()=>Le.flush())));const le=await R.getMachineId(),K={appender:Le,commonProperties:T.resolveCommonProperties(ke,_.release(),_.hostname(),process.arch,t.default.commit,t.default.version+"-remote",le,t.default.msftInternalDomains,this._environmentService.installSourcePath,"remoteAgent"),piiPaths:[this._environmentService.appRoot]};Z.set(o.ITelemetryService,new s.SyncDescriptor(V.TelemetryService,[K]))}else Z.set(o.ITelemetryService,F.NullTelemetryService);Z.set(A.IExtensionGalleryService,new s.SyncDescriptor(N.ExtensionGalleryService));const Oe=this._socketServer.getChannel("download",ye);Z.set(ce.IDownloadService,new se.DownloadServiceChannelClient(Oe,()=>this._getUriTransformer("renderer"))),Z.set(A.IExtensionManagementService,new s.SyncDescriptor(Q.ExtensionManagementService));const He=new J.InstantiationService(Z);Z.set($.ILocalizationsService,He.createInstance(q.LocalizationsService));const xe=He.createInstance(et.ExtensionManagementCLIService);Z.set(A.IExtensionManagementCLIService,xe);const re=He.createInstance(we.PtyHostService,{GraceTime:108e5,ShortGraceTime:3e5});return Z.set(Se.IPtyService,re),He.invokeFunction(le=>{const K=new be.RemoteAgentEnvironmentChannel(this._connectionToken,this._environmentService,xe,this._logService,le.get(o.ITelemetryService),Le);this._socketServer.registerChannel("remoteextensionsenvironment",K),this._socketServer.registerChannel(Me.REMOTE_TERMINAL_CHANNEL_NAME,new We.RemoteTerminalChannel(this._environmentService,this._logService,re));const H=new Ie.RemoteAgentFileSystemChannel(this._logService,this._environmentService);this._socketServer.registerChannel(Ae.REMOTE_FILE_SYSTEM_CHANNEL_NAME,H),this._socketServer.registerChannel("request",new Fe.RequestChannel(le.get(w.IRequestService)));const Pe=le.get(A.IExtensionManagementService),Re=new $e.ExtensionManagementChannel(Pe,je=>this._getUriTransformer(je.remoteAuthority));return this._socketServer.registerChannel("extensions",Re),Pe.removeDeprecatedExtensions(),this._register(new Qe.default(le.get(o.ITelemetryService))),{telemetryService:le.get(o.ITelemetryService)}})}_getUriTransformer(Z){return this._uriTransformerCache[Z]||(this._uriTransformerCache[Z]=h.createRemoteURITransformer(Z)),this._uriTransformerCache[Z]}async handleRequest(Z,ye){if(Z.method!=="GET")return nt.serveError(Z,ye,405,`Unsupported method ${Z.method}`);if(!Z.url)return nt.serveError(Z,ye,400,"Bad request.");const ke=C.parse(Z.url,!0),Le=ke.pathname;if(!Le)return nt.serveError(Z,ye,400,"Bad request.");if(Le==="/version")return ye.writeHead(200,{"Content-Type":"text/plain"}),ye.end(t.default.commit||"");if(Le==="/delay-shutdown")return this._delayShutdown(),ye.writeHead(200),ye.end("OK");if(Le==="/vscode-remote-resource"){if(ke.query.tkn!==this._connectionToken)return nt.serveError(Z,ye,403,"Forbidden.");const Oe=ke.query.path;if(typeof Oe!="string")return nt.serveError(Z,ye,400,"Bad request.");let He;try{He=Ce.URI.from({scheme:l.Schemas.file,path:Oe}).fsPath}catch(re){return nt.serveError(Z,ye,400,"Bad request.")}const xe=Object.create(null);return this._environmentService.isBuilt&&(De.isEqualOrParent(He,this._environmentService.builtinExtensionsPath,!u.isLinux)||De.isEqualOrParent(He,this._environmentService.extensionsPath,!u.isLinux))&&(xe["Cache-Control"]="public, max-age=31536000"),nt.serveFile(this._logService,Z,ye,He,xe)}if(this._webClientServer){this._webClientServer.handle(Z,ye,ke);return}return ye.writeHead(404,{"Content-Type":"text/plain"}),ye.end("Not found")}handleUpgrade(Z,ye){let ke=k.generateUuid(),Le=!1,Oe=!1;if(Z.url){const H=C.parse(Z.url,!0).query;typeof H.reconnectionToken=="string"&&(ke=H.reconnectionToken),H.reconnection==="true"&&(Le=!0),H.skipWebSocketFrames==="true"&&(Oe=!0)}if(Z.headers.upgrade!=="websocket"){ye.end("HTTP/1.1 400 Bad Request");return}const He=Z.headers["sec-websocket-key"],xe=y.createHash("sha1");xe.update(He+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const re=xe.digest("base64"),le=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${re}`];let K=!1;if(!Oe&&!this._environmentService.args["disable-websocket-compression"]&&Z.headers["sec-websocket-extensions"]){const H=Array.isArray(Z.headers["sec-websocket-extensions"])?Z.headers["sec-websocket-extensions"]:[Z.headers["sec-websocket-extensions"]];for(const Pe of H)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(Pe)){if(/\b(permessage-deflate)\b/.test(Pe)){K=!0,le.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(Pe)){K=!0,le.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}ye.write(le.join(`\r
`)+`\r
\r
`),ye.setTimeout(0),Oe?this._handleWebSocketConnection(new S.NodeSocket(ye),Le,ke):this._handleWebSocketConnection(new S.WebSocketNodeSocket(new S.NodeSocket(ye),K,null,!0),Le,ke)}handleServerError(Z){this._logService.error("Error occurred in server"),this._logService.error(Z)}async _cleanupOlderLogs(Z){const ye=Te.basename(Z),ke=Te.dirname(Z),He=(await b.Promises.readdir(ke)).filter(re=>/^\d{8}T\d{6}$/.test(re)).sort().filter(re=>re!==ye),xe=He.slice(0,Math.max(0,He.length-9));await Promise.all(xe.map(re=>b.Promises.rm(Te.join(ke,re))))}_getRemoteAddress(Z){let ye;return Z instanceof S.NodeSocket?ye=Z.socket:ye=Z.socket.socket,ye.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(Z,ye,ke){const Le=ye.getSocket();this._logService.error(`${Z} ${ke}.`);const Oe={type:"error",reason:ke};ye.sendControl(v.VSBuffer.fromString(JSON.stringify(Oe))),ye.dispose(),await Le.drain(),Le.dispose()}_handleWebSocketConnection(Z,ye,ke){const Le=this._getRemoteAddress(Z),Oe=`[${Le}][${ke.substr(0,8)}]`,He=new f.PersistentProtocol(Z);let xe;try{const Pe=X.__$__nodeRequire("vsda");xe=new Pe.validator}catch(Pe){}let re;(function(Pe){Pe[Pe.WaitingForAuth=0]="WaitingForAuth",Pe[Pe.WaitingForConnectionType=1]="WaitingForConnectionType",Pe[Pe.Done=2]="Done",Pe[Pe.Error=3]="Error"})(re||(re={}));let le=0;const K=Pe=>{le=3,H.dispose(),this._rejectWebSocketConnection(Oe,He,Pe)},H=He.onControlMessage(Pe=>{if(le===0){let Re;try{Re=JSON.parse(Pe.toString())}catch(Ye){return K("Malformed first message")}if(Re.type!=="auth")return K("Invalid first message");if(this._connectionTokenIsMandatory&&Re.auth!==this._connectionToken)return K("Unauthorized client refused: auth mismatch");let je="VS Code Headless is cool";if(xe)try{je=xe.createNewMessage(je)}catch(Ye){}const Be={type:"sign",data:je};He.sendControl(v.VSBuffer.fromString(JSON.stringify(Be))),le=1}else if(le===1){let Re;try{Re=JSON.parse(Pe.toString())}catch(it){return K("Malformed second message")}if(Re.type!=="connectionType")return K("Invalid second message");if(typeof Re.signedData!="string")return K("Invalid second message field type");const je=Re.commit,Be=t.default.commit;if(je&&Be&&je!==Be)return K("Client refused: version mismatch");let Ye=!1;if(Re.signedData===this._connectionToken)Ye=!0;else if(xe)try{Ye=xe.validate(Re.signedData)==="ok"}catch(it){}if(!Ye){if(this._environmentService.isBuilt)return K("Unauthorized client refused");this._logService.error(`${Oe} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let it in this._managementConnections)this._managementConnections[it].shortenReconnectionGraceTimeIfNecessary();for(let it in this._extHostConnections)this._extHostConnections[it].shortenReconnectionGraceTimeIfNecessary();le=2,H.dispose(),this._handleConnectionType(Le,Oe,He,Z,ye,ke,Re)}})}async _handleConnectionType(Z,ye,ke,Le,Oe,He,xe){const re=xe.desiredConnectionType===1?`${ye}[ManagementConnection]`:xe.desiredConnectionType===2?`${ye}[ExtensionHostConnection]`:ye;if(xe.desiredConnectionType===1)if(Oe){if(!this._managementConnections[He])return this._rejectWebSocketConnection(re,ke,"Unknown reconnection token");ke.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const le=ke.readEntireBuffer();ke.dispose(),this._managementConnections[He].acceptReconnection(Z,Le,le)}else{if(this._managementConnections[He])return this._rejectWebSocketConnection(re,ke,"Duplicate reconnection token");ke.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const le=new I.ManagementConnection(this._logService,He,Z,ke);this._socketServer.acceptConnection(le.protocol,le.onClose),this._managementConnections[He]=le,le.onClose(()=>{delete this._managementConnections[He]})}else if(xe.desiredConnectionType===2){const le=xe.args||{language:"en"},K=await this._updateWithFreeDebugPort(le);if(K.port&&this._logService.trace(`${re} - startParams debug port ${K.port}`),this._logService.trace(`${re} - startParams language: ${K.language}`),this._logService.trace(`${re} - startParams env: ${JSON.stringify(K.env)}`),Oe){if(!this._extHostConnections[He])return this._rejectWebSocketConnection(re,ke,"Unknown reconnection token");ke.sendControl(v.VSBuffer.fromString(JSON.stringify(K.port?{debugPort:K.port}:{})));const H=ke.readEntireBuffer();ke.dispose(),this._extHostConnections[He].acceptReconnection(Z,Le,H)}else{if(this._extHostConnections[He])return this._rejectWebSocketConnection(re,ke,"Duplicate reconnection token");ke.sendControl(v.VSBuffer.fromString(JSON.stringify(K.port?{debugPort:K.port}:{})));const H=ke.readEntireBuffer();ke.dispose();const Pe=new E.ExtensionHostConnection(this._environmentService,this._logService,He,Z,Le,H);this._extHostConnections[He]=Pe,Pe.onClose(()=>{delete this._extHostConnections[He],this._onDidCloseExtHostConnection()}),Pe.start(K)}}else if(xe.desiredConnectionType===3){const le=xe.args;this._createTunnel(ke,le)}else return this._rejectWebSocketConnection(re,ke,"Unknown initial data received")}async _createTunnel(Z,ye){const ke=Z.getSocket().socket,Le=Z.readEntireBuffer();Z.dispose(),ke.pause();const Oe=await this._connectTunnelSocket(ye.port);Le.byteLength>0&&Oe.write(Le.buffer),Oe.on("end",()=>ke.end()),Oe.on("close",()=>ke.end()),Oe.on("error",()=>ke.destroy()),ke.on("end",()=>Oe.end()),ke.on("close",()=>Oe.end()),ke.on("error",()=>Oe.destroy()),Oe.pipe(ke),ke.pipe(Oe)}_connectTunnelSocket(Z){return new Promise((ye,ke)=>{const Le=g.createConnection({port:Z},()=>{Le.removeListener("error",ke),Le.pause(),ye(Le)});Le.once("error",ke)})}_updateWithFreeDebugPort(Z){return typeof Z.port=="number"?m.findFreePort(Z.port,10,5e3).then(ye=>(Z.port=ye,Z)):(Z.debugId=void 0,Z.port=void 0,Z.break=void 0,Promise.resolve(Z))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},Ue))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}}e.RemoteExtensionHostAgentServer=oe;function B(de){if(de["connection-secret"]){de.connectionToken&&(console.warn("Please do not use the argument connectionToken at the same time as connection-secret."),process.exit(1));let Z=D.readFileSync(de["connection-secret"]).toString();return Z=Z.replace(/\r?\n$/,""),/^[0-9A-Za-z\-]+$/.test(Z)||(console.warn(`The secret defined in ${de["connection-secret"]} does not adhere to the characters 0-9, a-z, A-Z or -.`),process.exit(1)),{connectionToken:Z,connectionTokenIsMandatory:!0}}else return{connectionToken:de.connectionToken||k.generateUuid(),connectionTokenIsMandatory:!1}}async function ie(de,Z,ye){const ke={_serviceBrand:void 0,...t.default},Le=new _e.ServerEnvironmentService(Z,ke);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Be=Te.join(process.env.HOMEDRIVE,"node_modules"),Ye=Te.dirname(Te.join(process.env.HOMEDRIVE,process.env.HOMEPATH)),it=Te.join(Ye,"node_modules");if(D.existsSync(Be)||D.existsSync(it)){const at=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Be}
* ${it}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;ae(Le).warn(at),console.warn(at),process.exit(0)}}const{connectionToken:Oe,connectionTokenIsMandatory:He}=B(Z),xe=D.existsSync(l.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",X).fsPath);xe&&de&&typeof de!="string"&&console.log(`Web UI available at http://localhost${de.port===80?"":`:${de.port}`}/?tkn=${Oe}`);const re=new oe(Le,ke,Oe,He,xe,ye),le=await re.initialize(),{telemetryService:K}=le;P.mark("code/server/ready");const H=d.performance.now(),Pe=global.vscodeServerStartTime,Re=global.vscodeServerListenTime,je=global.vscodeServerCodeLoadedTime;if(K.publicLog2("serverStart",{startTime:Pe,startedTime:Re,codeLoadedTime:je,readyTime:H}),Z["print-startup-performance"]){const Be=qe.LoaderStats.get();let Ye="";Ye+=`

### Load AMD-module
`,Ye+=qe.LoaderStats.toMarkdownTable(["Module","Duration"],Be.amdLoad),Ye+=`

### Load commonjs-module
`,Ye+=qe.LoaderStats.toMarkdownTable(["Module","Duration"],Be.nodeRequire),Ye+=`

### Invoke AMD-module factory
`,Ye+=qe.LoaderStats.toMarkdownTable(["Module","Duration"],Be.amdInvoke),Ye+=`

### Invoke commonjs-module
`,Ye+=qe.LoaderStats.toMarkdownTable(["Module","Duration"],Be.nodeEval),Ye+=`Start-up time: ${Re-Pe}
`,Ye+=`Code loading time: ${je-Pe}
`,Ye+=`Initialized time: ${H-Pe}
`,Ye+=`
`,console.log(Ye)}return re}e.createServer=ie;const ae=function(){let de;return function(ye){return de||(de=new a.LogService(new ne.SpdLogLogger(Ge.RemoteExtensionLogFileName,Te.join(ye.logsPath,`${Ge.RemoteExtensionLogFileName}.log`),!0,a.getLogLevel(ye)))),de}}()}),define(fe[244],he([0,1,24,27,8,231,234,57,4,235,68,48]),function(X,e,y,D,g,C,_,P,d,v,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,k.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=v.performance.now();const b={onMultipleValues:(r,i)=>{console.error(`Option ${r} can only be defined once. Using value ${i}.`)},onUnknownOption:r=>{console.error(`Ignoring option ${r}: not supported for server.`)}},m=P.parseArgs(process.argv.slice(2),n.serverOptions,b),u=process.env.VSCODE_AGENT_FOLDER||d.join(y.homedir(),".vscode-remote"),f=d.join(u,"data"),S=d.join(f,"User"),E=d.join(S,"globalStorage"),I=d.join(f,"Machine");m["user-data-dir"]=f;const h=d.dirname(g.FileAccess.asFileUri("",X).fsPath),a=d.join(h,"extensions");m["builtin-extensions-dir"]=a,m["extensions-dir"]=m["extensions-dir"]||d.join(u,"extensions"),[u,m["extensions-dir"],f,S,I,E].forEach(r=>{try{D.existsSync(r)||D.mkdirSync(r)}catch(i){console.error(i)}});function l(){C.run(m,u)}e.spawnCli=l;function t(r){return _.createServer(r,m,u)}e.createServer=t})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2d23c42a936db1c7b3b06f918cde29561cc47cd6/core/vs/server/remoteExtensionHostAgent.js.map
